/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern18 (x1, 
E_HImode, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern18 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return pattern28 (x7); /* [-1, 5] */
}

int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_double_operand (operands[2], i1)
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_SImode:
      res = pattern46 (x6, 
E_SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_DImode:
      res = pattern46 (x6, 
E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (nvptx_register_operand (operands[0], E_BImode)
          && nvptx_nonmemory_operand (operands[1], E_BImode))
        return 1; /* movbi */
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && general_operand (operands[1], E_V2SImode)
          && 
#line 248 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 2; /* *movv2si_insn */
      break;

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode)
          && 
#line 248 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 3; /* *movv2di_insn */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 262 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 4; /* *movqi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && 
#line 262 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 5; /* *movhi_insn */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && general_operand (operands[1], E_SImode)
          && 
#line 262 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 6; /* *movsi_insn */
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode)
          && 
#line 262 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 7; /* *movdi_insn */
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && general_operand (operands[1], E_SFmode)
          && 
#line 287 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 8; /* *movsf_insn */
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode)
          && 
#line 287 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 9; /* *movdf_insn */
      break;

    case E_HFmode:
      if (nonimmediate_operand (operands[0], E_HFmode)
          && nonimmediate_operand (operands[1], E_HFmode)
          && 
#line 301 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 10; /* *movhf_insn */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != LABEL_REF
      || GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  return 141; /* jump */
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != LABEL_REF)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      return 564; /* *p jump */

    case UNSPEC:
      return recog_14 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case MEM:
          switch (pattern49 (x3))
            {
            case 0:
              if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
                return -1;
              return 440; /* *p zero_extendqihi2 */

            case 1:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 577; /* *p zero_extendbihi2 */

            case 2:
              return 441; /* *p zero_extendqisi2 */

            case 3:
              return 442; /* *p zero_extendhisi2 */

            case 4:
              return 578; /* *p zero_extendbisi2 */

            case 5:
              return 443; /* *p zero_extendqidi2 */

            case 6:
              return 444; /* *p zero_extendhidi2 */

            case 7:
              return 445; /* *p zero_extendsidi2 */

            case 8:
              return 579; /* *p zero_extendbidi2 */

            case 9:
              return 576; /* *p zero_extendbiqi2 */

            default:
              return -1;
            }

        case TRUNCATE:
          if (GET_MODE (x8) != E_QImode
              || !nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 749; /* *p *zext_truncsi2_qi */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case MEM:
          switch (pattern49 (x3))
            {
            case 0:
              if (!nvptx_register_operand (operands[1], E_QImode))
                return -1;
              return 446; /* *p extendqihi2 */

            case 1:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 573; /* *p extendbihi2 */

            case 2:
              return 447; /* *p extendqisi2 */

            case 3:
              return 448; /* *p extendhisi2 */

            case 4:
              return 574; /* *p extendbisi2 */

            case 5:
              return 449; /* *p extendqidi2 */

            case 6:
              return 450; /* *p extendhidi2 */

            case 7:
              return 451; /* *p extendsidi2 */

            case 8:
              return 575; /* *p extendbidi2 */

            case 9:
              return 572; /* *p extendbiqi2 */

            default:
              return -1;
            }

        case TRUNCATE:
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || GET_MODE (x8) != E_QImode
                  || !nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 458; /* *p *extend_trunc_hi2_qi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 459; /* *p *extend_trunc_si2_qi */

                case E_HImode:
                  return 461; /* *p *extend_trunc_si2_hi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 460; /* *p *extend_trunc_di2_qi */

                case E_HImode:
                  return 462; /* *p *extend_trunc_di2_hi */

                case E_SImode:
                  return 463; /* *p *extend_trunc_di2_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      return recog_16 (x1, insn, pnum_clobbers);

    case PLUS:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          switch (pattern28 (x3))
            {
            case 0:
              return 464; /* *p addhi3 */

            case 1:
              return 465; /* *p addsi3 */

            case 2:
              return 466; /* *p adddi3 */

            case 3:
              return 616; /* *p addsf3 */

            case 4:
              return 617; /* *p adddf3 */

            case 5:
              if (!
#line 1359 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 646; /* *p addhf3 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern44 (x1) != 0)
            return -1;
          return 467; /* *p *vadd_addsi4 */

        case MINUS:
          if (pattern44 (x1) != 0)
            return -1;
          return 468; /* *p *vsub_addsi4 */

        case MULT:
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          x11 = XEXP (x3, 1);
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern65 (x3, 
E_HImode) != 0)
                return -1;
              return 475; /* *p *madhi3 */

            case E_SImode:
              if (pattern65 (x3, 
E_SImode) != 0)
                return -1;
              return 476; /* *p *madsi3 */

            case E_DImode:
              if (pattern65 (x3, 
E_DImode) != 0)
                return -1;
              return 477; /* *p *maddi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x11 = XEXP (x3, 1);
      operands[2] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern27 (x3, 
E_HImode) != 0)
            return -1;
          return 469; /* *p subhi3 */

        case E_SImode:
          if (pattern27 (x3, 
E_SImode) != 0)
            return -1;
          return 470; /* *p subsi3 */

        case E_DImode:
          if (pattern27 (x3, 
E_DImode) != 0)
            return -1;
          return 471; /* *p subdi3 */

        case E_SFmode:
          if (pattern27 (x3, 
E_SFmode) != 0)
            return -1;
          return 618; /* *p subsf3 */

        case E_DFmode:
          if (pattern27 (x3, 
E_DFmode) != 0)
            return -1;
          return 619; /* *p subdf3 */

        case E_HFmode:
          if (pattern27 (x3, 
E_HFmode) != 0
              || !
#line 1366 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 647; /* *p subhf3 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          switch (pattern28 (x3))
            {
            case 0:
              return 472; /* *p mulhi3 */

            case 1:
              return 473; /* *p mulsi3 */

            case 2:
              return 474; /* *p muldi3 */

            case 3:
              return 620; /* *p mulsf3 */

            case 4:
              return 621; /* *p muldf3 */

            case 5:
              if (!
#line 1373 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 648; /* *p mulhf3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern51 (x3, 
SIGN_EXTEND))
            {
            case 0:
              return 521; /* *p mulhisi3 */

            case 1:
              return 522; /* *p mulsidi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern51 (x3, 
ZERO_EXTEND))
            {
            case 0:
              return 523; /* *p umulhisi3 */

            case 1:
              return 524; /* *p umulsidi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          x11 = XEXP (x3, 1);
          operands[2] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern25 (x3, 
E_HImode) != 0)
                return -1;
              return 478; /* *p divhi3 */

            case E_SImode:
              if (pattern25 (x3, 
E_SImode) != 0)
                return -1;
              return 479; /* *p divsi3 */

            case E_DImode:
              if (pattern25 (x3, 
E_DImode) != 0)
                return -1;
              return 480; /* *p divdi3 */

            case E_SFmode:
              if (pattern25 (x3, 
E_SFmode) != 0)
                return -1;
              return 626; /* *p divsf3 */

            case E_DFmode:
              if (pattern25 (x3, 
E_DFmode) != 0)
                return -1;
              return 627; /* *p divdf3 */

            default:
              return -1;
            }

        case CONST_DOUBLE:
          operands[2] = x8;
          x11 = XEXP (x3, 1);
          operands[1] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern62 (x3, 
E_SFmode) != 0
                  || !
#line 1244 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 624; /* *p *recipsf2 */

            case E_DFmode:
              if (pattern62 (x3, 
E_DFmode) != 0
                  || !
#line 1244 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 625; /* *p *recipdf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UDIV:
      switch (pattern26 (x1))
        {
        case 0:
          return 481; /* *p udivhi3 */

        case 1:
          return 482; /* *p udivsi3 */

        case 2:
          return 483; /* *p udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern26 (x1))
        {
        case 0:
          return 484; /* *p modhi3 */

        case 1:
          return 485; /* *p modsi3 */

        case 2:
          return 486; /* *p moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern26 (x1))
        {
        case 0:
          return 487; /* *p umodhi3 */

        case 1:
          return 488; /* *p umodsi3 */

        case 2:
          return 489; /* *p umoddi3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern29 (x1))
        {
        case 0:
          return 490; /* *p sminhi3 */

        case 1:
          return 491; /* *p sminsi3 */

        case 2:
          return 492; /* *p smindi3 */

        case 3:
          return 630; /* *p sminsf3 */

        case 4:
          return 631; /* *p smindf3 */

        case 5:
          if (!
#line 1416 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM80))
            return -1;
          return 655; /* *p sminhf3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern26 (x1))
        {
        case 0:
          return 493; /* *p uminhi3 */

        case 1:
          return 494; /* *p uminsi3 */

        case 2:
          return 495; /* *p umindi3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern29 (x1))
        {
        case 0:
          return 496; /* *p smaxhi3 */

        case 1:
          return 497; /* *p smaxsi3 */

        case 2:
          return 498; /* *p smaxdi3 */

        case 3:
          return 632; /* *p smaxsf3 */

        case 4:
          return 633; /* *p smaxdf3 */

        case 5:
          if (!
#line 1423 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM80))
            return -1;
          return 656; /* *p smaxhf3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern26 (x1))
        {
        case 0:
          return 499; /* *p umaxhi3 */

        case 1:
          return 500; /* *p umaxsi3 */

        case 2:
          return 501; /* *p umaxdi3 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (pattern52 (x3))
        {
        case 0:
          return 502; /* *p abshi2 */

        case 1:
          return 503; /* *p abssi2 */

        case 2:
          return 504; /* *p absdi2 */

        case 3:
          return 634; /* *p abssf2 */

        case 4:
          return 635; /* *p absdf2 */

        case 5:
          return 651; /* *p abshf2 */

        default:
          return -1;
        }

    case NEG:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          switch (pattern52 (x3))
            {
            case 0:
              return 505; /* *p neghi2 */

            case 1:
              return 506; /* *p negsi2 */

            case 2:
              return 507; /* *p negdi2 */

            case 3:
              return 636; /* *p negsf2 */

            case 4:
              return 637; /* *p negdf2 */

            case 5:
              return 650; /* *p neghf2 */

            default:
              return -1;
            }

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          switch (GET_CODE (x8))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case UNORDERED:
            case ORDERED:
            case UNEQ:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              res = recog_11 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          if (!nvptx_comparison_operator (x8, E_SImode))
            return -1;
          operands[1] = x8;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          switch (GET_MODE (operands[2]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[2], E_HImode)
                  || !nvptx_nonmemory_operand (operands[3], E_HImode))
                return -1;
              return 602; /* *p *setcc_inthi */

            case E_SImode:
              if (!nvptx_register_operand (operands[2], E_SImode)
                  || !nvptx_nonmemory_operand (operands[3], E_SImode))
                return -1;
              return 603; /* *p *setcc_intsi */

            case E_DImode:
              if (!nvptx_register_operand (operands[2], E_DImode)
                  || !nvptx_nonmemory_operand (operands[3], E_DImode))
                return -1;
              return 604; /* *p *setcc_intdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 508; /* *p one_cmplhi2 */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 509; /* *p one_cmplsi2 */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 510; /* *p one_cmpldi2 */

            case E_BImode:
              if (!nvptx_register_operand (operands[0], E_BImode)
                  || GET_MODE (x3) != E_BImode
                  || !nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 511; /* *p one_cmplbi2 */

            default:
              return -1;
            }

        case EQ:
          switch (pattern54 (x3))
            {
            case 0:
              return 596; /* *p *selphi_not_eq */

            case 1:
              return 598; /* *p *selpsi_not_eq */

            case 2:
              return 600; /* *p *selpdi_not_eq */

            default:
              return -1;
            }

        case NE:
          switch (pattern54 (x3))
            {
            case 0:
              return 597; /* *p *selphi_not_ne */

            case 1:
              return 599; /* *p *selpsi_not_ne */

            case 2:
              return 601; /* *p *selpdi_not_ne */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[1] = x3;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          x8 = XEXP (x3, 0);
          operands[2] = x8;
          x11 = XEXP (x3, 1);
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              switch (pattern66 (
E_BImode))
                {
                case 0:
                  return 558; /* *p cmphi */

                case 1:
                  return 559; /* *p cmpsi */

                case 2:
                  return 560; /* *p cmpdi */

                default:
                  return -1;
                }

            case E_SFmode:
              switch (pattern66 (
E_SFmode))
                {
                case 0:
                  return 607; /* *p setcc_floathi */

                case 1:
                  return 608; /* *p setcc_floatsi */

                case 2:
                  return 609; /* *p setcc_floatdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case BITREVERSE:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 515; /* *p bitrevsi2 */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nvptx_register_operand (operands[1], E_DImode))
            return -1;
          return 516; /* *p bitrevdi2 */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 517; /* *p clzsi2 */

        case E_DImode:
          if (!nvptx_register_operand (operands[1], E_DImode))
            return -1;
          return 518; /* *p clzdi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 519; /* *p popcountsi2 */

    case SMUL_HIGHPART:
      switch (pattern26 (x1))
        {
        case 0:
          return 525; /* *p smulhi3_highpart */

        case 1:
          return 526; /* *p smulsi3_highpart */

        case 2:
          return 527; /* *p smuldi3_highpart */

        default:
          return -1;
        }

    case UMUL_HIGHPART:
      switch (pattern26 (x1))
        {
        case 0:
          return 528; /* *p umulhi3_highpart */

        case 1:
          return 529; /* *p umulsi3_highpart */

        case 2:
          return 530; /* *p umuldi3_highpart */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern30 (x1))
        {
        case 0:
          return 535; /* *p ashlhi3 */

        case 1:
          return 536; /* *p ashlsi3 */

        case 2:
          return 537; /* *p ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern30 (x1))
        {
        case 0:
          return 538; /* *p ashrhi3 */

        case 1:
          return 539; /* *p ashrsi3 */

        case 2:
          return 540; /* *p ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern30 (x1))
        {
        case 0:
          return 541; /* *p lshrhi3 */

        case 1:
          return 542; /* *p lshrsi3 */

        case 2:
          return 543; /* *p lshrdi3 */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern31 (x1) != 0
          || !
#line 836 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM35))
        return -1;
      return 544; /* *p rotlsi3 */

    case ROTATERT:
      if (pattern31 (x1) != 0
          || !
#line 844 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM35))
        return -1;
      return 545; /* *p rotrsi3 */

    case AND:
      switch (pattern32 (x1))
        {
        case 0:
          return 546; /* *p andhi3 */

        case 1:
          return 549; /* *p andsi3 */

        case 2:
          return 552; /* *p anddi3 */

        case 3:
          return 555; /* *p andbi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern32 (x1))
        {
        case 0:
          return 547; /* *p iorhi3 */

        case 1:
          return 550; /* *p iorsi3 */

        case 2:
          return 553; /* *p iordi3 */

        case 3:
          return 556; /* *p iorbi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern32 (x1))
        {
        case 0:
          return 548; /* *p xorhi3 */

        case 1:
          return 551; /* *p xorsi3 */

        case 2:
          return 554; /* *p xordi3 */

        case 3:
          return 557; /* *p xorbi3 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x11 = XEXP (x3, 1);
      operands[2] = x11;
      x12 = XEXP (x3, 2);
      operands[3] = x12;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case NE:
          switch (pattern58 (x3))
            {
            case 0:
              return 580; /* *p sel_truehi */

            case 1:
              return 581; /* *p sel_truesi */

            case 2:
              return 582; /* *p sel_truedi */

            case 3:
              return 583; /* *p sel_truesf */

            case 4:
              return 584; /* *p sel_truedf */

            default:
              return -1;
            }

        case EQ:
          switch (pattern58 (x3))
            {
            case 0:
              return 585; /* *p sel_falsehi */

            case 1:
              return 586; /* *p sel_falsesi */

            case 2:
              return 587; /* *p sel_falsedi */

            case 3:
              return 588; /* *p sel_falsesf */

            case 4:
              return 589; /* *p sel_falsedf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x11 = XEXP (x3, 1);
      operands[2] = x11;
      x12 = XEXP (x3, 2);
      operands[3] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern63 (x3, 
E_SFmode) != 0)
            return -1;
          return 622; /* *p fmasf4 */

        case E_DFmode:
          if (pattern63 (x3, 
E_DFmode) != 0)
            return -1;
          return 623; /* *p fmadf4 */

        case E_HFmode:
          if (pattern63 (x3, 
E_HFmode) != 0
              || !
#line 1381 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 649; /* *p fmahf4 */

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 638; /* *p sqrtsf2 */

        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 639; /* *p sqrtdf2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[1], E_SFmode))
                return -1;
              return 657; /* *p extendsfdf2 */

            case E_HFmode:
              if (!nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1522 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 692; /* *p extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_HFmode)
              || !
#line 1522 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 691; /* *p extendhfsf2 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 658; /* *p truncdfsf2 */

        case E_HFmode:
          switch (pattern35 (x3, 
E_HFmode))
            {
            case 0:
              if (!
#line 1528 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 693; /* *p truncsfhf2 */

            case 1:
              if (!
#line 1528 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 694; /* *p truncdfhf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern34 (x1))
        {
        case 0:
          return 659; /* *p floatunssisf2 */

        case 1:
          return 663; /* *p floatunsdisf2 */

        case 2:
          return 660; /* *p floatunssidf2 */

        case 3:
          return 664; /* *p floatunsdidf2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern34 (x1))
        {
        case 0:
          return 661; /* *p floatsisf2 */

        case 1:
          return 665; /* *p floatdisf2 */

        case 2:
          return 662; /* *p floatsidf2 */

        case 3:
          return 666; /* *p floatdidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern36 (x1))
        {
        case 0:
          return 667; /* *p fixuns_truncsfsi2 */

        case 1:
          return 668; /* *p fixuns_truncdfsi2 */

        case 2:
          return 671; /* *p fixuns_truncsfdi2 */

        case 3:
          return 672; /* *p fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern36 (x1))
        {
        case 0:
          return 669; /* *p fix_truncsfsi2 */

        case 1:
          return 670; /* *p fix_truncdfsi2 */

        case 2:
          return 673; /* *p fix_truncsfdi2 */

        case 3:
          return 674; /* *p fix_truncdfdi2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != VEC_DUPLICATE)
        return -1;
      x12 = XEXP (x3, 2);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x11 = XEXP (x3, 1);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      switch (XWINT (x12, 0))
        {
        case 1L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern67 (x3, 
E_SImode, 
E_V2SImode) != 0)
                return -1;
              return 695; /* *p *vec_setv2si_0 */

            case E_V2DImode:
              if (pattern67 (x3, 
E_DImode, 
E_V2DImode) != 0)
                return -1;
              return 696; /* *p *vec_setv2di_0 */

            default:
              return -1;
            }

        case 2L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern67 (x3, 
E_SImode, 
E_V2SImode) != 0)
                return -1;
              return 697; /* *p *vec_setv2si_1 */

            case E_V2DImode:
              if (pattern67 (x3, 
E_DImode, 
E_V2DImode) != 0)
                return -1;
              return 698; /* *p *vec_setv2di_1 */

            default:
              return -1;
            }

        case 4L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern67 (x3, 
E_SImode, 
E_V2SImode) != 0)
                return -1;
              return 699; /* *p *vec_setv2si_2 */

            case E_V2DImode:
              if (pattern67 (x3, 
E_DImode, 
E_V2DImode) != 0)
                return -1;
              return 700; /* *p *vec_setv2di_2 */

            default:
              return -1;
            }

        case 8L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern67 (x3, 
E_SImode, 
E_V2SImode) != 0)
                return -1;
              return 701; /* *p *vec_setv2si_3 */

            case E_V2DImode:
              if (pattern67 (x3, 
E_DImode, 
E_V2DImode) != 0)
                return -1;
              return 702; /* *p *vec_setv2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x11 = XEXP (x3, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 1)
        return -1;
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x13 = XVECEXP (x11, 0, 0);
      operands[2] = x13;
      if (!nvptx_vector_index_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[1], E_V2SImode))
            return -1;
          return 703; /* *p vec_extractv2sisi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nvptx_register_operand (operands[1], E_V2DImode))
            return -1;
          return 704; /* *p vec_extractv2didi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_15 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}
