/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern10 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V2DFmode:
      if (pattern10 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern23 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != AND)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x4;
      return 1;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern41 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern41 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern43 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern43 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern49 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern49 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern49 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern49 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern49 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern49 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern49 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern49 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern49 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern49 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern50 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern50 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern51 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern51 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern51 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern51 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern51 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern51 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern51 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern51 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern51 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern51 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern90 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x7, 0);
  if (!scratch_operand (x9, E_DImode))
    return -1;
  x10 = XEXP (x3, 0);
  switch (GET_CODE (x10))
    {
    case EQ:
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case AND:
          if (GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x10, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XEXP (x8, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 100
              || GET_MODE (x13) != E_CCmode)
            return -1;
          x14 = XEXP (x11, 0);
          operands[1] = x14;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x15 = XEXP (x11, 1);
          operands[2] = x15;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x4, 0);
          operands[3] = x16;
          operands[0] = x9;
          return 0;

        case REG:
        case SUBREG:
          operands[1] = x11;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x4, 0);
          operands[0] = x16;
          operands[3] = x9;
          x13 = XEXP (x8, 0);
          operands[4] = x13;
          if (!scratch_operand (operands[4], E_CCUNSmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NE:
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x16 = XEXP (x4, 0);
      operands[0] = x16;
      operands[3] = x9;
      x13 = XEXP (x8, 0);
      operands[4] = x13;
      if (!scratch_operand (operands[4], E_CCUNSmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern123 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern123 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern3 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern3 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern3 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern3 (x1, 
E_V2DImode) != 0)
            return -1;
          return 5;

        case E_V1TImode:
          if (pattern2 (x1, 
E_V1TImode) != 0)
            return -1;
          return 6;

        case E_TImode:
          if (pattern2 (x1, 
E_TImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case VEC_DUPLICATE:
      res = pattern125 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 8; /* [8, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!altivec_register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V1TImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V1TImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V1TImode))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_reg_operand (operands[1], E_XOmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vsx_register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      return pattern179 (x1); /* [-1, 1] */

    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != i1)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      res = pattern180 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!non_update_memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[3], i1))
    return -1;
  return pattern188 (x1); /* [-1, 1] */
}

int
pattern193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern200 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern206 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern206 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern214 (x1, 
E_V1TImode); /* [-1, 0] */

    case E_TImode:
      if (pattern214 (x1, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  return 0;
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return pattern250 (x1); /* [-1, 1] */
}

int
pattern254 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XEXP (x4, 0);
  operands[1] = x12;
  x13 = XEXP (x6, 0);
  operands[0] = x13;
  x14 = XEXP (x9, 0);
  operands[2] = x14;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[2], E_SImode)
          || GET_MODE (x10) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[2], E_DImode)
          || GET_MODE (x10) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern270 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern277 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern275 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern275 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern276 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern276 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern276 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern276 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern276 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern276 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern276 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern276 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern276 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern276 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern291 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!gpc_reg_operand (operands[2], E_HImode)
      || !gpc_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern304 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern312 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern312 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern321 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern320 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern320 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern340 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern351 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[3] = x5;
  if (!const_0_to_1_operand (operands[3], E_QImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 106
          || GET_MODE (x7) != E_CCFPmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          return pattern350 (x3, 
E_V1TImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern350 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != COMPARE
          || GET_MODE (x8) != E_CCFPmode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 3
          || XINT (x9, 1) != i1
          || GET_MODE (x9) != E_V2DFmode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 106
          || GET_MODE (x7) != E_CCFPmode)
        return -1;
      x10 = XEXP (x8, 1);
      operands[4] = x10;
      if (!zero_constant (operands[4], E_V2DFmode))
        return -1;
      x11 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      x13 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x13, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (pattern350 (x3, 
E_V1TImode) != 0)
            return -1;
          return 2;

        case E_V16QImode:
          if (pattern350 (x3, 
E_V16QImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern389 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern398 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern394 (x5, 
i1); /* [-1, 0] */
}

int
pattern406 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern404 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern404 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern405 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern405 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern405 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern405 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern405 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern405 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern405 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern405 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern405 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern405 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern420 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern420 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern421 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern421 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern421 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern421 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern421 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern421 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern421 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern421 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern421 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern421 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern453 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern462 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern471 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern480 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!scratch_operand (operands[4], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DFmode
          || !gpc_reg_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DImode
          || !gpc_reg_operand (operands[1], E_V2DImode))
        return -1;
      return 1;

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_QImode
          || !gpc_reg_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_HImode
          || !gpc_reg_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SImode
          || !gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          return pattern511 (
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern511 (
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != AND)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[4]))
        return -1;
      x12 = XEXP (x10, 1);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern512 (x10, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern512 (x10, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern532 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern298 (x1, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern298 (x1, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_KFmode:
      if (pattern299 (x1, 
E_KFmode) != 0)
        return -1;
      return 4;

    case E_TFmode:
      if (pattern299 (x1, 
E_TFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern543 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern555 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!symbol_ref_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          return 0;

        case E_DFmode:
          if (!memory_operand (operands[2], E_DFmode)
              || !gpc_reg_operand (operands[3], E_DFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!symbol_ref_operand (operands[1], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          return 2;

        case E_DFmode:
          if (!memory_operand (operands[2], E_DFmode)
              || !gpc_reg_operand (operands[3], E_DFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern577 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern582 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern589 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern597 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !const_int_operand (operands[4], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern607 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x5, 0);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  x15 = XEXP (x6, 0);
  operands[2] = x15;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x16 = XEXP (x10, 0);
  x17 = XEXP (x16, 0);
  if (!rtx_equal_p (x17, operands[1]))
    return -1;
  x18 = XEXP (x11, 0);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (scc_rev_comparison_operator (operands[1], E_VOIDmode))
    {
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_CODE (x3) != NE)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!zero_constant (operands[2], E_V2DImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern502 (x2, 
E_SFmode) != 0
              || !
#line 5742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
            return -1;
          return 391; /* *xxselsf */

        case E_DFmode:
          if (pattern502 (x2, 
E_DFmode) != 0
              || !
#line 5742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
            return -1;
          return 392; /* *xxseldf */

        case E_KFmode:
          if (pattern503 (x2, 
E_KFmode) != 0
              || !(
#line 5848 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 399; /* *xxselkf */

        case E_TFmode:
          if (pattern503 (x2, 
E_TFmode) != 0
              || !(
#line 5848 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 400; /* *xxseltf */

        default:
          return -1;
        }

    case LABEL_REF:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC
          || !gpc_reg_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
        return -1;
      *pnum_clobbers = 2;
      return 573; /* *rotate_on_cmpdi */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern370 (
E_SImode) != 0)
            return -1;
          return 224; /* *boolsi3_imm */

        case E_DImode:
          if (pattern370 (
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 225; /* *booldi3_imm */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern358 (
E_TImode) != 0)
            return -1;
          return 516; /* *boolti3_internal */

        case E_PTImode:
          if (pattern358 (
E_PTImode) != 0)
            return -1;
          return 517; /* *boolpti3_internal */

        case E_V16QImode:
          if (pattern358 (
E_V16QImode) != 0
              || !
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 518; /* *boolv16qi3_internal */

        case E_V8HImode:
          if (pattern358 (
E_V8HImode) != 0
              || !
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 519; /* *boolv8hi3_internal */

        case E_V4SImode:
          if (pattern358 (
E_V4SImode) != 0
              || !
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 520; /* *boolv4si3_internal */

        case E_V4SFmode:
          if (pattern358 (
E_V4SFmode) != 0
              || !
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 521; /* *boolv4sf3_internal */

        case E_V2DImode:
          if (pattern358 (
E_V2DImode) != 0
              || !
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 522; /* *boolv2di3_internal */

        case E_V2DFmode:
          if (pattern358 (
E_V2DFmode) != 0
              || !
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 523; /* *boolv2df3_internal */

        case E_V1TImode:
          if (pattern358 (
E_V1TImode) != 0
              || !
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 524; /* *boolv1ti3_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern281 (x3))
        {
        case 0:
          if (!
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2583; /* *fuse_and_nand */

        case 1:
          if (!(
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2584; /* *fuse_and_nand */

        case 2:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2939; /* *fuse_vand_vnand */

        case 3:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2940; /* *fuse_vand_vnand */

        case 4:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2941; /* *fuse_vand_vnand */

        case 5:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2942; /* *fuse_vand_vnand */

        case 6:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2943; /* *fuse_vand_vnand */

        case 7:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2944; /* *fuse_vand_vnand */

        case 8:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2945; /* *fuse_vand_vnand */

        case 9:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2946; /* *fuse_vand_vnand */

        case 10:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2947; /* *fuse_vand_vnand */

        case 11:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2948; /* *fuse_vand_vnand */

        case 12:
          if (!
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2585; /* *fuse_andc_nand */

        case 13:
          if (!(
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2586; /* *fuse_andc_nand */

        case 14:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2949; /* *fuse_vandc_vnand */

        case 15:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2950; /* *fuse_vandc_vnand */

        case 16:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2951; /* *fuse_vandc_vnand */

        case 17:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2952; /* *fuse_vandc_vnand */

        case 18:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2953; /* *fuse_vandc_vnand */

        case 19:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2954; /* *fuse_vandc_vnand */

        case 20:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2955; /* *fuse_vandc_vnand */

        case 21:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2956; /* *fuse_vandc_vnand */

        case 22:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2957; /* *fuse_vandc_vnand */

        case 23:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2958; /* *fuse_vandc_vnand */

        case 24:
          if (!
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2591; /* *fuse_nor_nand */

        case 25:
          if (!(
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2592; /* *fuse_nor_nand */

        case 26:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2979; /* *fuse_vnor_vnand */

        case 27:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2980; /* *fuse_vnor_vnand */

        case 28:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2981; /* *fuse_vnor_vnand */

        case 29:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2982; /* *fuse_vnor_vnand */

        case 30:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2983; /* *fuse_vnor_vnand */

        case 31:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2984; /* *fuse_vnor_vnand */

        case 32:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2985; /* *fuse_vnor_vnand */

        case 33:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2986; /* *fuse_vnor_vnand */

        case 34:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2987; /* *fuse_vnor_vnand */

        case 35:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2988; /* *fuse_vnor_vnand */

        default:
          return -1;
        }

    case NOT:
      switch (pattern284 (x3))
        {
        case 0:
          if (!
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2587; /* *fuse_eqv_nand */

        case 1:
          if (!(
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2588; /* *fuse_eqv_nand */

        case 2:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2959; /* *fuse_veqv_vnand */

        case 3:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2960; /* *fuse_veqv_vnand */

        case 4:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2961; /* *fuse_veqv_vnand */

        case 5:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2962; /* *fuse_veqv_vnand */

        case 6:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2963; /* *fuse_veqv_vnand */

        case 7:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2964; /* *fuse_veqv_vnand */

        case 8:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2965; /* *fuse_veqv_vnand */

        case 9:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2966; /* *fuse_veqv_vnand */

        case 10:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2967; /* *fuse_veqv_vnand */

        case 11:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2968; /* *fuse_veqv_vnand */

        default:
          return -1;
        }

    case IOR:
      switch (pattern285 (x3))
        {
        case 0:
          if (!
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2589; /* *fuse_nand_nand */

        case 1:
          if (!(
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2590; /* *fuse_nand_nand */

        case 2:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2969; /* *fuse_vnand_vnand */

        case 3:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2970; /* *fuse_vnand_vnand */

        case 4:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2971; /* *fuse_vnand_vnand */

        case 5:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2972; /* *fuse_vnand_vnand */

        case 6:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2973; /* *fuse_vnand_vnand */

        case 7:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2974; /* *fuse_vnand_vnand */

        case 8:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2975; /* *fuse_vnand_vnand */

        case 9:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2976; /* *fuse_vnand_vnand */

        case 10:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2977; /* *fuse_vnand_vnand */

        case 11:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2978; /* *fuse_vnand_vnand */

        case 12:
          if (!
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2595; /* *fuse_orc_nand */

        case 13:
          if (!(
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2596; /* *fuse_orc_nand */

        case 14:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2999; /* *fuse_vorc_vnand */

        case 15:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3000; /* *fuse_vorc_vnand */

        case 16:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3001; /* *fuse_vorc_vnand */

        case 17:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3002; /* *fuse_vorc_vnand */

        case 18:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3003; /* *fuse_vorc_vnand */

        case 19:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3004; /* *fuse_vorc_vnand */

        case 20:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3005; /* *fuse_vorc_vnand */

        case 21:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3006; /* *fuse_vorc_vnand */

        case 22:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3007; /* *fuse_vorc_vnand */

        case 23:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3008; /* *fuse_vorc_vnand */

        case 24:
          if (!
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2593; /* *fuse_or_nand */

        case 25:
          if (!(
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2594; /* *fuse_or_nand */

        case 26:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2989; /* *fuse_vor_vnand */

        case 27:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2990; /* *fuse_vor_vnand */

        case 28:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2991; /* *fuse_vor_vnand */

        case 29:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2992; /* *fuse_vor_vnand */

        case 30:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2993; /* *fuse_vor_vnand */

        case 31:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2994; /* *fuse_vor_vnand */

        case 32:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2995; /* *fuse_vor_vnand */

        case 33:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2996; /* *fuse_vor_vnand */

        case 34:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2997; /* *fuse_vor_vnand */

        case 35:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2998; /* *fuse_vor_vnand */

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern272 (x3, 
E_SImode) != 0
                  || !
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2597; /* *fuse_xor_nand */

            case E_DImode:
              if (pattern272 (x3, 
E_DImode) != 0
                  || !(
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2598; /* *fuse_xor_nand */

            case E_V4SImode:
              if (pattern273 (x3, 
E_V4SImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3009; /* *fuse_vxor_vnand */

            case E_V8HImode:
              if (pattern273 (x3, 
E_V8HImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3010; /* *fuse_vxor_vnand */

            case E_V16QImode:
              if (pattern273 (x3, 
E_V16QImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3011; /* *fuse_vxor_vnand */

            case E_V4SFmode:
              if (pattern273 (x3, 
E_V4SFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3012; /* *fuse_vxor_vnand */

            case E_V2DFmode:
              if (pattern273 (x3, 
E_V2DFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3013; /* *fuse_vxor_vnand */

            case E_V2DImode:
              if (pattern273 (x3, 
E_V2DImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3014; /* *fuse_vxor_vnand */

            case E_V1TImode:
              if (pattern273 (x3, 
E_V1TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3015; /* *fuse_vxor_vnand */

            case E_TImode:
              if (pattern273 (x3, 
E_TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3016; /* *fuse_vxor_vnand */

            case E_KFmode:
              if (pattern273 (x3, 
E_KFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3017; /* *fuse_vxor_vnand */

            case E_TFmode:
              if (pattern273 (x3, 
E_TFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3018; /* *fuse_vxor_vnand */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern429 (x3))
            {
            case 0:
              if (!
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2627; /* *fuse_eqv_or */

            case 1:
              if (!(
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2628; /* *fuse_eqv_or */

            case 2:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3119; /* *fuse_veqv_vor */

            case 3:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3120; /* *fuse_veqv_vor */

            case 4:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3121; /* *fuse_veqv_vor */

            case 5:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3122; /* *fuse_veqv_vor */

            case 6:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3123; /* *fuse_veqv_vor */

            case 7:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3124; /* *fuse_veqv_vor */

            case 8:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3125; /* *fuse_veqv_vor */

            case 9:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3126; /* *fuse_veqv_vor */

            case 10:
              if (!(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3127; /* *fuse_veqv_vor */

            case 11:
              if (!(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3128; /* *fuse_veqv_vor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2599; /* *fuse_add_nand */

        case 1:
          if (!(
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2600; /* *fuse_add_nand */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2601; /* *fuse_subf_nand */

        case 1:
          if (!(
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2602; /* *fuse_subf_nand */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !
#line 9556 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 643; /* p8_fmrgow_di */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9556 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 644; /* p8_fmrgow_df */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !
#line 9556 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 645; /* p8_fmrgow_dd */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 2045 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2024; /* altivec_vrldnm */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 2045 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2025; /* altivec_vrlwnm */

    case E_V1TImode:
      if (pattern132 (x3, 
E_V1TImode) != 0
          || !
#line 2069 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2026; /* altivec_vrlqnm_inst */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], E_SFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_SFmode)
      || !
#line 3232 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
    return -1;
  return 1463; /* vsx_concat_v2sf */
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!u6bit_cint_operand (operands[1], E_QImode)
          || !altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 6455 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1738; /* vec_mtvsrbmi */

    case REG:
    case SUBREG:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!altivec_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1739; /* vec_mtvsr_v16qi */

        case E_V8HImode:
          if (!altivec_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1740; /* vec_mtvsr_v8hi */

        case E_V4SImode:
          if (!altivec_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1741; /* vec_mtvsr_v4si */

        case E_V2DImode:
          if (!altivec_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1742; /* vec_mtvsr_v2di */

        case E_V1TImode:
          if (!altivec_register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !
#line 6463 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1743; /* vec_mtvsr_v1ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 9580 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 648; /* p8_mtvsrd_v16qidi2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9614 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 652; /* p8_mtvsrd_df */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !
#line 9679 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 673; /* p8_mtvsrd_sf */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 100 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2489; /* crypto_vsbox_v16qi */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 100 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2490; /* crypto_vsbox_v2di */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      switch (pattern340 (x3, 
E_V1TImode))
        {
        case 0:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1665; /* xsxsigqp_kf_v1ti */

        case 1:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1666; /* xsxsigqp_tf_v1ti */

        default:
          return -1;
        }

    case E_TImode:
      switch (pattern340 (x3, 
E_TImode))
        {
        case 0:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1667; /* xsxsigqp_kf_ti */

        case 1:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1668; /* xsxsigqp_tf_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_3_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_DDmode:
          if (pattern381 (x3, 
E_DDmode) != 0
              || !
#line 406 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2469; /* dfp_dqua_dd */

        case E_TDmode:
          if (pattern381 (x3, 
E_TDmode) != 0
              || !
#line 406 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2470; /* dfp_dqua_td */

        default:
          return -1;
        }

    case CONST_INT:
      if (!s5bit_cint_operand (operands[1], E_SImode))
        return -1;
      switch (pattern382 (x3))
        {
        case 0:
          if (!
#line 417 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2471; /* dfp_dquai_dd */

        case 1:
          if (!
#line 417 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2472; /* dfp_dquai_td */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      return recog_105 (x1, insn, pnum_clobbers);

    case 1:
      return recog_106 (x1, insn, pnum_clobbers);

    case 3:
      return recog_107 (x1, insn, pnum_clobbers);

    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (XINT (x2, 1))
        {
        case 208:
          if (pattern436 (x2, 
E_V16QImode) != 0
              || !u3bit_cint_operand (operands[4], E_QImode)
              || !
#line 6746 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1786; /* xxpermx_inst */

        case 203:
          if (pattern436 (x2, 
E_V2DImode) != 0
              || !u8bit_cint_operand (operands[4], E_QImode)
              || !
#line 6759 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1787; /* xxeval */

        case 373:
          if (pattern437 (x2, 
E_V16QImode) != 0
              || !const_0_to_15_operand (operands[4], E_SImode)
              || !
#line 624 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2410; /* mma_pmxvf32ger */

        case 378:
          if (pattern437 (x2, 
E_OOmode) != 0
              || !const_0_to_3_operand (operands[4], E_SImode)
              || !
#line 649 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2415; /* mma_pmxvf64ger */

        default:
          return -1;
        }

    case 5:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode)
          || GET_MODE (x2) != E_XOmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      switch (XINT (x2, 1))
        {
        case 387:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !vsx_register_operand (operands[2], E_V16QImode)
              || !const_0_to_15_operand (operands[3], E_SImode)
              || !u8bit_cint_operand (operands[5], E_SImode)
              || !
#line 571 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2394; /* mma_pmxvi4ger8 */

        case 383:
          if (pattern534 () != 0
              || !
#line 598 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2396; /* mma_pmxvi16ger2 */

        case 385:
          if (pattern534 () != 0
              || !
#line 598 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2397; /* mma_pmxvi16ger2s */

        case 368:
          if (pattern534 () != 0
              || !
#line 598 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2398; /* mma_pmxvf16ger2 */

        case 363:
          if (pattern534 () != 0
              || !
#line 598 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2399; /* mma_pmxvbf16ger2 */

        case 377:
          if (pattern535 () != 0
              || !
#line 637 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2411; /* mma_pmxvf32gerpp */

        case 376:
          if (pattern535 () != 0
              || !
#line 637 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2412; /* mma_pmxvf32gerpn */

        case 375:
          if (pattern535 () != 0
              || !
#line 637 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2413; /* mma_pmxvf32gernp */

        case 374:
          if (pattern535 () != 0
              || !
#line 637 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2414; /* mma_pmxvf32gernn */

        case 382:
          if (pattern536 () != 0
              || !
#line 662 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2416; /* mma_pmxvf64gerpp */

        case 381:
          if (pattern536 () != 0
              || !
#line 662 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2417; /* mma_pmxvf64gerpn */

        case 380:
          if (pattern536 () != 0
              || !
#line 662 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2418; /* mma_pmxvf64gernp */

        case 379:
          if (pattern536 () != 0
              || !
#line 662 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2419; /* mma_pmxvf64gernn */

        case 389:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !vsx_register_operand (operands[2], E_V16QImode)
              || !const_0_to_15_operand (operands[3], E_SImode)
              || !const_0_to_15_operand (operands[5], E_SImode)
              || !
#line 675 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2420; /* mma_pmxvi8ger4 */

        default:
          return -1;
        }

    case 6:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode)
          || GET_MODE (x2) != E_XOmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vsx_register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!vsx_register_operand (operands[3], E_V16QImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      if (!const_0_to_15_operand (operands[5], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[6] = x9;
      switch (XINT (x2, 1))
        {
        case 388:
          if (!u8bit_cint_operand (operands[6], E_SImode)
              || !
#line 585 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2395; /* mma_pmxvi4ger8pp */

        case 384:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2400; /* mma_pmxvi16ger2pp */

        case 386:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2401; /* mma_pmxvi16ger2spp */

        case 372:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2402; /* mma_pmxvf16ger2pp */

        case 371:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2403; /* mma_pmxvf16ger2pn */

        case 370:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2404; /* mma_pmxvf16ger2np */

        case 369:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2405; /* mma_pmxvf16ger2nn */

        case 367:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2406; /* mma_pmxvbf16ger2pp */

        case 366:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2407; /* mma_pmxvbf16ger2pn */

        case 365:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2408; /* mma_pmxvbf16ger2np */

        case 364:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2409; /* mma_pmxvbf16ger2nn */

        case 390:
          if (!const_0_to_15_operand (operands[6], E_SImode)
              || !
#line 689 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2421; /* mma_pmxvi8ger4pp */

        case 391:
          if (!const_0_to_15_operand (operands[6], E_SImode)
              || !
#line 689 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2422; /* mma_pmxvi8ger4spp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (pattern30 (x2))
    {
    case 0:
      switch (GET_MODE (x2))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2242; /* altivec_stvx_v8hi_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2243; /* altivec_stvx_v8hi_2op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2250; /* altivec_stvx_v2di_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2251; /* altivec_stvx_v2di_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (x2))
        {
        case E_V8HImode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V8HImode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2260; /* altivec_stvx_v8hi_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2261; /* altivec_stvx_v8hi_1op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2268; /* altivec_stvx_v2di_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2269; /* altivec_stvx_v2di_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (GET_MODE (x2) != E_V2DImode)
            return -1;
          if (vsx_register_operand (operands[0], E_V2DImode)
              && memory_operand (operands[1], E_V2DImode)
              && 
#line 1393 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
            return 1319; /* vsx_ld_elemrev_v2di */
          if (memory_operand (operands[0], E_V2DImode)
              && vsx_register_operand (operands[1], E_V2DImode))
            {
              if (
#line 1563 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
                return 1328; /* vsx_st_elemrev_v2di */
              if (
#line 1625 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
                return 1331; /* *vsx_st_elemrev_v2di_internal */
            }
          if (vsx_register_operand (operands[0], E_V2DImode))
            {
              if (vsx_register_operand (operands[1], E_V2DImode))
                {
                  if (
#line 3280 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode)))
                    return 1465; /* *vsx_xxpermdi2_le_v2di */
                  if (
#line 3333 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1471; /* xxswapd_v2di */
                }
              if (memory_operand (operands[1], E_V2DImode)
                  && 
#line 3391 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode) && !TARGET_P9_VECTOR))
                return 1478; /* *vsx_lxvd2x2_le_v2di */
            }
          if (!memory_operand (operands[0], E_V2DImode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 3440 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1484; /* *vsx_stxvd2x2_le_v2di */

        case E_V2DFmode:
          if (GET_MODE (x2) != E_V2DFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V2DFmode)
              && memory_operand (operands[1], E_V2DFmode)
              && 
#line 1413 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return 1321; /* vsx_ld_elemrev_v2df */
          if (memory_operand (operands[0], E_V2DFmode)
              && vsx_register_operand (operands[1], E_V2DFmode)
              && 
#line 1554 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return 1327; /* vsx_st_elemrev_v2df */
          if (vsx_register_operand (operands[0], E_V2DFmode))
            {
              if (vsx_register_operand (operands[1], E_V2DFmode))
                {
                  if (
#line 3280 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode)))
                    return 1464; /* *vsx_xxpermdi2_le_v2df */
                  if (
#line 3333 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1470; /* xxswapd_v2df */
                }
              if (memory_operand (operands[1], E_V2DFmode)
                  && 
#line 3391 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode) && !TARGET_P9_VECTOR))
                return 1477; /* *vsx_lxvd2x2_le_v2df */
            }
          if (!memory_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 3440 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode) && !TARGET_P9_VECTOR))
            return -1;
          return 1483; /* *vsx_stxvd2x2_le_v2df */

        default:
          return -1;
        }

    case 1:
      return recog_122 (x1, insn, pnum_clobbers);

    case 4:
      if (pattern226 (x4) != 0)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 3L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 2L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 1L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (GET_MODE (x2) != E_V4SImode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SImode)
                  && memory_operand (operands[1], E_V4SImode)
                  && 
#line 1423 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && !BYTES_BIG_ENDIAN))
                return 1322; /* vsx_ld_elemrev_v4si */
              if (!memory_operand (operands[0], E_V4SImode)
                  || !vsx_register_operand (operands[1], E_V4SImode)
                  || !
#line 1583 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && !BYTES_BIG_ENDIAN))
                return -1;
              return 1330; /* vsx_st_elemrev_v4si */

            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && memory_operand (operands[1], E_V4SFmode)
                  && 
#line 1433 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
                return 1323; /* vsx_ld_elemrev_v4sf */
              if (!memory_operand (operands[0], E_V4SFmode)
                  || !vsx_register_operand (operands[1], E_V4SFmode)
                  || !
#line 1573 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
                return -1;
              return 1329; /* vsx_st_elemrev_v4sf */

            default:
              return -1;
            }

        case 2L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 3L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 1L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode))
                {
                  if (vsx_register_operand (operands[1], E_V4SFmode)
                      && 
#line 3322 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1468; /* xxswapd_v4sf */
                  if (memory_operand (operands[1], E_V4SFmode)
                      && 
#line 3401 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SFmode) && !TARGET_P9_VECTOR))
                    return 1479; /* *vsx_lxvd2x4_le_v4sf */
                }
              if (!memory_operand (operands[0], E_V4SFmode)
                  || !vsx_register_operand (operands[1], E_V4SFmode)
                  || !
#line 3450 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SFmode) && !TARGET_P9_VECTOR))
                return -1;
              return 1485; /* *vsx_stxvd2x4_le_v4sf */

            case E_V4SImode:
              if (GET_MODE (x2) != E_V4SImode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SImode))
                {
                  if (vsx_register_operand (operands[1], E_V4SImode)
                      && 
#line 3322 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1469; /* xxswapd_v4si */
                  if (memory_operand (operands[1], E_V4SImode)
                      && 
#line 3401 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SImode) && !TARGET_P9_VECTOR))
                    return 1480; /* *vsx_lxvd2x4_le_v4si */
                }
              if (!memory_operand (operands[0], E_V4SImode)
                  || !vsx_register_operand (operands[1], E_V4SImode)
                  || !
#line 3450 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SImode) && !TARGET_P9_VECTOR))
                return -1;
              return 1486; /* *vsx_stxvd2x4_le_v4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 8:
      if (pattern225 (x4) != 0
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 7L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 6L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 5L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 4L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 3L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 2L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 1L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 0L)
            return -1;
          if (vsx_register_operand (operands[0], E_V8HImode)
              && memory_operand (operands[1], E_V8HImode)
              && 
#line 1479 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return 1324; /* *vsx_ld_elemrev_v8hi_internal */
          if (!memory_operand (operands[0], E_V8HImode)
              || !vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 1637 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return -1;
          return 1332; /* *vsx_st_elemrev_v8hi_internal */

        case 4L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 5L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 6L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 7L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 0L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 2L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 3L)
            return -1;
          if (vsx_register_operand (operands[0], E_V8HImode))
            {
              if (vsx_register_operand (operands[1], E_V8HImode)
                  && 
#line 3310 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                return 1467; /* xxswapd_v8hi */
              if (memory_operand (operands[1], E_V8HImode)
                  && 
#line 3413 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V8HImode) && !TARGET_P9_VECTOR))
                return 1481; /* *vsx_lxvd2x8_le_V8HI */
            }
          if (!memory_operand (operands[0], E_V8HImode)
              || !vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 3489 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V8HImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1489; /* *vsx_stxvd2x8_le_V8HI */

        default:
          return -1;
        }

    case 16:
      if (pattern224 (x4) != 0
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 15L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 14L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 13L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 12L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 11L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 10L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 9L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 8L)
            return -1;
          x13 = XVECEXP (x4, 0, 8);
          if (XWINT (x13, 0) != 7L)
            return -1;
          x14 = XVECEXP (x4, 0, 9);
          if (XWINT (x14, 0) != 6L)
            return -1;
          x15 = XVECEXP (x4, 0, 10);
          if (XWINT (x15, 0) != 5L)
            return -1;
          x16 = XVECEXP (x4, 0, 11);
          if (XWINT (x16, 0) != 4L)
            return -1;
          x17 = XVECEXP (x4, 0, 12);
          if (XWINT (x17, 0) != 3L)
            return -1;
          x18 = XVECEXP (x4, 0, 13);
          if (XWINT (x18, 0) != 2L)
            return -1;
          x19 = XVECEXP (x4, 0, 14);
          if (XWINT (x19, 0) != 1L)
            return -1;
          x20 = XVECEXP (x4, 0, 15);
          if (XWINT (x20, 0) != 0L)
            return -1;
          if (vsx_register_operand (operands[0], E_V16QImode)
              && memory_operand (operands[1], E_V16QImode)
              && 
#line 1533 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return 1325; /* vsx_ld_elemrev_v16qi_internal */
          if (!memory_operand (operands[0], E_V16QImode)
              || !vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 1690 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return -1;
          return 1333; /* *vsx_st_elemrev_v16qi_internal */

        case 8L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 9L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 10L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 11L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 12L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 13L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 14L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 15L)
            return -1;
          x13 = XVECEXP (x4, 0, 8);
          if (XWINT (x13, 0) != 0L)
            return -1;
          x14 = XVECEXP (x4, 0, 9);
          if (XWINT (x14, 0) != 1L)
            return -1;
          x15 = XVECEXP (x4, 0, 10);
          if (XWINT (x15, 0) != 2L)
            return -1;
          x16 = XVECEXP (x4, 0, 11);
          if (XWINT (x16, 0) != 3L)
            return -1;
          x17 = XVECEXP (x4, 0, 12);
          if (XWINT (x17, 0) != 4L)
            return -1;
          x18 = XVECEXP (x4, 0, 13);
          if (XWINT (x18, 0) != 5L)
            return -1;
          x19 = XVECEXP (x4, 0, 14);
          if (XWINT (x19, 0) != 6L)
            return -1;
          x20 = XVECEXP (x4, 0, 15);
          if (XWINT (x20, 0) != 7L)
            return -1;
          if (vsx_register_operand (operands[0], E_V16QImode))
            {
              if (vsx_register_operand (operands[1], E_V16QImode)
                  && 
#line 3296 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                return 1466; /* xxswapd_v16qi */
              if (memory_operand (operands[1], E_V16QImode)
                  && 
#line 3429 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V16QImode) && !TARGET_P9_VECTOR))
                return 1482; /* *vsx_lxvd2x16_le_V16QI */
            }
          if (!memory_operand (operands[0], E_V16QImode)
              || !vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 3505 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V16QImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1490; /* *vsx_stxvd2x16_le_V16QI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
                    {
                      *pnum_clobbers = 1;
                      return 411; /* floatunssisf2_lfiwzx */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 7118 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
                    return 505; /* floatunsdisf2_fcfidus */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 7129 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
                    {
                      *pnum_clobbers = 1;
                      return 506; /* *floatunsdisf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern333 (
E_SFmode))
            {
            case 0:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 421; /* *floatunsqisf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 422; /* *floatunshisf2_internal */

            default:
              return -1;
            }

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
                    {
                      *pnum_clobbers = 1;
                      return 412; /* floatunssidf2_lfiwzx */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 6994 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDU))
                    return 500; /* *floatunsdidf2_fcfidu */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 7004 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))))
                    {
                      *pnum_clobbers = 1;
                      return 501; /* *floatunsdidf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern333 (
E_DFmode))
            {
            case 0:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 423; /* *floatunsqidf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 424; /* *floatunshidf2_internal */

            default:
              return -1;
            }

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_KFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6942 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 493; /* floatunstikf2 */
          if (!altivec_register_operand (operands[0], E_KFmode))
            return -1;
          switch (pattern334 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15384 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1167; /* floatuns_kfdi2_hw */

            case 1:
              if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1169; /* floatuns_kfsi2_hw */

            case 2:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1171; /* floatunsqikf2 */

            case 3:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1172; /* floatunshikf2 */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_TFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6942 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 494; /* floatunstitf2 */
          if (!altivec_register_operand (operands[0], E_TFmode))
            return -1;
          switch (pattern334 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15384 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1168; /* floatuns_tfdi2_hw */

            case 1:
              if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1170; /* floatuns_tfsi2_hw */

            case 2:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1173; /* floatunsqitf2 */

            case 3:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1174; /* floatunshitf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SFmode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && 
#line 2285 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1398; /* vsx_floatunsv4siv4sf2 */
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || !vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 2489 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1433; /* vsx_xvcvuxwsp */

        case E_V2DFmode:
          if (GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DFmode)
              && gpc_reg_operand (operands[1], E_V2DImode)
              && 
#line 2285 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1399; /* vsx_floatunsv2div2df2 */
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 2496 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1435; /* vsx_xvcvuxddp */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern66 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
            return -1;
          *pnum_clobbers = 1;
          return 413; /* floatunssisf2_lfiwzx_mem */

        case 1:
          if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
            return -1;
          *pnum_clobbers = 1;
          return 414; /* floatunssidf2_lfiwzx_mem */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 471; /* *roundu32sf2_fprs */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 472; /* *roundu32df2_fprs */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern68 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 2631 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1445; /* vsx_xvcvuxwdp_be */

        case 1:
          if (!
#line 2640 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1447; /* vsx_xvcvuxwdp_le */

        case 2:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 1;
              return 1570; /* *vsx_extract_si_unsfloat_df */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1600; /* *vsx_ext_SI_ufl_df */

        case 3:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1592; /* *vsx_ext_QI_ufl_df */

        case 4:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1596; /* *vsx_ext_HI_ufl_df */

        case 5:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 2;
              return 1572; /* *vsx_extract_si_unsfloat_sf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1599; /* *vsx_ext_SI_ufl_sf */

        case 6:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1591; /* *vsx_ext_QI_ufl_sf */

        case 7:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1595; /* *vsx_ext_HI_ufl_sf */

        case 8:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          *pnum_clobbers = 2;
          return 1574; /* *vsx_extract_si_unsfloat_if */

        case 9:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            {
              *pnum_clobbers = 2;
              return 1576; /* *vsx_extract_si_unsfloat_kf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1601; /* *vsx_ext_SI_ufl_kf */

        case 10:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1593; /* *vsx_ext_QI_ufl_kf */

        case 11:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1597; /* *vsx_ext_HI_ufl_kf */

        case 12:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            {
              *pnum_clobbers = 2;
              return 1578; /* *vsx_extract_si_unsfloat_tf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1602; /* *vsx_ext_SI_ufl_tf */

        case 13:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1594; /* *vsx_ext_QI_ufl_tf */

        case 14:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1598; /* *vsx_ext_HI_ufl_tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern342 (x3, 
E_SFmode) != 0
              || !
#line 14466 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1053; /* *fmasf4_fpr */

        case E_DFmode:
          if (pattern342 (x3, 
E_DFmode) != 0
              || !
#line 14466 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1054; /* *fmadf4_fpr */

        case E_KFmode:
          if (pattern343 (x3, 
E_KFmode) != 0
              || !(
#line 15155 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1113; /* fmakf4_hw */

        case E_TFmode:
          if (pattern343 (x3, 
E_TFmode) != 0
              || !(
#line 15155 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1114; /* fmatf4_hw */

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && vsx_register_operand (operands[2], E_V4SFmode)
              && vsx_register_operand (operands[3], E_V4SFmode)
              && 
#line 2082 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1373; /* *vsx_fmav4sf4 */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !register_operand (operands[2], E_V4SFmode)
              || !register_operand (operands[3], E_V4SFmode)
              || !
#line 765 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1908; /* *altivec_fmav4sf4 */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !vsx_register_operand (operands[2], E_V2DFmode)
              || !vsx_register_operand (operands[3], E_V2DFmode)
              || !
#line 2094 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1374; /* *vsx_fmav2df4 */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern344 (x3, 
E_SFmode) != 0
              || !
#line 14490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1055; /* *fmssf4_fpr */

        case E_DFmode:
          if (pattern344 (x3, 
E_DFmode) != 0
              || !
#line 14490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1056; /* *fmsdf4_fpr */

        case E_KFmode:
          if (pattern345 (x3, 
E_KFmode) != 0
              || !(
#line 15167 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1115; /* *fmskf4_hw */

        case E_TFmode:
          if (pattern345 (x3, 
E_TFmode) != 0
              || !(
#line 15167 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1116; /* *fmstf4_hw */

        case E_V4SFmode:
          if (pattern346 (x3, 
E_V4SFmode) != 0
              || !
#line 2107 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1375; /* *vsx_fmsv4sf4 */

        case E_V2DFmode:
          if (pattern346 (x3, 
E_V2DFmode) != 0
              || !
#line 2107 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1376; /* *vsx_fmsv2df4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  operands[4] = x8;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x6, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (pattern580 (x7, 
E_SImode) != 0
          || !
#line 3756 "../../gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (SImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)))
        return -1;
      return 209; /* *andsi3_imm_dot_shifted */

    case E_DImode:
      if (pattern580 (x7, 
E_DImode) != 0
          || !(
#line 3756 "../../gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (DImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 210; /* *anddi3_imm_dot_shifted */

    default:
      return -1;
    }
}

 int
recog_158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  switch (GET_CODE (x6))
    {
    case LTU:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x5, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 98)
        return -1;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      x10 = XEXP (x7, 1);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x6, 1);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern570 (x1, 
E_SImode) != 0
              || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 78; /* addsi3_carry */

        case E_DImode:
          if (pattern570 (x1, 
E_DImode) != 0
              || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 79; /* adddi3_carry */

        default:
          return -1;
        }

    case GEU:
      switch (pattern444 (x1))
        {
        case 0:
          if (!(
#line 2010 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 80; /* *addsi3_imm_carry_pos */

        case 1:
          if (!(
#line 2010 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 81; /* *adddi3_imm_carry_pos */

        default:
          return -1;
        }

    case GTU:
      switch (pattern444 (x1))
        {
        case 0:
          if (!(
#line 2042 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) < 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == -1) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 86; /* *addsi3_imm_carry_neg */

        case 1:
          if (!(
#line 2042 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) < 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == -1) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 87; /* *adddi3_imm_carry_neg */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x6, 0) != 0L)
        return -1;
      x8 = XEXP (x5, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_BLKmode)
        return -1;
      x12 = XEXP (x8, 0);
      if (GET_CODE (x12) != SCRATCH
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_cint_operand (operands[2], E_SImode)
          || !
#line 14088 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
        return -1;
      return 1018; /* stack_restore_tie */

    default:
      return -1;
    }
}

 int
recog_167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  x10 = XEXP (x5, 0);
  operands[0] = x10;
  x11 = XEXP (x6, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x6, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[3], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern576 (x6, 
E_SImode) != 0
              || !(
#line 10241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 702; /* *movdi_update1 */

        case E_DImode:
          if (pattern576 (x6, 
E_DImode) != 0
              || !(
#line 10241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 703; /* *movdi_update1 */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern554 (x1, 
E_SImode))
        {
        case 0:
          if (!(
#line 10291 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 707; /* *movsi_update1 */

        case 1:
          if (!(
#line 10291 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 708; /* *movsi_update1 */

        default:
          return -1;
        }

    case E_HImode:
      switch (pattern554 (x1, 
E_HImode))
        {
        case 0:
          if (!(
#line 10355 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], SImode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 714; /* *movhi_update1 */

        case 1:
          if (!(
#line 10355 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], SImode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 715; /* *movhi_update1 */

        default:
          return -1;
        }

    case E_QImode:
      switch (pattern554 (x1, 
E_QImode))
        {
        case 0:
          if (!(
#line 10422 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 726; /* *movqi_update1 */

        case 1:
          if (!(
#line 10422 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 727; /* *movqi_update1 */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern554 (x1, 
E_SFmode))
        {
        case 0:
          if ((
#line 10471 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return 734; /* *movsf_update1 */
          if (!(
#line 10505 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 742; /* *movsf_update3 */

        case 1:
          if ((
#line 10471 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return 735; /* *movsf_update1 */
          if (!(
#line 10505 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 743; /* *movsf_update3 */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern554 (x1, 
E_DFmode))
        {
        case 0:
          if (!(
#line 10471 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 736; /* *movdf_update1 */

        case 1:
          if (!(
#line 10471 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 737; /* *movdf_update1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          switch (pattern410 (x5))
            {
            case 0:
              if (!
#line 1519 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2659; /* *fuse_and_xor */

            case 1:
              if (!(
#line 1519 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2660; /* *fuse_and_xor */

            case 2:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3259; /* *fuse_vand_vxor */

            case 3:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3260; /* *fuse_vand_vxor */

            case 4:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3261; /* *fuse_vand_vxor */

            case 5:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3262; /* *fuse_vand_vxor */

            case 6:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3263; /* *fuse_vand_vxor */

            case 7:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3264; /* *fuse_vand_vxor */

            case 8:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3265; /* *fuse_vand_vxor */

            case 9:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3266; /* *fuse_vand_vxor */

            case 10:
              if (!(
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3267; /* *fuse_vand_vxor */

            case 11:
              if (!(
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3268; /* *fuse_vand_vxor */

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern238 (x5, 
E_SImode) != 0
                      || !
#line 1537 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2661; /* *fuse_andc_xor */

                case E_DImode:
                  if (pattern238 (x5, 
E_DImode) != 0
                      || !(
#line 1537 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2662; /* *fuse_andc_xor */

                case E_V4SImode:
                  if (pattern239 (x5, 
E_V4SImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3269; /* *fuse_vandc_vxor */

                case E_V8HImode:
                  if (pattern239 (x5, 
E_V8HImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3270; /* *fuse_vandc_vxor */

                case E_V16QImode:
                  if (pattern239 (x5, 
E_V16QImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3271; /* *fuse_vandc_vxor */

                case E_V4SFmode:
                  if (pattern239 (x5, 
E_V4SFmode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3272; /* *fuse_vandc_vxor */

                case E_V2DFmode:
                  if (pattern239 (x5, 
E_V2DFmode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3273; /* *fuse_vandc_vxor */

                case E_V2DImode:
                  if (pattern239 (x5, 
E_V2DImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3274; /* *fuse_vandc_vxor */

                case E_V1TImode:
                  if (pattern239 (x5, 
E_V1TImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3275; /* *fuse_vandc_vxor */

                case E_TImode:
                  if (pattern239 (x5, 
E_TImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3276; /* *fuse_vandc_vxor */

                case E_KFmode:
                  if (pattern239 (x5, 
E_KFmode) != 0
                      || !(
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3277; /* *fuse_vandc_vxor */

                case E_TFmode:
                  if (pattern239 (x5, 
E_TFmode) != 0
                      || !(
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3278; /* *fuse_vandc_vxor */

                default:
                  return -1;
                }

            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern193 (x5, 
E_SImode) != 0
                      || !
#line 1591 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2667; /* *fuse_nor_xor */

                case E_DImode:
                  if (pattern193 (x5, 
E_DImode) != 0
                      || !(
#line 1591 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2668; /* *fuse_nor_xor */

                case E_V4SImode:
                  if (pattern243 (x5, 
E_V4SImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3299; /* *fuse_vnor_vxor */

                case E_V8HImode:
                  if (pattern243 (x5, 
E_V8HImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3300; /* *fuse_vnor_vxor */

                case E_V16QImode:
                  if (pattern243 (x5, 
E_V16QImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3301; /* *fuse_vnor_vxor */

                case E_V4SFmode:
                  if (pattern243 (x5, 
E_V4SFmode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3302; /* *fuse_vnor_vxor */

                case E_V2DFmode:
                  if (pattern243 (x5, 
E_V2DFmode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3303; /* *fuse_vnor_vxor */

                case E_V2DImode:
                  if (pattern243 (x5, 
E_V2DImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3304; /* *fuse_vnor_vxor */

                case E_V1TImode:
                  if (pattern243 (x5, 
E_V1TImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3305; /* *fuse_vnor_vxor */

                case E_TImode:
                  if (pattern243 (x5, 
E_TImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3306; /* *fuse_vnor_vxor */

                case E_KFmode:
                  if (pattern243 (x5, 
E_KFmode) != 0
                      || !(
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3307; /* *fuse_vnor_vxor */

                case E_TFmode:
                  if (pattern243 (x5, 
E_TFmode) != 0
                      || !(
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3308; /* *fuse_vnor_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != XOR)
        return -1;
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x13 = XEXP (x9, 1);
      operands[1] = x13;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern527 (x5, 
E_SImode) != 0
              || !
#line 1555 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2663; /* *fuse_eqv_xor */

        case E_DImode:
          if (pattern527 (x5, 
E_DImode) != 0
              || !(
#line 1555 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2664; /* *fuse_eqv_xor */

        case E_V4SImode:
          if (pattern528 (x5, 
E_V4SImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3279; /* *fuse_veqv_vxor */

        case E_V8HImode:
          if (pattern528 (x5, 
E_V8HImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3280; /* *fuse_veqv_vxor */

        case E_V16QImode:
          if (pattern528 (x5, 
E_V16QImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3281; /* *fuse_veqv_vxor */

        case E_V4SFmode:
          if (pattern528 (x5, 
E_V4SFmode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3282; /* *fuse_veqv_vxor */

        case E_V2DFmode:
          if (pattern528 (x5, 
E_V2DFmode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3283; /* *fuse_veqv_vxor */

        case E_V2DImode:
          if (pattern528 (x5, 
E_V2DImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3284; /* *fuse_veqv_vxor */

        case E_V1TImode:
          if (pattern528 (x5, 
E_V1TImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3285; /* *fuse_veqv_vxor */

        case E_TImode:
          if (pattern528 (x5, 
E_TImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3286; /* *fuse_veqv_vxor */

        case E_KFmode:
          if (pattern528 (x5, 
E_KFmode) != 0
              || !(
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3287; /* *fuse_veqv_vxor */

        case E_TFmode:
          if (pattern528 (x5, 
E_TFmode) != 0
              || !(
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3288; /* *fuse_veqv_vxor */

        default:
          return -1;
        }

    case IOR:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern193 (x5, 
E_SImode) != 0
                      || !
#line 1573 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2665; /* *fuse_nand_xor */

                case E_DImode:
                  if (pattern193 (x5, 
E_DImode) != 0
                      || !(
#line 1573 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2666; /* *fuse_nand_xor */

                case E_V4SImode:
                  if (pattern243 (x5, 
E_V4SImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3289; /* *fuse_vnand_vxor */

                case E_V8HImode:
                  if (pattern243 (x5, 
E_V8HImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3290; /* *fuse_vnand_vxor */

                case E_V16QImode:
                  if (pattern243 (x5, 
E_V16QImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3291; /* *fuse_vnand_vxor */

                case E_V4SFmode:
                  if (pattern243 (x5, 
E_V4SFmode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3292; /* *fuse_vnand_vxor */

                case E_V2DFmode:
                  if (pattern243 (x5, 
E_V2DFmode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3293; /* *fuse_vnand_vxor */

                case E_V2DImode:
                  if (pattern243 (x5, 
E_V2DImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3294; /* *fuse_vnand_vxor */

                case E_V1TImode:
                  if (pattern243 (x5, 
E_V1TImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3295; /* *fuse_vnand_vxor */

                case E_TImode:
                  if (pattern243 (x5, 
E_TImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3296; /* *fuse_vnand_vxor */

                case E_KFmode:
                  if (pattern243 (x5, 
E_KFmode) != 0
                      || !(
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3297; /* *fuse_vnand_vxor */

                case E_TFmode:
                  if (pattern243 (x5, 
E_TFmode) != 0
                      || !(
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3298; /* *fuse_vnand_vxor */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern238 (x5, 
E_SImode) != 0
                      || !
#line 1627 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2671; /* *fuse_orc_xor */

                case E_DImode:
                  if (pattern238 (x5, 
E_DImode) != 0
                      || !(
#line 1627 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2672; /* *fuse_orc_xor */

                case E_V4SImode:
                  if (pattern239 (x5, 
E_V4SImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3319; /* *fuse_vorc_vxor */

                case E_V8HImode:
                  if (pattern239 (x5, 
E_V8HImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3320; /* *fuse_vorc_vxor */

                case E_V16QImode:
                  if (pattern239 (x5, 
E_V16QImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3321; /* *fuse_vorc_vxor */

                case E_V4SFmode:
                  if (pattern239 (x5, 
E_V4SFmode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3322; /* *fuse_vorc_vxor */

                case E_V2DFmode:
                  if (pattern239 (x5, 
E_V2DFmode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3323; /* *fuse_vorc_vxor */

                case E_V2DImode:
                  if (pattern239 (x5, 
E_V2DImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3324; /* *fuse_vorc_vxor */

                case E_V1TImode:
                  if (pattern239 (x5, 
E_V1TImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3325; /* *fuse_vorc_vxor */

                case E_TImode:
                  if (pattern239 (x5, 
E_TImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3326; /* *fuse_vorc_vxor */

                case E_KFmode:
                  if (pattern239 (x5, 
E_KFmode) != 0
                      || !(
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3327; /* *fuse_vorc_vxor */

                case E_TFmode:
                  if (pattern239 (x5, 
E_TFmode) != 0
                      || !(
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3328; /* *fuse_vorc_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern410 (x5))
            {
            case 0:
              if (!
#line 1609 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2669; /* *fuse_or_xor */

            case 1:
              if (!(
#line 1609 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2670; /* *fuse_or_xor */

            case 2:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3309; /* *fuse_vor_vxor */

            case 3:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3310; /* *fuse_vor_vxor */

            case 4:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3311; /* *fuse_vor_vxor */

            case 5:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3312; /* *fuse_vor_vxor */

            case 6:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3313; /* *fuse_vor_vxor */

            case 7:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3314; /* *fuse_vor_vxor */

            case 8:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3315; /* *fuse_vor_vxor */

            case 9:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3316; /* *fuse_vor_vxor */

            case 10:
              if (!(
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3317; /* *fuse_vor_vxor */

            case 11:
              if (!(
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3318; /* *fuse_vor_vxor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      switch (pattern410 (x5))
        {
        case 0:
          if (!
#line 1645 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2673; /* *fuse_xor_xor */

        case 1:
          if (!(
#line 1645 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2674; /* *fuse_xor_xor */

        case 2:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3329; /* *fuse_vxor_vxor */

        case 3:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3330; /* *fuse_vxor_vxor */

        case 4:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3331; /* *fuse_vxor_vxor */

        case 5:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3332; /* *fuse_vxor_vxor */

        case 6:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3333; /* *fuse_vxor_vxor */

        case 7:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3334; /* *fuse_vxor_vxor */

        case 8:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3335; /* *fuse_vxor_vxor */

        case 9:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3336; /* *fuse_vxor_vxor */

        case 10:
          if (!(
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3337; /* *fuse_vxor_vxor */

        case 11:
          if (!(
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3338; /* *fuse_vxor_vxor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 74; /* *addsi3_imm_dot */

        case 1:
          if (!(
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 75; /* *adddi3_imm_dot */

        case 2:
          if (!
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 76; /* *addsi3_imm_dot2 */

        case 3:
          if (!(
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 77; /* *adddi3_imm_dot2 */

        case 4:
          if (!(
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 110; /* subfsi3_carry_dot2 */

        case 5:
          if (!(
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 111; /* subfdi3_carry_dot2 */

        case 6:
          if (!
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 194; /* *divsi3_sra_dot */

        case 7:
          if (!(
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 195; /* *divdi3_sra_dot */

        case 8:
          if (!
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 196; /* *divsi3_sra_dot2 */

        case 9:
          if (!(
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 197; /* *divdi3_sra_dot2 */

        case 10:
          if (!
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
            return -1;
          return 201; /* *andsi3_imm_dot */

        case 11:
          if (!(
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 202; /* *anddi3_imm_dot */

        case 12:
          if (!
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
            return -1;
          return 203; /* *andsi3_imm_dot2 */

        case 13:
          if (!(
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 204; /* *anddi3_imm_dot2 */

        case 14:
          if (!
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 302; /* *ashrsi3_dot */

        case 15:
          if (!(
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 303; /* *ashrdi3_dot */

        case 16:
          if (!
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 304; /* *ashrsi3_dot2 */

        case 17:
          if (!(
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 305; /* *ashrdi3_dot2 */

        default:
          return -1;
        }

    case BSWAP:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (gpc_reg_operand (operands[1], E_DImode)
          && gpc_reg_operand (operands[0], E_DImode))
        {
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          if (scratch_operand (operands[2], E_DImode))
            {
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (scratch_operand (operands[3], E_DImode)
                  && 
#line 2806 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX && !TARGET_P9_VECTOR))
                return 162; /* bswapdi2_reg */
            }
        }
      if (!reg_or_mem_operand (operands[1], E_DImode)
          || !reg_or_mem_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_DImode)
          || !
#line 2816 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX
   && (REG_P (operands[0]) || REG_P (operands[1]))
   && !(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))
   && !(MEM_P (operands[1]) && MEM_VOLATILE_P (operands[1]))))
        return -1;
      return 163; /* *bswapdi2_64bit */

    case IF_THEN_ELSE:
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 3906 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64))
            return -1;
          return 223; /* *branch_anddi3_dot */

        case 1:
          if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
            return -1;
          return 572; /* *rotate_on_cmpdi */

        case 2:
          if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
            return -1;
          return 573; /* *rotate_on_cmpdi */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 421; /* *floatunsqisf2_internal */

        case 1:
          if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 422; /* *floatunshisf2_internal */

        case 2:
          if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 423; /* *floatunsqidf2_internal */

        case 3:
          if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 424; /* *floatunshidf2_internal */

        case 4:
          if (!
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          return 471; /* *roundu32sf2_fprs */

        case 5:
          if (!
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          return 472; /* *roundu32df2_fprs */

        case 6:
          if (!
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1572; /* *vsx_extract_si_unsfloat_sf */

        case 7:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          return 1574; /* *vsx_extract_si_unsfloat_if */

        case 8:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          return 1576; /* *vsx_extract_si_unsfloat_kf */

        case 9:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            return -1;
          return 1578; /* *vsx_extract_si_unsfloat_tf */

        default:
          return -1;
        }

    case FIX:
      switch (pattern102 (x1))
        {
        case 0:
          if (!
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 427; /* fix_truncsfsi2_internal */

        case 1:
          if (!
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 428; /* fix_truncdfsi2_internal */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern103 (x1))
        {
        case 0:
          if (!
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
            return -1;
          return 469; /* *round32sf2_fprs */

        case 1:
          if (!
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
            return -1;
          return 470; /* *round32df2_fprs */

        case 2:
          if (!
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1571; /* *vsx_extract_si_float_sf */

        case 3:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          return 1573; /* *vsx_extract_si_float_if */

        case 4:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          return 1575; /* *vsx_extract_si_float_kf */

        case 5:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            return -1;
          return 1577; /* *vsx_extract_si_float_tf */

        default:
          return -1;
        }

    case CALL:
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != MEM)
        return -1;
      switch (pattern199 (x1))
        {
        case 0:
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case CLOBBER:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (GET_MODE (x9) != E_SImode)
                    return -1;
                  if (current_file_function_operand (operands[1], E_SImode)
                      && (
#line 11512 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 821; /* *call_value_localsi */
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode))
                    return -1;
                  if ((
#line 11637 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 831; /* *call_value_nonlocal_sysvsi */
                  if (!(
#line 11705 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 837; /* *call_value_nonlocal_aixsi */

                case E_DImode:
                  if (GET_MODE (x9) != E_DImode)
                    return -1;
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11512 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 822; /* *call_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  if ((
#line 11637 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 832; /* *call_value_nonlocal_sysvdi */
                  if (!(
#line 11705 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 838; /* *call_value_nonlocal_aixdi */

                default:
                  return -1;
                }

            case USE:
              if (pnum_clobbers == NULL)
                return -1;
              x9 = XEXP (x5, 0);
              operands[4] = x9;
              if (!register_operand (operands[4], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode)
                      || !(
#line 11662 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 833; /* *call_value_nonlocal_sysv_securesi */

                case E_DImode:
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode)
                      || !(
#line 11662 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 834; /* *call_value_nonlocal_sysv_securedi */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (current_file_function_operand (operands[1], E_SImode)
                      && (
#line 11949 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 853; /* *sibcall_value_localsi */
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !(
#line 12045 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 861; /* *sibcall_value_nonlocal_sysvsi */

                case E_DImode:
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11949 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 854; /* *sibcall_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !(
#line 12045 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 862; /* *sibcall_value_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case CLOBBER:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!indirect_call_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode)
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  if ((
#line 11609 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 829; /* *call_value_indirect_nonlocal_sysvsi */
                  if (!(
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 849; /* *call_value_indirect_pcrelsi */

                case E_DImode:
                  if (!indirect_call_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode)
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  if ((
#line 11609 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 830; /* *call_value_indirect_nonlocal_sysvdi */
                  if (!(
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 850; /* *call_value_indirect_pcreldi */

                default:
                  return -1;
                }

            case SET:
              if (pattern501 (x5, pnum_clobbers) != 0)
                return -1;
              x10 = XEXP (x5, 1);
              x11 = XVECEXP (x10, 0, 0);
              operands[4] = x11;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pattern590 (x5, 
E_SImode) != 0
                      || !(
#line 11806 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 847; /* *call_value_indirect_elfv2si */

                case E_DImode:
                  if (pattern590 (x5, 
E_DImode) != 0
                      || !(
#line 11806 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 848; /* *call_value_indirect_elfv2di */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!indirect_call_operand (operands[1], E_SImode)
                      || !(
#line 12016 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 859; /* *sibcall_value_indirect_nonlocal_sysvsi */

                case E_DImode:
                  if (!indirect_call_operand (operands[1], E_DImode)
                      || !(
#line 12016 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 860; /* *sibcall_value_indirect_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x12 = XVECEXP (x3, 0, 0);
      operands[1] = x12;
      x13 = XVECEXP (x3, 0, 1);
      operands[2] = x13;
      switch (XINT (x3, 1))
        {
        case 35:
          if (GET_MODE (x3) != E_CCEQmode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x14 = XEXP (x4, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !cc_reg_operand (operands[0], E_CCEQmode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[4] = x8;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (pattern573 (
E_SImode) != 0
                  || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 874; /* stack_protect_testsi */

            case E_DImode:
              if (pattern573 (
E_DImode) != 0
                  || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 875; /* stack_protect_testdi */

            default:
              return -1;
            }

        case 145:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          switch (pattern480 (x1))
            {
            case 0:
              if (!
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1503; /* vsx_extract_v2df_var */

            case 1:
              if (!
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1504; /* vsx_extract_v2di_var */

            case 2:
              if (!
#line 3745 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1510; /* vsx_extract_v4sf_var */

            case 3:
              if (!
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1531; /* vsx_extract_v16qi_var */

            case 4:
              if (!
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1532; /* vsx_extract_v8hi_var */

            case 5:
              if (!
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1533; /* vsx_extract_v4si_var */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      switch (pattern105 (x1))
        {
        case 0:
          if (!
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)))
            return -1;
          return 928; /* *eqsi3 */

        case 1:
          if (!(
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 929; /* *eqdi3 */

        case 2:
          if (!(
#line 13220 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 944; /* *eqsi3_extdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[0] = x3;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x15 = XEXP (x8, 0);
      operands[1] = x15;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !(
#line 13656 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 985; /* tablejumpsi_insn_nospec */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !(
#line 13656 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 986; /* tablejumpdi_insn_nospec */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 6
          || GET_MODE (x3) != E_DImode)
        return -1;
      x12 = XVECEXP (x3, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!scratch_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      if (!scratch_operand (operands[2], E_CCmode)
          || !
#line 14589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
        return -1;
      return 1061; /* rs6000_get_timebase_ppc32 */

    case VEC_SELECT:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1522; /* *vsx_extract_v16qi_store_p9 */

        case 1:
          if (!
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1523; /* *vsx_extract_v8hi_store_p9 */

        case 2:
          if (!
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1524; /* *vsx_extract_v4si_store_p9 */

        default:
          return -1;
        }

    case PLUS:
      if (pattern108 (x1) != 0
          || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1638; /* vsx_reduc_plus_v4sf */

    case SMIN:
      if (pattern108 (x1) != 0
          || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1639; /* vsx_reduc_smin_v4sf */

    case SMAX:
      if (pattern108 (x1) != 0
          || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1640; /* vsx_reduc_smax_v4sf */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_SDmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!gpc_reg_operand (operands[0], E_SDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_TDmode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_TDmode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_DFmode)
          || !
#line 165 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      return 2435; /* trunctdsd2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (XINT (x2, 1))
        {
        case 85:
          if (GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode))
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (gpc_reg_operand (operands[1], E_KFmode)
                  && ((
#line 5356 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 5360 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[1], KFmode))))
                return gen_split_153 (insn, operands);
              if (!memory_operand (operands[1], E_KFmode)
                  || !((
#line 5375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 5377 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_155 (insn, operands);

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode)
                  && ((
#line 5356 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 5360 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[1], TFmode))))
                return gen_split_154 (insn, operands);
              if (!memory_operand (operands[1], E_TFmode)
                  || !((
#line 5375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 5377 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_156 (insn, operands);

            default:
              return NULL;
            }

        case 15:
          switch (pattern292 (x2))
            {
            case 0:
              if (!((
#line 10622 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10624 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_394 (insn, operands);

            case 1:
              if (!((
#line 10622 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10624 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_395 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      operands[2] = x4;
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[0], E_SImode)
              || !got_no_const_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !
#line 7707 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
    && flag_pic == 1
    && reload_completed))
            return NULL;
          return gen_split_290 (insn, operands);

        case 14:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern417 (x2, 
E_SImode) != 0
                  || !((
#line 10575 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10577 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_392 (insn, operands);

            case E_DImode:
              if (pattern417 (x2, 
E_DImode) != 0
                  || !((
#line 10575 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10577 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_393 (insn, operands);

            default:
              return NULL;
            }

        case 23:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern220 (x2, 
E_SImode) != 0
                  || !((
#line 10688 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10690 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_396 (insn, operands);

            case E_DImode:
              if (pattern220 (x2, 
E_DImode) != 0
                  || !((
#line 10688 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10690 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_397 (insn, operands);

            default:
              return NULL;
            }

        case 27:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern220 (x2, 
E_SImode) != 0
                  || !((
#line 10768 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10770 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_398 (insn, operands);

            case E_DImode:
              if (pattern220 (x2, 
E_DImode) != 0
                  || !((
#line 10768 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10770 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_399 (insn, operands);

            default:
              return NULL;
            }

        case 70:
          if (GET_MODE (x2) != E_DFmode
              || !nonimmediate_operand (operands[0], E_DFmode))
            return NULL;
          switch (pattern433 ())
            {
            case 0:
              if (((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14883 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_493 (insn, operands);
              if (!((
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14906 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_496 (insn, operands);

            case 1:
              if (((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14883 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_494 (insn, operands);
              if (!((
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14906 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_497 (insn, operands);

            default:
              return NULL;
            }

        case 71:
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern146 (x2, 
E_DFmode, 
E_TFmode) != 0)
                return NULL;
              if (((
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14942 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_499 (insn, operands);
              if (!((
#line 14964 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14966 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_502 (insn, operands);

            case E_IFmode:
              if (pattern146 (x2, 
E_DFmode, 
E_IFmode) != 0
                  || !((
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14942 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_500 (insn, operands);

            case E_TDmode:
              if (pattern146 (x2, 
E_DImode, 
E_TDmode) != 0
                  || !((
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14942 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_501 (insn, operands);

            default:
              return NULL;
            }

        case 138:
          if (pattern360 (x2) != 0
              || !
#line 1730 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_600 (insn, operands);

        case 130:
          if (pattern360 (x2) != 0
              || !
#line 1785 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_601 (insn, operands);

        case 131:
          if (pattern360 (x2) != 0
              || !
#line 1832 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_602 (insn, operands);

        case 361:
          if (GET_MODE (x2) != E_OOmode
              || !vsx_register_operand (operands[0], E_OOmode)
              || !mma_assemble_input_operand (operands[1], E_V16QImode)
              || !mma_assemble_input_operand (operands[2], E_V16QImode)
              || !(
#line 383 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA) && 
#line 385 "../../gcc/config/rs6000/mma.md"
( reload_completed)))
            return NULL;
          return gen_split_740 (insn, operands);

        case 362:
          if (GET_MODE (x2) != E_V16QImode
              || !mma_disassemble_output_operand (operands[0], E_V16QImode))
            return NULL;
          switch (pattern434 ())
            {
            case 0:
              if (!(
#line 415 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && vsx_register_operand (operands[1], OOmode)) && 
#line 418 "../../gcc/config/rs6000/mma.md"
( reload_completed)))
                return NULL;
              return gen_split_741 (insn, operands);

            case 1:
              if (!(
#line 489 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[1], XOmode)) && 
#line 492 "../../gcc/config/rs6000/mma.md"
( reload_completed)))
                return NULL;
              return gen_split_743 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 3:
      if (XINT (x2, 1) != 263)
        return NULL;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (pattern318 (x2))
        {
        case 0:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_722 (insn, operands);

        case 1:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_723 (insn, operands);

        case 2:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_724 (insn, operands);

        case 3:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_725 (insn, operands);

        case 4:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_726 (insn, operands);

        case 5:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_727 (insn, operands);

        case 6:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_728 (insn, operands);

        case 7:
          if (!(
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_729 (insn, operands);

        case 8:
          if (!((
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_730 (insn, operands);

        case 9:
          if (!((
#line 391 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 393 "../../gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_731 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
