/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vfloat_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vfloat_operand (operands[1], i1)
      || !vfloat_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[11]))
    {
    case E_SImode:
      if (!scratch_operand (operands[11], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[11], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 26
      || GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!mma_assemble_input_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!mma_assemble_input_operand (operands[2], E_V16QImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!mma_assemble_input_operand (operands[3], E_V16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!mma_assemble_input_operand (operands[4], E_V16QImode))
    return -1;
  return 0;
}

int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      return pattern44 (x3); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern42 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case NOT:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case NOT:
          return pattern52 (x3); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern58 (x3);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern63 (x3);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern70 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 282
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 109
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern84 (x8, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern84 (x8, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern84 (x8, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!offsettable_mem_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_CCmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern110 (x4, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern110 (x4, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern120 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern120 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 96)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !immediate_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !immediate_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern141 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      if (GET_MODE (x5) != E_V2DFmode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 1L
          || !vfloat_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!vfloat_operand (operands[1], E_V2DFmode))
        return -1;
      x13 = XEXP (x9, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x4, 1);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 102
          || GET_MODE (x5) != E_V4SFmode)
        return -1;
      x15 = XVECEXP (x5, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 3L
          || !vfloat_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x4) != E_V4SFmode)
        return -1;
      x14 = XEXP (x4, 1);
      operands[1] = x14;
      if (!vfloat_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern204 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  return pattern203 (x1, 
i1); /* [-1, 3] */
}

int
pattern211 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!altivec_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern220 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern220 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 356
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x7) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x7) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern253 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 441
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!cc_reg_operand (operands[1], E_CCmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[0] = x7;
  return 0;
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern260 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern260 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern267 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern272 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern272 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern273 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern273 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern273 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern273 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern273 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern273 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern273 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern273 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern273 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern273 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern288 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern288 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern296 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern306 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!memory_operand (operands[0], E_V4SFmode)
          || !immediate_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!memory_operand (operands[0], E_V4SImode)
          || !immediate_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern326 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scc_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !symbol_ref_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !symbol_ref_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern347 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern354 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern359 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !non_add_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern365 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern371 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern41 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern41 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern59 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern59 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern59 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern59 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern59 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern59 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern59 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern59 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern59 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern59 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern402 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern400 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern400 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern401 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern401 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern401 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern401 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern401 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern401 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern401 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern401 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern401 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern401 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern415 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  return 0;
}

int
pattern420 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern428 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern435 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || !register_operand (operands[1], E_V2DImode)
      || !register_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], E_V2DImode))
    return -1;
  return 0;
}

int
pattern439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern33 (x2); /* [-1, 1] */
}

int
pattern446 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern454 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern458 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern473 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern483 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1)
    return -1;
  return 0;
}

int
pattern489 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern502 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[3], i1)
      || !vsx_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern506 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern515 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern523 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern523 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern524 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern524 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern524 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern524 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern524 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern524 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern524 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern524 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern524 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern524 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern546 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern554 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern553 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern553 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern567 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!symbol_ref_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !short_cint_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern581 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern588 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[2], E_SImode)
          || GET_MODE (x9) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[2], E_DImode)
          || GET_MODE (x9) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  x12 = XEXP (x9, 1);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x4, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x5, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern487 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 357; /* *isel_reversed_cc_si */

        case 1:
          if (!
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 359; /* *isel_reversed_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern487 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 358; /* *isel_reversed_cc_di */

        case 1:
          if (!(
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 360; /* *isel_reversed_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  operands[4] = x6;
  x7 = XEXP (x3, 2);
  operands[5] = x7;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern505 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 381; /* *movsfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 383; /* *movsfdfcc_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern505 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 382; /* *movdfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 384; /* *movdfdfcc_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern506 (x3, 
E_KFmode) != 0
              || !(
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 393; /* *movkfcc_p10 */

        case E_TFmode:
          if (pattern506 (x3, 
E_TFmode) != 0
              || !(
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 394; /* *movtfcc_p10 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      if (!all_ones_constant (operands[4], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !zero_constant (operands[5], E_V2DImode))
        return -1;
      if (vsx_register_operand (operands[0], E_V2DImode))
        {
          switch (pattern504 ())
            {
            case 0:
              if (
#line 5732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 389; /* *fpmasksf */
              break;

            case 1:
              if (
#line 5732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 390; /* *fpmaskdf */
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[2], E_KFmode)
              || !altivec_register_operand (operands[3], E_KFmode)
              || !(
#line 5837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 397; /* *fpmaskkf */

        case E_TFmode:
          if (!altivec_register_operand (operands[2], E_TFmode)
              || !altivec_register_operand (operands[3], E_TFmode)
              || !(
#line 5837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 398; /* *fpmasktf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x4;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x10 = XEXP (x5, 0);
      operands[5] = x10;
      x11 = XEXP (x5, 1);
      operands[6] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern560 (x2, 
E_SImode) != 0
              || !
#line 4281 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
            return -1;
          return 256; /* *rotlsi3_insert */

        case E_DImode:
          if (pattern560 (x2, 
E_DImode) != 0
              || !(
#line 4281 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 257; /* *rotldi3_insert */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 1);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              switch (GET_CODE (x10))
                {
                case ASHIFT:
                case ROTATE:
                case LSHIFTRT:
                  operands[4] = x10;
                  operands[5] = x4;
                  operands[6] = x9;
                  x12 = XEXP (x10, 0);
                  operands[1] = x12;
                  x13 = XEXP (x10, 1);
                  operands[2] = x13;
                  if (!const_int_operand (operands[2], E_SImode))
                    return -1;
                  x11 = XEXP (x5, 1);
                  operands[3] = x11;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern574 (x2, 
E_SImode) != 0
                          || !
#line 4299 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
                        return -1;
                      return 258; /* *rotlsi3_insert_2 */

                    case E_DImode:
                      if (pattern574 (x2, 
E_DImode) != 0
                          || !(
#line 4299 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 259; /* *rotldi3_insert_2 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (!gpc_reg_operand (operands[0], E_SImode)
                          || GET_MODE (x2) != E_SImode
                          || GET_MODE (x3) != E_SImode)
                        return -1;
                      operands[1] = x4;
                      if (!gpc_reg_operand (operands[1], E_SImode))
                        return -1;
                      operands[2] = x9;
                      if (!const_int_operand (operands[2], E_SImode)
                          || GET_MODE (x5) != E_SImode)
                        return -1;
                      operands[3] = x10;
                      if (!gpc_reg_operand (operands[3], E_SImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[4] = x11;
                      if (!const_int_operand (operands[4], E_SImode)
                          || !
#line 4375 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)
   && UINTVAL (operands[2]) != 0 && UINTVAL (operands[4]) != 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 267; /* *rotlsi3_insert_5 */

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x2) != E_DImode
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (x4, E_DImode)
                          || !const_int_operand (x9, E_DImode))
                        return -1;
                      operands[2] = x9;
                      operands[1] = x4;
                      if (GET_MODE (x5) == E_DImode)
                        {
                          operands[3] = x10;
                          if (gpc_reg_operand (operands[3], E_DImode))
                            {
                              x11 = XEXP (x5, 1);
                              operands[4] = x11;
                              if (const_int_operand (operands[4], E_DImode)
                                  && 
#line 4389 "../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                                return 268; /* *rotldi3_insert_6 */
                            }
                        }
                      operands[4] = x9;
                      operands[3] = x4;
                      if (GET_MODE (x5) != E_DImode)
                        return -1;
                      operands[1] = x10;
                      if (!gpc_reg_operand (operands[1], E_DImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[2] = x11;
                      if (!const_int_operand (operands[2], E_DImode)
                          || !
#line 4404 "../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 269; /* *rotldi3_insert_7 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern219 (x2))
                {
                case 0:
                  if (!
#line 4313 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
                    return -1;
                  return 260; /* rotlsi3_insert_3 */

                case 1:
                  if (!(
#line 4313 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 261; /* rotldi3_insert_3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (GET_MODE (x5) != E_SImode
                  || !gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              operands[3] = x4;
              if (!gpc_reg_operand (operands[3], E_SImode))
                return -1;
              operands[4] = x9;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x5, 0);
              operands[1] = x10;
              if (!gpc_reg_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 4365 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) + exact_log2 (-UINTVAL (operands[4])) == 32))
                return -1;
              return 266; /* *rotlsi3_insert_4 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              if (GET_CODE (x10) != NOT)
                return -1;
              x6 = XEXP (x1, 0);
              operands[0] = x6;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern488 (x2, 
E_V4SImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V4SImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1888; /* altivec_vselv4si3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V4SImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return -1;
                  return 1898; /* altivec_vselv4si4 */

                case E_V8HImode:
                  if (pattern488 (x2, 
E_V8HImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V8HImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1889; /* altivec_vselv8hi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V8HImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return -1;
                  return 1899; /* altivec_vselv8hi4 */

                case E_V16QImode:
                  if (pattern488 (x2, 
E_V16QImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V16QImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1890; /* altivec_vselv16qi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V16QImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return -1;
                  return 1900; /* altivec_vselv16qi4 */

                case E_V4SFmode:
                  if (pattern488 (x2, 
E_V4SFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V4SFmode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1891; /* altivec_vselv4sf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V4SFmode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return -1;
                  return 1901; /* altivec_vselv4sf4 */

                case E_V2DFmode:
                  if (pattern488 (x2, 
E_V2DFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V2DFmode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1892; /* altivec_vselv2df3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V2DFmode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return -1;
                  return 1902; /* altivec_vselv2df4 */

                case E_V2DImode:
                  if (pattern488 (x2, 
E_V2DImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V2DImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1893; /* altivec_vselv2di3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V2DImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return -1;
                  return 1903; /* altivec_vselv2di4 */

                case E_V1TImode:
                  if (pattern488 (x2, 
E_V1TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V1TImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1894; /* altivec_vselv1ti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V1TImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return -1;
                  return 1904; /* altivec_vselv1ti4 */

                case E_TImode:
                  if (pattern488 (x2, 
E_TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_TImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1895; /* altivec_vselti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_TImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return -1;
                  return 1905; /* altivec_vselti4 */

                case E_KFmode:
                  if (pattern488 (x2, 
E_KFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_KFmode) == 0
                      && (
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1896; /* altivec_vselkf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_KFmode) != 0
                      || !(
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 1906; /* altivec_vselkf4 */

                case E_TFmode:
                  if (pattern488 (x2, 
E_TFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_TFmode) == 0
                      && (
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1897; /* altivec_vseltf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_TFmode) != 0
                      || !(
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 1907; /* altivec_vseltf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              switch (pattern371 (x2))
                {
                case 0:
                  if (!
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2623; /* *fuse_and_or */

                case 1:
                  if (!(
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2624; /* *fuse_and_or */

                case 2:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3099; /* *fuse_vand_vor */

                case 3:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3100; /* *fuse_vand_vor */

                case 4:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3101; /* *fuse_vand_vor */

                case 5:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3102; /* *fuse_vand_vor */

                case 6:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3103; /* *fuse_vand_vor */

                case 7:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3104; /* *fuse_vand_vor */

                case 8:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3105; /* *fuse_vand_vor */

                case 9:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3106; /* *fuse_vand_vor */

                case 10:
                  if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3107; /* *fuse_vand_vor */

                case 11:
                  if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3108; /* *fuse_vand_vor */

                default:
                  return -1;
                }

            case NOT:
              if (pnum_clobbers == NULL)
                return -1;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              operands[0] = x4;
              operands[1] = x9;
              switch (pattern62 (x2))
                {
                case 0:
                  if (!
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2643; /* *fuse_and_orc */

                case 1:
                  if (!(
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2644; /* *fuse_and_orc */

                case 2:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3179; /* *fuse_vand_vorc */

                case 3:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3180; /* *fuse_vand_vorc */

                case 4:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3181; /* *fuse_vand_vorc */

                case 5:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3182; /* *fuse_vand_vorc */

                case 6:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3183; /* *fuse_vand_vorc */

                case 7:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3184; /* *fuse_vand_vorc */

                case 8:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3185; /* *fuse_vand_vorc */

                case 9:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3186; /* *fuse_vand_vorc */

                case 10:
                  if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3187; /* *fuse_vand_vorc */

                case 11:
                  if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3188; /* *fuse_vand_vorc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_19 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1473; /* xxgenpcvm_v16qi_internal */

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1474; /* xxgenpcvm_v8hi_internal */

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !altivec_register_operand (operands[1], E_V4SImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1475; /* xxgenpcvm_v4si_internal */

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !altivec_register_operand (operands[1], E_V2DImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1476; /* xxgenpcvm_v2di_internal */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      if (XWINT (x4, 0) != 0L)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !rs6000_tls_symbol_ref (operands[1], E_SImode)
              || !(
#line 10756 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 780; /* *tls_got_tprel_pcrel_32 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !rs6000_tls_symbol_ref (operands[1], E_DImode)
              || !(
#line 10756 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 781; /* *tls_got_tprel_pcrel_64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern221 (x3))
        {
        case 0:
          if (!(
#line 10768 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 782; /* tls_got_tprel_32 */

        case 1:
          if (!(
#line 10768 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 783; /* tls_got_tprel_64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2481; /* crypto_vpmsumb */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2482; /* crypto_vpmsumh */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2483; /* crypto_vpmsumw */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2484; /* crypto_vpmsumd */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (pattern132 (x3, 
E_V4SFmode) != 0
          || !
#line 5484 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1691; /* xviexpsp */

    case E_V2DFmode:
      if (pattern132 (x3, 
E_V2DFmode) != 0
          || !
#line 5484 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1692; /* xviexpdp */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern381 (x3, 
E_SImode) != 0
          || !
#line 2600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB))
        return -1;
      return 148; /* cmpbsi3 */

    case E_DImode:
      if (pattern381 (x3, 
E_DImode) != 0
          || !(
#line 2600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 149; /* cmpbdi3 */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6851 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 485; /* roundsf2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6851 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 486; /* rounddf2 */

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15477 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1181; /* roundkf2 */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15477 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1182; /* roundtf2 */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1))
    {
    case 0:
      if (!
#line 6830 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 481; /* ceilsf2 */

    case 1:
      if (!
#line 6830 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 482; /* ceildf2 */

    case 2:
      if (!(
#line 15457 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1177; /* ceilkf2 */

    case 3:
      if (!(
#line 15457 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1178; /* ceiltf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2347 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1417; /* vsx_ceilv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2573 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2105; /* altivec_vrfip */

    case 5:
      if (!
#line 2347 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1418; /* vsx_ceilv2df2 */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1191; /* sqrtkf2_odd */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1192; /* sqrttf2_odd */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6776 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
        return -1;
      return 473; /* lrintsfdi2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6776 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
        return -1;
      return 474; /* lrintdfdi2 */

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1565; /* vreplace_un_si */

    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1566; /* vreplace_un_sf */

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1567; /* vreplace_un_di */

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1568; /* vreplace_un_df */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 32:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (pattern292 (x2))
        {
        case 0:
          if (!
#line 2523 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB))
            return -1;
          return 137; /* popcntbsi2 */

        case 1:
          if (!(
#line 2523 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 138; /* popcntbdi2 */

        default:
          return -1;
        }

    case 50:
      return recog_61 (x1, insn, pnum_clobbers);

    case 33:
      return recog_77 (x1, insn, pnum_clobbers);

    case 46:
      return recog_76 (x1, insn, pnum_clobbers);

    case 85:
      return recog_74 (x1, insn, pnum_clobbers);

    case 54:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX))
        return -1;
      return 401; /* lfiwax */

    case 55:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5963 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX))
        return -1;
      return 410; /* lfiwzx */

    case 5:
      switch (pattern155 (x1, 
FIX))
        {
        case 0:
          if (!
#line 6669 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 464; /* fctiwz_sf */

        case 1:
          if (!
#line 6669 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 465; /* fctiwz_df */

        default:
          return -1;
        }

    case 56:
      switch (pattern155 (x1, 
UNSIGNED_FIX))
        {
        case 0:
          if (!
#line 6680 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 466; /* fctiwuz_sf */

        case 1:
          if (!
#line 6680 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 467; /* fctiwuz_df */

        default:
          return -1;
        }

    case 53:
      return recog_94 (x1, insn, pnum_clobbers);

    case 52:
      return recog_93 (x1, insn, pnum_clobbers);

    case 9:
      return recog_62 (x1, insn, pnum_clobbers);

    case 8:
      return recog_72 (x1, insn, pnum_clobbers);

    case 6:
      return recog_71 (x1, insn, pnum_clobbers);

    case 7:
      return recog_68 (x1, insn, pnum_clobbers);

    case 10:
      return recog_84 (x1, insn, pnum_clobbers);

    case 31:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !
#line 6880 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PPC_GFXOPT))
        return -1;
      return 489; /* stfiwx */

    case 87:
      return recog_75 (x1, insn, pnum_clobbers);

    case 86:
      return recog_69 (x1, insn, pnum_clobbers);

    case 97:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 8733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 597; /* xxspltidp_sf_internal */

        case 1:
          if (!
#line 8733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 598; /* xxspltidp_df_internal */

        default:
          return -1;
        }

    case 98:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 8742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 599; /* xxspltiw_sf_internal */

        case 1:
          if (!
#line 8742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 600; /* xxspltiw_df_internal */

        default:
          return -1;
        }

    case 60:
      return recog_88 (x1, insn, pnum_clobbers);

    case 62:
      return recog_73 (x1, insn, pnum_clobbers);

    case 64:
      return recog_63 (x1, insn, pnum_clobbers);

    case 15:
      return recog_87 (x1, insn, pnum_clobbers);

    case 2:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 96
          || GET_MODE (x3) != E_SImode
          || !
#line 11135 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4 && flag_pic == 1 && TARGET_32BIT))
        return -1;
      return 796; /* load_toc_v4_pic_si */

    case 73:
      return recog_83 (x1, insn, pnum_clobbers);

    case 83:
      return recog_82 (x1, insn, pnum_clobbers);

    case 84:
      return recog_92 (x1, insn, pnum_clobbers);

    case 36:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1214; /* *hwsync */

    case 37:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1215; /* *lwsync */

    case 72:
      return recog_86 (x1, insn, pnum_clobbers);

    case 122:
      return recog_81 (x1, insn, pnum_clobbers);

    case 19:
      if (GET_MODE (x2) != E_CCmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!cc_reg_operand (operands[0], E_CCmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2214 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1391; /* *xvtlsbb_internal */

    case 124:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 2308 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1404; /* vsx_xsrdpi */

        case 1:
          if (!
#line 2308 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1405; /* vsx_xvrspi */

        case 2:
          if (!
#line 2308 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1406; /* vsx_xvrdpi */

        default:
          return -1;
        }

    case 125:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 2316 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1407; /* vsx_xsrdpic */

        case 1:
          if (!
#line 2316 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1408; /* vsx_xvrspic */

        case 2:
          if (!
#line 2316 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1409; /* vsx_xvrdpic */

        default:
          return -1;
        }

    case 107:
      return recog_66 (x1, insn, pnum_clobbers);

    case 108:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2427 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1425; /* vsx_xvcvhpsp */

    case 143:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2436 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1426; /* vsx_xvcvsphp */

    case 110:
      return recog_91 (x1, insn, pnum_clobbers);

    case 109:
      return recog_80 (x1, insn, pnum_clobbers);

    case 105:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2596 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1440; /* vsx_xvcvdpsxws */

    case 106:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2604 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1441; /* vsx_xvcvdpuxws */

    case 113:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2612 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1442; /* vsx_xvcvsxdsp */

    case 114:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2620 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1443; /* vsx_xvcvuxdsp */

    case 111:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2661 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1448; /* vsx_xvcvsxwdp_df */

    case 112:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2669 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1449; /* vsx_xvcvuxwdp_df */

    case 139:
      return recog_67 (x1, insn, pnum_clobbers);

    case 190:
      if (GET_MODE (x2) != E_TImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_TImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_TImode)
          || !
#line 5187 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1658; /* extendditi2_vector */

    case 146:
      return recog_90 (x1, insn, pnum_clobbers);

    case 147:
      return recog_89 (x1, insn, pnum_clobbers);

    case 155:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 5463 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1687; /* xvxexpsp */

        case 1:
          if (!
#line 5463 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1688; /* xvxexpdp */

        default:
          return -1;
        }

    case 156:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 5473 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1689; /* xvxsigsp */

        case 1:
          if (!
#line 5473 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1690; /* xvxsigdp */

        default:
          return -1;
        }

    case 141:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1736; /* vsx_xvcvspbf16 */

    case 140:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1737; /* vsx_xvcvbf16spn */

    case 189:
      return recog_64 (x1, insn, pnum_clobbers);

    case 192:
      return recog_65 (x1, insn, pnum_clobbers);

    case 204:
      return recog_78 (x1, insn, pnum_clobbers);

    case 205:
      if (GET_MODE (x2) != E_V2DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6628 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1777; /* xxspltidp_v2df_inst */

    case 356:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 907 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1920; /* vstrir_direct_v8hi */

        case 1:
          if (!
#line 907 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1921; /* vstrir_direct_v16qi */

        default:
          return -1;
        }

    case 357:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 959 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1924; /* vstril_direct_v8hi */

        case 1:
          if (!
#line 959 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1925; /* vstril_direct_v16qi */

        default:
          return -1;
        }

    case 360:
      return recog_85 (x1, insn, pnum_clobbers);

    case 256:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2581 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2106; /* altivec_vrfin */

    case 261:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2635 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2112; /* altivec_vlogefp */

    case 262:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2643 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2113; /* altivec_vexptefp */

    case 264:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2693 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2126; /* altivec_vupkhsw */

        case 1:
          if (!
#line 2693 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2127; /* altivec_vupkhsh */

        case 2:
          if (!
#line 2693 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2128; /* altivec_vupkhsb */

        default:
          return -1;
        }

    case 266:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2706 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2129; /* altivec_vupkhsw_direct */

        case 1:
          if (!
#line 2706 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2130; /* altivec_vupkhsh_direct */

        case 2:
          if (!
#line 2706 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2131; /* altivec_vupkhsb_direct */

        default:
          return -1;
        }

    case 265:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2714 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2132; /* altivec_vupklsw */

        case 1:
          if (!
#line 2714 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2133; /* altivec_vupklsh */

        case 2:
          if (!
#line 2714 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2134; /* altivec_vupklsb */

        default:
          return -1;
        }

    case 267:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2727 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2135; /* *altivec_vupklsw_direct */

        case 1:
          if (!
#line 2727 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2136; /* *altivec_vupklsh_direct */

        case 2:
          if (!
#line 2727 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2137; /* *altivec_vupklsb_direct */

        default:
          return -1;
        }

    case 268:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2735 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2138; /* altivec_vupkhpx */

    case 269:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2748 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2139; /* altivec_vupklpx */

    case 162:
      switch (pattern162 (x1))
        {
        case 0:
          if (!
#line 3020 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2167; /* altivec_lvsl_reg_si */

        case 1:
          if (!(
#line 3020 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2168; /* altivec_lvsl_reg_di */

        default:
          return -1;
        }

    case 276:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3028 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2169; /* altivec_lvsl_direct */

    case 163:
      switch (pattern162 (x1))
        {
        case 0:
          if (!
#line 3058 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2170; /* altivec_lvsr_reg_si */

        case 1:
          if (!(
#line 3058 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2171; /* altivec_lvsr_reg_di */

        default:
          return -1;
        }

    case 277:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3066 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2172; /* altivec_lvsr_direct */

    case 281:
      return recog_70 (x1, insn, pnum_clobbers);

    case 301:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4247 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2293; /* altivec_lvlx */

    case 302:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4255 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2294; /* altivec_lvlxl */

    case 303:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4263 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2295; /* altivec_lvrx */

    case 304:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4271 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2296; /* altivec_lvrxl */

    case 329:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode)
          || !
#line 4419 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2321; /* p8v_vgbbd */

    case 421:
      if (GET_MODE (x2) != E_XOmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 510 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2362; /* mma_xxmfacc */

    case 422:
      if (GET_MODE (x2) != E_XOmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 510 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2363; /* mma_xxmtacc */

    case 424:
      if (GET_MODE (x2) != E_DDmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_DDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_SDmode)
          || !
#line 41 "../../gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], DDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2423; /* movsd_store */

    case 423:
      if (GET_MODE (x2) != E_SDmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_SDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DDmode)
          || !
#line 51 "../../gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], DDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2424; /* movsd_load */

    case 437:
      return recog_79 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case MULT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[3] = x3;
          if (!gpc_reg_operand (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x6))
            {
            case ASHIFTRT:
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x9 = XEXP (x6, 0);
              if (!gpc_reg_operand (x9, E_SImode))
                return -1;
              switch (GET_CODE (x7))
                {
                case SIGN_EXTEND:
                  operands[2] = x9;
                  x10 = XEXP (x7, 0);
                  operands[1] = x10;
                  if (!gpc_reg_operand (operands[1], E_HImode)
                      || !
#line 1478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 50; /* *nmacchw */

                case ASHIFTRT:
                  x11 = XEXP (x7, 1);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x9;
                  x10 = XEXP (x7, 0);
                  operands[2] = x10;
                  if (!gpc_reg_operand (operands[2], E_SImode)
                      || !
#line 1513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 52; /* *nmachhw */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x7) != SIGN_EXTEND)
                return -1;
              x9 = XEXP (x6, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x10 = XEXP (x7, 0);
              operands[2] = x10;
              if (!gpc_reg_operand (operands[2], E_HImode)
                  || !
#line 1542 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 54; /* *nmaclhw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern209 (x2, 
E_SImode) != 0)
                return -1;
              return 102; /* *subfsi3 */

            case E_DImode:
              if (pattern209 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 103; /* *subfdi3 */

            case E_SFmode:
              if (pattern210 (x2, 
E_SFmode) != 0
                  || !
#line 5079 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 314; /* *subsf3_fpr */

            case E_DFmode:
              if (pattern210 (x2, 
E_DFmode) != 0
                  || !
#line 5079 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 315; /* *subdf3_fpr */

            case E_KFmode:
              if (pattern211 (x2, 
E_KFmode) != 0
                  || !(
#line 15030 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1095; /* subkf3 */

            case E_TFmode:
              if (pattern211 (x2, 
E_TFmode) != 0
                  || !(
#line 15030 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1096; /* subtf3 */

            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              operands[1] = x3;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode))
                {
                  operands[2] = x4;
                  if (vsx_register_operand (operands[2], E_V4SFmode)
                      && 
#line 1710 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                    return 1336; /* *vsx_subv4sf3 */
                }
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode))
                return -1;
              operands[2] = x4;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !
#line 563 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 1835; /* *altivec_subv4sf3 */

            case E_V2DFmode:
              if (!vsx_register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode)
                return -1;
              operands[1] = x3;
              if (!vsx_register_operand (operands[1], E_V2DFmode))
                return -1;
              operands[2] = x4;
              if (!vsx_register_operand (operands[2], E_V2DFmode)
                  || !
#line 1710 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1337; /* *vsx_subv2df3 */

            case E_V4SImode:
              if (pattern212 (x2, 
E_V4SImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 1831; /* subv4si3 */

            case E_V8HImode:
              if (pattern212 (x2, 
E_V8HImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 1832; /* subv8hi3 */

            case E_V16QImode:
              if (pattern212 (x2, 
E_V16QImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 1833; /* subv16qi3 */

            case E_V2DImode:
              if (pattern212 (x2, 
E_V2DImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 1834; /* subv2di3 */

            case E_V1TImode:
              if (pattern212 (x2, 
E_V1TImode) != 0
                  || !
#line 4450 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
                return -1;
              return 2324; /* subv1ti3 */

            case E_DDmode:
              if (pattern210 (x2, 
E_DDmode) != 0
                  || !
#line 185 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2438; /* subdd3 */

            case E_TDmode:
              if (pattern210 (x2, 
E_TDmode) != 0
                  || !
#line 185 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2439; /* subtd3 */

            default:
              return -1;
            }

        case EQ:
          switch (pattern40 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 940; /* *minus_eq_si */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 941; /* *minus_eq_di */

            default:
              return -1;
            }

        case NE:
          switch (pattern40 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 942; /* *minus_ne_si */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 943; /* *minus_ne_di */

            default:
              return -1;
            }

        case AND:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              switch (pattern321 (x2))
                {
                case 0:
                  if (!
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2691; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2692; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern323 (x2))
                {
                case 0:
                  if (!
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2695; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2696; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case NOT:
              switch (pattern323 (x2))
                {
                case 0:
                  if (!
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2693; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2694; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern321 (x2))
                {
                case 0:
                  if (!
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2697; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2698; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern324 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 108; /* subfsi3_imm */

        case E_DImode:
          if (pattern324 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 109; /* subfdi3_imm */

        default:
          return -1;
        }

    case UMAX:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != UMIN)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x12 = XEXP (x3, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern419 (x2, 
E_V4SImode) != 0
              || !
#line 4384 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2305; /* uabdv4si3 */

        case E_V8HImode:
          if (pattern419 (x2, 
E_V8HImode) != 0
              || !
#line 4384 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2306; /* uabdv8hi3 */

        case E_V16QImode:
          if (pattern419 (x2, 
E_V16QImode) != 0
              || !
#line 4384 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2307; /* uabdv16qi3 */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2683; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2684; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2687; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2688; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern46 (x1))
        {
        case 0:
          if (!
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2685; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2686; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2689; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2690; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  res = recog_26 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_CODE (x2))
    {
    case NE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers != NULL)
            {
              switch (pattern331 (x2))
                {
                case 0:
                  if (reg_or_short_operand (operands[2], E_SImode)
                      && 
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                    {
                      *pnum_clobbers = 3;
                      return 889; /* nesisi2_isel */
                    }
                  if (scc_eq_operand (operands[2], E_SImode)
                      && (
#line 12993 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 3;
                      return 930; /* *nesi3 */
                    }
                  break;

                case 1:
                  if ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 909; /* nesidi2_isel */
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        case E_DImode:
          if (pnum_clobbers != NULL)
            {
              switch (pattern332 (x2))
                {
                case 0:
                  if (reg_or_short_operand (operands[2], E_SImode)
                      && (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 899; /* nedisi2_isel */
                    }
                  if (scc_eq_operand (operands[2], E_SImode)
                      && (
#line 13248 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 945; /* *nesi3_extdi */
                    }
                  break;

                case 1:
                  if (reg_or_short_operand (operands[2], E_DImode)
                      && (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 919; /* nedidi2_isel */
                    }
                  if (scc_eq_operand (operands[2], E_DImode)
                      && (
#line 12993 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 3;
                      return 931; /* *nedi3 */
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SFmode:
          if (pattern10 (x2, 
E_V4SFmode) == 0
              && 
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return 1238; /* vector_nev4sf */
          break;

        case E_V2DFmode:
          if (pattern10 (x2, 
E_V2DFmode) == 0
              && 
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return 1245; /* vector_nev2df */
          break;

        default:
          break;
        }
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 947; /* *nesi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 951; /* *nedi_cc */

        default:
          return -1;
        }

    case LE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 955; /* *lesi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 961; /* *ledi_cc */

        default:
          return -1;
        }

    case LEU:
      switch (pattern128 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 895; /* leusisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 915; /* leusidi2_isel */

        case 2:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 905; /* leudisi2_isel */

        case 3:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 925; /* leudidi2_isel */

        default:
          return -1;
        }

    case GE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 956; /* *gesi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 962; /* *gedi_cc */

        default:
          return -1;
        }

    case GEU:
      switch (pattern128 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 897; /* geusisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 917; /* geusidi2_isel */

        case 2:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 907; /* geudisi2_isel */

        case 3:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 927; /* geudidi2_isel */

        default:
          return -1;
        }

    case ORDERED:
      switch (pattern12 (x2))
        {
        case 0:
          if (!
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 946; /* *orderedsi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 950; /* *ordereddi_cc */

        case 2:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1253; /* vector_orderedv4sf */

        case 3:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1257; /* vector_orderedv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern403 (x6))
        {
        case 0:
          if (!
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2583; /* *fuse_and_nand */

        case 1:
          if (!(
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2584; /* *fuse_and_nand */

        case 2:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2939; /* *fuse_vand_vnand */

        case 3:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2940; /* *fuse_vand_vnand */

        case 4:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2941; /* *fuse_vand_vnand */

        case 5:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2942; /* *fuse_vand_vnand */

        case 6:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2943; /* *fuse_vand_vnand */

        case 7:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2944; /* *fuse_vand_vnand */

        case 8:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2945; /* *fuse_vand_vnand */

        case 9:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2946; /* *fuse_vand_vnand */

        case 10:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2947; /* *fuse_vand_vnand */

        case 11:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2948; /* *fuse_vand_vnand */

        case 12:
          if (!
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2585; /* *fuse_andc_nand */

        case 13:
          if (!(
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2586; /* *fuse_andc_nand */

        case 14:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2949; /* *fuse_vandc_vnand */

        case 15:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2950; /* *fuse_vandc_vnand */

        case 16:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2951; /* *fuse_vandc_vnand */

        case 17:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2952; /* *fuse_vandc_vnand */

        case 18:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2953; /* *fuse_vandc_vnand */

        case 19:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2954; /* *fuse_vandc_vnand */

        case 20:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2955; /* *fuse_vandc_vnand */

        case 21:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2956; /* *fuse_vandc_vnand */

        case 22:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2957; /* *fuse_vandc_vnand */

        case 23:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2958; /* *fuse_vandc_vnand */

        case 24:
          if (!
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2591; /* *fuse_nor_nand */

        case 25:
          if (!(
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2592; /* *fuse_nor_nand */

        case 26:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2979; /* *fuse_vnor_vnand */

        case 27:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2980; /* *fuse_vnor_vnand */

        case 28:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2981; /* *fuse_vnor_vnand */

        case 29:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2982; /* *fuse_vnor_vnand */

        case 30:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2983; /* *fuse_vnor_vnand */

        case 31:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2984; /* *fuse_vnor_vnand */

        case 32:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2985; /* *fuse_vnor_vnand */

        case 33:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2986; /* *fuse_vnor_vnand */

        case 34:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2987; /* *fuse_vnor_vnand */

        case 35:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2988; /* *fuse_vnor_vnand */

        default:
          return -1;
        }

    case NOT:
      switch (pattern406 (x6))
        {
        case 0:
          if (!
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2587; /* *fuse_eqv_nand */

        case 1:
          if (!(
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2588; /* *fuse_eqv_nand */

        case 2:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2959; /* *fuse_veqv_vnand */

        case 3:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2960; /* *fuse_veqv_vnand */

        case 4:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2961; /* *fuse_veqv_vnand */

        case 5:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2962; /* *fuse_veqv_vnand */

        case 6:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2963; /* *fuse_veqv_vnand */

        case 7:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2964; /* *fuse_veqv_vnand */

        case 8:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2965; /* *fuse_veqv_vnand */

        case 9:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2966; /* *fuse_veqv_vnand */

        case 10:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2967; /* *fuse_veqv_vnand */

        case 11:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2968; /* *fuse_veqv_vnand */

        default:
          return -1;
        }

    case IOR:
      switch (pattern407 (x6))
        {
        case 0:
          if (!
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2589; /* *fuse_nand_nand */

        case 1:
          if (!(
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2590; /* *fuse_nand_nand */

        case 2:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2969; /* *fuse_vnand_vnand */

        case 3:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2970; /* *fuse_vnand_vnand */

        case 4:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2971; /* *fuse_vnand_vnand */

        case 5:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2972; /* *fuse_vnand_vnand */

        case 6:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2973; /* *fuse_vnand_vnand */

        case 7:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2974; /* *fuse_vnand_vnand */

        case 8:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2975; /* *fuse_vnand_vnand */

        case 9:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2976; /* *fuse_vnand_vnand */

        case 10:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2977; /* *fuse_vnand_vnand */

        case 11:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2978; /* *fuse_vnand_vnand */

        case 12:
          if (!
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2595; /* *fuse_orc_nand */

        case 13:
          if (!(
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2596; /* *fuse_orc_nand */

        case 14:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2999; /* *fuse_vorc_vnand */

        case 15:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3000; /* *fuse_vorc_vnand */

        case 16:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3001; /* *fuse_vorc_vnand */

        case 17:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3002; /* *fuse_vorc_vnand */

        case 18:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3003; /* *fuse_vorc_vnand */

        case 19:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3004; /* *fuse_vorc_vnand */

        case 20:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3005; /* *fuse_vorc_vnand */

        case 21:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3006; /* *fuse_vorc_vnand */

        case 22:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3007; /* *fuse_vorc_vnand */

        case 23:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3008; /* *fuse_vorc_vnand */

        case 24:
          if (!
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2593; /* *fuse_or_nand */

        case 25:
          if (!(
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2594; /* *fuse_or_nand */

        case 26:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2989; /* *fuse_vor_vnand */

        case 27:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2990; /* *fuse_vor_vnand */

        case 28:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2991; /* *fuse_vor_vnand */

        case 29:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2992; /* *fuse_vor_vnand */

        case 30:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2993; /* *fuse_vor_vnand */

        case 31:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2994; /* *fuse_vor_vnand */

        case 32:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2995; /* *fuse_vor_vnand */

        case 33:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2996; /* *fuse_vor_vnand */

        case 34:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2997; /* *fuse_vor_vnand */

        case 35:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2998; /* *fuse_vor_vnand */

        default:
          return -1;
        }

    case XOR:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 1);
      operands[1] = x10;
      x11 = XEXP (x6, 1);
      switch (GET_CODE (x11))
        {
        case NOT:
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern393 (x6, 
E_SImode) != 0
                  || !
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2597; /* *fuse_xor_nand */

            case E_DImode:
              if (pattern393 (x6, 
E_DImode) != 0
                  || !(
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2598; /* *fuse_xor_nand */

            case E_V4SImode:
              if (pattern395 (x6, 
E_V4SImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3009; /* *fuse_vxor_vnand */

            case E_V8HImode:
              if (pattern395 (x6, 
E_V8HImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3010; /* *fuse_vxor_vnand */

            case E_V16QImode:
              if (pattern395 (x6, 
E_V16QImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3011; /* *fuse_vxor_vnand */

            case E_V4SFmode:
              if (pattern395 (x6, 
E_V4SFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3012; /* *fuse_vxor_vnand */

            case E_V2DFmode:
              if (pattern395 (x6, 
E_V2DFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3013; /* *fuse_vxor_vnand */

            case E_V2DImode:
              if (pattern395 (x6, 
E_V2DImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3014; /* *fuse_vxor_vnand */

            case E_V1TImode:
              if (pattern395 (x6, 
E_V1TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3015; /* *fuse_vxor_vnand */

            case E_TImode:
              if (pattern395 (x6, 
E_TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3016; /* *fuse_vxor_vnand */

            case E_KFmode:
              if (pattern395 (x6, 
E_KFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3017; /* *fuse_vxor_vnand */

            case E_TFmode:
              if (pattern395 (x6, 
E_TFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3018; /* *fuse_vxor_vnand */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern527 (x6, 
E_SImode) != 0
                  || !
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2627; /* *fuse_eqv_or */

            case E_DImode:
              if (pattern527 (x6, 
E_DImode) != 0
                  || !(
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2628; /* *fuse_eqv_or */

            case E_V4SImode:
              if (pattern528 (x6, 
E_V4SImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3119; /* *fuse_veqv_vor */

            case E_V8HImode:
              if (pattern528 (x6, 
E_V8HImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3120; /* *fuse_veqv_vor */

            case E_V16QImode:
              if (pattern528 (x6, 
E_V16QImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3121; /* *fuse_veqv_vor */

            case E_V4SFmode:
              if (pattern528 (x6, 
E_V4SFmode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3122; /* *fuse_veqv_vor */

            case E_V2DFmode:
              if (pattern528 (x6, 
E_V2DFmode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3123; /* *fuse_veqv_vor */

            case E_V2DImode:
              if (pattern528 (x6, 
E_V2DImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3124; /* *fuse_veqv_vor */

            case E_V1TImode:
              if (pattern528 (x6, 
E_V1TImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3125; /* *fuse_veqv_vor */

            case E_TImode:
              if (pattern528 (x6, 
E_TImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3126; /* *fuse_veqv_vor */

            case E_KFmode:
              if (pattern528 (x6, 
E_KFmode) != 0
                  || !(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3127; /* *fuse_veqv_vor */

            case E_TFmode:
              if (pattern528 (x6, 
E_TFmode) != 0
                  || !(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3128; /* *fuse_veqv_vor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2599; /* *fuse_add_nand */

        case 1:
          if (!(
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2600; /* *fuse_add_nand */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2601; /* *fuse_subf_nand */

        case 1:
          if (!(
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2602; /* *fuse_subf_nand */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern519 (x1, 
E_SImode) != 0)
                    return -1;
                  return 108; /* subfsi3_imm */

                case E_DImode:
                  if (pattern519 (x1, 
E_DImode) != 0
                      || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 109; /* subfdi3_imm */

                default:
                  return -1;
                }

            case SET:
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != LEU)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98)
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x9, 1);
              if (!rtx_equal_p (x11, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern564 (x1, 
E_SImode) != 0
                      || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 112; /* subfsi3_carry */

                case E_DImode:
                  if (pattern564 (x1, 
E_DImode) != 0
                      || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 113; /* subfdi3_carry */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              switch (pattern472 (x3))
                {
                case 0:
                  if (!
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2691; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2692; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern474 (x3))
                {
                case 0:
                  if (!
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2695; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2696; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case NOT:
              switch (pattern474 (x3))
                {
                case 0:
                  if (!
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2693; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2694; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern472 (x3))
                {
                case 0:
                  if (!
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2697; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2698; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2683; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2684; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2687; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2688; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern196 (x1))
        {
        case 0:
          if (!
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2685; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2686; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2689; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2690; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  if (pnum_clobbers != NULL)
    {
      switch (pattern199 (x1))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (current_file_function_operand (operands[1], E_SImode)
                  && (
#line 11512 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                {
                  *pnum_clobbers = 1;
                  return 821; /* *call_value_localsi */
                }
              if (symbol_ref_operand (operands[1], E_SImode)
                  && unspec_tls (operands[2], E_SImode))
                {
                  if ((
#line 11637 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 831; /* *call_value_nonlocal_sysvsi */
                    }
                  if ((
#line 11705 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 837; /* *call_value_nonlocal_aixsi */
                    }
                }
              break;

            case E_DImode:
              if (current_file_function_operand (operands[1], E_DImode)
                  && (
#line 11512 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 822; /* *call_value_localdi */
                }
              if (symbol_ref_operand (operands[1], E_DImode)
                  && unspec_tls (operands[2], E_DImode))
                {
                  if ((
#line 11637 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 832; /* *call_value_nonlocal_sysvdi */
                    }
                  if ((
#line 11705 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 838; /* *call_value_nonlocal_aixdi */
                    }
                }
              break;

            default:
              break;
            }
          break;

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (indirect_call_operand (operands[1], E_SImode)
                  && unspec_tls (operands[2], E_SImode))
                {
                  if ((
#line 11609 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 829; /* *call_value_indirect_nonlocal_sysvsi */
                    }
                  if ((
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 849; /* *call_value_indirect_pcrelsi */
                    }
                }
              break;

            case E_DImode:
              if (indirect_call_operand (operands[1], E_DImode)
                  && unspec_tls (operands[2], E_DImode))
                {
                  if ((
#line 11609 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 830; /* *call_value_indirect_nonlocal_sysvdi */
                    }
                  if ((
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 850; /* *call_value_indirect_pcreldi */
                    }
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SIMPLE_RETURN)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!call_operand (operands[1], E_SImode)
          || !(
#line 12080 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 865; /* *sibcall_value_aixsi */

    case E_DImode:
      if (!call_operand (operands[1], E_DImode)
          || !(
#line 12080 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 866; /* *sibcall_value_aixdi */

    default:
      return -1;
    }
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case FLOAT:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern305 (x1))
            {
            case 0:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 417; /* *floatqisf2_internal */

            case 1:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 418; /* *floathisf2_internal */

            case 2:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 419; /* *floatqidf2_internal */

            case 3:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 420; /* *floathidf2_internal */

            default:
              return -1;
            }

        case CALL:
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != MEM)
            return -1;
          switch (pattern199 (x1))
            {
            case 0:
              if (pattern483 (x1, 
96, 
USE) != 0)
                return -1;
              x5 = XVECEXP (x1, 0, 2);
              x8 = XEXP (x5, 0);
              operands[4] = x8;
              if (!register_operand (operands[4], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode))
                    return -1;
                  x6 = XVECEXP (x1, 0, 3);
                  x9 = XEXP (x6, 0);
                  if (GET_MODE (x9) != E_SImode
                      || !(
#line 11662 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 833; /* *call_value_nonlocal_sysv_securesi */

                case E_DImode:
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  x6 = XVECEXP (x1, 0, 3);
                  x9 = XEXP (x6, 0);
                  if (GET_MODE (x9) != E_DImode
                      || !(
#line 11662 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 834; /* *call_value_nonlocal_sysv_securedi */

                default:
                  return -1;
                }

            case 1:
              switch (pattern484 (x1, pnum_clobbers))
                {
                case 0:
                  x5 = XVECEXP (x1, 0, 2);
                  x8 = XEXP (x5, 0);
                  operands[4] = x8;
                  x6 = XVECEXP (x1, 0, 3);
                  x10 = XEXP (x6, 1);
                  x11 = XVECEXP (x10, 0, 0);
                  operands[5] = x11;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SImode:
                      if (pattern596 (x6, 
E_SImode) != 0
                          || !(
#line 11749 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 841; /* *call_value_indirect_aixsi */

                    case E_DImode:
                      if (pattern596 (x6, 
E_DImode) != 0
                          || !(
#line 11749 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 842; /* *call_value_indirect_aixdi */

                    default:
                      return -1;
                    }

                case 1:
                  x5 = XVECEXP (x1, 0, 2);
                  x12 = XEXP (x5, 1);
                  x13 = XVECEXP (x12, 0, 0);
                  operands[4] = x13;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SImode:
                      if (pattern597 (x1, 
E_SImode) != 0
                          || !(
#line 11806 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        return -1;
                      return 847; /* *call_value_indirect_elfv2si */

                    case E_DImode:
                      if (pattern597 (x1, 
E_DImode) != 0
                          || !(
#line 11806 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return -1;
                      return 848; /* *call_value_indirect_elfv2di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 888; /* eqsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 908; /* eqsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 898; /* eqdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 918; /* eqdidi2_isel */

            default:
              return -1;
            }

        case NE:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          x16 = XEXP (x4, 0);
          operands[3] = x16;
          x8 = XEXP (x5, 0);
          operands[4] = x8;
          x9 = XEXP (x6, 0);
          operands[5] = x9;
          switch (pattern529 (x3))
            {
            case 0:
              if (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return 889; /* nesisi2_isel */
              break;

            case 1:
              if ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 909; /* nesidi2_isel */
              break;

            case 2:
              if (reg_or_short_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && scratch_operand (operands[5], E_CCmode)
                  && (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 899; /* nedisi2_isel */
              if (scc_eq_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_SImode)
                  && scratch_operand (operands[4], E_SImode)
                  && scratch_operand (operands[5], E_DImode)
                  && (
#line 13248 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 945; /* *nesi3_extdi */
              break;

            case 3:
              if ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 919; /* nedidi2_isel */
              break;

            default:
              break;
            }
          if (GET_CODE (x9) != REG)
            return -1;
          switch (pattern531 (x1))
            {
            case 0:
              if (!(
#line 12993 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 930; /* *nesi3 */

            case 1:
              if (!(
#line 12993 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 931; /* *nedi3 */

            default:
              return -1;
            }

        case LT:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 890; /* ltsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 910; /* ltsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 900; /* ltdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 920; /* ltdidi2_isel */

            default:
              return -1;
            }

        case LTU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 891; /* ltusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 911; /* ltusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 901; /* ltudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 921; /* ltudidi2_isel */

            default:
              return -1;
            }

        case GT:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 892; /* gtsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 912; /* gtsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 902; /* gtdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 922; /* gtdidi2_isel */

            default:
              return -1;
            }

        case GTU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 893; /* gtusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 913; /* gtusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 903; /* gtudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 923; /* gtudidi2_isel */

            default:
              return -1;
            }

        case LE:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 894; /* lesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 914; /* lesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 904; /* ledisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 924; /* ledidi2_isel */

            default:
              return -1;
            }

        case LEU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 895; /* leusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 915; /* leusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 905; /* leudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 925; /* leudidi2_isel */

            default:
              return -1;
            }

        case GE:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 896; /* gesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 916; /* gesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 906; /* gedisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 926; /* gedidi2_isel */

            default:
              return -1;
            }

        case GEU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 897; /* geusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 917; /* geusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 907; /* geudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 927; /* geudidi2_isel */

            default:
              return -1;
            }

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern308 (x1))
            {
            case 0:
              if (!(
#line 13026 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 932; /* *neg_eq_si */

            case 1:
              if (!(
#line 13026 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 933; /* *neg_eq_di */

            case 2:
              if (!(
#line 13058 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 934; /* *neg_ne_si */

            case 3:
              if (!(
#line 13058 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 935; /* *neg_ne_di */

            default:
              return -1;
            }

        case PLUS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern311 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 936; /* *plus_eq_si */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 937; /* *plus_eq_di */

            case 2:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 938; /* *plus_ne_si */

            case 3:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 939; /* *plus_ne_di */

            default:
              return -1;
            }

        case MINUS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern314 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 940; /* *minus_eq_si */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 941; /* *minus_eq_di */

            case 2:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 942; /* *minus_ne_si */

            case 3:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 943; /* *minus_ne_di */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          if (pattern116 (x1) != 0)
            return -1;
          x15 = XEXP (x3, 1);
          x17 = XEXP (x15, 0);
          operands[0] = x17;
          x4 = XVECEXP (x1, 0, 1);
          x16 = XEXP (x4, 0);
          operands[2] = x16;
          x5 = XVECEXP (x1, 0, 2);
          x8 = XEXP (x5, 0);
          operands[3] = x8;
          if (!scratch_operand (operands[3], E_CCmode))
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case EQ:
              switch (pattern578 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 990; /* bdz_si */

                case 1:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 992; /* bdz_di */

                default:
                  return -1;
                }

            case NE:
              switch (pattern578 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 991; /* bdnz_si */

                case 1:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 993; /* bdnz_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          x15 = XEXP (x3, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x18 = XVECEXP (x15, 0, 0);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern482 (x1))
            {
            case 0:
              if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1644; /* *vsx_reduc_plus_v4sf_scalar */

            case 1:
              if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1645; /* *vsx_reduc_smin_v4sf_scalar */

            case 2:
              if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1646; /* *vsx_reduc_smax_v4sf_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x14 = XEXP (x2, 0);
      if (GET_CODE (x14) != MEM)
        return -1;
      switch (pattern117 (x1))
        {
        case 0:
          if (pattern483 (x1, 
96, 
USE) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x8 = XEXP (x5, 0);
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!symbol_ref_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              x9 = XEXP (x6, 0);
              if (GET_MODE (x9) != E_SImode
                  || !(
#line 11588 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 827; /* *call_nonlocal_sysv_securesi */

            case E_DImode:
              if (!symbol_ref_operand (operands[0], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              x9 = XEXP (x6, 0);
              if (GET_MODE (x9) != E_DImode
                  || !(
#line 11588 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 828; /* *call_nonlocal_sysv_securedi */

            default:
              return -1;
            }

        case 1:
          switch (pattern484 (x1, pnum_clobbers))
            {
            case 0:
              x5 = XVECEXP (x1, 0, 2);
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              x6 = XVECEXP (x1, 0, 3);
              x10 = XEXP (x6, 1);
              x11 = XVECEXP (x10, 0, 0);
              operands[4] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern591 (x6, 
E_SImode) != 0
                      || !(
#line 11728 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 839; /* *call_indirect_aixsi */

                case E_DImode:
                  if (pattern591 (x6, 
E_DImode) != 0
                      || !(
#line 11728 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 840; /* *call_indirect_aixdi */

                default:
                  return -1;
                }

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              x12 = XEXP (x5, 1);
              x13 = XVECEXP (x12, 0, 0);
              operands[3] = x13;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern592 (x1, 
E_SImode) != 0
                      || !(
#line 11770 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 843; /* *call_indirect_elfv2si */

                case E_DImode:
                  if (pattern592 (x1, 
E_DImode) != 0
                      || !(
#line 11770 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 844; /* *call_indirect_elfv2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_7 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case COMPARE:
              switch (pattern96 (x1))
                {
                case 0:
                  if (!(
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1923 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_29 (insn, operands);

                case 1:
                  if (!((
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1923 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_30 (insn, operands);

                case 2:
                  if (!(
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1948 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_31 (insn, operands);

                case 3:
                  if (!((
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1948 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_32 (insn, operands);

                case 4:
                  if (!((
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 2279 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_43 (insn, operands);

                case 5:
                  if (!((
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 2279 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_44 (insn, operands);

                case 6:
                  if (!(
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3398 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_62 (insn, operands);

                case 7:
                  if (!((
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3398 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_63 (insn, operands);

                case 8:
                  if (!(
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3424 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_64 (insn, operands);

                case 9:
                  if (!((
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3424 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_65 (insn, operands);

                case 10:
                  if (!(
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3659 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_66 (insn, operands);

                case 11:
                  if (!((
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3659 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_67 (insn, operands);

                case 12:
                  if (!(
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3686 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_68 (insn, operands);

                case 13:
                  if (!((
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3686 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_69 (insn, operands);

                case 14:
                  if (!(
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4922 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_144 (insn, operands);

                case 15:
                  if (!((
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4922 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_145 (insn, operands);

                case 16:
                  if (!(
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4949 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_146 (insn, operands);

                case 17:
                  if (!((
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4949 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_147 (insn, operands);

                default:
                  return NULL;
                }

            case BSWAP:
              if (GET_MODE (x3) != E_DImode)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!gpc_reg_operand (operands[2], E_DImode))
                return NULL;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!gpc_reg_operand (operands[3], E_DImode))
                return NULL;
              switch (GET_CODE (operands[1]))
                {
                case MEM:
                  if (!indexed_or_indirect_operand (operands[1], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode)
                      || !
#line 2828 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX && reload_completed))
                    return NULL;
                  return gen_split_52 (insn, operands);

                case REG:
                case SUBREG:
                  if (!gpc_reg_operand (operands[1], E_DImode))
                    return NULL;
                  switch (GET_CODE (operands[0]))
                    {
                    case MEM:
                      if (!indexed_or_indirect_operand (operands[0], E_DImode)
                          || !
#line 2891 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX && reload_completed))
                        return NULL;
                      return gen_split_53 (insn, operands);

                    case REG:
                    case SUBREG:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || !
#line 2953 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_P9_VECTOR && reload_completed))
                        return NULL;
                      return gen_split_54 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              switch (pattern97 (x1))
                {
                case 0:
                  if (!(
#line 3906 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64) && 
#line 3909 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_84 (insn, operands);

                case 1:
                  if (!(
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))) && 
#line 7958 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_293 (insn, operands);

                case 2:
                  if (!(
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))) && 
#line 7958 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_294 (insn, operands);

                default:
                  return NULL;
                }

            case UNSIGNED_FLOAT:
              switch (pattern101 (x1))
                {
                case 0:
                  if (!(
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_191 (insn, operands);

                case 1:
                  if (!(
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_192 (insn, operands);

                case 2:
                  if (!(
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_193 (insn, operands);

                case 3:
                  if (!(
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_194 (insn, operands);

                case 4:
                  if (!(
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()) && 
#line 6748 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_223 (insn, operands);

                case 5:
                  if (!(
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()) && 
#line 6748 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_224 (insn, operands);

                case 6:
                  if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_642 (insn, operands);

                case 7:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_644 (insn, operands);

                case 8:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_646 (insn, operands);

                case 9:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_648 (insn, operands);

                default:
                  return NULL;
                }

            case FIX:
              switch (pattern102 (x1))
                {
                case 0:
                  if (!(
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE) && 
#line 6365 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_197 (insn, operands);

                case 1:
                  if (!(
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE) && 
#line 6365 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                default:
                  return NULL;
                }

            case FLOAT:
              switch (pattern103 (x1))
                {
                case 0:
                  if (!(
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()) && 
#line 6715 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_221 (insn, operands);

                case 1:
                  if (!(
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()) && 
#line 6715 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_222 (insn, operands);

                case 2:
                  if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_641 (insn, operands);

                case 3:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_643 (insn, operands);

                case 4:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_645 (insn, operands);

                case 5:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_647 (insn, operands);

                default:
                  return NULL;
                }

            case EQ:
              switch (pattern105 (x1))
                {
                case 0:
                  if (!(
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 12930 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_446 (insn, operands);

                case 1:
                  if (!((
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12930 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_447 (insn, operands);

                case 2:
                  if (!((
#line 13220 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13222 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_462 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC:
              if (XVECLEN (x3, 0) != 2
                  || XINT (x3, 1) != 145)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x10 = XVECEXP (x3, 0, 0);
              operands[1] = x10;
              x11 = XVECEXP (x3, 0, 1);
              operands[2] = x11;
              switch (pattern480 (x1))
                {
                case 0:
                  if (!(
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3660 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_609 (insn, operands);

                case 1:
                  if (!(
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3660 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_610 (insn, operands);

                case 2:
                  if (!(
#line 3745 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3747 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_616 (insn, operands);

                case 3:
                  if (!(
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4187 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_633 (insn, operands);

                case 4:
                  if (!(
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4187 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_634 (insn, operands);

                case 5:
                  if (!(
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4187 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_635 (insn, operands);

                default:
                  return NULL;
                }

            case VEC_SELECT:
              switch (pattern107 (x1))
                {
                case 0:
                  if (!(
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB) && 
#line 4051 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_624 (insn, operands);

                case 1:
                  if (!(
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB) && 
#line 4051 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_625 (insn, operands);

                case 2:
                  if (!(
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB) && 
#line 4051 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_626 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (pattern108 (x1) != 0
                  || !(
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 4951 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_680 (insn, operands);

            case SMIN:
              if (pattern108 (x1) != 0
                  || !(
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 4951 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_681 (insn, operands);

            case SMAX:
              if (pattern108 (x1) != 0
                  || !(
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 4951 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_682 (insn, operands);

            default:
              return NULL;
            }

        case 6:
          if (pattern16 (x1) != 0
              || !(
#line 6081 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFID && TARGET_HARD_FLOAT) && 
#line 6083 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_185 (insn, operands);

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != CLOBBER)
            return NULL;
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != CLOBBER)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case UNSIGNED_FLOAT:
              if (GET_MODE (x3) != E_DFmode)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != USE)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != USE
                  || pattern411 (x1) != 0
                  || !(
#line 6170 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)) && 
#line 6173 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_186 (insn, operands);

            case FIX:
              if (GET_MODE (x3) != E_SImode)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              switch (pattern412 (x1))
                {
                case 0:
                  if (!((
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 9099 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_328 (insn, operands);

                case 1:
                  if (!((
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 9099 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_329 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != AND)
                return NULL;
              x14 = XEXP (x7, 0);
              if (!comparison_operator (x14, E_VOIDmode))
                return NULL;
              operands[1] = x14;
              x15 = XEXP (x14, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x16 = XEXP (x7, 1);
              if (!branch_comparison_operator (x16, E_VOIDmode))
                return NULL;
              operands[3] = x16;
              x17 = XEXP (x16, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x6 = XEXP (x2, 0);
              if (GET_CODE (x6) != PC)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return NULL;
              x18 = XEXP (x4, 1);
              if (GET_CODE (x18) != PLUS)
                return NULL;
              x19 = XEXP (x18, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x20 = XEXP (x14, 0);
              operands[0] = x20;
              x21 = XEXP (x16, 0);
              operands[2] = x21;
              if (!cc_reg_operand (operands[2], E_VOIDmode))
                return NULL;
              x22 = XEXP (x3, 1);
              operands[4] = x22;
              x23 = XEXP (x3, 2);
              operands[5] = x23;
              x8 = XEXP (x4, 0);
              operands[6] = x8;
              x9 = XEXP (x5, 0);
              operands[7] = x9;
              x24 = XEXP (x12, 0);
              operands[8] = x24;
              if (!scratch_operand (operands[8], E_CCmode))
                return NULL;
              x25 = XEXP (x13, 0);
              operands[9] = x25;
              if (!scratch_operand (operands[9], E_CCEQmode))
                return NULL;
              x26 = XEXP (x18, 0);
              if (!rtx_equal_p (x26, operands[0]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern605 (x18, 
E_SImode) != 0
                      || !(
#line 13862 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return NULL;
                  return gen_split_488 (insn, operands);

                case E_DImode:
                  if (pattern605 (x18, 
E_DImode) != 0
                      || !(
#line 13862 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_489 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 4:
          return split_8 (x1, insn);

        case 10:
          switch (pattern18 (x1))
            {
            case 0:
              if (!((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 12726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_402 (insn, operands);

            case 1:
              if (!((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))) && 
#line 12726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_403 (insn, operands);

            case 2:
              if (!((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 12726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_404 (insn, operands);

            case 3:
              if (!((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))) && 
#line 12726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_405 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      return split_18 (x1, insn);

    case EH_RETURN:
      if (!
#line 14331 "../../gcc/config/rs6000/rs6000.md"
(epilogue_completed))
        return NULL;
      return gen_split_492 (insn, operands);

    default:
      return NULL;
    }
}
