/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return 0;

    case VEC_SELECT:
      res = pattern7 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern2 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || pattern37 (x1, 
E_DImode, 
-1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern43 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern43 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern41 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern41 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern59 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern59 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern59 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern59 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern59 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern59 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern59 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern59 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern59 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern59 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!vfloat_operand (operands[1], E_V2DFmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!scratch_operand (operands[2], E_V2DFmode))
    return -1;
  x9 = XEXP (x4, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern87 (x1); /* [-1, 1] */
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case FIX:
      return pattern99 (x1); /* [-1, 1] */

    case VEC_SELECT:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 102
      || GET_MODE (x4) != E_V4SFmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!vfloat_operand (operands[0], E_V4SFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!vfloat_operand (operands[1], E_V4SFmode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  if (!scratch_operand (operands[2], E_V4SFmode))
    return -1;
  x11 = XEXP (x7, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern119 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = PATTERN (peep2_next_insn (1));
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x7, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern118 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern118 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern146 (x3, 
E_V2DImode, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern146 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern146 (x3, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!vsx_register_operand (operands[0], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[2] = x6;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern172 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_1_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern141 (x3, 
E_V1TImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern187 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!non_update_memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern193 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern193 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (operands[1]))
    {
    case SYMBOL_REF:
      return 0;

    case UNSPEC:
    case REG:
      return 1;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], i1))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  operands[2] = x10;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern234 (x4, 
i1); /* [-1, 0] */
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  return pattern236 (x4); /* [-1, 23] */
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 87)
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 441
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  x9 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  operands[1] = x1;
  if (!any_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!gpc_reg_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern267 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern267 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern268 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern268 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern268 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern268 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern268 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern268 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern268 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern268 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern268 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern268 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern287 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !scc_rev_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern293 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern299 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern308 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x4, 1);
  x11 = XEXP (x10, 0);
  switch (GET_CODE (x11))
    {
    case EQ:
      return pattern307 (x1); /* [-1, 1] */

    case NE:
      res = pattern307 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[2] = x2;
  if (!u5bit_cint_operand (operands[2], E_QImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !const_vector_each_byte_same (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !const_vector_each_byte_same (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !const_vector_each_byte_same (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!altivec_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !const_vector_each_byte_same (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!altivec_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !const_vector_each_byte_same (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !const_vector_each_byte_same (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!altivec_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !const_vector_each_byte_same (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_TImode:
      if (!altivec_register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !const_vector_each_byte_same (operands[1], E_TImode))
        return -1;
      return 7;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !const_vector_each_byte_same (operands[1], E_KFmode))
        return -1;
      return 8;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !const_vector_each_byte_same (operands[1], E_TFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern363 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern373 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !vlogical_operand (operands[2], i1)
      || !vlogical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern380 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern388 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern397 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern392 (x5, 
i1); /* [-1, 0] */
}

int
pattern405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern191 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern191 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern231 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern231 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern231 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern231 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern231 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern231 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern231 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern231 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern231 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern231 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern427 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern432 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern438 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern445 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern452 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern459 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern466 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern477 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern486 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != MINUS)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x7, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (pattern485 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern485 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern511 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern518 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern524 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern533 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern541 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !d_form_memory (operands[1], i1)
      || !vsx_register_operand (operands[2], E_DImode)
      || !base_reg_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern551 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern556 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!symbol_ref_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!symbol_ref_operand (operands[1], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern564 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern573 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern579 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[3]))
    return -1;
  return 0;
}

int
pattern585 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern592 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern603 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (!cc_reg_operand (x5, E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      operands[3] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          if (logical_const_operand (operands[2], E_SImode))
            {
              if (
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
                {
                  *pnum_clobbers = 2;
                  return 201; /* *andsi3_imm_dot */
                }
              if (
#line 3705 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                {
                  *pnum_clobbers = 1;
                  return 205; /* *andsi3_imm_mask_dot */
                }
            }
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          if (
#line 3785 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
            {
              *pnum_clobbers = 1;
              return 213; /* *andsi3_mask_dot */
            }
          if (!
#line 3859 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
            return -1;
          *pnum_clobbers = 1;
          return 219; /* *andsi3_2insn_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          if (logical_const_operand (operands[2], E_DImode))
            {
              if ((
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 2;
                  return 202; /* *anddi3_imm_dot */
                }
              if ((
#line 3705 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 1;
                  return 206; /* *anddi3_imm_mask_dot */
                }
            }
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          if ((
#line 3785 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            {
              *pnum_clobbers = 1;
              return 214; /* *anddi3_mask_dot */
            }
          if (!(
#line 3859 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 220; /* *anddi3_2insn_dot */

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (GET_CODE (x6) == LSHIFTRT)
        {
          operands[3] = x5;
          x9 = XEXP (x6, 1);
          operands[4] = x9;
          if (const_int_operand (operands[4], E_SImode))
            {
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              switch (GET_MODE (x3))
                {
                case E_SImode:
                  if (GET_MODE (x6) == E_SImode
                      && gpc_reg_operand (operands[1], E_SImode)
                      && const_int_operand (operands[2], E_SImode)
                      && 
#line 3756 "../../gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (SImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)))
                    {
                      *pnum_clobbers = 1;
                      return 209; /* *andsi3_imm_dot_shifted */
                    }
                  break;

                case E_DImode:
                  if (GET_MODE (x6) == E_DImode
                      && gpc_reg_operand (operands[1], E_DImode)
                      && const_int_operand (operands[2], E_DImode)
                      && (
#line 3756 "../../gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (DImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 1;
                      return 210; /* *anddi3_imm_dot_shifted */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      operands[5] = x5;
      operands[4] = x6;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!rotate_mask_operator (operands[4], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !const_int_operand (operands[3], E_SImode)
              || !
#line 4198 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          *pnum_clobbers = 1;
          return 248; /* *rotlsi3_mask_dot */

        case E_DImode:
          if (!rotate_mask_operator (operands[4], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !const_int_operand (operands[3], E_DImode)
              || !(
#line 4198 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 249; /* *rotldi3_mask_dot */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
              operands[4] = x5;
              x6 = XEXP (x2, 1);
              if (GET_CODE (x6) != ASHIFT)
                return -1;
              x7 = XEXP (x1, 0);
              operands[0] = x7;
              operands[3] = x4;
              switch (pattern218 (x2))
                {
                case 0:
                  if (!
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
                    return -1;
                  return 263; /* *rotlsi3_insert_3_xor */

                case 1:
                  if (!(
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 265; /* *rotldi3_insert_3_xor */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              x7 = XEXP (x1, 0);
              operands[3] = x7;
              operands[0] = x4;
              x6 = XEXP (x2, 1);
              operands[2] = x6;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern41 (x2, 
E_SImode) != 0
                      || !
#line 1519 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2659; /* *fuse_and_xor */

                case E_DImode:
                  if (pattern41 (x2, 
E_DImode) != 0
                      || !(
#line 1519 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2660; /* *fuse_and_xor */

                case E_V4SImode:
                  if (pattern59 (x2, 
E_V4SImode) != 0
                      || !
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3259; /* *fuse_vand_vxor */

                case E_V8HImode:
                  if (pattern59 (x2, 
E_V8HImode) != 0
                      || !
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3260; /* *fuse_vand_vxor */

                case E_V16QImode:
                  if (pattern59 (x2, 
E_V16QImode) != 0
                      || !
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3261; /* *fuse_vand_vxor */

                case E_V4SFmode:
                  if (pattern59 (x2, 
E_V4SFmode) != 0
                      || !
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3262; /* *fuse_vand_vxor */

                case E_V2DFmode:
                  if (pattern59 (x2, 
E_V2DFmode) != 0
                      || !
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3263; /* *fuse_vand_vxor */

                case E_V2DImode:
                  if (pattern59 (x2, 
E_V2DImode) != 0
                      || !
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3264; /* *fuse_vand_vxor */

                case E_V1TImode:
                  if (pattern59 (x2, 
E_V1TImode) != 0
                      || !
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3265; /* *fuse_vand_vxor */

                case E_TImode:
                  if (pattern59 (x2, 
E_TImode) != 0
                      || !
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3266; /* *fuse_vand_vxor */

                case E_KFmode:
                  if (pattern59 (x2, 
E_KFmode) != 0
                      || !(
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3267; /* *fuse_vand_vxor */

                case E_TFmode:
                  if (pattern59 (x2, 
E_TFmode) != 0
                      || !(
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3268; /* *fuse_vand_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern53 (x2, 
E_SImode) != 0
                      || !
#line 1537 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2661; /* *fuse_andc_xor */

                case E_DImode:
                  if (pattern53 (x2, 
E_DImode) != 0
                      || !(
#line 1537 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2662; /* *fuse_andc_xor */

                case E_V4SImode:
                  if (pattern54 (x2, 
E_V4SImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3269; /* *fuse_vandc_vxor */

                case E_V8HImode:
                  if (pattern54 (x2, 
E_V8HImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3270; /* *fuse_vandc_vxor */

                case E_V16QImode:
                  if (pattern54 (x2, 
E_V16QImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3271; /* *fuse_vandc_vxor */

                case E_V4SFmode:
                  if (pattern54 (x2, 
E_V4SFmode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3272; /* *fuse_vandc_vxor */

                case E_V2DFmode:
                  if (pattern54 (x2, 
E_V2DFmode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3273; /* *fuse_vandc_vxor */

                case E_V2DImode:
                  if (pattern54 (x2, 
E_V2DImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3274; /* *fuse_vandc_vxor */

                case E_V1TImode:
                  if (pattern54 (x2, 
E_V1TImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3275; /* *fuse_vandc_vxor */

                case E_TImode:
                  if (pattern54 (x2, 
E_TImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3276; /* *fuse_vandc_vxor */

                case E_KFmode:
                  if (pattern54 (x2, 
E_KFmode) != 0
                      || !(
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3277; /* *fuse_vandc_vxor */

                case E_TFmode:
                  if (pattern54 (x2, 
E_TFmode) != 0
                      || !(
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3278; /* *fuse_vandc_vxor */

                default:
                  return -1;
                }

            case NOT:
              x9 = XEXP (x5, 0);
              operands[1] = x9;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern43 (x2, 
E_SImode) != 0
                      || !
#line 1591 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2667; /* *fuse_nor_xor */

                case E_DImode:
                  if (pattern43 (x2, 
E_DImode) != 0
                      || !(
#line 1591 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2668; /* *fuse_nor_xor */

                case E_V4SImode:
                  if (pattern49 (x2, 
E_V4SImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3299; /* *fuse_vnor_vxor */

                case E_V8HImode:
                  if (pattern49 (x2, 
E_V8HImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3300; /* *fuse_vnor_vxor */

                case E_V16QImode:
                  if (pattern49 (x2, 
E_V16QImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3301; /* *fuse_vnor_vxor */

                case E_V4SFmode:
                  if (pattern49 (x2, 
E_V4SFmode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3302; /* *fuse_vnor_vxor */

                case E_V2DFmode:
                  if (pattern49 (x2, 
E_V2DFmode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3303; /* *fuse_vnor_vxor */

                case E_V2DImode:
                  if (pattern49 (x2, 
E_V2DImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3304; /* *fuse_vnor_vxor */

                case E_V1TImode:
                  if (pattern49 (x2, 
E_V1TImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3305; /* *fuse_vnor_vxor */

                case E_TImode:
                  if (pattern49 (x2, 
E_TImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3306; /* *fuse_vnor_vxor */

                case E_KFmode:
                  if (pattern49 (x2, 
E_KFmode) != 0
                      || !(
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3307; /* *fuse_vnor_vxor */

                case E_TFmode:
                  if (pattern49 (x2, 
E_TFmode) != 0
                      || !(
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3308; /* *fuse_vnor_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != XOR)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      x10 = XEXP (x4, 1);
      operands[1] = x10;
      switch (pattern429 (x2))
        {
        case 0:
          if (!
#line 1555 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2663; /* *fuse_eqv_xor */

        case 1:
          if (!(
#line 1555 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2664; /* *fuse_eqv_xor */

        case 2:
          if (!
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3279; /* *fuse_veqv_vxor */

        case 3:
          if (!
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3280; /* *fuse_veqv_vxor */

        case 4:
          if (!
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3281; /* *fuse_veqv_vxor */

        case 5:
          if (!
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3282; /* *fuse_veqv_vxor */

        case 6:
          if (!
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3283; /* *fuse_veqv_vxor */

        case 7:
          if (!
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3284; /* *fuse_veqv_vxor */

        case 8:
          if (!
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3285; /* *fuse_veqv_vxor */

        case 9:
          if (!
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3286; /* *fuse_veqv_vxor */

        case 10:
          if (!(
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3287; /* *fuse_veqv_vxor */

        case 11:
          if (!(
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3288; /* *fuse_veqv_vxor */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NOT:
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case NOT:
              x9 = XEXP (x5, 0);
              operands[1] = x9;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern43 (x2, 
E_SImode) != 0
                      || !
#line 1573 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2665; /* *fuse_nand_xor */

                case E_DImode:
                  if (pattern43 (x2, 
E_DImode) != 0
                      || !(
#line 1573 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2666; /* *fuse_nand_xor */

                case E_V4SImode:
                  if (pattern49 (x2, 
E_V4SImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3289; /* *fuse_vnand_vxor */

                case E_V8HImode:
                  if (pattern49 (x2, 
E_V8HImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3290; /* *fuse_vnand_vxor */

                case E_V16QImode:
                  if (pattern49 (x2, 
E_V16QImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3291; /* *fuse_vnand_vxor */

                case E_V4SFmode:
                  if (pattern49 (x2, 
E_V4SFmode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3292; /* *fuse_vnand_vxor */

                case E_V2DFmode:
                  if (pattern49 (x2, 
E_V2DFmode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3293; /* *fuse_vnand_vxor */

                case E_V2DImode:
                  if (pattern49 (x2, 
E_V2DImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3294; /* *fuse_vnand_vxor */

                case E_V1TImode:
                  if (pattern49 (x2, 
E_V1TImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3295; /* *fuse_vnand_vxor */

                case E_TImode:
                  if (pattern49 (x2, 
E_TImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3296; /* *fuse_vnand_vxor */

                case E_KFmode:
                  if (pattern49 (x2, 
E_KFmode) != 0
                      || !(
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3297; /* *fuse_vnand_vxor */

                case E_TFmode:
                  if (pattern49 (x2, 
E_TFmode) != 0
                      || !(
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3298; /* *fuse_vnand_vxor */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x5;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern53 (x2, 
E_SImode) != 0
                      || !
#line 1627 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2671; /* *fuse_orc_xor */

                case E_DImode:
                  if (pattern53 (x2, 
E_DImode) != 0
                      || !(
#line 1627 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2672; /* *fuse_orc_xor */

                case E_V4SImode:
                  if (pattern54 (x2, 
E_V4SImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3319; /* *fuse_vorc_vxor */

                case E_V8HImode:
                  if (pattern54 (x2, 
E_V8HImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3320; /* *fuse_vorc_vxor */

                case E_V16QImode:
                  if (pattern54 (x2, 
E_V16QImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3321; /* *fuse_vorc_vxor */

                case E_V4SFmode:
                  if (pattern54 (x2, 
E_V4SFmode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3322; /* *fuse_vorc_vxor */

                case E_V2DFmode:
                  if (pattern54 (x2, 
E_V2DFmode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3323; /* *fuse_vorc_vxor */

                case E_V2DImode:
                  if (pattern54 (x2, 
E_V2DImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3324; /* *fuse_vorc_vxor */

                case E_V1TImode:
                  if (pattern54 (x2, 
E_V1TImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3325; /* *fuse_vorc_vxor */

                case E_TImode:
                  if (pattern54 (x2, 
E_TImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3326; /* *fuse_vorc_vxor */

                case E_KFmode:
                  if (pattern54 (x2, 
E_KFmode) != 0
                      || !(
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3327; /* *fuse_vorc_vxor */

                case E_TFmode:
                  if (pattern54 (x2, 
E_TFmode) != 0
                      || !(
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3328; /* *fuse_vorc_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern371 (x2))
            {
            case 0:
              if (!
#line 1609 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2669; /* *fuse_or_xor */

            case 1:
              if (!(
#line 1609 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2670; /* *fuse_or_xor */

            case 2:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3309; /* *fuse_vor_vxor */

            case 3:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3310; /* *fuse_vor_vxor */

            case 4:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3311; /* *fuse_vor_vxor */

            case 5:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3312; /* *fuse_vor_vxor */

            case 6:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3313; /* *fuse_vor_vxor */

            case 7:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3314; /* *fuse_vor_vxor */

            case 8:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3315; /* *fuse_vor_vxor */

            case 9:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3316; /* *fuse_vor_vxor */

            case 10:
              if (!(
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3317; /* *fuse_vor_vxor */

            case 11:
              if (!(
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3318; /* *fuse_vor_vxor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern41 (x2, 
E_SImode) != 0
              || !
#line 1645 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2673; /* *fuse_xor_xor */

        case E_DImode:
          if (pattern41 (x2, 
E_DImode) != 0
              || !(
#line 1645 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2674; /* *fuse_xor_xor */

        case E_V4SImode:
          if (pattern59 (x2, 
E_V4SImode) != 0
              || !
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3329; /* *fuse_vxor_vxor */

        case E_V8HImode:
          if (pattern59 (x2, 
E_V8HImode) != 0
              || !
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3330; /* *fuse_vxor_vxor */

        case E_V16QImode:
          if (pattern59 (x2, 
E_V16QImode) != 0
              || !
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3331; /* *fuse_vxor_vxor */

        case E_V4SFmode:
          if (pattern59 (x2, 
E_V4SFmode) != 0
              || !
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3332; /* *fuse_vxor_vxor */

        case E_V2DFmode:
          if (pattern59 (x2, 
E_V2DFmode) != 0
              || !
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3333; /* *fuse_vxor_vxor */

        case E_V2DImode:
          if (pattern59 (x2, 
E_V2DImode) != 0
              || !
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3334; /* *fuse_vxor_vxor */

        case E_V1TImode:
          if (pattern59 (x2, 
E_V1TImode) != 0
              || !
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3335; /* *fuse_vxor_vxor */

        case E_TImode:
          if (pattern59 (x2, 
E_TImode) != 0
              || !
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3336; /* *fuse_vxor_vxor */

        case E_KFmode:
          if (pattern59 (x2, 
E_KFmode) != 0
              || !(
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3337; /* *fuse_vxor_vxor */

        case E_TFmode:
          if (pattern59 (x2, 
E_TFmode) != 0
              || !(
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3338; /* *fuse_vxor_vxor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern154 (x1))
    {
    case 0:
      if (!
#line 5162 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FRES))
        return -1;
      return 322; /* fres */

    case 1:
      if (!
#line 5162 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FRE))
        return -1;
      return 323; /* fred */

    case 2:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 1977 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1354; /* vsx_frev4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2659 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 2115; /* altivec_vrefp */

    case 3:
      if (!
#line 1977 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1355; /* vsx_frev2df2 */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_PTImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case MEM:
      if (!quad_memory_operand (operands[1], E_TImode)
          || !quad_int_reg_operand (operands[0], E_PTImode)
          || !
#line 130 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI
   && !reg_mentioned_p (operands[0], operands[1])))
        return -1;
      return 1222; /* load_quadpti */

    case REG:
      if (!quad_int_reg_operand (operands[1], E_PTImode)
          || !quad_memory_operand (operands[0], E_PTImode)
          || !
#line 206 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
        return -1;
      return 1223; /* store_quadpti */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern464 (x3, 
E_QImode, 
E_V16QImode) != 0
              || !const_0_to_15_operand (operands[3], E_QImode)
              || !
#line 4592 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1603; /* vsx_set_v16qi_p9 */

        case E_V8HImode:
          if (pattern464 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !const_0_to_7_operand (operands[3], E_QImode)
              || !
#line 4592 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1604; /* vsx_set_v8hi_p9 */

        case E_V4SImode:
          if (pattern465 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 4592 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1605; /* vsx_set_v4si_p9 */

        case E_V4SFmode:
          if (pnum_clobbers == NULL
              || pattern465 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 4616 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 1606; /* vsx_set_v4sf_p9 */

        default:
          return -1;
        }

    case CONST_DOUBLE:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x5;
      if (!zero_fp_constant (operands[2], E_SFmode)
          || !gpc_reg_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_3_operand (operands[3], E_QImode)
          || !
#line 4652 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 1;
      return 1607; /* *vsx_set_v4sf_p9_zero */

    case VEC_SELECT:
      if (GET_MODE (x5) != E_SFmode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1
          || !gpc_reg_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x9 = XVECEXP (x7, 0, 0);
      operands[3] = x9;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      if (!const_0_to_3_operand (operands[4], E_QImode))
        return -1;
      if (
#line 4683 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) == (BYTES_BIG_ENDIAN ? 1 : 2))))
        return 1608; /* *vsx_insert_extract_v4sf_p9 */
      if (pnum_clobbers == NULL
          || !
#line 4712 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
        return -1;
      *pnum_clobbers = 1;
      return 1609; /* *vsx_insert_extract_v4sf_p9_2 */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          switch (pattern439 (x2, 
E_V16QImode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2199; /* altivec_lvx_v16qi_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2200; /* altivec_lvx_v16qi_2op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern439 (x2, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2203; /* altivec_lvx_v2df_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2204; /* altivec_lvx_v2df_2op_di */

            default:
              return -1;
            }

        case E_KFmode:
          switch (pattern439 (x2, 
E_KFmode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 2209; /* altivec_lvx_kf_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 2210; /* altivec_lvx_kf_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          switch (pattern384 (x2, 
E_V16QImode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2217; /* altivec_lvx_v16qi_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2218; /* altivec_lvx_v16qi_1op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern384 (x2, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2221; /* altivec_lvx_v2df_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2222; /* altivec_lvx_v2df_1op_di */

            default:
              return -1;
            }

        case E_KFmode:
          switch (pattern384 (x2, 
E_KFmode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 2227; /* altivec_lvx_kf_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 2228; /* altivec_lvx_kf_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[1] = x4;
      if (s8bit_cint_operand (operands[1], E_SImode)
          && vsx_register_operand (operands[0], E_V16QImode)
          && GET_MODE (x3) == E_V16QImode
          && 
#line 1146 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1283; /* xxspltib_v16qi */
      if (!s5bit_cint_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 2461 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2072; /* altivec_vspltisb */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[1], E_DFmode)
              && 
#line 4787 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return 1610; /* vsx_splat_v2df_reg */
          if (!memory_operand (operands[1], E_DFmode)
              || !
#line 4797 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return -1;
          return 1612; /* vsx_splat_v2df_mem */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !splat_input_operand (operands[1], E_SFmode)
              || !
#line 4832 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1616; /* vsx_splat_v4sf */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode
              || GET_MODE (x4) != E_SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && 
#line 4856 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
            return 1617; /* vsx_xxspltw_v4sf */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !
#line 2448 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 2069; /* *altivec_vspltsf_internal */

        case E_V16QImode:
          if (pattern438 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 2334 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2063; /* *altivec_vspltb_internal */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x4) != E_QImode
          || !altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!altivec_register_operand (operands[1], E_DImode)
          || !
#line 4880 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 1621; /* vsx_vspltb_di */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          switch (pattern439 (x2, 
E_V8HImode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2197; /* altivec_lvx_v8hi_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2198; /* altivec_lvx_v8hi_2op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern439 (x2, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2205; /* altivec_lvx_v2di_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2206; /* altivec_lvx_v2di_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          switch (pattern384 (x2, 
E_V8HImode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2215; /* altivec_lvx_v8hi_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2216; /* altivec_lvx_v8hi_1op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern384 (x2, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2223; /* altivec_lvx_v2di_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2224; /* altivec_lvx_v2di_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (pattern22 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 9; /* *zero_extendqisi2_dot */

        case 1:
          *pnum_clobbers = 1;
          return 15; /* *zero_extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 10; /* *zero_extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 16; /* *zero_extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 20; /* *zero_extendsidi2_dot */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern22 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 24; /* *extendqisi2_dot */

        case 1:
          *pnum_clobbers = 1;
          return 30; /* *extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 25; /* *extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 31; /* *extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 35; /* *extendsidi2_dot */

        default:
          return -1;
        }

    case PLUS:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (pattern418 (x3))
            {
            case 0:
              if (!
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 70; /* *addsi3_dot */

            case 1:
              if (!(
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 71; /* *adddi3_dot */

            default:
              return -1;
            }

        case CONST_INT:
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !short_cint_operand (operands[2], E_SImode)
                  || !
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 2;
              return 74; /* *addsi3_imm_dot */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !short_cint_operand (operands[2], E_DImode)
                  || !(
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 2;
              return 75; /* *adddi3_imm_dot */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern24 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 98; /* *one_cmplsi2_dot */

        case 1:
          if (!(
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 99; /* *one_cmpldi2_dot */

        default:
          return -1;
        }

    case MINUS:
      if (pattern25 (x1, pnum_clobbers) != 0)
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 104; /* *subfsi3_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !(
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 105; /* *subfdi3_dot */

        default:
          return -1;
        }

    case NEG:
      switch (pattern24 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 129; /* *negsi2_dot */

        case 1:
          if (!(
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 130; /* *negdi2_dot */

        default:
          return -1;
        }

    case MULT:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (pattern418 (x3))
        {
        case 0:
          if (!
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 167; /* *mulsi3_dot */

        case 1:
          if (!(
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 168; /* *muldi3_dot */

        default:
          return -1;
        }

    case DIV:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode)
              || !exact_log2_cint_operand (operands[2], E_SImode)
              || !
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 2;
          return 194; /* *divsi3_sra_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !exact_log2_cint_operand (operands[2], E_DImode)
              || !(
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 2;
          return 195; /* *divdi3_sra_dot */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      return recog_3 (x1, insn, pnum_clobbers);

    case ROTATE:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 278; /* *rotlsi3_dot */

        case 1:
          if (!(
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 279; /* *rotldi3_dot */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern25 (x1, pnum_clobbers) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern26 (x3))
            {
            case 0:
              if (!
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 285; /* *ashlsi3_dot */

            case 1:
              if (!(
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 286; /* *ashldi3_dot */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!reg_or_mem_operand (operands[1], E_SImode)
              || !u6bit_cint_operand (operands[2], E_DImode)
              || !
#line 4732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          *pnum_clobbers = 1;
          return 290; /* ashdi3_extswsli_dot */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 295; /* *lshrsi3_dot */

        case 1:
          if (!(
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 296; /* *lshrdi3_dot */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 2;
          return 302; /* *ashrsi3_dot */

        case 1:
          if (!(
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 2;
          return 303; /* *ashrdi3_dot */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_CCFPmode:
          if (!cc_reg_operand (operands[0], E_CCFPmode)
              || GET_MODE (x2) != E_CCFPmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!gpc_reg_operand (operands[1], E_SFmode)
                  || !gpc_reg_operand (operands[2], E_SFmode)
                  || !
#line 5221 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 326; /* *cmpsf_fpr */

            case E_DFmode:
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !gpc_reg_operand (operands[2], E_DFmode)
                  || !
#line 5221 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 327; /* *cmpdf_fpr */

            case E_IFmode:
              if (!gpc_reg_operand (operands[1], E_IFmode)
                  || !gpc_reg_operand (operands[2], E_IFmode))
                return -1;
              if ((
#line 12704 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return 880; /* *cmpif_internal1 */
              if (pnum_clobbers == NULL)
                return -1;
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                {
                  *pnum_clobbers = 9;
                  return 882; /* *cmpif_internal2 */
                }
              if (!(
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return -1;
              *pnum_clobbers = 9;
              return 883; /* *cmpif_internal2 */

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode)
                  && gpc_reg_operand (operands[2], E_TFmode))
                {
                  if ((
#line 12704 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 881; /* *cmptf_internal1 */
                  if (pnum_clobbers != NULL)
                    {
                      if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                        {
                          *pnum_clobbers = 9;
                          return 884; /* *cmptf_internal2 */
                        }
                      if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                        {
                          *pnum_clobbers = 9;
                          return 885; /* *cmptf_internal2 */
                        }
                    }
                }
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !altivec_register_operand (operands[2], E_TFmode)
                  || !(
#line 15603 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1204; /* *cmptf_hw */

            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !altivec_register_operand (operands[2], E_KFmode)
                  || !(
#line 15603 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1203; /* *cmpkf_hw */

            case E_DDmode:
              if (!gpc_reg_operand (operands[1], E_DDmode)
                  || !gpc_reg_operand (operands[2], E_DDmode)
                  || !
#line 209 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2444; /* *cmpdd_internal1 */

            case E_TDmode:
              if (!gpc_reg_operand (operands[1], E_TDmode)
                  || !gpc_reg_operand (operands[2], E_TDmode)
                  || !
#line 209 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2445; /* *cmptd_internal1 */

            default:
              return -1;
            }

        case E_CCmode:
          if (!cc_reg_operand (operands[0], E_CCmode))
            return -1;
          switch (pattern319 (x2, 
E_CCmode))
            {
            case 0:
              return 876; /* *cmpsi_signed */

            case 1:
              if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 877; /* *cmpdi_signed */

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[0], E_CCUNSmode))
            return -1;
          switch (pattern127 (x2, 
E_CCUNSmode))
            {
            case 0:
              return 878; /* *cmpsi_unsigned */

            case 1:
              if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 879; /* *cmpdi_unsigned */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNLE:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!cc_reg_operand (operands[0], E_CCEQmode)
          || GET_MODE (x2) != E_CCEQmode)
        return -1;
      operands[1] = x3;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case EQ:
        case GT:
        case LT:
        case GTU:
        case LTU:
        case UNORDERED:
          x8 = XEXP (x2, 1);
          if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (branch_positive_comparison_operator (operands[1], E_SImode))
                    return 973; /* cceq_rev_compare_si */
                  break;

                case E_DImode:
                  if (branch_positive_comparison_operator (operands[1], E_DImode)
                      && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return 974; /* cceq_rev_compare_di */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      x8 = XEXP (x2, 1);
      if (!branch_comparison_operator (x8, E_VOIDmode))
        return -1;
      operands[3] = x8;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !branch_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[4] = x10;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return -1;
      return 975; /* *rs6000.md:13454 */

    case UNSPEC:
      return recog_2 (x1, insn, pnum_clobbers);

    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      x7 = XEXP (x1, 0);
      operands[2] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x2) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_m1_to_1_operand (operands[3], E_DImode)
                  || !
#line 28 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2509; /* *ld_cmpdi_cr0_DI_clobber_CC_none */

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !
#line 112 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2513; /* *lwz_cmpwi_cr0_SI_clobber_CC_none */

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              if (
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2519; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */
                }
              if (!(
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2520; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x2) != E_CCUNSmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_0_to_1_operand (operands[3], E_DImode)
                  || !
#line 49 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2510; /* *ld_cmpldi_cr0_DI_clobber_CCUNS_none */

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !
#line 133 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2514; /* *lwz_cmpldi_cr0_SI_clobber_CCUNS_none */

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_0_to_1_operand (operands[3], E_HImode))
                return -1;
              if (
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2521; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */
                }
              if (!(
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2522; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

            case E_QImode:
              if (!non_update_memory_operand (operands[1], E_QImode)
                  || !const_0_to_1_operand (operands[3], E_QImode))
                return -1;
              if (
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2527; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */
                }
              if (!(
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2528; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = recog_17 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
    case XOR:
      res = recog_23 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern329 (
E_SImode) != 0)
            return -1;
          return 226; /* *boolsi3 */

        case E_DImode:
          if (pattern329 (
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 227; /* *booldi3 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern372 (x4, 
E_SImode) != 0)
                return -1;
              return 232; /* *boolcsi3 */

            case E_DImode:
              if (pattern372 (x4, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 233; /* *boolcdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && 
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 525; /* *boolcti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !
#line 7488 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 534; /* *boolcti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && 
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 526; /* *boolcpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !
#line 7488 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 535; /* *boolcpti3_internal2 */

            case E_V16QImode:
              if (pattern373 (x4, 
E_V16QImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 527; /* *boolcv16qi3_internal1 */

            case E_V8HImode:
              if (pattern373 (x4, 
E_V8HImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 528; /* *boolcv8hi3_internal1 */

            case E_V4SImode:
              if (pattern373 (x4, 
E_V4SImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 529; /* *boolcv4si3_internal1 */

            case E_V4SFmode:
              if (pattern373 (x4, 
E_V4SFmode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 530; /* *boolcv4sf3_internal1 */

            case E_V2DImode:
              if (pattern373 (x4, 
E_V2DImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 531; /* *boolcv2di3_internal1 */

            case E_V2DFmode:
              if (pattern373 (x4, 
E_V2DFmode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 532; /* *boolcv2df3_internal1 */

            case E_V1TImode:
              if (pattern373 (x4, 
E_V1TImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 533; /* *boolcv1ti3_internal1 */

            default:
              return -1;
            }

        case NOT:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern375 (x2, 
E_SImode) != 0)
                return -1;
              return 238; /* *boolccsi3 */

            case E_DImode:
              if (pattern375 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 239; /* *boolccdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode
                  || GET_MODE (x5) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && 
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 536; /* *boolccti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !
#line 7549 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 545; /* *boolccti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode
                  || GET_MODE (x5) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && 
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 537; /* *boolccpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !
#line 7549 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 546; /* *boolccpti3_internal2 */

            case E_V16QImode:
              if (pattern376 (x2, 
E_V16QImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 538; /* *boolccv16qi3_internal1 */

            case E_V8HImode:
              if (pattern376 (x2, 
E_V8HImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 539; /* *boolccv8hi3_internal1 */

            case E_V4SImode:
              if (pattern376 (x2, 
E_V4SImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 540; /* *boolccv4si3_internal1 */

            case E_V4SFmode:
              if (pattern376 (x2, 
E_V4SFmode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 541; /* *boolccv4sf3_internal1 */

            case E_V2DImode:
              if (pattern376 (x2, 
E_V2DImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 542; /* *boolccv2di3_internal1 */

            case E_V2DFmode:
              if (pattern376 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 543; /* *boolccv2df3_internal1 */

            case E_V1TImode:
              if (pattern376 (x2, 
E_V1TImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 544; /* *boolccv1ti3_internal1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern347 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3132 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1455; /* vsx_concat_v2df */

            case E_V2DImode:
              if (pattern347 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3132 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1456; /* vsx_concat_v2di */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern493 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3181 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1459; /* *vsx_concat_v2df_2 */

            case E_V2DImode:
              if (pattern493 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3181 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1460; /* *vsx_concat_v2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x11 = XVECEXP (x9, 0, 0);
      operands[2] = x11;
      if (!const_0_to_1_operand (operands[2], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern494 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3158 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1457; /* *vsx_concat_v2df_1 */

            case E_V2DImode:
              if (pattern494 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3158 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1458; /* *vsx_concat_v2di_1 */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[3] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[4] = x8;
          if (!const_0_to_1_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern561 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3206 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1461; /* *vsx_concat_v2df_3 */

            case E_V2DImode:
              if (pattern561 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3206 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1462; /* *vsx_concat_v2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 98)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 98)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern549 (x1, 
E_SImode) != 0)
        return -1;
      return 88; /* *addsi3_carry_in_internal */

    case E_DImode:
      if (pattern549 (x1, 
E_DImode) != 0
          || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 89; /* *adddi3_carry_in_internal */

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern198 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[3], E_DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_SImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern587 (x7, 
E_SImode) != 0
                  || !(
#line 10308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 709; /* *movsi_update2 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern587 (x7, 
E_DImode) != 0
                  || !(
#line 10308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 710; /* *movsi_update2 */

            default:
              return -1;
            }

        case E_HImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern551 (x7, 
E_SImode) != 0
                  || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 721; /* *movhi_update3 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern551 (x7, 
E_DImode) != 0
                  || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 723; /* *movhi_update3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!gpc_reg_operand (operands[3], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_SImode) != 0
              || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 720; /* *movhi_update3 */

        case E_DImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_DImode) != 0
              || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 722; /* *movhi_update3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (pattern355 (x1))
        {
        case 0:
          if (!
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)))
            return -1;
          return 270; /* *iorsi_mask */

        case 1:
          if (!(
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 271; /* *iordi_mask */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern252 (x4) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (pattern526 (x1))
        {
        case 0:
          if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8))
            return -1;
          return 272; /* *rotldi3_insert_sf */

        case 1:
          if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16))
            return -1;
          return 273; /* *rotldi3_insert_sf */

        case 2:
          if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32))
            return -1;
          return 274; /* *rotldi3_insert_sf */

        default:
          return -1;
        }

    case NOT:
      return recog_163 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern247 (x1))
        {
        case 0:
          if (!
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2623; /* *fuse_and_or */

        case 1:
          if (!(
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2624; /* *fuse_and_or */

        case 2:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3099; /* *fuse_vand_vor */

        case 3:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3100; /* *fuse_vand_vor */

        case 4:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3101; /* *fuse_vand_vor */

        case 5:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3102; /* *fuse_vand_vor */

        case 6:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3103; /* *fuse_vand_vor */

        case 7:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3104; /* *fuse_vand_vor */

        case 8:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3105; /* *fuse_vand_vor */

        case 9:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3106; /* *fuse_vand_vor */

        case 10:
          if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3107; /* *fuse_vand_vor */

        case 11:
          if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3108; /* *fuse_vand_vor */

        case 12:
          if (!
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2643; /* *fuse_and_orc */

        case 13:
          if (!(
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2644; /* *fuse_and_orc */

        case 14:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3179; /* *fuse_vand_vorc */

        case 15:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3180; /* *fuse_vand_vorc */

        case 16:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3181; /* *fuse_vand_vorc */

        case 17:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3182; /* *fuse_vand_vorc */

        case 18:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3183; /* *fuse_vand_vorc */

        case 19:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3184; /* *fuse_vand_vorc */

        case 20:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3185; /* *fuse_vand_vorc */

        case 21:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3186; /* *fuse_vand_vorc */

        case 22:
          if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3187; /* *fuse_vand_vorc */

        case 23:
          if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3188; /* *fuse_vand_vorc */

        case 24:
          if (!
#line 1213 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2625; /* *fuse_andc_or */

        case 25:
          if (!(
#line 1213 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2626; /* *fuse_andc_or */

        case 26:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3109; /* *fuse_vandc_vor */

        case 27:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3110; /* *fuse_vandc_vor */

        case 28:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3111; /* *fuse_vandc_vor */

        case 29:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3112; /* *fuse_vandc_vor */

        case 30:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3113; /* *fuse_vandc_vor */

        case 31:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3114; /* *fuse_vandc_vor */

        case 32:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3115; /* *fuse_vandc_vor */

        case 33:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3116; /* *fuse_vandc_vor */

        case 34:
          if (!(
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3117; /* *fuse_vandc_vor */

        case 35:
          if (!(
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3118; /* *fuse_vandc_vor */

        case 36:
          if (!
#line 1393 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2645; /* *fuse_andc_orc */

        case 37:
          if (!(
#line 1393 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2646; /* *fuse_andc_orc */

        case 38:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3189; /* *fuse_vandc_vorc */

        case 39:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3190; /* *fuse_vandc_vorc */

        case 40:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3191; /* *fuse_vandc_vorc */

        case 41:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3192; /* *fuse_vandc_vorc */

        case 42:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3193; /* *fuse_vandc_vorc */

        case 43:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3194; /* *fuse_vandc_vorc */

        case 44:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3195; /* *fuse_vandc_vorc */

        case 45:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3196; /* *fuse_vandc_vorc */

        case 46:
          if (!(
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3197; /* *fuse_vandc_vorc */

        case 47:
          if (!(
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3198; /* *fuse_vandc_vorc */

        case 48:
          if (!
#line 1267 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2631; /* *fuse_nor_or */

        case 49:
          if (!(
#line 1267 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2632; /* *fuse_nor_or */

        case 50:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3139; /* *fuse_vnor_vor */

        case 51:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3140; /* *fuse_vnor_vor */

        case 52:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3141; /* *fuse_vnor_vor */

        case 53:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3142; /* *fuse_vnor_vor */

        case 54:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3143; /* *fuse_vnor_vor */

        case 55:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3144; /* *fuse_vnor_vor */

        case 56:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3145; /* *fuse_vnor_vor */

        case 57:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3146; /* *fuse_vnor_vor */

        case 58:
          if (!(
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3147; /* *fuse_vnor_vor */

        case 59:
          if (!(
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3148; /* *fuse_vnor_vor */

        case 60:
          if (!
#line 1447 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2651; /* *fuse_nor_orc */

        case 61:
          if (!(
#line 1447 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2652; /* *fuse_nor_orc */

        case 62:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3219; /* *fuse_vnor_vorc */

        case 63:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3220; /* *fuse_vnor_vorc */

        case 64:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3221; /* *fuse_vnor_vorc */

        case 65:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3222; /* *fuse_vnor_vorc */

        case 66:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3223; /* *fuse_vnor_vorc */

        case 67:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3224; /* *fuse_vnor_vorc */

        case 68:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3225; /* *fuse_vnor_vorc */

        case 69:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3226; /* *fuse_vnor_vorc */

        case 70:
          if (!(
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3227; /* *fuse_vnor_vorc */

        case 71:
          if (!(
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3228; /* *fuse_vnor_vorc */

        default:
          return -1;
        }

    case IOR:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 1249 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2629; /* *fuse_nand_or */

        case 1:
          if (!(
#line 1249 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2630; /* *fuse_nand_or */

        case 2:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3129; /* *fuse_vnand_vor */

        case 3:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3130; /* *fuse_vnand_vor */

        case 4:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3131; /* *fuse_vnand_vor */

        case 5:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3132; /* *fuse_vnand_vor */

        case 6:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3133; /* *fuse_vnand_vor */

        case 7:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3134; /* *fuse_vnand_vor */

        case 8:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3135; /* *fuse_vnand_vor */

        case 9:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3136; /* *fuse_vnand_vor */

        case 10:
          if (!(
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3137; /* *fuse_vnand_vor */

        case 11:
          if (!(
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3138; /* *fuse_vnand_vor */

        case 12:
          if (!
#line 1429 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2649; /* *fuse_nand_orc */

        case 13:
          if (!(
#line 1429 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2650; /* *fuse_nand_orc */

        case 14:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3209; /* *fuse_vnand_vorc */

        case 15:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3210; /* *fuse_vnand_vorc */

        case 16:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3211; /* *fuse_vnand_vorc */

        case 17:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3212; /* *fuse_vnand_vorc */

        case 18:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3213; /* *fuse_vnand_vorc */

        case 19:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3214; /* *fuse_vnand_vorc */

        case 20:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3215; /* *fuse_vnand_vorc */

        case 21:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3216; /* *fuse_vnand_vorc */

        case 22:
          if (!(
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3217; /* *fuse_vnand_vorc */

        case 23:
          if (!(
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3218; /* *fuse_vnand_vorc */

        case 24:
          if (!
#line 1303 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2635; /* *fuse_orc_or */

        case 25:
          if (!(
#line 1303 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2636; /* *fuse_orc_or */

        case 26:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3159; /* *fuse_vorc_vor */

        case 27:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3160; /* *fuse_vorc_vor */

        case 28:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3161; /* *fuse_vorc_vor */

        case 29:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3162; /* *fuse_vorc_vor */

        case 30:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3163; /* *fuse_vorc_vor */

        case 31:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3164; /* *fuse_vorc_vor */

        case 32:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3165; /* *fuse_vorc_vor */

        case 33:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3166; /* *fuse_vorc_vor */

        case 34:
          if (!(
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3167; /* *fuse_vorc_vor */

        case 35:
          if (!(
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3168; /* *fuse_vorc_vor */

        case 36:
          if (!
#line 1483 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2655; /* *fuse_orc_orc */

        case 37:
          if (!(
#line 1483 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2656; /* *fuse_orc_orc */

        case 38:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3239; /* *fuse_vorc_vorc */

        case 39:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3240; /* *fuse_vorc_vorc */

        case 40:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3241; /* *fuse_vorc_vorc */

        case 41:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3242; /* *fuse_vorc_vorc */

        case 42:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3243; /* *fuse_vorc_vorc */

        case 43:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3244; /* *fuse_vorc_vorc */

        case 44:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3245; /* *fuse_vorc_vorc */

        case 45:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3246; /* *fuse_vorc_vorc */

        case 46:
          if (!(
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3247; /* *fuse_vorc_vorc */

        case 47:
          if (!(
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3248; /* *fuse_vorc_vorc */

        case 48:
          if (!
#line 1285 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2633; /* *fuse_or_or */

        case 49:
          if (!(
#line 1285 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2634; /* *fuse_or_or */

        case 50:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3149; /* *fuse_vor_vor */

        case 51:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3150; /* *fuse_vor_vor */

        case 52:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3151; /* *fuse_vor_vor */

        case 53:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3152; /* *fuse_vor_vor */

        case 54:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3153; /* *fuse_vor_vor */

        case 55:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3154; /* *fuse_vor_vor */

        case 56:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3155; /* *fuse_vor_vor */

        case 57:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3156; /* *fuse_vor_vor */

        case 58:
          if (!(
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3157; /* *fuse_vor_vor */

        case 59:
          if (!(
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3158; /* *fuse_vor_vor */

        case 60:
          if (!
#line 1465 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2653; /* *fuse_or_orc */

        case 61:
          if (!(
#line 1465 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2654; /* *fuse_or_orc */

        case 62:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3229; /* *fuse_vor_vorc */

        case 63:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3230; /* *fuse_vor_vorc */

        case 64:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3231; /* *fuse_vor_vorc */

        case 65:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3232; /* *fuse_vor_vorc */

        case 66:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3233; /* *fuse_vor_vorc */

        case 67:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3234; /* *fuse_vor_vorc */

        case 68:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3235; /* *fuse_vor_vorc */

        case 69:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3236; /* *fuse_vor_vorc */

        case 70:
          if (!(
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3237; /* *fuse_vor_vorc */

        case 71:
          if (!(
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3238; /* *fuse_vor_vorc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern249 (x1))
        {
        case 0:
          if (!
#line 1321 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2637; /* *fuse_xor_or */

        case 1:
          if (!(
#line 1321 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2638; /* *fuse_xor_or */

        case 2:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3169; /* *fuse_vxor_vor */

        case 3:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3170; /* *fuse_vxor_vor */

        case 4:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3171; /* *fuse_vxor_vor */

        case 5:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3172; /* *fuse_vxor_vor */

        case 6:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3173; /* *fuse_vxor_vor */

        case 7:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3174; /* *fuse_vxor_vor */

        case 8:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3175; /* *fuse_vxor_vor */

        case 9:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3176; /* *fuse_vxor_vor */

        case 10:
          if (!(
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3177; /* *fuse_vxor_vor */

        case 11:
          if (!(
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3178; /* *fuse_vxor_vor */

        case 12:
          if (!
#line 1501 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2657; /* *fuse_xor_orc */

        case 13:
          if (!(
#line 1501 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2658; /* *fuse_xor_orc */

        case 14:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3249; /* *fuse_vxor_vorc */

        case 15:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3250; /* *fuse_vxor_vorc */

        case 16:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3251; /* *fuse_vxor_vorc */

        case 17:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3252; /* *fuse_vxor_vorc */

        case 18:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3253; /* *fuse_vxor_vorc */

        case 19:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3254; /* *fuse_vxor_vorc */

        case 20:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3255; /* *fuse_vxor_vorc */

        case 21:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3256; /* *fuse_vxor_vorc */

        case 22:
          if (!(
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3257; /* *fuse_vxor_vorc */

        case 23:
          if (!(
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3258; /* *fuse_vxor_vorc */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern251 (x1))
        {
        case 0:
          if (!
#line 1339 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2639; /* *fuse_add_or */

        case 1:
          if (!(
#line 1339 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2640; /* *fuse_add_or */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern251 (x1))
        {
        case 0:
          if (!
#line 1357 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2641; /* *fuse_subf_or */

        case 1:
          if (!(
#line 1357 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2642; /* *fuse_subf_or */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_193 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_186 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_188 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          if (pattern16 (x1) == 0
              && 
#line 6081 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFID && TARGET_HARD_FLOAT))
            return 415; /* *floatsidf2_internal */
          break;

        case 5:
          res = recog_189 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_190 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 10:
          switch (pattern18 (x1))
            {
            case 0:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return 882; /* *cmpif_internal2 */
              break;

            case 1:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 883; /* *cmpif_internal2 */
              break;

            case 2:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return 884; /* *cmptf_internal2 */
              break;

            case 3:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 885; /* *cmptf_internal2 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 1)
        {
          res = recog_191 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 4
          && any_parallel_operand (operands[0], E_VOIDmode))
        {
          res = recog_192 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) < 5
          || !any_parallel_operand (operands[0], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x2) != USE)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x5))
        {
        case RETURN:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 96)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != USE)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x4, 0);
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          switch (REGNO (x3))
            {
            case 11:
              switch (pattern565 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1028; /* *return_and_restore_gpregs_si_r11 */

                case 1:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1034; /* *return_and_restore_fpregs_si_r11 */

                case 2:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1029; /* *return_and_restore_gpregs_di_r11 */

                case 3:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1035; /* *return_and_restore_fpregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern565 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1030; /* *return_and_restore_gpregs_si_r12 */

                case 1:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1036; /* *return_and_restore_fpregs_si_r12 */

                case 2:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1031; /* *return_and_restore_gpregs_di_r12 */

                case 3:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1037; /* *return_and_restore_fpregs_di_r12 */

                default:
                  return -1;
                }

            case 1:
              switch (pattern565 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1032; /* *return_and_restore_gpregs_si_r1 */

                case 1:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1038; /* *return_and_restore_fpregs_si_r1 */

                case 2:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1033; /* *return_and_restore_gpregs_di_r1 */

                case 3:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1039; /* *return_and_restore_fpregs_di_r1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CLOBBER:
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 96)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x3) != 0)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          switch (REGNO (x9))
            {
            case 11:
              switch (pattern568 (x1))
                {
                case 0:
                  if (!(
#line 461 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1811; /* *save_vregs_si_r11 */

                case 1:
                  if (!(
#line 461 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1812; /* *save_vregs_di_r11 */

                case 2:
                  if (!(
#line 487 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1815; /* *restore_vregs_si_r11 */

                case 3:
                  if (!(
#line 487 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1816; /* *restore_vregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern568 (x1))
                {
                case 0:
                  if (!(
#line 474 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1813; /* *save_vregs_si_r12 */

                case 1:
                  if (!(
#line 474 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1814; /* *save_vregs_di_r12 */

                case 2:
                  if (!(
#line 500 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1817; /* *restore_vregs_si_r12 */

                case 3:
                  if (!(
#line 500 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1818; /* *restore_vregs_di_r12 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 15:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 459; /* rs6000_mtfsb0 */

            case 16:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6518 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 460; /* rs6000_mtfsb1 */

            case 0:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 867; /* blockage */

            case 18:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 989; /* speculation_barrier */

            case 4:
              if (pnum_clobbers == NULL)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1044; /* eh_set_lr_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1045; /* eh_set_lr_di */

                default:
                  return -1;
                }

            case 5:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                  if (XWINT (x5, 0) != 0L)
                    return -1;
                  return 1216; /* isync */

                case REG:
                case SUBREG:
                  if (pnum_clobbers == NULL)
                    return -1;
                  operands[0] = x5;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1217; /* loadsync_qi */

                    case E_HImode:
                      if (!register_operand (operands[0], E_HImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1218; /* loadsync_hi */

                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1219; /* loadsync_si */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 111 "../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1220; /* loadsync_di */

                    case E_TImode:
                      if (!register_operand (operands[0], E_TImode)
                          || !
#line 112 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1221; /* loadsync_ti */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 24:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2951 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2161; /* altivec_dssall */

            case 25:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!immediate_operand (operands[0], E_QImode)
                  || !
#line 2958 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2162; /* altivec_dss */

            default:
              return -1;
            }

        case 2:
          switch (XINT (x1, 1))
            {
            case 17:
              x5 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 0
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 96
                  || GET_MODE (x6) != E_SImode)
                return -1;
              return 1050; /* split_stack_return */

            case 13:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14688 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1066; /* rs6000_mtfsf */

            case 14:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14695 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1067; /* rs6000_mtfsf_hi */

            case 96:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!int_reg_operand (operands[0], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!simple_offsettable_mem_operand (operands[1], E_DImode)
                  || !
#line 15858 "../../gcc/config/rs6000/rs6000.md"
(rs6000_rop_protect))
                return -1;
              return 1213; /* hashchk */

            case 39:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!u10bit_cint_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!gpc_reg_operand (operands[0], E_SImode)
                      || !
#line 280 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                    return -1;
                  return 2507; /* htm_mtspr_si */

                case E_DImode:
                  if (!gpc_reg_operand (operands[0], E_DImode)
                      || !(
#line 280 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2508; /* htm_mtspr_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!
#line 13515 "../../gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 977; /* return */

    case SIMPLE_RETURN:
      return 978; /* simple_return */

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          x5 = XVECEXP (x1, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (XINT (x1, 1))
            {
            case 57:
              return 987; /* nop */

            case 58:
              return 988; /* group_ending_nop */

            default:
              return -1;
            }

        case 3:
          x5 = XVECEXP (x1, 0, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          operands[2] = x8;
          if (!immediate_operand (operands[2], E_QImode))
            return -1;
          switch (XINT (x1, 1))
            {
            case 272:
              if (!
#line 2966 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2163; /* altivec_dst */

            case 273:
              if (!
#line 2974 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2164; /* altivec_dstt */

            case 274:
              if (!
#line 2982 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2165; /* altivec_dstst */

            case 275:
              if (!
#line 2990 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2166; /* altivec_dststt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x13 = XEXP (x1, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x1, 0);
      switch (GET_CODE (x14))
        {
        case CONST_INT:
          if (XWINT (x14, 0) != 1L)
            return -1;
          return 998; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[0] = x14;
          if (!ordered_comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          x16 = XEXP (x14, 1);
          operands[2] = x16;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !reg_or_short_operand (operands[2], E_SImode))
                return -1;
              return 999; /* *rs6000.md:13918 */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !reg_or_short_operand (operands[2], E_DImode)
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 1000; /* *rs6000.md:13918 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EH_RETURN:
      return 1046; /* eh_return_internal */

    case PREFETCH:
      x14 = XEXP (x1, 0);
      operands[0] = x14;
      if (!indexed_or_indirect_address (operands[0], E_VOIDmode))
        return -1;
      x13 = XEXP (x1, 1);
      operands[1] = x13;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x1, 2);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 1047; /* prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IOR:
      res = split_10 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern263 (x2))
            {
            case 0:
              return gen_split_86 (insn, operands);

            case 1:
              if (
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return gen_split_88 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case AND:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == ASHIFT)
            {
              switch (pattern219 (x2))
                {
                case 0:
                  if ((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_106 (insn, operands);
                  break;

                case 1:
                  if (((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_108 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case ASHIFT:
          switch (pattern207 (x2))
            {
            case 0:
              if (
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                return gen_split_111 (insn, operands);
              break;

            case 1:
              if ((
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return gen_split_114 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pattern358 (
E_TImode) != 0
          || !
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
        return NULL;
      return gen_split_239 (insn, operands);

    case E_PTImode:
      if (pattern358 (
E_PTImode) != 0
          || !
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
        return NULL;
      return gen_split_240 (insn, operands);

    case E_V16QImode:
      if (pattern358 (
E_V16QImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_241 (insn, operands);

    case E_V8HImode:
      if (pattern358 (
E_V8HImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_242 (insn, operands);

    case E_V4SImode:
      if (pattern358 (
E_V4SImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_243 (insn, operands);

    case E_V4SFmode:
      if (pattern358 (
E_V4SFmode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_244 (insn, operands);

    case E_V2DImode:
      if (pattern358 (
E_V2DImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_245 (insn, operands);

    case E_V2DFmode:
      if (pattern358 (
E_V2DFmode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_246 (insn, operands);

    case E_V1TImode:
      if (pattern358 (
E_V1TImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_247 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_VECTOR:
    case VEC_DUPLICATE:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (gpc_reg_operand (operands[0], E_SImode)
              && const_int_operand (operands[1], E_SImode)
              && 
#line 8013 "../../gcc/config/rs6000/rs6000.md"
(num_insns_constant (operands[1], SImode) > 1))
            return gen_split_295 (insn, operands);
          if (altivec_register_operand (operands[0], E_SImode)
              && xxspltib_constant_split (operands[1], E_SImode)
              && 
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_386 (insn, operands);
          break;

        case E_DImode:
          if (altivec_register_operand (operands[0], E_DImode)
              && xxspltib_constant_split (operands[1], E_DImode)
              && 
#line 8026 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_296 (insn, operands);
          if (gpc_reg_operand (operands[0], E_DImode)
              && const_int_operand (operands[1], E_DImode)
              && 
#line 9838 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
            return gen_split_377 (insn, operands);
          break;

        case E_DFmode:
          if (gpc_reg_operand (operands[0], E_DFmode)
              && const_int_operand (operands[1], E_DFmode)
              && 
#line 8483 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_304 (insn, operands);
          break;

        case E_DDmode:
          if (gpc_reg_operand (operands[0], E_DDmode)
              && const_int_operand (operands[1], E_DDmode)
              && 
#line 8483 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_305 (insn, operands);
          break;

        case E_QImode:
          if (altivec_register_operand (operands[0], E_QImode)
              && xxspltib_constant_split (operands[1], E_QImode)
              && 
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_384 (insn, operands);
          break;

        case E_HImode:
          if (altivec_register_operand (operands[0], E_HImode)
              && xxspltib_constant_split (operands[1], E_HImode)
              && 
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_385 (insn, operands);
          break;

        case E_PTImode:
          if (int_reg_operand (operands[0], E_PTImode)
              && const_scalar_int_operand (operands[1], E_PTImode)
              && 
#line 10063 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (PTImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))))
            return gen_split_389 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) == VEC_DUPLICATE
          && GET_MODE (x3) == E_V4SFmode
          && vsx_register_operand (operands[0], E_V4SFmode))
        {
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (splat_input_operand (operands[1], E_SFmode)
              && (
#line 4832 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 4837 "../../gcc/config/rs6000/vsx.md"
( reload_completed && vsx_register_operand (operands[1], SFmode))))
            return gen_split_676 (insn, operands);
        }
      break;

    case CONST_DOUBLE:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (gpc_reg_operand (operands[0], E_SFmode)
              && const_double_operand (operands[1], E_SFmode)
              && 
#line 8216 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_299 (insn, operands);
          break;

        case E_SDmode:
          if (gpc_reg_operand (operands[0], E_SDmode)
              && const_double_operand (operands[1], E_SDmode)
              && 
#line 8216 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_300 (insn, operands);
          break;

        case E_DFmode:
          if (gpc_reg_operand (operands[0], E_DFmode)
              && const_double_operand (operands[1], E_DFmode))
            {
              if (
#line 8503 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_306 (insn, operands);
              if (
#line 8525 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_308 (insn, operands);
            }
          break;

        case E_DDmode:
          if (gpc_reg_operand (operands[0], E_DDmode)
              && const_double_operand (operands[1], E_DDmode))
            {
              if (
#line 8503 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_307 (insn, operands);
              if (
#line 8525 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_309 (insn, operands);
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  res = split_13 (x1, insn);
  if (res != NULL_RTX)
    return res;
  if (vsx_register_operand (operands[0], E_V1TImode)
      && GET_CODE (x3) == SUBREG
      && known_eq (SUBREG_BYTE (x3), 0)
      && GET_MODE (x3) == E_V1TImode)
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (int_reg_operand (operands[1], E_TImode)
          && 
#line 6769 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && !reload_completed))
        return gen_split_690 (insn, operands);
    }
  operands[1] = x3;
  if (vsx_register_operand (operands[1], E_V1TImode)
      && gpc_reg_operand (operands[0], E_V1TImode)
      && 
#line 6796 "../../gcc/config/rs6000/vsx.md"
(reload_completed
   && TARGET_DIRECT_MOVE_64BIT
   && int_reg_operand (operands[0], V1TImode)
   && vsx_register_operand (operands[1], V1TImode)))
    return gen_split_691 (insn, operands);
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!altivec_register_operand (operands[0], E_DImode)
          || !xxspltib_constant_split (operands[1], E_DImode)
          || !
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_387 (insn, operands);

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V8HImode)
          && (
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_596 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V8HImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && reload_completed))
        return gen_split_693 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V8HImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && reload_completed))
        return gen_split_703 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V8HImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_713 (insn, operands);

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V4SImode)
          && (
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_597 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V4SImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && reload_completed))
        return gen_split_692 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V4SImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && reload_completed))
        return gen_split_702 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V4SImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_712 (insn, operands);

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V2DImode)
          && (
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_598 (insn, operands);
      if (vspltisw_vupkhsw_constant_split (operands[1], E_V2DImode)
          && (
#line 1213 "../../gcc/config/rs6000/vsx.md"
(TARGET_P8_VECTOR && vspltisw_vupkhsw_constant_split (operands[1], V2DImode)) && 
#line 1215 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_599 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V2DImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && reload_completed))
        return gen_split_697 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V2DImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && reload_completed))
        return gen_split_707 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V2DImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_717 (insn, operands);

    default:
      return NULL;
    }
}
