/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[0] = x9;
  return 0;
}

int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return pattern34 (x3); /* [-1, 3] */
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern66 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern109 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_CCUNSmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern113 (x4, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern113 (x4, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1))
    return -1;
  return 0;
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 4;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern177 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return pattern180 (x1); /* [-1, 1] */
}

int
pattern186 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 106
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern191 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case NOT:
      return pattern194 (x5); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern192 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_IFmode)
      || GET_MODE (x1) != E_IFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!gpc_reg_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern213 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  return pattern218 (x1); /* [-1, 1] */
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern232 (x3, 
i1); /* [-1, 0] */
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern193 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern193 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern243 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern243 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern243 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern243 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern243 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern243 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern243 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern243 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern243 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern243 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern244 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern244 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern245 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern245 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern245 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern245 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern245 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern245 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern245 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern245 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern245 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern245 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern282 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !rs6000_tls_symbol_ref (operands[2], i1))
    return -1;
  return 0;
}

int
pattern295 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!scratch_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern301 (x5); /* [-1, 1] */
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern319 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern329 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern336 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern344 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern353 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 98)
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern352 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern352 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!base_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[2], E_QImode)
          || !fusion_gpr_mem_load (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!base_reg_operand (operands[2], E_HImode)
          || !fusion_gpr_mem_load (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!base_reg_operand (operands[2], E_SImode)
          || !fusion_gpr_mem_load (operands[3], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!base_reg_operand (operands[2], E_DImode)
          || !fusion_gpr_mem_load (operands[3], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern381 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern390 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern399 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern397 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern397 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern398 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern398 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern398 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern398 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern398 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern398 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern398 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern398 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern398 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern398 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern413 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!vfloat_operand (operands[0], E_DFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DFmode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!vfloat_operand (operands[1], E_V2DFmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_DFmode))
    return -1;
  x10 = XEXP (x5, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x4, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  return 0;
}

int
pattern423 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern437 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_XOmode
      || !fpr_reg_operand (operands[0], E_XOmode)
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern443 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern450 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || !memory_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern478 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern490 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !immediate_operand (operands[2], i1)
      || !immediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern494 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern503 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], E_V2DImode)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern508 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern521 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern538 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_TImode)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != E_TImode)
    return -1;
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      return pattern547 (x1, 
SIGN_EXTEND); /* [-1, 0] */

    case ZERO_EXTEND:
      if (pattern547 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern558 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern563 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern571 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern578 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern577 (x8, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern577 (x8, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern600 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1)
      || !memory_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !const_int_operand (operands[5], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      switch (XINT (x3, 1))
        {
        case 150:
          if (GET_MODE (x3) != E_DFmode
              || !cc_reg_operand (operands[0], E_CCFPmode)
              || !vsx_register_operand (operands[1], E_DFmode)
              || !vsx_register_operand (operands[2], E_DFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode)
              || !
#line 5305 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1680; /* *xscmpexpdp */

        case 151:
          if (!cc_reg_operand (operands[0], E_CCFPmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !altivec_register_operand (operands[2], E_KFmode)
                  || !(
#line 5339 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1681; /* *xscmpexpqp */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !altivec_register_operand (operands[2], E_TFmode)
                  || !(
#line 5339 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1682; /* *xscmpexpqp */

            default:
              return -1;
            }

        case 152:
          x7 = XEXP (x2, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !u7bit_cint_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_SFmode:
              if (!vsx_register_operand (operands[1], E_SFmode)
                  || !
#line 5452 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (SFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1683; /* *xststdc_sf */

            case E_DFmode:
              if (!vsx_register_operand (operands[1], E_DFmode)
                  || !
#line 5452 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (DFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1684; /* *xststdc_df */

            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 5452 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (KFmode) || TARGET_FLOAT128_HW)) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1685; /* *xststdc_kf */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 5452 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (TFmode) || TARGET_FLOAT128_HW)) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1686; /* *xststdc_tf */

            default:
              return -1;
            }

        case 430:
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DDmode:
              if (!gpc_reg_operand (operands[2], E_DDmode)
                  || !
#line 368 "../../../gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2463; /* *dfp_sgnfcnc_dd */

            case E_TDmode:
              if (!gpc_reg_operand (operands[2], E_TDmode)
                  || !
#line 368 "../../../gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2464; /* *dfp_sgnfcnc_td */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      if (!const_0_to_1_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      if (!zero_constant (operands[4], E_V2DFmode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 342:
          switch (pattern569 ())
            {
            case 0:
              if (!
#line 4610 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2337; /* *bcdadd_test_v1ti */

            case 1:
              if (!
#line 4610 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2339; /* *bcdadd_test_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern569 ())
            {
            case 0:
              if (!
#line 4610 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2338; /* *bcdsub_test_v1ti */

            case 1:
              if (!
#line 4610 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2340; /* *bcdsub_test_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x3, 1) != 343
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!zero_constant (operands[2], E_V2DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1TImode:
          if (!register_operand (operands[1], E_V1TImode)
              || !
#line 4737 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2353; /* *bcdinvalid_v1ti */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !
#line 4737 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2354; /* *bcdinvalid_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LT:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern330 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 4257 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 252; /* *lt0_sidi */

                case 1:
                  return 254; /* *lt0_sisi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern330 (x2, 
E_DImode))
                {
                case 0:
                  if (!
#line 4257 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 253; /* *lt0_didi */

                case 1:
                  if (!
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 255; /* *lt0_disi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
                return -1;
              return 1236; /* vector_ltv4sf */

            case 1:
              if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
                return -1;
              return 1243; /* vector_ltv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNORDERED:
      switch (pattern11 (x2))
        {
        case 0:
          if (!
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1252; /* vector_unorderedv4sf */

        case 1:
          if (!
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1256; /* vector_unorderedv2df */

        default:
          return -1;
        }

    case EQ:
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && vsx_register_operand (operands[2], E_V4SFmode)
              && 
#line 2159 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1381; /* vsx_eqv4sf */
          if (!altivec_register_operand (operands[0], E_V4SFmode)
              || !altivec_register_operand (operands[1], E_V4SFmode)
              || !altivec_register_operand (operands[2], E_V4SFmode)
              || !
#line 674 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1865; /* *altivec_eqv4sf */

        case E_V2DFmode:
          if (pattern2 (x2, 
E_V2DFmode) != 0
              || !
#line 2159 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1382; /* vsx_eqv2df */

        case E_V1TImode:
          if (pattern1 (x2, 
E_V1TImode) != 0
              || !
#line 626 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1850; /* altivec_eqv1ti */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0
              || !
#line 634 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1851; /* altivec_eqv4si */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0
              || !
#line 634 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1852; /* altivec_eqv8hi */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0
              || !
#line 634 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1853; /* altivec_eqv16qi */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 634 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1854; /* altivec_eqv2di */

        default:
          return -1;
        }

    case GT:
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && vsx_register_operand (operands[2], E_V4SFmode)
              && 
#line 2167 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1383; /* vsx_gtv4sf */
          if (!altivec_register_operand (operands[0], E_V4SFmode)
              || !altivec_register_operand (operands[1], E_V4SFmode)
              || !altivec_register_operand (operands[2], E_V4SFmode)
              || !
#line 682 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1866; /* *altivec_gtv4sf */

        case E_V2DFmode:
          if (pattern2 (x2, 
E_V2DFmode) != 0
              || !
#line 2167 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1384; /* vsx_gtv2df */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0
              || !
#line 642 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1855; /* *altivec_gtv4si */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0
              || !
#line 642 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1856; /* *altivec_gtv8hi */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0
              || !
#line 642 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1857; /* *altivec_gtv16qi */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 642 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1858; /* *altivec_gtv2di */

        case E_V1TImode:
          if (pattern1 (x2, 
E_V1TImode) != 0
              || !
#line 650 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1859; /* *altivec_gtv1ti */

        default:
          return -1;
        }

    case GTU:
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0
              || !
#line 658 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1860; /* *altivec_gtuv4si */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0
              || !
#line 658 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1861; /* *altivec_gtuv8hi */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0
              || !
#line 658 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1862; /* *altivec_gtuv16qi */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 658 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1863; /* *altivec_gtuv2di */

        case E_V1TImode:
          if (pattern1 (x2, 
E_V1TImode) != 0
              || !
#line 666 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1864; /* *altivec_gtuv1ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || !scc_comparison_operator (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (cc_reg_operand (operands[2], E_CCmode)
              && 
#line 5599 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return 361; /* setbc_cc_si */
          break;

        case E_CCUNSmode:
          if (cc_reg_operand (operands[2], E_CCUNSmode)
              && 
#line 5599 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return 363; /* setbc_ccuns_si */
          break;

        default:
          break;
        }
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return -1;
      return 886; /* setsi_cc */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !scc_comparison_operator (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (cc_reg_operand (operands[2], E_CCmode)
              && (
#line 5599 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return 362; /* setbc_cc_di */
          break;

        case E_CCUNSmode:
          if (cc_reg_operand (operands[2], E_CCUNSmode)
              && (
#line 5599 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return 364; /* setbc_ccuns_di */
          break;

        default:
          break;
        }
      if (!cc_reg_operand (operands[2], E_VOIDmode)
          || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 887; /* setdi_cc */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern287 (
E_SImode))
        {
        case 0:
          if (!
#line 5608 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 365; /* *setbcr_cc_si */

        case 1:
          if (!
#line 5608 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 367; /* *setbcr_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern287 (
E_DImode))
        {
        case 0:
          if (!(
#line 5608 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 366; /* *setbcr_cc_di */

        case 1:
          if (!(
#line 5608 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 368; /* *setbcr_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 894; /* lesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 914; /* lesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 904; /* ledisi2_isel */

        case 1:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 924; /* ledidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V4SFmode) != 0
          || !
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
        return -1;
      return 1237; /* vector_lev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V2DFmode) != 0
          || !
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
        return -1;
      return 1244; /* vector_lev2df */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      switch (XINT (x3, 1))
        {
        case 14:
          x4 = XVECEXP (x3, 0, 0);
          operands[2] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern430 (x2, 
E_SImode) != 0
                  || !(
#line 10607 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 752; /* *tls_gd_low32 */

            case E_DImode:
              if (pattern430 (x2, 
E_DImode) != 0
                  || !(
#line 10607 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 753; /* *tls_gd_low64 */

            default:
              return -1;
            }

        case 23:
          switch (pattern289 (x2))
            {
            case 0:
              if (!(
#line 10720 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 772; /* *tls_got_dtprel_low32 */

            case 1:
              if (!(
#line 10720 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 773; /* *tls_got_dtprel_low64 */

            default:
              return -1;
            }

        case 27:
          switch (pattern289 (x2))
            {
            case 0:
              if (!(
#line 10800 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 786; /* *tls_got_tprel_low32 */

            case 1:
              if (!(
#line 10800 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 787; /* *tls_got_tprel_low64 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (XINT (x3, 1) != 15)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern379 (x2, 
E_SImode) != 0
              || !(
#line 10652 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 760; /* *tls_ld_low32 */

        case E_DImode:
          if (pattern379 (x2, 
E_DImode) != 0
              || !(
#line 10652 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 761; /* *tls_ld_low64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != REG
          || REGNO (x3) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 124; /* subfsi3_carry_in_xx */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 125; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFTRT:
          if (pattern290 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1286 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 38; /* *macchw */

            case ASHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1353 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 42; /* *machhw */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern290 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1318 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 40; /* *macchwu */

            case LSHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1388 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 44; /* *machhwu */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern291 (x2, 
SIGN_EXTEND) != 0
              || !
#line 1417 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 46; /* *maclhw */

        case ZERO_EXTEND:
          if (pattern291 (x2, 
ZERO_EXTEND) != 0
              || !
#line 1446 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 48; /* *maclhwu */

        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern431 (x2, 
E_SImode) != 0
                  || !
#line 3265 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD))
                return -1;
              return 181; /* maddldsi4 */

            case E_DImode:
              if (pattern431 (x2, 
E_DImode) != 0
                  || !(
#line 3265 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 182; /* maddlddi4 */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !register_operand (operands[3], E_V8HImode)
                  || !
#line 1144 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 1957; /* fmav8hi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 98)
            {
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern491 (x2, 
E_SImode) == 0)
                    {
                      *pnum_clobbers = 1;
                      return 88; /* *addsi3_carry_in_internal */
                    }
                  break;

                case E_DImode:
                  if (pattern491 (x2, 
E_DImode) == 0
                      && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    {
                      *pnum_clobbers = 1;
                      return 89; /* *adddi3_carry_in_internal */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x6;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x1, 0);
              operands[3] = x5;
              if (altivec_register_operand (operands[3], E_V2DImode)
                  && GET_MODE (x2) == E_V2DImode
                  && GET_MODE (x3) == E_V2DImode)
                {
                  x7 = XEXP (x3, 1);
                  operands[1] = x7;
                  if (altivec_register_operand (operands[1], E_V2DImode))
                    {
                      operands[2] = x4;
                      if (altivec_register_operand (operands[2], E_V2DImode)
                          && 
#line 3049 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        {
                          *pnum_clobbers = 1;
                          return 3341; /* *fuse_vaddudm_vaddudm */
                        }
                    }
                }
            }
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[2] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern507 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 90; /* *addsi3_carry_in_internal2 */

                case E_DImode:
                  if (pattern507 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 91; /* *adddi3_carry_in_internal2 */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x4, 0) != -1L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern508 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 94; /* addsi3_carry_in_m1 */

                case E_DImode:
                  if (pattern508 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 95; /* adddi3_carry_in_m1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern492 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 118; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern492 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              *pnum_clobbers = 1;
              return 119; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern432 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 120; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern432 (x2, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 121; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern459 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 122; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern459 (x2, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 123; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ASHIFT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern219 (x2))
        {
        case 0:
          if (!
#line 4333 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
            return -1;
          return 262; /* *rotlsi3_insert_3_plus */

        case 1:
          if (!(
#line 4333 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 264; /* *rotldi3_insert_3_plus */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 1)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x13 = XVECEXP (x10, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (pattern4 (x2) != 0
          || !
#line 4927 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1635; /* vsx_reduc_plus_v2df */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 102
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!vfloat_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!vfloat_operand (operands[1], E_V4SFmode)
          || !
#line 4949 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1638; /* vsx_reduc_plus_v4sf */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_PTImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case MEM:
      if (!quad_memory_operand (operands[1], E_TImode)
          || !quad_int_reg_operand (operands[0], E_PTImode)
          || !
#line 130 "../../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI
   && !reg_mentioned_p (operands[0], operands[1])))
        return -1;
      return 1222; /* load_quadpti */

    case REG:
      if (!quad_int_reg_operand (operands[1], E_PTImode)
          || !quad_memory_operand (operands[0], E_PTImode)
          || !
#line 206 "../../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
        return -1;
      return 1223; /* store_quadpti */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern464 (x3, 
E_QImode, 
E_V16QImode) != 0
              || !const_0_to_15_operand (operands[3], E_QImode)
              || !
#line 4592 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1603; /* vsx_set_v16qi_p9 */

        case E_V8HImode:
          if (pattern464 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !const_0_to_7_operand (operands[3], E_QImode)
              || !
#line 4592 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1604; /* vsx_set_v8hi_p9 */

        case E_V4SImode:
          if (pattern465 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 4592 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1605; /* vsx_set_v4si_p9 */

        case E_V4SFmode:
          if (pnum_clobbers == NULL
              || pattern465 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 4616 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 1606; /* vsx_set_v4sf_p9 */

        default:
          return -1;
        }

    case CONST_DOUBLE:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x5;
      if (!zero_fp_constant (operands[2], E_SFmode)
          || !gpc_reg_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_3_operand (operands[3], E_QImode)
          || !
#line 4652 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 1;
      return 1607; /* *vsx_set_v4sf_p9_zero */

    case VEC_SELECT:
      if (GET_MODE (x5) != E_SFmode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1
          || !gpc_reg_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x9 = XVECEXP (x7, 0, 0);
      operands[3] = x9;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      if (!const_0_to_3_operand (operands[4], E_QImode))
        return -1;
      if (
#line 4683 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) == (BYTES_BIG_ENDIAN ? 1 : 2))))
        return 1608; /* *vsx_insert_extract_v4sf_p9 */
      if (pnum_clobbers == NULL
          || !
#line 4712 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
        return -1;
      *pnum_clobbers = 1;
      return 1609; /* *vsx_insert_extract_v4sf_p9_2 */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          switch (pattern439 (x2, 
E_V16QImode))
            {
            case 0:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2199; /* altivec_lvx_v16qi_2op_si */

            case 1:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2200; /* altivec_lvx_v16qi_2op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern439 (x2, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2203; /* altivec_lvx_v2df_2op_si */

            case 1:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2204; /* altivec_lvx_v2df_2op_di */

            default:
              return -1;
            }

        case E_KFmode:
          switch (pattern439 (x2, 
E_KFmode))
            {
            case 0:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 2209; /* altivec_lvx_kf_2op_si */

            case 1:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 2210; /* altivec_lvx_kf_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          switch (pattern384 (x2, 
E_V16QImode))
            {
            case 0:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2217; /* altivec_lvx_v16qi_1op_si */

            case 1:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2218; /* altivec_lvx_v16qi_1op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern384 (x2, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2221; /* altivec_lvx_v2df_1op_si */

            case 1:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2222; /* altivec_lvx_v2df_1op_di */

            default:
              return -1;
            }

        case E_KFmode:
          switch (pattern384 (x2, 
E_KFmode))
            {
            case 0:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 2227; /* altivec_lvx_kf_1op_si */

            case 1:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 2228; /* altivec_lvx_kf_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[1] = x4;
      if (s8bit_cint_operand (operands[1], E_SImode)
          && vsx_register_operand (operands[0], E_V16QImode)
          && GET_MODE (x3) == E_V16QImode
          && 
#line 1146 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1283; /* xxspltib_v16qi */
      if (!s5bit_cint_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 2461 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2072; /* altivec_vspltisb */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[1], E_DFmode)
              && 
#line 4787 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return 1610; /* vsx_splat_v2df_reg */
          if (!memory_operand (operands[1], E_DFmode)
              || !
#line 4797 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return -1;
          return 1612; /* vsx_splat_v2df_mem */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !splat_input_operand (operands[1], E_SFmode)
              || !
#line 4832 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1616; /* vsx_splat_v4sf */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode
              || GET_MODE (x4) != E_SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && 
#line 4856 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
            return 1617; /* vsx_xxspltw_v4sf */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !
#line 2448 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 2069; /* *altivec_vspltsf_internal */

        case E_V16QImode:
          if (pattern438 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 2334 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2063; /* *altivec_vspltb_internal */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x4) != E_QImode
          || !altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!altivec_register_operand (operands[1], E_DImode)
          || !
#line 4880 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 1621; /* vsx_vspltb_di */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          switch (pattern439 (x2, 
E_V8HImode))
            {
            case 0:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2197; /* altivec_lvx_v8hi_2op_si */

            case 1:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2198; /* altivec_lvx_v8hi_2op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern439 (x2, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2205; /* altivec_lvx_v2di_2op_si */

            case 1:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2206; /* altivec_lvx_v2di_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          switch (pattern384 (x2, 
E_V8HImode))
            {
            case 0:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2215; /* altivec_lvx_v8hi_1op_si */

            case 1:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2216; /* altivec_lvx_v8hi_1op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern384 (x2, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2223; /* altivec_lvx_v2di_1op_si */

            case 1:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2224; /* altivec_lvx_v2di_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (pattern22 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 9; /* *zero_extendqisi2_dot */

        case 1:
          *pnum_clobbers = 1;
          return 15; /* *zero_extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 10; /* *zero_extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 16; /* *zero_extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 20; /* *zero_extendsidi2_dot */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern22 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 24; /* *extendqisi2_dot */

        case 1:
          *pnum_clobbers = 1;
          return 30; /* *extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 25; /* *extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 31; /* *extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 35; /* *extendsidi2_dot */

        default:
          return -1;
        }

    case PLUS:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (pattern418 (x3))
            {
            case 0:
              if (!
#line 1872 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 70; /* *addsi3_dot */

            case 1:
              if (!(
#line 1872 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 71; /* *adddi3_dot */

            default:
              return -1;
            }

        case CONST_INT:
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !short_cint_operand (operands[2], E_SImode)
                  || !
#line 1919 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 2;
              return 74; /* *addsi3_imm_dot */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !short_cint_operand (operands[2], E_DImode)
                  || !(
#line 1919 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 2;
              return 75; /* *adddi3_imm_dot */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern24 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 2132 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 98; /* *one_cmplsi2_dot */

        case 1:
          if (!(
#line 2132 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 99; /* *one_cmpldi2_dot */

        default:
          return -1;
        }

    case MINUS:
      if (pattern25 (x1, pnum_clobbers) != 0)
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !
#line 2215 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 104; /* *subfsi3_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !(
#line 2215 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 105; /* *subfdi3_dot */

        default:
          return -1;
        }

    case NEG:
      switch (pattern24 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 2410 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 129; /* *negsi2_dot */

        case 1:
          if (!(
#line 2410 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 130; /* *negdi2_dot */

        default:
          return -1;
        }

    case MULT:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (pattern418 (x3))
        {
        case 0:
          if (!
#line 3124 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 167; /* *mulsi3_dot */

        case 1:
          if (!(
#line 3124 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 168; /* *muldi3_dot */

        default:
          return -1;
        }

    case DIV:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode)
              || !exact_log2_cint_operand (operands[2], E_SImode)
              || !
#line 3394 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 2;
          return 194; /* *divsi3_sra_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !exact_log2_cint_operand (operands[2], E_DImode)
              || !(
#line 3394 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 2;
          return 195; /* *divdi3_sra_dot */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      return recog_3 (x1, insn, pnum_clobbers);

    case ROTATE:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4590 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 278; /* *rotlsi3_dot */

        case 1:
          if (!(
#line 4590 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 279; /* *rotldi3_dot */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern25 (x1, pnum_clobbers) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern26 (x3))
            {
            case 0:
              if (!
#line 4658 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 285; /* *ashlsi3_dot */

            case 1:
              if (!(
#line 4658 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 286; /* *ashldi3_dot */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!reg_or_mem_operand (operands[1], E_SImode)
              || !u6bit_cint_operand (operands[2], E_DImode)
              || !
#line 4732 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          *pnum_clobbers = 1;
          return 290; /* ashdi3_extswsli_dot */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4847 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 295; /* *lshrsi3_dot */

        case 1:
          if (!(
#line 4847 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 296; /* *lshrdi3_dot */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4918 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 2;
          return 302; /* *ashrsi3_dot */

        case 1:
          if (!(
#line 4918 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 2;
          return 303; /* *ashrdi3_dot */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_CCFPmode:
          if (!cc_reg_operand (operands[0], E_CCFPmode)
              || GET_MODE (x2) != E_CCFPmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!gpc_reg_operand (operands[1], E_SFmode)
                  || !gpc_reg_operand (operands[2], E_SFmode)
                  || !
#line 5221 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 326; /* *cmpsf_fpr */

            case E_DFmode:
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !gpc_reg_operand (operands[2], E_DFmode)
                  || !
#line 5221 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 327; /* *cmpdf_fpr */

            case E_IFmode:
              if (!gpc_reg_operand (operands[1], E_IFmode)
                  || !gpc_reg_operand (operands[2], E_IFmode))
                return -1;
              if ((
#line 12704 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return 880; /* *cmpif_internal1 */
              if (pnum_clobbers == NULL)
                return -1;
              if ((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                {
                  *pnum_clobbers = 9;
                  return 882; /* *cmpif_internal2 */
                }
              if (!(
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return -1;
              *pnum_clobbers = 9;
              return 883; /* *cmpif_internal2 */

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode)
                  && gpc_reg_operand (operands[2], E_TFmode))
                {
                  if ((
#line 12704 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 881; /* *cmptf_internal1 */
                  if (pnum_clobbers != NULL)
                    {
                      if ((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                        {
                          *pnum_clobbers = 9;
                          return 884; /* *cmptf_internal2 */
                        }
                      if ((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                        {
                          *pnum_clobbers = 9;
                          return 885; /* *cmptf_internal2 */
                        }
                    }
                }
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !altivec_register_operand (operands[2], E_TFmode)
                  || !(
#line 15603 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1204; /* *cmptf_hw */

            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !altivec_register_operand (operands[2], E_KFmode)
                  || !(
#line 15603 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1203; /* *cmpkf_hw */

            case E_DDmode:
              if (!gpc_reg_operand (operands[1], E_DDmode)
                  || !gpc_reg_operand (operands[2], E_DDmode)
                  || !
#line 209 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2444; /* *cmpdd_internal1 */

            case E_TDmode:
              if (!gpc_reg_operand (operands[1], E_TDmode)
                  || !gpc_reg_operand (operands[2], E_TDmode)
                  || !
#line 209 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2445; /* *cmptd_internal1 */

            default:
              return -1;
            }

        case E_CCmode:
          if (!cc_reg_operand (operands[0], E_CCmode))
            return -1;
          switch (pattern319 (x2, 
E_CCmode))
            {
            case 0:
              return 876; /* *cmpsi_signed */

            case 1:
              if (!
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 877; /* *cmpdi_signed */

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[0], E_CCUNSmode))
            return -1;
          switch (pattern127 (x2, 
E_CCUNSmode))
            {
            case 0:
              return 878; /* *cmpsi_unsigned */

            case 1:
              if (!
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 879; /* *cmpdi_unsigned */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNLE:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!cc_reg_operand (operands[0], E_CCEQmode)
          || GET_MODE (x2) != E_CCEQmode)
        return -1;
      operands[1] = x3;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case EQ:
        case GT:
        case LT:
        case GTU:
        case LTU:
        case UNORDERED:
          x8 = XEXP (x2, 1);
          if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (branch_positive_comparison_operator (operands[1], E_SImode))
                    return 973; /* cceq_rev_compare_si */
                  break;

                case E_DImode:
                  if (branch_positive_comparison_operator (operands[1], E_DImode)
                      && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return 974; /* cceq_rev_compare_di */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      x8 = XEXP (x2, 1);
      if (!branch_comparison_operator (x8, E_VOIDmode))
        return -1;
      operands[3] = x8;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !branch_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[4] = x10;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return -1;
      return 975; /* *rs6000.md:13454 */

    case UNSPEC:
      return recog_2 (x1, insn, pnum_clobbers);

    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      x7 = XEXP (x1, 0);
      operands[2] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x2) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_m1_to_1_operand (operands[3], E_DImode)
                  || !
#line 28 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2509; /* *ld_cmpdi_cr0_DI_clobber_CC_none */

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !
#line 112 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2513; /* *lwz_cmpwi_cr0_SI_clobber_CC_none */

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              if (
#line 239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2519; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */
                }
              if (!(
#line 239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2520; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x2) != E_CCUNSmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_0_to_1_operand (operands[3], E_DImode)
                  || !
#line 49 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2510; /* *ld_cmpldi_cr0_DI_clobber_CCUNS_none */

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !
#line 133 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2514; /* *lwz_cmpldi_cr0_SI_clobber_CCUNS_none */

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_0_to_1_operand (operands[3], E_HImode))
                return -1;
              if (
#line 260 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2521; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */
                }
              if (!(
#line 260 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2522; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

            case E_QImode:
              if (!non_update_memory_operand (operands[1], E_QImode)
                  || !const_0_to_1_operand (operands[3], E_QImode))
                return -1;
              if (
#line 323 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2527; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */
                }
              if (!(
#line 323 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2528; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = recog_17 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
    case XOR:
      res = recog_23 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern329 (
E_SImode) != 0)
            return -1;
          return 226; /* *boolsi3 */

        case E_DImode:
          if (pattern329 (
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 227; /* *booldi3 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern372 (x4, 
E_SImode) != 0)
                return -1;
              return 232; /* *boolcsi3 */

            case E_DImode:
              if (pattern372 (x4, 
E_DImode) != 0
                  || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 233; /* *boolcdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && 
#line 7451 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 525; /* *boolcti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !
#line 7488 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 534; /* *boolcti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && 
#line 7451 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 526; /* *boolcpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !
#line 7488 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 535; /* *boolcpti3_internal2 */

            case E_V16QImode:
              if (pattern373 (x4, 
E_V16QImode) != 0
                  || !(
#line 7451 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 527; /* *boolcv16qi3_internal1 */

            case E_V8HImode:
              if (pattern373 (x4, 
E_V8HImode) != 0
                  || !(
#line 7451 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 528; /* *boolcv8hi3_internal1 */

            case E_V4SImode:
              if (pattern373 (x4, 
E_V4SImode) != 0
                  || !(
#line 7451 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 529; /* *boolcv4si3_internal1 */

            case E_V4SFmode:
              if (pattern373 (x4, 
E_V4SFmode) != 0
                  || !(
#line 7451 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 530; /* *boolcv4sf3_internal1 */

            case E_V2DImode:
              if (pattern373 (x4, 
E_V2DImode) != 0
                  || !(
#line 7451 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 531; /* *boolcv2di3_internal1 */

            case E_V2DFmode:
              if (pattern373 (x4, 
E_V2DFmode) != 0
                  || !(
#line 7451 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 532; /* *boolcv2df3_internal1 */

            case E_V1TImode:
              if (pattern373 (x4, 
E_V1TImode) != 0
                  || !(
#line 7451 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 533; /* *boolcv1ti3_internal1 */

            default:
              return -1;
            }

        case NOT:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern375 (x2, 
E_SImode) != 0)
                return -1;
              return 238; /* *boolccsi3 */

            case E_DImode:
              if (pattern375 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 239; /* *boolccdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode
                  || GET_MODE (x5) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && 
#line 7511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 536; /* *boolccti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !
#line 7549 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 545; /* *boolccti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode
                  || GET_MODE (x5) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && 
#line 7511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 537; /* *boolccpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !
#line 7549 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 546; /* *boolccpti3_internal2 */

            case E_V16QImode:
              if (pattern376 (x2, 
E_V16QImode) != 0
                  || !(
#line 7511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 538; /* *boolccv16qi3_internal1 */

            case E_V8HImode:
              if (pattern376 (x2, 
E_V8HImode) != 0
                  || !(
#line 7511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 539; /* *boolccv8hi3_internal1 */

            case E_V4SImode:
              if (pattern376 (x2, 
E_V4SImode) != 0
                  || !(
#line 7511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 540; /* *boolccv4si3_internal1 */

            case E_V4SFmode:
              if (pattern376 (x2, 
E_V4SFmode) != 0
                  || !(
#line 7511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 541; /* *boolccv4sf3_internal1 */

            case E_V2DImode:
              if (pattern376 (x2, 
E_V2DImode) != 0
                  || !(
#line 7511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 542; /* *boolccv2di3_internal1 */

            case E_V2DFmode:
              if (pattern376 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 543; /* *boolccv2df3_internal1 */

            case E_V1TImode:
              if (pattern376 (x2, 
E_V1TImode) != 0
                  || !(
#line 7511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 544; /* *boolccv1ti3_internal1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern347 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3132 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1455; /* vsx_concat_v2df */

            case E_V2DImode:
              if (pattern347 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3132 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1456; /* vsx_concat_v2di */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern493 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3181 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1459; /* *vsx_concat_v2df_2 */

            case E_V2DImode:
              if (pattern493 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3181 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1460; /* *vsx_concat_v2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x11 = XVECEXP (x9, 0, 0);
      operands[2] = x11;
      if (!const_0_to_1_operand (operands[2], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern494 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3158 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1457; /* *vsx_concat_v2df_1 */

            case E_V2DImode:
              if (pattern494 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3158 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1458; /* *vsx_concat_v2di_1 */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[3] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[4] = x8;
          if (!const_0_to_1_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern561 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3206 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1461; /* *vsx_concat_v2df_3 */

            case E_V2DImode:
              if (pattern561 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3206 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1462; /* *vsx_concat_v2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 98)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 98)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern549 (x1, 
E_SImode) != 0)
        return -1;
      return 88; /* *addsi3_carry_in_internal */

    case E_DImode:
      if (pattern549 (x1, 
E_DImode) != 0
          || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 89; /* *adddi3_carry_in_internal */

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern198 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[3], E_DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_SImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern587 (x7, 
E_SImode) != 0
                  || !(
#line 10308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 709; /* *movsi_update2 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern587 (x7, 
E_DImode) != 0
                  || !(
#line 10308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 710; /* *movsi_update2 */

            default:
              return -1;
            }

        case E_HImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern551 (x7, 
E_SImode) != 0
                  || !(
#line 10389 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 721; /* *movhi_update3 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern551 (x7, 
E_DImode) != 0
                  || !(
#line 10389 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 723; /* *movhi_update3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!gpc_reg_operand (operands[3], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_SImode) != 0
              || !(
#line 10389 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 720; /* *movhi_update3 */

        case E_DImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_DImode) != 0
              || !(
#line 10389 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 722; /* *movhi_update3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (pattern355 (x1))
        {
        case 0:
          if (!
#line 4472 "../../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)))
            return -1;
          return 270; /* *iorsi_mask */

        case 1:
          if (!(
#line 4472 "../../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 271; /* *iordi_mask */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern252 (x4) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (pattern526 (x1))
        {
        case 0:
          if (!
#line 4528 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8))
            return -1;
          return 272; /* *rotldi3_insert_sf */

        case 1:
          if (!
#line 4528 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16))
            return -1;
          return 273; /* *rotldi3_insert_sf */

        case 2:
          if (!
#line 4528 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32))
            return -1;
          return 274; /* *rotldi3_insert_sf */

        default:
          return -1;
        }

    case NOT:
      return recog_163 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern247 (x1))
        {
        case 0:
          if (!
#line 1195 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2623; /* *fuse_and_or */

        case 1:
          if (!(
#line 1195 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2624; /* *fuse_and_or */

        case 2:
          if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3099; /* *fuse_vand_vor */

        case 3:
          if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3100; /* *fuse_vand_vor */

        case 4:
          if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3101; /* *fuse_vand_vor */

        case 5:
          if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3102; /* *fuse_vand_vor */

        case 6:
          if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3103; /* *fuse_vand_vor */

        case 7:
          if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3104; /* *fuse_vand_vor */

        case 8:
          if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3105; /* *fuse_vand_vor */

        case 9:
          if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3106; /* *fuse_vand_vor */

        case 10:
          if (!(
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3107; /* *fuse_vand_vor */

        case 11:
          if (!(
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3108; /* *fuse_vand_vor */

        case 12:
          if (!
#line 1375 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2643; /* *fuse_and_orc */

        case 13:
          if (!(
#line 1375 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2644; /* *fuse_and_orc */

        case 14:
          if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3179; /* *fuse_vand_vorc */

        case 15:
          if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3180; /* *fuse_vand_vorc */

        case 16:
          if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3181; /* *fuse_vand_vorc */

        case 17:
          if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3182; /* *fuse_vand_vorc */

        case 18:
          if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3183; /* *fuse_vand_vorc */

        case 19:
          if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3184; /* *fuse_vand_vorc */

        case 20:
          if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3185; /* *fuse_vand_vorc */

        case 21:
          if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3186; /* *fuse_vand_vorc */

        case 22:
          if (!(
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3187; /* *fuse_vand_vorc */

        case 23:
          if (!(
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3188; /* *fuse_vand_vorc */

        case 24:
          if (!
#line 1213 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2625; /* *fuse_andc_or */

        case 25:
          if (!(
#line 1213 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2626; /* *fuse_andc_or */

        case 26:
          if (!
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3109; /* *fuse_vandc_vor */

        case 27:
          if (!
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3110; /* *fuse_vandc_vor */

        case 28:
          if (!
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3111; /* *fuse_vandc_vor */

        case 29:
          if (!
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3112; /* *fuse_vandc_vor */

        case 30:
          if (!
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3113; /* *fuse_vandc_vor */

        case 31:
          if (!
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3114; /* *fuse_vandc_vor */

        case 32:
          if (!
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3115; /* *fuse_vandc_vor */

        case 33:
          if (!
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3116; /* *fuse_vandc_vor */

        case 34:
          if (!(
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3117; /* *fuse_vandc_vor */

        case 35:
          if (!(
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3118; /* *fuse_vandc_vor */

        case 36:
          if (!
#line 1393 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2645; /* *fuse_andc_orc */

        case 37:
          if (!(
#line 1393 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2646; /* *fuse_andc_orc */

        case 38:
          if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3189; /* *fuse_vandc_vorc */

        case 39:
          if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3190; /* *fuse_vandc_vorc */

        case 40:
          if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3191; /* *fuse_vandc_vorc */

        case 41:
          if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3192; /* *fuse_vandc_vorc */

        case 42:
          if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3193; /* *fuse_vandc_vorc */

        case 43:
          if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3194; /* *fuse_vandc_vorc */

        case 44:
          if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3195; /* *fuse_vandc_vorc */

        case 45:
          if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3196; /* *fuse_vandc_vorc */

        case 46:
          if (!(
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3197; /* *fuse_vandc_vorc */

        case 47:
          if (!(
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3198; /* *fuse_vandc_vorc */

        case 48:
          if (!
#line 1267 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2631; /* *fuse_nor_or */

        case 49:
          if (!(
#line 1267 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2632; /* *fuse_nor_or */

        case 50:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3139; /* *fuse_vnor_vor */

        case 51:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3140; /* *fuse_vnor_vor */

        case 52:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3141; /* *fuse_vnor_vor */

        case 53:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3142; /* *fuse_vnor_vor */

        case 54:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3143; /* *fuse_vnor_vor */

        case 55:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3144; /* *fuse_vnor_vor */

        case 56:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3145; /* *fuse_vnor_vor */

        case 57:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3146; /* *fuse_vnor_vor */

        case 58:
          if (!(
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3147; /* *fuse_vnor_vor */

        case 59:
          if (!(
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3148; /* *fuse_vnor_vor */

        case 60:
          if (!
#line 1447 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2651; /* *fuse_nor_orc */

        case 61:
          if (!(
#line 1447 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2652; /* *fuse_nor_orc */

        case 62:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3219; /* *fuse_vnor_vorc */

        case 63:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3220; /* *fuse_vnor_vorc */

        case 64:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3221; /* *fuse_vnor_vorc */

        case 65:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3222; /* *fuse_vnor_vorc */

        case 66:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3223; /* *fuse_vnor_vorc */

        case 67:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3224; /* *fuse_vnor_vorc */

        case 68:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3225; /* *fuse_vnor_vorc */

        case 69:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3226; /* *fuse_vnor_vorc */

        case 70:
          if (!(
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3227; /* *fuse_vnor_vorc */

        case 71:
          if (!(
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3228; /* *fuse_vnor_vorc */

        default:
          return -1;
        }

    case IOR:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 1249 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2629; /* *fuse_nand_or */

        case 1:
          if (!(
#line 1249 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2630; /* *fuse_nand_or */

        case 2:
          if (!
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3129; /* *fuse_vnand_vor */

        case 3:
          if (!
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3130; /* *fuse_vnand_vor */

        case 4:
          if (!
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3131; /* *fuse_vnand_vor */

        case 5:
          if (!
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3132; /* *fuse_vnand_vor */

        case 6:
          if (!
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3133; /* *fuse_vnand_vor */

        case 7:
          if (!
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3134; /* *fuse_vnand_vor */

        case 8:
          if (!
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3135; /* *fuse_vnand_vor */

        case 9:
          if (!
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3136; /* *fuse_vnand_vor */

        case 10:
          if (!(
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3137; /* *fuse_vnand_vor */

        case 11:
          if (!(
#line 2653 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3138; /* *fuse_vnand_vor */

        case 12:
          if (!
#line 1429 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2649; /* *fuse_nand_orc */

        case 13:
          if (!(
#line 1429 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2650; /* *fuse_nand_orc */

        case 14:
          if (!
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3209; /* *fuse_vnand_vorc */

        case 15:
          if (!
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3210; /* *fuse_vnand_vorc */

        case 16:
          if (!
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3211; /* *fuse_vnand_vorc */

        case 17:
          if (!
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3212; /* *fuse_vnand_vorc */

        case 18:
          if (!
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3213; /* *fuse_vnand_vorc */

        case 19:
          if (!
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3214; /* *fuse_vnand_vorc */

        case 20:
          if (!
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3215; /* *fuse_vnand_vorc */

        case 21:
          if (!
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3216; /* *fuse_vnand_vorc */

        case 22:
          if (!(
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3217; /* *fuse_vnand_vorc */

        case 23:
          if (!(
#line 2797 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3218; /* *fuse_vnand_vorc */

        case 24:
          if (!
#line 1303 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2635; /* *fuse_orc_or */

        case 25:
          if (!(
#line 1303 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2636; /* *fuse_orc_or */

        case 26:
          if (!
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3159; /* *fuse_vorc_vor */

        case 27:
          if (!
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3160; /* *fuse_vorc_vor */

        case 28:
          if (!
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3161; /* *fuse_vorc_vor */

        case 29:
          if (!
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3162; /* *fuse_vorc_vor */

        case 30:
          if (!
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3163; /* *fuse_vorc_vor */

        case 31:
          if (!
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3164; /* *fuse_vorc_vor */

        case 32:
          if (!
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3165; /* *fuse_vorc_vor */

        case 33:
          if (!
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3166; /* *fuse_vorc_vor */

        case 34:
          if (!(
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3167; /* *fuse_vorc_vor */

        case 35:
          if (!(
#line 2707 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3168; /* *fuse_vorc_vor */

        case 36:
          if (!
#line 1483 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2655; /* *fuse_orc_orc */

        case 37:
          if (!(
#line 1483 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2656; /* *fuse_orc_orc */

        case 38:
          if (!
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3239; /* *fuse_vorc_vorc */

        case 39:
          if (!
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3240; /* *fuse_vorc_vorc */

        case 40:
          if (!
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3241; /* *fuse_vorc_vorc */

        case 41:
          if (!
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3242; /* *fuse_vorc_vorc */

        case 42:
          if (!
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3243; /* *fuse_vorc_vorc */

        case 43:
          if (!
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3244; /* *fuse_vorc_vorc */

        case 44:
          if (!
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3245; /* *fuse_vorc_vorc */

        case 45:
          if (!
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3246; /* *fuse_vorc_vorc */

        case 46:
          if (!(
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3247; /* *fuse_vorc_vorc */

        case 47:
          if (!(
#line 2851 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3248; /* *fuse_vorc_vorc */

        case 48:
          if (!
#line 1285 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2633; /* *fuse_or_or */

        case 49:
          if (!(
#line 1285 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2634; /* *fuse_or_or */

        case 50:
          if (!
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3149; /* *fuse_vor_vor */

        case 51:
          if (!
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3150; /* *fuse_vor_vor */

        case 52:
          if (!
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3151; /* *fuse_vor_vor */

        case 53:
          if (!
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3152; /* *fuse_vor_vor */

        case 54:
          if (!
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3153; /* *fuse_vor_vor */

        case 55:
          if (!
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3154; /* *fuse_vor_vor */

        case 56:
          if (!
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3155; /* *fuse_vor_vor */

        case 57:
          if (!
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3156; /* *fuse_vor_vor */

        case 58:
          if (!(
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3157; /* *fuse_vor_vor */

        case 59:
          if (!(
#line 2689 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3158; /* *fuse_vor_vor */

        case 60:
          if (!
#line 1465 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2653; /* *fuse_or_orc */

        case 61:
          if (!(
#line 1465 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2654; /* *fuse_or_orc */

        case 62:
          if (!
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3229; /* *fuse_vor_vorc */

        case 63:
          if (!
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3230; /* *fuse_vor_vorc */

        case 64:
          if (!
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3231; /* *fuse_vor_vorc */

        case 65:
          if (!
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3232; /* *fuse_vor_vorc */

        case 66:
          if (!
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3233; /* *fuse_vor_vorc */

        case 67:
          if (!
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3234; /* *fuse_vor_vorc */

        case 68:
          if (!
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3235; /* *fuse_vor_vorc */

        case 69:
          if (!
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3236; /* *fuse_vor_vorc */

        case 70:
          if (!(
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3237; /* *fuse_vor_vorc */

        case 71:
          if (!(
#line 2833 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3238; /* *fuse_vor_vorc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern249 (x1))
        {
        case 0:
          if (!
#line 1321 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2637; /* *fuse_xor_or */

        case 1:
          if (!(
#line 1321 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2638; /* *fuse_xor_or */

        case 2:
          if (!
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3169; /* *fuse_vxor_vor */

        case 3:
          if (!
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3170; /* *fuse_vxor_vor */

        case 4:
          if (!
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3171; /* *fuse_vxor_vor */

        case 5:
          if (!
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3172; /* *fuse_vxor_vor */

        case 6:
          if (!
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3173; /* *fuse_vxor_vor */

        case 7:
          if (!
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3174; /* *fuse_vxor_vor */

        case 8:
          if (!
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3175; /* *fuse_vxor_vor */

        case 9:
          if (!
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3176; /* *fuse_vxor_vor */

        case 10:
          if (!(
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3177; /* *fuse_vxor_vor */

        case 11:
          if (!(
#line 2725 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3178; /* *fuse_vxor_vor */

        case 12:
          if (!
#line 1501 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2657; /* *fuse_xor_orc */

        case 13:
          if (!(
#line 1501 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2658; /* *fuse_xor_orc */

        case 14:
          if (!
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3249; /* *fuse_vxor_vorc */

        case 15:
          if (!
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3250; /* *fuse_vxor_vorc */

        case 16:
          if (!
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3251; /* *fuse_vxor_vorc */

        case 17:
          if (!
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3252; /* *fuse_vxor_vorc */

        case 18:
          if (!
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3253; /* *fuse_vxor_vorc */

        case 19:
          if (!
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3254; /* *fuse_vxor_vorc */

        case 20:
          if (!
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3255; /* *fuse_vxor_vorc */

        case 21:
          if (!
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3256; /* *fuse_vxor_vorc */

        case 22:
          if (!(
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3257; /* *fuse_vxor_vorc */

        case 23:
          if (!(
#line 2869 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3258; /* *fuse_vxor_vorc */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern251 (x1))
        {
        case 0:
          if (!
#line 1339 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2639; /* *fuse_add_or */

        case 1:
          if (!(
#line 1339 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2640; /* *fuse_add_or */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern251 (x1))
        {
        case 0:
          if (!
#line 1357 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2641; /* *fuse_subf_or */

        case 1:
          if (!(
#line 1357 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2642; /* *fuse_subf_or */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTEND:
      return recog_133 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_125 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_144 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_131 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_136 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_141 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_124 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern0 (x1))
        {
        case 0:
          return 133; /* clzsi2 */

        case 1:
          if (!
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 134; /* clzdi2 */

        case 2:
          if (!
#line 4370 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2301; /* *p8v_clzv4si2 */

        case 3:
          if (!
#line 4370 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2302; /* *p8v_clzv8hi2 */

        case 4:
          if (!
#line 4370 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2303; /* *p8v_clzv16qi2 */

        case 5:
          if (!
#line 4370 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2304; /* *p8v_clzv2di2 */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 2490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_CTZ))
            return -1;
          return 135; /* ctzsi2_hw */

        case 1:
          if (!(
#line 2490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_CTZ) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 136; /* ctzdi2_hw */

        case 2:
          if (!
#line 4392 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2308; /* *p9v_ctzv4si2 */

        case 3:
          if (!
#line 4392 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2309; /* *p9v_ctzv8hi2 */

        case 4:
          if (!
#line 4392 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2310; /* *p9v_ctzv16qi2 */

        case 5:
          if (!
#line 4392 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2311; /* *p9v_ctzv2di2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 2530 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
            return -1;
          return 139; /* popcntdsi2 */

        case 1:
          if (!(
#line 2530 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 140; /* popcntddi2 */

        case 2:
          if (!
#line 4400 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2312; /* *p8v_popcountv4si2 */

        case 3:
          if (!
#line 4400 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2313; /* *p8v_popcountv8hi2 */

        case 4:
          if (!
#line 4400 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2314; /* *p8v_popcountv16qi2 */

        case 5:
          if (!
#line 4400 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2315; /* *p8v_popcountv2di2 */

        default:
          return -1;
        }

    case BSWAP:
      return recog_142 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_152 (x1, insn, pnum_clobbers);

    case UDIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern19 (x2, 
E_SImode) != 0)
            return -1;
          return 187; /* udivsi3 */

        case E_DImode:
          if (pattern19 (x2, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 188; /* udivdi3 */

        case E_TImode:
          if (pattern1 (x2, 
E_TImode) != 0
              || !
#line 3343 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
            return -1;
          return 189; /* udivti3 */

        case E_V2DImode:
          if (pattern2 (x2, 
E_V2DImode) != 0
              || !
#line 6525 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1764; /* udivv2di3 */

        case E_V4SImode:
          if (pattern2 (x2, 
E_V4SImode) != 0
              || !
#line 6525 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1765; /* udivv4si3 */

        default:
          return -1;
        }

    case DIV:
      return recog_150 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case EQ:
        case GT:
        case LT:
        case GTU:
        case LTU:
        case UNORDERED:
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case NE:
        case GE:
        case LE:
        case GEU:
        case LEU:
        case ORDERED:
        case UNLE:
        case UNLT:
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNLE:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!extra_insn_branch_comparison_operator (x4, E_VOIDmode)
          || pattern28 (x1) != 0
          || !
#line 13342 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
        return -1;
      return 967; /* *cbranch_2insn */

    case AND:
    case IOR:
    case XOR:
      return recog_135 (x1, insn, pnum_clobbers);

    case EQ:
    case GT:
    case LT:
    case GTU:
    case LTU:
    case UNORDERED:
      return recog_138 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_151 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern126 (x2, pnum_clobbers))
            {
            case 0:
              return 282; /* ashlsi3 */

            case 1:
              if (!
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 283; /* ashldi3 */

            case 2:
              if (!
#line 2114 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2031; /* *altivec_vslw */

            case 3:
              if (!
#line 2114 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2032; /* *altivec_vslh */

            case 4:
              if (!
#line 2114 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2033; /* *altivec_vslb */

            case 5:
              if (!
#line 2114 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2034; /* *altivec_vsld */

            case 6:
              if (!
#line 2122 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2035; /* altivec_vslq_v1ti */

            case 7:
              if (!
#line 2122 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2036; /* altivec_vslq_ti */

            case 8:
              if (!(
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 2050; /* *altivec_v4si_ashift_const */

            case 9:
              if (!(
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 2053; /* *altivec_v2di_ashift_const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!reg_or_mem_operand (operands[1], E_SImode)
              || !u6bit_cint_operand (operands[2], E_DImode)
              || !
#line 4707 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 289; /* ashdi3_extswsli */

        default:
          return -1;
        }

    case LSHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern126 (x2, pnum_clobbers))
        {
        case 0:
          return 292; /* lshrsi3 */

        case 1:
          if (!
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 293; /* lshrdi3 */

        case 2:
          if (!
#line 2131 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2037; /* *altivec_vsrw */

        case 3:
          if (!
#line 2131 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2038; /* *altivec_vsrh */

        case 4:
          if (!
#line 2131 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 2039; /* *altivec_vsrb */

        case 5:
          if (!
#line 2131 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2040; /* *altivec_vsrd */

        case 6:
          if (!
#line 2139 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 2041; /* altivec_vsrq_v1ti */

        case 7:
          if (!
#line 2139 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 2042; /* altivec_vsrq_ti */

        case 8:
          if (!(
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
            return -1;
          *pnum_clobbers = 1;
          return 2052; /* *altivec_v4si_lshiftrt_const */

        case 9:
          if (!(
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
            return -1;
          *pnum_clobbers = 1;
          return 2055; /* *altivec_v2di_lshiftrt_const */

        default:
          return -1;
        }

    case ASHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern123 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 299; /* ashrsi3 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern123 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              *pnum_clobbers = 1;
              return 300; /* ashrdi3 */

            case E_V4SImode:
              if (pattern3 (x2, 
E_V4SImode) != 0
                  || !
#line 2148 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2043; /* *altivec_vsraw */

            case E_V8HImode:
              if (pattern3 (x2, 
E_V8HImode) != 0
                  || !
#line 2148 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2044; /* *altivec_vsrah */

            case E_V16QImode:
              if (pattern3 (x2, 
E_V16QImode) != 0
                  || !
#line 2148 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2045; /* *altivec_vsrab */

            case E_V2DImode:
              if (pattern3 (x2, 
E_V2DImode) != 0
                  || !
#line 2148 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2046; /* *altivec_vsrad */

            case E_V1TImode:
              if (pattern2 (x2, 
E_V1TImode) != 0
                  || !
#line 2156 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2047; /* altivec_vsraq */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case VEC_DUPLICATE:
          switch (pattern125 (x2, pnum_clobbers))
            {
            case 0:
              if (!(
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 2051; /* *altivec_v4si_ashiftrt_const */

            case 1:
              if (!(
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 2054; /* *altivec_v2di_ashiftrt_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      return recog_143 (x1, insn, pnum_clobbers);

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5133 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GPOPT))
            return -1;
          return 320; /* *sqrtsf2_internal */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 5133 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GPOPT))
            return -1;
          return 321; /* *sqrtdf2_internal */

        case E_KFmode:
          if (!altivec_register_operand (operands[0], E_KFmode)
              || GET_MODE (x2) != E_KFmode
              || !altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15059 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1101; /* sqrtkf2 */

        case E_TFmode:
          if (!altivec_register_operand (operands[0], E_TFmode)
              || GET_MODE (x2) != E_TFmode
              || !altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15059 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1102; /* sqrttf2 */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 2023 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1366; /* *vsx_sqrtv4sf2 */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2023 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1367; /* *vsx_sqrtv2df2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      return recog_140 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_146 (x1, insn, pnum_clobbers);

    case COPYSIGN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern19 (x2, 
E_SFmode) != 0
              || !
#line 5455 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_CMPB || VECTOR_UNIT_VSX_P (SFmode))))
            return -1;
          return 335; /* copysignsf3_fcpsgn */

        case E_DFmode:
          if (pattern19 (x2, 
E_DFmode) != 0
              || !
#line 5455 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_CMPB || VECTOR_UNIT_VSX_P (DFmode))))
            return -1;
          return 336; /* copysigndf3_fcpsgn */

        case E_KFmode:
          if (pattern1 (x2, 
E_KFmode) != 0)
            return -1;
          if ((
#line 15102 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 1103; /* copysignkf3_hard */
          if (pnum_clobbers == NULL
              || !(
#line 15113 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1105; /* copysignkf3_soft */

        case E_TFmode:
          if (pattern1 (x2, 
E_TFmode) != 0)
            return -1;
          if ((
#line 15102 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 1104; /* copysigntf3_hard */
          if (pnum_clobbers == NULL
              || !(
#line 15113 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1106; /* copysigntf3_soft */

        case E_V4SFmode:
          if (pattern2 (x2, 
E_V4SFmode) != 0
              || !
#line 2265 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1394; /* vsx_copysignv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x2, 
E_V2DFmode) != 0
              || !
#line 2265 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1395; /* vsx_copysignv2df3 */

        default:
          return -1;
        }

    case SMIN:
      return recog_148 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_147 (x1, insn, pnum_clobbers);

    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      return recog_139 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_128 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_132 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_127 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_129 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_134 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          res = recog_29 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST:
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) == MINUS
              && GET_MODE (x7) == E_SImode
              && gpc_reg_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && gpc_reg_operand (operands[1], E_SImode))
            {
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (symbol_ref_operand (operands[2], E_SImode))
                {
                  x9 = XEXP (x7, 1);
                  operands[3] = x9;
                  if (symbol_ref_operand (operands[3], E_SImode)
                      && 
#line 11241 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_SECURE_PLT && DEFAULT_ABI == ABI_V4 && flag_pic))
                    return 801; /* load_toc_v4_PIC_3c */
                }
            }
          break;

        default:
          break;
        }
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 11324 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL))
            return -1;
          return 804; /* *largetoc_low */

        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode)
              || !
#line 11358 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && !TARGET_64BIT && !flag_pic))
            return -1;
          return 808; /* elf_low */

        default:
          return -1;
        }

    case UNSPEC:
    case PLUS:
      return recog_126 (x1, insn, pnum_clobbers);

    case UNLE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 948; /* *unlesi_cc */

        case 1:
          if (!(
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 952; /* *unledi_cc */

        case 2:
          if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1242; /* vector_unlev4sf */

        case 3:
          if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1249; /* vector_unlev2df */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 949; /* *ungesi_cc */

        case 1:
          if (!(
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 953; /* *ungedi_cc */

        case 2:
          if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1240; /* vector_ungev4sf */

        case 3:
          if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1247; /* vector_ungev2df */

        default:
          return -1;
        }

    case LTGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 954; /* *ltgtsi_cc */

        case 1:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 960; /* *ltgtdi_cc */

        case 2:
          if (!
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1250; /* vector_ltgtv4sf */

        case 3:
          if (!
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1254; /* vector_ltgtv2df */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 957; /* *unltsi_cc */

        case 1:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 963; /* *unltdi_cc */

        case 2:
          if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1241; /* vector_unltv4sf */

        case 3:
          if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1248; /* vector_unltv2df */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 958; /* *ungtsi_cc */

        case 1:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 964; /* *ungtdi_cc */

        case 2:
          if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1239; /* vector_ungtv4sf */

        case 3:
          if (!
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1246; /* vector_ungtv2df */

        default:
          return -1;
        }

    case UNEQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 959; /* *uneqsi_cc */

        case 1:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 965; /* *uneqdi_cc */

        case 2:
          if (!
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1251; /* vector_uneqv4sf */

        case 3:
          if (!
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1255; /* vector_uneqv2df */

        default:
          return -1;
        }

    case FMA:
      return recog_145 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
    case VEC_DUPLICATE:
      return recog_137 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_130 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_149 (x1, insn, pnum_clobbers);

    case MOD:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 6534 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1766; /* modv2di3 */

        case 1:
          if (!
#line 6534 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1767; /* modv4si3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 6543 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1768; /* umodv2di3 */

        case 1:
          if (!
#line 6543 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1769; /* umodv4si3 */

        default:
          return -1;
        }

    case US_MULT:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ASHIFTRT)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != ASHIFTRT)
        return -1;
      x11 = XEXP (x5, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern294 (x2))
        {
        case 0:
          if (!
#line 6568 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1772; /* umulv2di3_highpart */

        case 1:
          if (!
#line 6568 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1773; /* umulv4si3_highpart */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 1073 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1937; /* umaxv4si3 */

        case 1:
          if (!
#line 1073 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1938; /* umaxv8hi3 */

        case 2:
          if (!
#line 1073 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1939; /* umaxv16qi3 */

        case 3:
          if (!
#line 1073 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1940; /* umaxv2di3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 1097 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1946; /* uminv4si3 */

        case 1:
          if (!
#line 1097 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1947; /* uminv8hi3 */

        case 2:
          if (!
#line 1097 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1948; /* uminv16qi3 */

        case 3:
          if (!
#line 1097 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1949; /* uminv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case MEM:
          operands[1] = x4;
          if (!indexed_or_indirect_operand (operands[1], E_HImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!altivec_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 1106 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
                return NULL;
              return gen_split_15 (insn, operands);

            case E_DImode:
              if (!altivec_register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !(
#line 1106 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed) && 
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_16 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (vsx_register_operand (operands[1], E_SImode)
              && int_reg_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && (
#line 1180 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && reload_completed) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return gen_split_21 (insn, operands);
          if (!altivec_register_operand (operands[1], E_SImode)
              || !altivec_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 1192 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && !TARGET_P9_VECTOR && reload_completed))
            return NULL;
          return gen_split_22 (insn, operands);

        case PLUS:
          if (pattern38 (x2) != 0
              || !(
#line 2388 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 2390 "../../../gcc/config/rs6000/rs6000.md"
(1)))
            return NULL;
          return gen_split_45 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2708 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], SImode)))
        return NULL;
      return gen_split_51 (insn, operands);

    case ASHIFT:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != SIGN_EXTEND
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_mem_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!u6bit_cint_operand (operands[2], E_DImode)
          || !(
#line 4707 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4711 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && MEM_P (operands[1]))))
        return NULL;
      return gen_split_137 (insn, operands);

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_VOIDmode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!gpc_reg_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !
#line 4984 "../../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 4984 "../../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_V4SFmode:
          if (!gpc_reg_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !
#line 4984 "../../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (V4SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_V2DFmode:
          if (!gpc_reg_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !
#line 4984 "../../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (V2DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !reg_or_mem_operand (operands[1], E_SFmode)
              || !(
#line 5241 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)) && 
#line 5250 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && REG_P (operands[1]) && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_152 (insn, operands);

        case E_IFmode:
          switch (pattern205 (x2))
            {
            case 0:
              if (!((
#line 8930 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8932 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_324 (insn, operands);

            case 1:
              if (!(
#line 9461 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)) && 
#line 9464 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_338 (insn, operands);

            default:
              return NULL;
            }

        case E_TFmode:
          if (GET_MODE (x2) != E_TFmode)
            return NULL;
          if (gpc_reg_operand (operands[0], E_TFmode))
            {
              switch (pattern316 ())
                {
                case 0:
                  if (((
#line 8930 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8932 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_325 (insn, operands);
                  break;

                case 1:
                  if ((
#line 9448 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)) && 
#line 9451 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_336 (insn, operands);
                  break;

                case 2:
                  if ((
#line 9448 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)) && 
#line 9451 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_337 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_TFmode)
              || !vsx_register_operand (operands[1], E_KFmode)
              || !(
#line 15211 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD) && 
#line 15215 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed  && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_503 (insn, operands);

        case E_KFmode:
          if (GET_MODE (x2) != E_KFmode)
            return NULL;
          if (gpc_reg_operand (operands[0], E_KFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && (
#line 9461 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)) && 
#line 9464 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_339 (insn, operands);
          if (!vsx_register_operand (operands[0], E_KFmode)
              || !vsx_register_operand (operands[1], E_TFmode)
              || !(
#line 15227 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD) && 
#line 15231 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed  && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_504 (insn, operands);

        default:
          return NULL;
        }

    case SMIN:
      switch (pattern20 (x1))
        {
        case 0:
          if (!(
#line 5515 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_157 (insn, operands);

        case 1:
          if (!(
#line 5515 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      switch (pattern20 (x1))
        {
        case 0:
          if (!(
#line 5515 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_158 (insn, operands);

        case 1:
          if (!(
#line 5515 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_160 (insn, operands);

        default:
          return NULL;
        }

    case AND:
    case IOR:
    case XOR:
      return split_16 (x1, insn);

    case NOT:
      return split_17 (x1, insn);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
    case VEC_DUPLICATE:
      return split_15 (x1, insn);

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_DFmode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_IFmode:
          if (!gpc_reg_operand (operands[1], E_IFmode)
              || !((
#line 8978 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8983 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_326 (insn, operands);

        case E_TFmode:
          if (!gpc_reg_operand (operands[1], E_TFmode)
              || !((
#line 8978 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8983 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_327 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case PLUS:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              x6 = XEXP (x2, 1);
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern359 (x2, 
E_SImode) == 0)
                    return gen_split_33 (insn, operands);
                  break;

                case E_DImode:
                  if (pattern359 (x2, 
E_DImode) == 0
                      && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return gen_split_34 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              x6 = XEXP (x2, 1);
              if (GET_CODE (x6) == ASHIFT)
                {
                  switch (pattern219 (x2))
                    {
                    case 0:
                      if ((
#line 4333 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 4336 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_105 (insn, operands);
                      break;

                    case 1:
                      if (((
#line 4333 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4336 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_107 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case ASHIFT:
              switch (pattern207 (x2))
                {
                case 0:
                  if (
#line 4348 "../../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                    return gen_split_109 (insn, operands);
                  break;

                case 1:
                  if ((
#line 4348 "../../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return gen_split_112 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case UNSPEC:
          res = split_14 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x2;
      switch (pattern69 ())
        {
        case 0:
          if (((
#line 11337 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 11340 "../../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL && reload_completed)))
            return gen_split_400 (insn, operands);
          break;

        case 1:
          if (((
#line 11337 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 11340 "../../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL && reload_completed)))
            return gen_split_401 (insn, operands);
          break;

        default:
          break;
        }
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_CODE (x2) != UNSPEC
          || XVECLEN (x2, 0) != 2
          || XINT (x2, 1) != 70
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_TDmode))
        return NULL;
      x8 = XVECEXP (x2, 0, 1);
      operands[2] = x8;
      if (!const_0_to_1_operand (operands[2], E_QImode))
        return NULL;
      if (((
#line 14881 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14883 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_495 (insn, operands);
      if (!((
#line 14904 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14906 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_498 (insn, operands);

    case ORDERED:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_464 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_468 (insn, operands);

        case 2:
          if (!(
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_558 (insn, operands);

        case 3:
          if (!(
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_562 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_465 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_469 (insn, operands);

        case 2:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_543 (insn, operands);

        case 3:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_550 (insn, operands);

        default:
          return NULL;
        }

    case UNLE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_466 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_470 (insn, operands);

        case 2:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_547 (insn, operands);

        case 3:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_554 (insn, operands);

        default:
          return NULL;
        }

    case UNGE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_467 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_471 (insn, operands);

        case 2:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_545 (insn, operands);

        case 3:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_552 (insn, operands);

        default:
          return NULL;
        }

    case LTGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_472 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_478 (insn, operands);

        case 2:
          if (!(
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_555 (insn, operands);

        case 3:
          if (!(
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_559 (insn, operands);

        default:
          return NULL;
        }

    case LE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_473 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_479 (insn, operands);

        case 2:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_542 (insn, operands);

        case 3:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_549 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!cc_reg_operand (operands[1], E_CCFPmode))
        return NULL;
      switch (pattern9 (x2))
        {
        case 0:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_474 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_480 (insn, operands);

        default:
          return NULL;
        }

    case UNLT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_475 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_481 (insn, operands);

        case 2:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_546 (insn, operands);

        case 3:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_553 (insn, operands);

        default:
          return NULL;
        }

    case UNGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_476 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_482 (insn, operands);

        case 2:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_544 (insn, operands);

        case 3:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_551 (insn, operands);

        default:
          return NULL;
        }

    case UNEQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_477 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_483 (insn, operands);

        case 2:
          if (!(
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_556 (insn, operands);

        case 3:
          if (!(
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_560 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (!extra_insn_branch_comparison_operator (x4, E_VOIDmode)
          || pattern28 (x1) != 0
          || !(
#line 13342 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13344 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_484 (insn, operands);

    case COMPARE:
      if (GET_MODE (x2) != E_CCEQmode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (!branch_comparison_operator (x4, E_VOIDmode))
        return NULL;
      operands[1] = x4;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 1);
      if (!branch_comparison_operator (x6, E_VOIDmode))
        return NULL;
      operands[3] = x6;
      x10 = XEXP (x6, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!cc_reg_operand (operands[0], E_CCEQmode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return NULL;
      x11 = XEXP (x6, 0);
      operands[4] = x11;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return NULL;
      return gen_split_485 (insn, operands);

    case LT:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_541 (insn, operands);

        case 1:
          if (!(
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_548 (insn, operands);

        default:
          return NULL;
        }

    case UNORDERED:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_557 (insn, operands);

        case 1:
          if (!(
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_561 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ROTATE)
        return NULL;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern215 (x2))
        {
        case 0:
          if (!(
#line 1021 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX) && 
#line 1025 "../../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_582 (insn, operands);

        case 1:
          if (!(
#line 1021 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX) && 
#line 1025 "../../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_583 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 4
          || pattern29 (x1) != 0
          || !(
#line 455 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)) && 
#line 458 "../../../gcc/config/rs6000/mma.md"
( reload_completed)))
        return NULL;
      return gen_split_742 (insn, operands);

    default:
      return NULL;
    }
}
