/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      if (XWINT (x2, 0) != 0L
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      return pattern9 (x1); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern11 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern11 (x3); /* [-1, 1] */
}

int
pattern24 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern39 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern39 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern60 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern60 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern61 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern61 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern61 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern61 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern61 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern61 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern61 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern61 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern61 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern61 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x5) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !scratch_operand (operands[2], E_DImode))
                return -1;
              return 0;

            case E_DImode:
              return 1;

            default:
              return -1;
            }

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x5) != E_DFmode
              || !scratch_operand (operands[2], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              return 2;

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_KFmode:
          res = pattern71 (x5, 
E_KFmode);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        case E_TFmode:
          res = pattern71 (x5, 
E_TFmode);
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          res = pattern73 (x5, 
E_SFmode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        case E_DFmode:
          res = pattern73 (x5, 
E_DFmode);
          if (res >= 0)
            return res + 14; /* [14, 15] */
          return -1;

        default:
          return -1;
        }

    case VEC_SELECT:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 16; /* [16, 27] */
      return -1;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return pattern109 (); /* [-1, 1] */
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  return pattern111 (x1); /* [-1, 3] */
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (operands[0]))
    {
    case SYMBOL_REF:
      return 0;

    case UNSPEC:
    case REG:
      return 1;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern132 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern132 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!c32bit_cint_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16QImode:
          if (!altivec_register_operand (operands[2], E_V16QImode))
            return -1;
          return 0;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[3], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HImode:
          if (!altivec_register_operand (operands[2], E_V8HImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !altivec_register_operand (operands[3], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SImode:
          if (!altivec_register_operand (operands[2], E_V4SImode))
            return -1;
          return 4;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !altivec_register_operand (operands[3], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DImode:
          if (!altivec_register_operand (operands[2], E_V2DImode))
            return -1;
          return 6;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_m1_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 0;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 1;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!scratch_operand (operands[0], E_SImode))
                    return -1;
                  return 2;

                case E_DImode:
                  if (!scratch_operand (operands[0], E_DImode))
                    return -1;
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_0_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 4;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 5;

            case E_HImode:
              res = pattern187 (
E_HImode);
              if (res >= 0)
                return res + 6; /* [6, 7] */
              return -1;

            case E_QImode:
              res = pattern187 (
E_QImode);
              if (res >= 0)
                return res + 8; /* [8, 9] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x7, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_CCmode:
              if (!cc_reg_operand (operands[2], E_CCmode)
                  || GET_MODE (x3) != E_CCmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_m1_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 10;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_m1_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            case E_CCUNSmode:
              if (!cc_reg_operand (operands[2], E_CCUNSmode)
                  || GET_MODE (x3) != E_CCUNSmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_0_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 12;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_0_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 13;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 14;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              res = pattern188 (x9);
              if (res >= 0)
                return res + 15; /* [15, 16] */
              return -1;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 17;

            case E_HImode:
              res = pattern189 (x9, 
E_HImode);
              if (res >= 0)
                return res + 18; /* [18, 19] */
              return -1;

            case E_QImode:
              res = pattern189 (x9, 
E_QImode);
              if (res >= 0)
                return res + 20; /* [20, 21] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern290 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  if (!gpc_reg_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != E_SImode
      || !gpc_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x5, 1);
  operands[4] = x9;
  x10 = XEXP (x5, 2);
  operands[5] = x10;
  x11 = XEXP (x2, 0);
  operands[6] = x11;
  if (!scratch_operand (operands[6], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern298 (x5, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern298 (x5, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_KFmode:
      if (pattern299 (x5, 
E_KFmode) != 0)
        return -1;
      return 4;

    case E_TFmode:
      if (pattern299 (x5, 
E_TFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern316 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[1], E_IFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern332 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_SImode)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 1;

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern375 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || pattern374 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern382 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x1) != E_DDmode
          || !gpc_reg_operand (operands[2], E_DDmode))
        return -1;
      return 0;

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x1) != E_TDmode
          || !gpc_reg_operand (operands[2], E_TDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern394 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern401 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern393 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern393 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern413 (x1) != 0)
    return -1;
  return 0;
}

int
pattern429 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern427 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern427 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern428 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern428 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern428 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern428 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern428 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern428 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern428 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern428 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern428 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern428 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern448 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern455 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern461 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern476 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern485 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern488 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern493 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern500 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!memory_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!memory_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!memory_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!memory_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!memory_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!memory_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!memory_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!memory_operand (operands[0], E_KFmode)
          || !register_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!memory_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern527 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern534 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], E_V16QImode)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !const_0_to_15_operand (operands[3], E_SImode)
      || !const_0_to_3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern537 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern549 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern560 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[5], i1)
      || !const_int_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern569 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern576 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern583 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode)
          || !scratch_operand (operands[0], E_V1TImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode)
          || !scratch_operand (operands[0], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern596 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1)
      || !memory_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern603 (x9, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern603 (x9, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case AND:
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!
#line 3906 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 2;
      return 223; /* *branch_anddi3_dot */

    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x3, 0);
      operands[0] = x11;
      if (!
#line 7954 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
        return -1;
      *pnum_clobbers = 2;
      return 572; /* *rotate_on_cmpdi */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (branch_comparison_operator (operands[0], E_VOIDmode))
    {
      res = recog_12 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (fpmask_comparison_operator (operands[1], E_CCFPmode))
    {
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x2, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != PC
      || !branch_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[0] = x9;
  return 966; /* *cbranch */
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !gpc_reg_operand (operands[1], E_SImode))
                return -1;
              if (pnum_clobbers != NULL
                  && logical_const_operand (operands[2], E_SImode)
                  && 
#line 3642 "../../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], SImode)))
                {
                  *pnum_clobbers = 1;
                  return 199; /* andsi3_imm */
                }
              if (!const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 3773 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_and_mask (operands[2], SImode)))
                return 211; /* andsi3_mask */
              if (!
#line 3840 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
                return -1;
              return 217; /* *andsi3_2insn */

            case E_DImode:
              if (!gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode))
                return -1;
              if (pnum_clobbers != NULL
                  && logical_const_operand (operands[2], E_DImode)
                  && (
#line 3642 "../../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 1;
                  return 200; /* anddi3_imm */
                }
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              if ((
#line 3773 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 212; /* anddi3_mask */
              if (!(
#line 3840 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 218; /* *anddi3_2insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern369 (x2, 
E_TImode) != 0)
                return -1;
              return 507; /* *andti3_internal */

            case E_PTImode:
              if (pattern369 (x2, 
E_PTImode) != 0)
                return -1;
              return 508; /* *andpti3_internal */

            case E_V16QImode:
              if (pattern369 (x2, 
E_V16QImode) != 0
                  || !
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 509; /* *andv16qi3_internal */

            case E_V8HImode:
              if (pattern369 (x2, 
E_V8HImode) != 0
                  || !
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 510; /* *andv8hi3_internal */

            case E_V4SImode:
              if (pattern369 (x2, 
E_V4SImode) != 0
                  || !
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 511; /* *andv4si3_internal */

            case E_V4SFmode:
              if (pattern369 (x2, 
E_V4SFmode) != 0
                  || !
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 512; /* *andv4sf3_internal */

            case E_V2DImode:
              if (pattern369 (x2, 
E_V2DImode) != 0
                  || !
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 513; /* *andv2di3_internal */

            case E_V2DFmode:
              if (pattern369 (x2, 
E_V2DFmode) != 0
                  || !
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 514; /* *andv2df3_internal */

            case E_V1TImode:
              if (pattern369 (x2, 
E_V1TImode) != 0
                  || !
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 515; /* *andv1ti3_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern457 (x2, 
E_SImode) != 0
              || !
#line 4182 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          return 246; /* *rotlsi3_mask */

        case E_DImode:
          if (pattern457 (x2, 
E_DImode) != 0
              || !(
#line 4182 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 247; /* *rotldi3_mask */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != -16L)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (pattern261 (x2))
            {
            case 0:
              if (!(
#line 9532 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 641; /* *vec_reload_and_plus_si */

            case 1:
              if (!(
#line 9532 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 642; /* *vec_reload_and_plus_di */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          switch (pattern42 (x2))
            {
            case 0:
              if (!
#line 511 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2547; /* *fuse_add_and */

            case 1:
              if (!(
#line 511 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2548; /* *fuse_add_and */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      return recog_16 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_15 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern64 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 421 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2537; /* *fuse_nand_and */

        case 1:
          if (!(
#line 421 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2538; /* *fuse_nand_and */

        case 2:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2729; /* *fuse_vnand_vand */

        case 3:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2730; /* *fuse_vnand_vand */

        case 4:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2731; /* *fuse_vnand_vand */

        case 5:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2732; /* *fuse_vnand_vand */

        case 6:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2733; /* *fuse_vnand_vand */

        case 7:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2734; /* *fuse_vnand_vand */

        case 8:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2735; /* *fuse_vnand_vand */

        case 9:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2736; /* *fuse_vnand_vand */

        case 10:
          if (!(
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2737; /* *fuse_vnand_vand */

        case 11:
          if (!(
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2738; /* *fuse_vnand_vand */

        case 12:
          if (!
#line 601 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2557; /* *fuse_nand_andc */

        case 13:
          if (!(
#line 601 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2558; /* *fuse_nand_andc */

        case 14:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2809; /* *fuse_vnand_vandc */

        case 15:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2810; /* *fuse_vnand_vandc */

        case 16:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2811; /* *fuse_vnand_vandc */

        case 17:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2812; /* *fuse_vnand_vandc */

        case 18:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2813; /* *fuse_vnand_vandc */

        case 19:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2814; /* *fuse_vnand_vandc */

        case 20:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2815; /* *fuse_vnand_vandc */

        case 21:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2816; /* *fuse_vnand_vandc */

        case 22:
          if (!(
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2817; /* *fuse_vnand_vandc */

        case 23:
          if (!(
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2818; /* *fuse_vnand_vandc */

        case 24:
          if (!
#line 475 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2543; /* *fuse_orc_and */

        case 25:
          if (!(
#line 475 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2544; /* *fuse_orc_and */

        case 26:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2759; /* *fuse_vorc_vand */

        case 27:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2760; /* *fuse_vorc_vand */

        case 28:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2761; /* *fuse_vorc_vand */

        case 29:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2762; /* *fuse_vorc_vand */

        case 30:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2763; /* *fuse_vorc_vand */

        case 31:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2764; /* *fuse_vorc_vand */

        case 32:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2765; /* *fuse_vorc_vand */

        case 33:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2766; /* *fuse_vorc_vand */

        case 34:
          if (!(
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2767; /* *fuse_vorc_vand */

        case 35:
          if (!(
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2768; /* *fuse_vorc_vand */

        case 36:
          if (!
#line 655 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2563; /* *fuse_orc_andc */

        case 37:
          if (!(
#line 655 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2564; /* *fuse_orc_andc */

        case 38:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2839; /* *fuse_vorc_vandc */

        case 39:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2840; /* *fuse_vorc_vandc */

        case 40:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2841; /* *fuse_vorc_vandc */

        case 41:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2842; /* *fuse_vorc_vandc */

        case 42:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2843; /* *fuse_vorc_vandc */

        case 43:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2844; /* *fuse_vorc_vandc */

        case 44:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2845; /* *fuse_vorc_vandc */

        case 45:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2846; /* *fuse_vorc_vandc */

        case 46:
          if (!(
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2847; /* *fuse_vorc_vandc */

        case 47:
          if (!(
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2848; /* *fuse_vorc_vandc */

        case 48:
          if (!
#line 457 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2541; /* *fuse_or_and */

        case 49:
          if (!(
#line 457 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2542; /* *fuse_or_and */

        case 50:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2749; /* *fuse_vor_vand */

        case 51:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2750; /* *fuse_vor_vand */

        case 52:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2751; /* *fuse_vor_vand */

        case 53:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2752; /* *fuse_vor_vand */

        case 54:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2753; /* *fuse_vor_vand */

        case 55:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2754; /* *fuse_vor_vand */

        case 56:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2755; /* *fuse_vor_vand */

        case 57:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2756; /* *fuse_vor_vand */

        case 58:
          if (!(
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2757; /* *fuse_vor_vand */

        case 59:
          if (!(
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2758; /* *fuse_vor_vand */

        case 60:
          if (!
#line 637 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2561; /* *fuse_or_andc */

        case 61:
          if (!(
#line 637 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2562; /* *fuse_or_andc */

        case 62:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2829; /* *fuse_vor_vandc */

        case 63:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2830; /* *fuse_vor_vandc */

        case 64:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2831; /* *fuse_vor_vandc */

        case 65:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2832; /* *fuse_vor_vandc */

        case 66:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2833; /* *fuse_vor_vandc */

        case 67:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2834; /* *fuse_vor_vandc */

        case 68:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2835; /* *fuse_vor_vandc */

        case 69:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2836; /* *fuse_vor_vandc */

        case 70:
          if (!(
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2837; /* *fuse_vor_vandc */

        case 71:
          if (!(
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2838; /* *fuse_vor_vandc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern65 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 493 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2545; /* *fuse_xor_and */

        case 1:
          if (!(
#line 493 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2546; /* *fuse_xor_and */

        case 2:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2769; /* *fuse_vxor_vand */

        case 3:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2770; /* *fuse_vxor_vand */

        case 4:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2771; /* *fuse_vxor_vand */

        case 5:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2772; /* *fuse_vxor_vand */

        case 6:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2773; /* *fuse_vxor_vand */

        case 7:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2774; /* *fuse_vxor_vand */

        case 8:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2775; /* *fuse_vxor_vand */

        case 9:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2776; /* *fuse_vxor_vand */

        case 10:
          if (!(
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2777; /* *fuse_vxor_vand */

        case 11:
          if (!(
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2778; /* *fuse_vxor_vand */

        case 12:
          if (!
#line 673 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2565; /* *fuse_xor_andc */

        case 13:
          if (!(
#line 673 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2566; /* *fuse_xor_andc */

        case 14:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2849; /* *fuse_vxor_vandc */

        case 15:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2850; /* *fuse_vxor_vandc */

        case 16:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2851; /* *fuse_vxor_vandc */

        case 17:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2852; /* *fuse_vxor_vandc */

        case 18:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2853; /* *fuse_vxor_vandc */

        case 19:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2854; /* *fuse_vxor_vandc */

        case 20:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2855; /* *fuse_vxor_vandc */

        case 21:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2856; /* *fuse_vxor_vandc */

        case 22:
          if (!(
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2857; /* *fuse_vxor_vandc */

        case 23:
          if (!(
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2858; /* *fuse_vxor_vandc */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 529 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2549; /* *fuse_subf_and */

        case 1:
          if (!(
#line 529 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2550; /* *fuse_subf_and */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (pattern146 (x3, 
E_DFmode, 
E_TFmode) != 0)
        return -1;
      if ((
#line 14940 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && 
#line 543 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return 1085; /* packtf_hard */
      if (!(
#line 14964 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && 
#line 543 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return -1;
      return 1088; /* packtf_soft */

    case E_IFmode:
      if (pattern146 (x3, 
E_DFmode, 
E_IFmode) != 0
          || !(
#line 14940 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && 
#line 544 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
        return -1;
      return 1086; /* packif_hard */

    case E_TDmode:
      if (pattern146 (x3, 
E_DImode, 
E_TDmode) != 0
          || !(
#line 14940 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && 
#line 545 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 1087; /* packtd_hard */

    case E_V1TImode:
      if (pattern146 (x3, 
E_DImode, 
E_V1TImode) != 0
          || !
#line 15007 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 1091; /* packv1ti */

    case E_KFmode:
      if (pattern146 (x3, 
E_DImode, 
E_KFmode) != 0
          || !
#line 15007 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 1092; /* packkf */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_OOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_OOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!mma_assemble_input_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!mma_assemble_input_operand (operands[2], E_V16QImode)
      || !
#line 383 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
    return -1;
  return 2358; /* *vsx_assemble_pair */
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_VOIDmode)
      || !
#line 14137 "../../../gcc/config/rs6000/rs6000.md"
(REG_P (operands[0])
   && CR_REGNO_P (REGNO (operands[0]))
   && CONST_INT_P (operands[2])
   && INTVAL (operands[2]) == 1 << (7 - (REGNO (operands[0]) - CR0_REGNO))))
    return -1;
  return 1020; /* *mtcrfsi */
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 5088 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1647; /* vsx_sign_extend_v2di_v1ti */

    case E_V4SImode:
      switch (pattern339 (x3, 
E_V4SImode))
        {
        case 0:
          if (!
#line 5099 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1648; /* vsx_sign_extend_v16qi_v4si */

        case 1:
          if (!
#line 5108 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1652; /* vsx_sign_extend_v8hi_v4si */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 5099 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1649; /* vsx_sign_extend_v16qi_v2di */

        case E_V8HImode:
          if (!vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 5108 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1653; /* vsx_sign_extend_v8hi_v2di */

        case E_V4SImode:
          if (!vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 5116 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1656; /* vsx_sign_extend_v4si_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x4;
      if (!input_operand (operands[1], E_SFmode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || !
#line 7832 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))))
        return -1;
      *pnum_clobbers = 1;
      return 569; /* movsi_from_sf */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x4) != E_SFmode
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 7938 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      return 571; /* *movsi_from_df */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2463 "../../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVSPDPN))
        return -1;
      return 1429; /* vsx_xscvspdpn */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !vsx_register_operand (operands[1], E_SFmode)
          || !
#line 2480 "../../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVSPDPN))
        return -1;
      return 1431; /* vsx_xscvspdpn_directmove */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 5200 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1659; /* xsxexpqp_kf_v2di */

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 5200 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1661; /* xsxexpqp_tf_v2di */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern378 (x3, 
E_V4SImode) != 0
          || !
#line 6700 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1780; /* xxblend_v4si */

    case E_V8HImode:
      if (pattern378 (x3, 
E_V8HImode) != 0
          || !
#line 6700 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1781; /* xxblend_v8hi */

    case E_V16QImode:
      if (pattern378 (x3, 
E_V16QImode) != 0
          || !
#line 6700 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1782; /* xxblend_v16qi */

    case E_V4SFmode:
      if (pattern378 (x3, 
E_V4SFmode) != 0
          || !
#line 6700 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1783; /* xxblend_v4sf */

    case E_V2DFmode:
      if (pattern378 (x3, 
E_V2DFmode) != 0
          || !
#line 6700 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1784; /* xxblend_v2df */

    case E_V2DImode:
      if (pattern435 (x3) != 0
          || !
#line 6700 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1785; /* xxblend_v2di */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 82:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern461 (x2, 
E_KFmode) != 0
                  || !(
#line 15544 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1193; /* fmakf4_odd */

            case E_TFmode:
              if (pattern461 (x2, 
E_TFmode) != 0
                  || !(
#line 15544 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1194; /* fmatf4_odd */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern462 (x2, 
E_KFmode) != 0
                  || !(
#line 15557 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1195; /* *fmskf4_odd */

            case E_TFmode:
              if (pattern462 (x2, 
E_TFmode) != 0
                  || !(
#line 15557 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1196; /* *fmstf4_odd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 194:
      switch (pattern163 (x1))
        {
        case 0:
          if (!
#line 4241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1537; /* vextractlv16qi_internal */

        case 1:
          if (!
#line 4241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1538; /* vextractlv8hi_internal */

        case 2:
          if (!
#line 4241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1539; /* vextractlv4si_internal */

        case 3:
          if (!
#line 4241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1540; /* vextractlv2di_internal */

        default:
          return -1;
        }

    case 195:
      switch (pattern163 (x1))
        {
        case 0:
          if (!
#line 4271 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1541; /* vextractrv16qi_internal */

        case 1:
          if (!
#line 4271 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1542; /* vextractrv8hi_internal */

        case 2:
          if (!
#line 4271 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1543; /* vextractrv4si_internal */

        case 3:
          if (!
#line 4271 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1544; /* vextractrv2di_internal */

        default:
          return -1;
        }

    case 196:
      switch (pattern164 (x1))
        {
        case 0:
          if (!
#line 4298 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1545; /* vinsertvl_internal_v16qi */

        case 1:
          if (!
#line 4352 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1553; /* vinsertgl_internal_v16qi */

        case 2:
          if (!
#line 4298 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1546; /* vinsertvl_internal_v8hi */

        case 3:
          if (!
#line 4352 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1554; /* vinsertgl_internal_v8hi */

        case 4:
          if (!
#line 4298 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1547; /* vinsertvl_internal_v4si */

        case 5:
          if (!
#line 4352 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1555; /* vinsertgl_internal_v4si */

        case 6:
          if (!
#line 4298 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1548; /* vinsertvl_internal_v2di */

        case 7:
          if (!
#line 4352 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1556; /* vinsertgl_internal_v2di */

        default:
          return -1;
        }

    case 197:
      switch (pattern164 (x1))
        {
        case 0:
          if (!
#line 4325 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1549; /* vinsertvr_internal_v16qi */

        case 1:
          if (!
#line 4379 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1557; /* vinsertgr_internal_v16qi */

        case 2:
          if (!
#line 4325 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1550; /* vinsertvr_internal_v8hi */

        case 3:
          if (!
#line 4379 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1558; /* vinsertgr_internal_v8hi */

        case 4:
          if (!
#line 4325 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1551; /* vinsertvr_internal_v4si */

        case 5:
          if (!
#line 4379 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1559; /* vinsertgr_internal_v4si */

        case 6:
          if (!
#line 4325 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1552; /* vinsertvr_internal_v2di */

        case 7:
          if (!
#line 4379 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1560; /* vinsertgr_internal_v2di */

        default:
          return -1;
        }

    case 198:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern463 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 4413 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1561; /* vreplace_elt_v4si_inst */

        case E_V4SFmode:
          if (pattern463 (x2, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 4413 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1562; /* vreplace_elt_v4sf_inst */

        case E_V2DImode:
          if (pattern463 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 4413 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1563; /* vreplace_elt_v2di_inst */

        case E_V2DFmode:
          if (pattern463 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 4413 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1564; /* vreplace_elt_v2df_inst */

        default:
          return -1;
        }

    case 199:
      return recog_101 (x1, insn, pnum_clobbers);

    case 123:
      return recog_96 (x1, insn, pnum_clobbers);

    case 126:
      return recog_98 (x1, insn, pnum_clobbers);

    case 160:
      if (pattern165 (x1) != 0
          || !
#line 5738 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1701; /* *lxvl */

    case 161:
      if (pattern165 (x1) != 0
          || !
#line 5748 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1702; /* lxvll */

    case 165:
      if (pattern166 (x1) != 0
          || !
#line 5777 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1703; /* stxvll */

    case 164:
      if (pattern166 (x1) != 0
          || !
#line 5834 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1704; /* *stxvl */

    case 183:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vsx_register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode)
          || !
#line 6073 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1731; /* *insert4b_internal */

    case 206:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!u1bit_cint_operand (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!s32bit_cint_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 6659 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1778; /* xxsplti32dx_v4si_inst */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 6688 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1779; /* xxsplti32dx_v4sf_inst */

        default:
          return -1;
        }

    case 207:
      return recog_100 (x1, insn, pnum_clobbers);

    case 202:
      if (pattern167 (x1, 
E_V2DImode) != 0
          || !
#line 6788 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1788; /* vmsumcud */

    case 263:
      return recog_95 (x1, insn, pnum_clobbers);

    case 358:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1910; /* vsldb_v16qi */

        case 1:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1912; /* vsldb_v8hi */

        case 2:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1914; /* vsldb_v4si */

        case 3:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1916; /* vsldb_v2di */

        case 4:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1918; /* vsldb_v1ti */

        default:
          return -1;
        }

    case 359:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1911; /* vsrdb_v16qi */

        case 1:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1913; /* vsrdb_v8hi */

        case 2:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1915; /* vsrdb_v4si */

        case 3:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1917; /* vsrdb_v2di */

        case 4:
          if (!
#line 885 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1919; /* vsrdb_v1ti */

        default:
          return -1;
        }

    case 210:
      switch (pattern169 (x1))
        {
        case 0:
          if (!
#line 1011 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1929; /* altivec_vmsumuhm */

        case 1:
          if (!
#line 1011 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1930; /* altivec_vmsumubm */

        default:
          return -1;
        }

    case 211:
      if (pattern167 (x1, 
E_V2DImode) != 0
          || !
#line 1021 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1931; /* altivec_vmsumudm */

    case 212:
      switch (pattern169 (x1))
        {
        case 0:
          if (!
#line 1031 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1932; /* altivec_vmsummhm */

        case 1:
          if (!
#line 1031 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1933; /* altivec_vmsummbm */

        default:
          return -1;
        }

    case 213:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V4SImode)
          || !
#line 1041 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1934; /* altivec_vmsumshm */

    case 346:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern435 (x2) != 0
              || !
#line 2008 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2021; /* altivec_vrldmi */

        case E_V4SImode:
          if (pattern378 (x2, 
E_V4SImode) != 0
              || !
#line 2008 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2022; /* altivec_vrlwmi */

        case E_V1TImode:
          if (pattern132 (x2, 
E_V1TImode) != 0
              || !vsx_register_operand (operands[3], E_V1TImode)
              || !
#line 2036 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 2023; /* altivec_vrlqmi_inst */

        default:
          return -1;
        }

    case 253:
      return recog_97 (x1, insn, pnum_clobbers);

    case 255:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2085; /* *altivec_vperm_v4si_uns_internal */

        case 1:
          if (!
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2086; /* *altivec_vperm_v8hi_uns_internal */

        case 2:
          if (!
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2087; /* *altivec_vperm_v16qi_uns_internal */

        case 3:
          if (!
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2088; /* *altivec_vperm_v4sf_uns_internal */

        case 4:
          if (!
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2089; /* *altivec_vperm_v2df_uns_internal */

        case 5:
          if (!
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2090; /* *altivec_vperm_v2di_uns_internal */

        case 6:
          if (!
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2091; /* *altivec_vperm_v1ti_uns_internal */

        case 7:
          if (!
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2092; /* *altivec_vperm_ti_uns_internal */

        case 8:
          if (!(
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2093; /* *altivec_vperm_kf_uns_internal */

        case 9:
          if (!(
#line 2535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2094; /* *altivec_vperm_tf_uns_internal */

        default:
          return -1;
        }

    case 254:
      return recog_104 (x1, insn, pnum_clobbers);

    case 321:
      if (pattern171 (x1, 
E_V4SImode, 
E_V8HImode) != 0
          || !
#line 3837 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2291; /* vperm_v8hiv4si */

    case 322:
      if (pattern171 (x1, 
E_V8HImode, 
E_V16QImode) != 0
          || !
#line 3850 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2292; /* vperm_v16qiv8hi */

    case 335:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4469 "../../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2326; /* altivec_vaddeuqm */

    case 336:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4479 "../../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2327; /* altivec_vaddecuq */

    case 338:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4489 "../../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2328; /* altivec_vsubeuqm */

    case 339:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4499 "../../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2329; /* altivec_vsubecuq */

    case 342:
      switch (pattern172 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2333; /* bcdadd_v1ti */

        case 1:
          if (!
#line 4592 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2335; /* bcdadd_v16qi */

        default:
          return -1;
        }

    case 343:
      switch (pattern172 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2334; /* bcdsub_v1ti */

        case 1:
          if (!
#line 4592 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2336; /* bcdsub_v16qi */

        default:
          return -1;
        }

    case 345:
      if (pnum_clobbers == NULL
          || pattern148 (x1, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_1_operand (operands[3], E_QImode)
          || !
#line 4763 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      *pnum_clobbers = 1;
      return 2355; /* bcdshift_v16qi */

    case 417:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2372; /* mma_xvi4ger8pp */

    case 419:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2373; /* mma_xvi8ger4pp */

    case 420:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2374; /* mma_xvi8ger4spp */

    case 413:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2375; /* mma_xvi16ger2pp */

    case 415:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2376; /* mma_xvi16ger2spp */

    case 401:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2377; /* mma_xvf16ger2pp */

    case 400:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2378; /* mma_xvf16ger2pn */

    case 399:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2379; /* mma_xvf16ger2np */

    case 398:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2380; /* mma_xvf16ger2nn */

    case 396:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2381; /* mma_xvbf16ger2pp */

    case 395:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2382; /* mma_xvbf16ger2pn */

    case 394:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2383; /* mma_xvbf16ger2np */

    case 393:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2384; /* mma_xvbf16ger2nn */

    case 406:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2385; /* mma_xvf32gerpp */

    case 405:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2386; /* mma_xvf32gerpn */

    case 404:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2387; /* mma_xvf32gernp */

    case 403:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2388; /* mma_xvf32gernn */

    case 411:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2390; /* mma_xvf64gerpp */

    case 410:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2391; /* mma_xvf64gerpn */

    case 409:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2392; /* mma_xvf64gernp */

    case 408:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2393; /* mma_xvf64gernn */

    case 432:
      return recog_103 (x1, insn, pnum_clobbers);

    case 439:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern378 (x2, 
E_V16QImode) != 0
              || !
#line 91 "../../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2485; /* crypto_vpermxor_v16qi */

        case E_V8HImode:
          if (pattern378 (x2, 
E_V8HImode) != 0
              || !
#line 91 "../../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2486; /* crypto_vpermxor_v8hi */

        case E_V4SImode:
          if (pattern378 (x2, 
E_V4SImode) != 0
              || !
#line 91 "../../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2487; /* crypto_vpermxor_v4si */

        case E_V2DImode:
          if (pattern435 (x2) != 0
              || !
#line 91 "../../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2488; /* crypto_vpermxor_v2di */

        default:
          return -1;
        }

    case 438:
      return recog_102 (x1, insn, pnum_clobbers);

    case 445:
      return recog_99 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_123 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[4] = x9;
          if (!const_2_to_3_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern510 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 3855 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1512; /* vsx_xxpermdi2_v2df_1 */

            case E_V2DImode:
              if (pattern510 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 3855 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1513; /* vsx_xxpermdi2_v2di_1 */

            default:
              return -1;
            }

        case 16:
          if (pattern224 (x3) != 0
              || pattern537 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 16L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 17L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 18L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 19L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 4L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 20L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 5L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 21L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 6L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 22L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 7L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 23L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1177 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1958; /* altivec_vmrghb_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1351 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1968; /* altivec_vmrglb_direct_le */

            case 8L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 24L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 9L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 25L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 10L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 26L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 11L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 27L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 12L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 28L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 13L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 29L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 14L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 30L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 15L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 31L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1195 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1959; /* altivec_vmrghb_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1333 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1967; /* altivec_vmrglb_direct_be */

            default:
              return -1;
            }

        case 8:
          if (pattern225 (x3) != 0
              || pattern537 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 8L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 9L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 10L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 11L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1224 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1960; /* altivec_vmrghh_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1394 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1970; /* altivec_vmrglh_direct_le */

            case 4L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 12L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 5L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 13L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 6L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 14L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 7L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 15L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1238 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1961; /* altivec_vmrghh_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1380 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1969; /* altivec_vmrglh_direct_be */

            default:
              return -1;
            }

        case 4:
          if (pattern226 (x3) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 4L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              switch (XWINT (x10, 0))
                {
                case 1L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 5L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern537 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1962; /* altivec_vmrghw_direct_v4sf_be */
                      if (
#line 1295 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                        return 1966; /* *altivec_vmrghsf */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1973; /* altivec_vmrglw_direct_v4sf_le */

                    case E_V4SImode:
                      if (pattern537 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1963; /* altivec_vmrghw_direct_v4si_be */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1974; /* altivec_vmrglw_direct_v4si_le */

                    default:
                      return -1;
                    }

                case 2L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 6L)
                    return -1;
                  switch (pattern539 (x2))
                    {
                    case 0:
                      if (!
#line 1487 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1976; /* p8_vmrgew_v4sf */

                    case 1:
                      if (!
#line 1487 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1977; /* p8_vmrgew_v4si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 2L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 6L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern537 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1964; /* altivec_vmrghw_direct_v4sf_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (
#line 1423 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return 1971; /* altivec_vmrglw_direct_v4sf_be */
                  if (!
#line 1451 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                    return -1;
                  return 1975; /* *altivec_vmrglsf */

                case E_V4SImode:
                  if (pattern537 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1965; /* altivec_vmrghw_direct_v4si_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (!
#line 1423 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return -1;
                  return 1972; /* altivec_vmrglw_direct_v4si_be */

                default:
                  return -1;
                }

            case 1L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 5L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (pattern539 (x2))
                {
                case 0:
                  if (!
#line 1504 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1978; /* p8_vmrgow_v4sf */

                case 1:
                  if (!
#line 1504 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1979; /* p8_vmrgow_v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1641; /* *vsx_reduc_plus_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1644; /* *vsx_reduc_plus_v4sf_scalar */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1642; /* *vsx_reduc_smin_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1645; /* *vsx_reduc_smin_v4sf_scalar */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1643; /* *vsx_reduc_smax_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1646; /* *vsx_reduc_smax_v4sf_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          if (reg_or_mem_operand (operands[1], E_SFmode)
              && 
#line 5241 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)))
            return 328; /* *extendsfdf2_fpr */
          if (!gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5262 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && HONOR_SNANS (SFmode)))
            return -1;
          return 329; /* *extendsfdf2_snan */

        case E_IFmode:
          switch (pattern205 (x3))
            {
            case 0:
              if (!(
#line 8930 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 613; /* extenddfif2_vsx */

            case 1:
              if (!
#line 9461 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                return -1;
              return 639; /* *extendtfif2_internal */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_TFmode))
            {
              switch (pattern316 ())
                {
                case 0:
                  if ((
#line 8930 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 614; /* extenddftf2_vsx */
                  break;

                case 1:
                  if (
#line 9448 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                    return 637; /* *extendiftf2_internal */
                  break;

                case 2:
                  if (
#line 9448 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
                    return 638; /* *extendkftf2_internal */
                  break;

                default:
                  break;
                }
            }
          if (altivec_register_operand (operands[0], E_TFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1122; /* extendsftf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1124; /* extenddftf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_TFmode)
              || !vsx_register_operand (operands[1], E_KFmode)
              || !
#line 15211 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1125; /* *extendkftf2 */

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_KFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && 
#line 9461 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
            return 640; /* *extendtfkf2_internal */
          if (altivec_register_operand (operands[0], E_KFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1121; /* extendsfkf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1123; /* extenddfkf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_KFmode)
              || !vsx_register_operand (operands[1], E_TFmode)
              || !
#line 15227 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1126; /* *extendtfkf2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_SDmode)
              || !
#line 62 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2425; /* extendsddd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 140 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2433; /* extendddtd2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern7 (x3, 
E_V2DFmode))
        {
        case 0:
          if (!
#line 2371 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1420; /* vsx_xvcvspdp_be */

        case 1:
          if (!
#line 2380 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1421; /* vsx_xvcvspdp_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern123 (x3, 
E_SImode) == 0)
            return 275; /* rotlsi3 */
          break;

        case E_DImode:
          if (pattern123 (x3, 
E_DImode) == 0
              && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return 276; /* rotldi3 */
          break;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) == 0
              && 
#line 1989 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return 2016; /* altivec_vrlw */
          break;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) == 0
              && 
#line 1989 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return 2017; /* altivec_vrlh */
          break;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) == 0
              && 
#line 1989 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return 2018; /* altivec_vrlb */
          break;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) == 0
              && 
#line 1989 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return 2019; /* altivec_vrld */
          break;

        case E_V1TImode:
          if (pattern2 (x3, 
E_V1TImode) == 0
              && 
#line 1997 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return 2020; /* altivec_vrlq */
          break;

        default:
          break;
        }
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !input_operand (operands[1], E_V1TImode)
              || !
#line 1003 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1271; /* *vsx_le_permute_v1ti */

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !input_operand (operands[1], E_TImode)
              || !
#line 1003 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1272; /* *vsx_le_permute_ti */

        default:
          return -1;
        }

    case ROTATE:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (pattern215 (x3))
        {
        case 0:
          if (!
#line 1021 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1273; /* *vsx_le_undo_permute_v1ti */

        case 1:
          if (!
#line 1021 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1274; /* *vsx_le_undo_permute_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!altivec_register_operand (operands[3], E_V2DImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_V2DImode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  if (!altivec_register_operand (operands[1], E_V2DImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!altivec_register_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_V2DImode)
      || !
#line 3049 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
    return -1;
  return 3341; /* *fuse_vaddudm_vaddudm */
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 82; /* *addsi3_imm_carry_0 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 83; /* *adddi3_imm_carry_0 */

        default:
          return -1;
        }

    case MEM:
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x5, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x8))
            {
            case E_SImode:
              if (pattern581 (x5, 
E_SImode) != 0
                  || !(
#line 10257 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 704; /* movdi_si_update */

            case E_DImode:
              if (pattern581 (x5, 
E_DImode) != 0)
                return -1;
              if ((
#line 10257 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 705; /* movdi_di_update */
              if (!
#line 10277 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 706; /* movdi_update_stack */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern572 (x1, 
E_SImode))
            {
            case 0:
              if ((
#line 10321 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 711; /* movsi_si_update */
              if (!
#line 10341 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 713; /* movsi_update_stack */

            case 1:
              if (!(
#line 10321 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 712; /* movsi_di_update */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern572 (x1, 
E_HImode))
            {
            case 0:
              if (!(
#line 10406 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 724; /* *movhi_update4 */

            case 1:
              if (!(
#line 10406 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 725; /* *movhi_update4 */

            default:
              return -1;
            }

        case E_QImode:
          switch (pattern572 (x1, 
E_QImode))
            {
            case 0:
              if (!(
#line 10455 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 732; /* *movqi_update3 */

            case 1:
              if (!(
#line 10455 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 733; /* *movqi_update3 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern572 (x1, 
E_SFmode))
            {
            case 0:
              if ((
#line 10488 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 738; /* *movsf_update2 */
              if (!(
#line 10521 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 744; /* *movsf_update4 */

            case 1:
              if ((
#line 10488 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 739; /* *movsf_update2 */
              if (!(
#line 10521 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 745; /* *movsf_update4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern572 (x1, 
E_DFmode))
            {
            case 0:
              if (!(
#line 10488 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 740; /* *movdf_update2 */

            case 1:
              if (!(
#line 10488 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 741; /* *movdf_update2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern497 (x1, 
E_SImode) != 0
              || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 116; /* *subfsi3_imm_carry_m1 */

        case E_DImode:
          if (pattern497 (x1, 
E_DImode) != 0
              || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 117; /* *subfdi3_imm_carry_m1 */

        default:
          return -1;
        }

    case XOR:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[3] = x8;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          x11 = XEXP (x10, 0);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              switch (pattern447 (x3))
                {
                case 0:
                  if (!
#line 691 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2567; /* *fuse_and_eqv */

                case 1:
                  if (!(
#line 691 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2568; /* *fuse_and_eqv */

                case 2:
                  if (!
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2859; /* *fuse_vand_veqv */

                case 3:
                  if (!
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2860; /* *fuse_vand_veqv */

                case 4:
                  if (!
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2861; /* *fuse_vand_veqv */

                case 5:
                  if (!
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2862; /* *fuse_vand_veqv */

                case 6:
                  if (!
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2863; /* *fuse_vand_veqv */

                case 7:
                  if (!
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2864; /* *fuse_vand_veqv */

                case 8:
                  if (!
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2865; /* *fuse_vand_veqv */

                case 9:
                  if (!
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2866; /* *fuse_vand_veqv */

                case 10:
                  if (!(
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 2867; /* *fuse_vand_veqv */

                case 11:
                  if (!(
#line 2167 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 2868; /* *fuse_vand_veqv */

                default:
                  return -1;
                }

            case NOT:
              x12 = XEXP (x11, 0);
              operands[0] = x12;
              x13 = XEXP (x10, 1);
              switch (GET_CODE (x13))
                {
                case REG:
                case SUBREG:
                  switch (pattern522 (x3))
                    {
                    case 0:
                      if (!
#line 709 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2569; /* *fuse_andc_eqv */

                    case 1:
                      if (!(
#line 709 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2570; /* *fuse_andc_eqv */

                    case 2:
                      if (!
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2869; /* *fuse_vandc_veqv */

                    case 3:
                      if (!
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2870; /* *fuse_vandc_veqv */

                    case 4:
                      if (!
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2871; /* *fuse_vandc_veqv */

                    case 5:
                      if (!
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2872; /* *fuse_vandc_veqv */

                    case 6:
                      if (!
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2873; /* *fuse_vandc_veqv */

                    case 7:
                      if (!
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2874; /* *fuse_vandc_veqv */

                    case 8:
                      if (!
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2875; /* *fuse_vandc_veqv */

                    case 9:
                      if (!
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2876; /* *fuse_vandc_veqv */

                    case 10:
                      if (!(
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2877; /* *fuse_vandc_veqv */

                    case 11:
                      if (!(
#line 2185 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2878; /* *fuse_vandc_veqv */

                    default:
                      return -1;
                    }

                case NOT:
                  switch (pattern525 (x3))
                    {
                    case 0:
                      if (!
#line 763 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2575; /* *fuse_nor_eqv */

                    case 1:
                      if (!(
#line 763 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2576; /* *fuse_nor_eqv */

                    case 2:
                      if (!
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2899; /* *fuse_vnor_veqv */

                    case 3:
                      if (!
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2900; /* *fuse_vnor_veqv */

                    case 4:
                      if (!
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2901; /* *fuse_vnor_veqv */

                    case 5:
                      if (!
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2902; /* *fuse_vnor_veqv */

                    case 6:
                      if (!
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2903; /* *fuse_vnor_veqv */

                    case 7:
                      if (!
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2904; /* *fuse_vnor_veqv */

                    case 8:
                      if (!
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2905; /* *fuse_vnor_veqv */

                    case 9:
                      if (!
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2906; /* *fuse_vnor_veqv */

                    case 10:
                      if (!(
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2907; /* *fuse_vnor_veqv */

                    case 11:
                      if (!(
#line 2239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2908; /* *fuse_vnor_veqv */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != XOR)
            return -1;
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          x14 = XEXP (x11, 1);
          operands[1] = x14;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern543 (x3, 
E_SImode) != 0
                  || !
#line 727 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2571; /* *fuse_eqv_eqv */

            case E_DImode:
              if (pattern543 (x3, 
E_DImode) != 0
                  || !(
#line 727 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2572; /* *fuse_eqv_eqv */

            case E_V4SImode:
              if (pattern544 (x3, 
E_V4SImode) != 0
                  || !
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2879; /* *fuse_veqv_veqv */

            case E_V8HImode:
              if (pattern544 (x3, 
E_V8HImode) != 0
                  || !
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2880; /* *fuse_veqv_veqv */

            case E_V16QImode:
              if (pattern544 (x3, 
E_V16QImode) != 0
                  || !
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2881; /* *fuse_veqv_veqv */

            case E_V4SFmode:
              if (pattern544 (x3, 
E_V4SFmode) != 0
                  || !
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2882; /* *fuse_veqv_veqv */

            case E_V2DFmode:
              if (pattern544 (x3, 
E_V2DFmode) != 0
                  || !
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2883; /* *fuse_veqv_veqv */

            case E_V2DImode:
              if (pattern544 (x3, 
E_V2DImode) != 0
                  || !
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2884; /* *fuse_veqv_veqv */

            case E_V1TImode:
              if (pattern544 (x3, 
E_V1TImode) != 0
                  || !
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2885; /* *fuse_veqv_veqv */

            case E_TImode:
              if (pattern544 (x3, 
E_TImode) != 0
                  || !
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2886; /* *fuse_veqv_veqv */

            case E_KFmode:
              if (pattern544 (x3, 
E_KFmode) != 0
                  || !(
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2887; /* *fuse_veqv_veqv */

            case E_TFmode:
              if (pattern544 (x3, 
E_TFmode) != 0
                  || !(
#line 2203 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2888; /* *fuse_veqv_veqv */

            default:
              return -1;
            }

        case IOR:
          x11 = XEXP (x10, 0);
          switch (GET_CODE (x11))
            {
            case NOT:
              x12 = XEXP (x11, 0);
              operands[0] = x12;
              x13 = XEXP (x10, 1);
              switch (GET_CODE (x13))
                {
                case NOT:
                  switch (pattern525 (x3))
                    {
                    case 0:
                      if (!
#line 745 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2573; /* *fuse_nand_eqv */

                    case 1:
                      if (!(
#line 745 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2574; /* *fuse_nand_eqv */

                    case 2:
                      if (!
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2889; /* *fuse_vnand_veqv */

                    case 3:
                      if (!
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2890; /* *fuse_vnand_veqv */

                    case 4:
                      if (!
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2891; /* *fuse_vnand_veqv */

                    case 5:
                      if (!
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2892; /* *fuse_vnand_veqv */

                    case 6:
                      if (!
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2893; /* *fuse_vnand_veqv */

                    case 7:
                      if (!
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2894; /* *fuse_vnand_veqv */

                    case 8:
                      if (!
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2895; /* *fuse_vnand_veqv */

                    case 9:
                      if (!
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2896; /* *fuse_vnand_veqv */

                    case 10:
                      if (!(
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2897; /* *fuse_vnand_veqv */

                    case 11:
                      if (!(
#line 2221 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2898; /* *fuse_vnand_veqv */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (pattern522 (x3))
                    {
                    case 0:
                      if (!
#line 799 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2579; /* *fuse_orc_eqv */

                    case 1:
                      if (!(
#line 799 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2580; /* *fuse_orc_eqv */

                    case 2:
                      if (!
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2919; /* *fuse_vorc_veqv */

                    case 3:
                      if (!
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2920; /* *fuse_vorc_veqv */

                    case 4:
                      if (!
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2921; /* *fuse_vorc_veqv */

                    case 5:
                      if (!
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2922; /* *fuse_vorc_veqv */

                    case 6:
                      if (!
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2923; /* *fuse_vorc_veqv */

                    case 7:
                      if (!
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2924; /* *fuse_vorc_veqv */

                    case 8:
                      if (!
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2925; /* *fuse_vorc_veqv */

                    case 9:
                      if (!
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2926; /* *fuse_vorc_veqv */

                    case 10:
                      if (!(
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2927; /* *fuse_vorc_veqv */

                    case 11:
                      if (!(
#line 2275 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2928; /* *fuse_vorc_veqv */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern447 (x3))
                {
                case 0:
                  if (!
#line 781 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2577; /* *fuse_or_eqv */

                case 1:
                  if (!(
#line 781 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2578; /* *fuse_or_eqv */

                case 2:
                  if (!
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2909; /* *fuse_vor_veqv */

                case 3:
                  if (!
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2910; /* *fuse_vor_veqv */

                case 4:
                  if (!
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2911; /* *fuse_vor_veqv */

                case 5:
                  if (!
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2912; /* *fuse_vor_veqv */

                case 6:
                  if (!
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2913; /* *fuse_vor_veqv */

                case 7:
                  if (!
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2914; /* *fuse_vor_veqv */

                case 8:
                  if (!
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2915; /* *fuse_vor_veqv */

                case 9:
                  if (!
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2916; /* *fuse_vor_veqv */

                case 10:
                  if (!(
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 2917; /* *fuse_vor_veqv */

                case 11:
                  if (!(
#line 2257 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 2918; /* *fuse_vor_veqv */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case XOR:
          switch (pattern447 (x3))
            {
            case 0:
              if (!
#line 817 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2581; /* *fuse_xor_eqv */

            case 1:
              if (!(
#line 817 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2582; /* *fuse_xor_eqv */

            case 2:
              if (!
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2929; /* *fuse_vxor_veqv */

            case 3:
              if (!
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2930; /* *fuse_vxor_veqv */

            case 4:
              if (!
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2931; /* *fuse_vxor_veqv */

            case 5:
              if (!
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2932; /* *fuse_vxor_veqv */

            case 6:
              if (!
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2933; /* *fuse_vxor_veqv */

            case 7:
              if (!
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2934; /* *fuse_vxor_veqv */

            case 8:
              if (!
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2935; /* *fuse_vxor_veqv */

            case 9:
              if (!
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2936; /* *fuse_vxor_veqv */

            case 10:
              if (!(
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2937; /* *fuse_vxor_veqv */

            case 11:
              if (!(
#line 2293 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2938; /* *fuse_vxor_veqv */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_185 (x1, insn, pnum_clobbers);

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM)
        return -1;
      if (pnum_clobbers != NULL)
        {
          switch (pattern117 (x1))
            {
            case 0:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (current_file_function_operand (operands[0], E_SImode)
                      && (
#line 11491 "../../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 819; /* *call_localsi */
                    }
                  if (symbol_ref_operand (operands[0], E_SImode))
                    {
                      if ((
#line 11567 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 825; /* *call_nonlocal_sysvsi */
                        }
                      if ((
#line 11688 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 835; /* *call_nonlocal_aixsi */
                        }
                    }
                  break;

                case E_DImode:
                  if (current_file_function_operand (operands[0], E_DImode)
                      && (
#line 11491 "../../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 820; /* *call_localdi */
                    }
                  if (symbol_ref_operand (operands[0], E_DImode))
                    {
                      if ((
#line 11567 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 826; /* *call_nonlocal_sysvdi */
                        }
                      if ((
#line 11688 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 836; /* *call_nonlocal_aixdi */
                        }
                    }
                  break;

                default:
                  break;
                }
              break;

            case 1:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (indirect_call_operand (operands[0], E_SImode))
                    {
                      if ((
#line 11539 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 823; /* *call_indirect_nonlocal_sysvsi */
                        }
                      if ((
#line 11786 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 845; /* *call_indirect_pcrelsi */
                        }
                    }
                  break;

                case E_DImode:
                  if (indirect_call_operand (operands[0], E_DImode))
                    {
                      if ((
#line 11539 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 824; /* *call_indirect_nonlocal_sysvdi */
                        }
                      if ((
#line 11786 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 846; /* *call_indirect_pcreldi */
                        }
                    }
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SIMPLE_RETURN)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!call_operand (operands[0], E_SImode)
              || !(
#line 12066 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 863; /* *sibcall_aixsi */

        case E_DImode:
          if (!call_operand (operands[0], E_DImode)
              || !(
#line 12066 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 864; /* *sibcall_aixdi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[0] = x7;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      switch (XINT (x2, 1))
        {
        case 4:
          switch (pattern356 ())
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1044; /* eh_set_lr_si */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1045; /* eh_set_lr_di */

            default:
              return -1;
            }

        case 5:
          if (GET_MODE (x2) != E_BLKmode
              || !scratch_operand (operands[1], E_CCmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode))
                return -1;
              return 1217; /* loadsync_qi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode))
                return -1;
              return 1218; /* loadsync_hi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 1219; /* loadsync_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 111 "../../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1220; /* loadsync_di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !
#line 112 "../../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
                return -1;
              return 1221; /* loadsync_ti */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern178 (x1, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 886 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_1 (insn, operands);

        case 1:
          if (!
#line 940 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_5 (insn, operands);

        case 2:
          if (!(
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 886 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_2 (insn, operands);

        case 3:
          if (!(
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 940 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_6 (insn, operands);

        case 4:
          if (!(
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 997 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_9 (insn, operands);

        case 5:
          if (!
#line 907 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_3 (insn, operands);

        case 6:
          if (!
#line 961 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_7 (insn, operands);

        case 7:
          if (!(
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 907 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_4 (insn, operands);

        case 8:
          if (!(
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 961 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_8 (insn, operands);

        case 9:
          if (!(
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1018 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_10 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern178 (x1, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 1049 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_11 (insn, operands);

        case 1:
          if (!
#line 1124 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_17 (insn, operands);

        case 2:
          if (!(
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1049 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_12 (insn, operands);

        case 3:
          if (!(
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1124 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_18 (insn, operands);

        case 4:
          if (!(
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1224 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_23 (insn, operands);

        case 5:
          if (!
#line 1070 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_13 (insn, operands);

        case 6:
          if (!
#line 1145 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 7:
          if (!(
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1070 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_14 (insn, operands);

        case 8:
          if (!(
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1145 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_20 (insn, operands);

        case 9:
          if (!(
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1245 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_24 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern204 (x1, 
PLUS))
        {
        case 0:
          if (!(
#line 1872 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1876 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_25 (insn, operands);

        case 1:
          if (!((
#line 1872 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1876 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_26 (insn, operands);

        case 2:
          if (!(
#line 1896 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1900 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_27 (insn, operands);

        case 3:
          if (!((
#line 1896 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1900 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_28 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      switch (pattern181 (x1, 
NOT))
        {
        case 0:
          if (!(
#line 2132 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2136 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_35 (insn, operands);

        case 1:
          if (!((
#line 2132 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2136 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_36 (insn, operands);

        case 2:
          if (!(
#line 2153 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2157 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_37 (insn, operands);

        case 3:
          if (!((
#line 2153 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2157 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_38 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      switch (pattern486 (x1))
        {
        case 0:
          if (!(
#line 2215 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2219 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_39 (insn, operands);

        case 1:
          if (!((
#line 2215 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2219 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_40 (insn, operands);

        case 2:
          if (!(
#line 2239 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2243 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_41 (insn, operands);

        case 3:
          if (!((
#line 2239 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2243 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_42 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      switch (pattern181 (x1, 
NEG))
        {
        case 0:
          if (!(
#line 2410 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2414 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_46 (insn, operands);

        case 1:
          if (!((
#line 2410 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2414 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_47 (insn, operands);

        case 2:
          if (!(
#line 2431 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2435 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_48 (insn, operands);

        case 3:
          if (!((
#line 2431 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2435 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_49 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      switch (pattern204 (x1, 
MULT))
        {
        case 0:
          if (!(
#line 3124 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3128 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_58 (insn, operands);

        case 1:
          if (!((
#line 3124 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3128 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_59 (insn, operands);

        case 2:
          if (!(
#line 3149 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3153 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_60 (insn, operands);

        case 3:
          if (!((
#line 3149 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3153 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_61 (insn, operands);

        default:
          return NULL;
        }

    case AND:
    case IOR:
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 0);
      if (!cc_reg_operand (x6, E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      if (GET_CODE (x4) == AND)
        {
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      operands[4] = x6;
      switch (pattern391 (x1))
        {
        case 0:
          if (!(
#line 4016 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4020 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_89 (insn, operands);

        case 1:
          if (!((
#line 4016 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4020 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_90 (insn, operands);

        case 2:
          if (!(
#line 4039 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4043 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_91 (insn, operands);

        case 3:
          if (!((
#line 4039 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4043 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_92 (insn, operands);

        case 4:
          if (!(
#line 4071 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4075 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_93 (insn, operands);

        case 5:
          if (!((
#line 4071 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4075 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_94 (insn, operands);

        case 6:
          if (!(
#line 4094 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4098 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_95 (insn, operands);

        case 7:
          if (!((
#line 4094 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4098 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_96 (insn, operands);

        case 8:
          if (!(
#line 4126 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4130 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_97 (insn, operands);

        case 9:
          if (!((
#line 4126 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4130 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_98 (insn, operands);

        case 10:
          if (!(
#line 4149 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4153 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_99 (insn, operands);

        case 11:
          if (!((
#line 4149 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4153 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_100 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      switch (pattern184 (x1, 
ROTATE))
        {
        case 0:
          if (!(
#line 4590 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4594 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_129 (insn, operands);

        case 1:
          if (!((
#line 4590 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4594 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_130 (insn, operands);

        case 2:
          if (!(
#line 4615 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4619 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_131 (insn, operands);

        case 3:
          if (!((
#line 4615 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4619 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_132 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern185 (x1))
        {
        case 0:
          if (!(
#line 4658 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4662 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_133 (insn, operands);

        case 1:
          if (!((
#line 4658 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4662 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_134 (insn, operands);

        case 2:
          if (!(
#line 4683 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4687 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_135 (insn, operands);

        case 3:
          if (!((
#line 4683 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4687 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_136 (insn, operands);

        case 4:
          if (!(
#line 4732 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4738 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[3], CCmode)
       || memory_operand (operands[1], SImode)))))
            return NULL;
          return gen_split_138 (insn, operands);

        case 5:
          if (!(
#line 4782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4788 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[3], CCmode)
       || memory_operand (operands[1], SImode)))))
            return NULL;
          return gen_split_139 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern184 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!(
#line 4847 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4851 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_140 (insn, operands);

        case 1:
          if (!((
#line 4847 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4851 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_141 (insn, operands);

        case 2:
          if (!(
#line 4872 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4876 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!((
#line 4872 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4876 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_143 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return NULL;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!cc_reg_not_cr0_operand (operands[2], E_CCmode))
        return NULL;
      switch (pattern442 (x1))
        {
        case 0:
          if (!(
#line 8088 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
            return NULL;
          return gen_split_297 (insn, operands);

        case 1:
          if (!(
#line 8088 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          return gen_split_298 (insn, operands);

        default:
          return NULL;
        }

    case MEM:
      switch (pattern190 (x1))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 30 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_744 (insn, operands);

        case 1:
          if (!(
#line 112 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 114 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_748 (insn, operands);

        case 2:
          if (!(
#line 239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 241 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_754 (insn, operands);

        case 3:
          if (!((
#line 239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 241 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_755 (insn, operands);

        case 4:
          if (!(
#line 49 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 51 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_745 (insn, operands);

        case 5:
          if (!(
#line 133 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 135 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_749 (insn, operands);

        case 6:
          if (!(
#line 260 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 262 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_756 (insn, operands);

        case 7:
          if (!((
#line 260 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 262 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_757 (insn, operands);

        case 8:
          if (!(
#line 323 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 325 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_762 (insn, operands);

        case 9:
          if (!((
#line 323 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 325 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_763 (insn, operands);

        case 10:
          if (!(
#line 70 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 72 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_746 (insn, operands);

        case 11:
          if (!(
#line 154 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 156 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_750 (insn, operands);

        case 12:
          if (!(
#line 91 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 93 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_747 (insn, operands);

        case 13:
          if (!(
#line 175 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 177 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_751 (insn, operands);

        case 14:
          if (!((
#line 196 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 198 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_752 (insn, operands);

        case 15:
          if (!(
#line 281 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 283 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_758 (insn, operands);

        case 16:
          if (!((
#line 281 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 283 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_759 (insn, operands);

        case 17:
          if (!((
#line 218 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 220 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_753 (insn, operands);

        case 18:
          if (!(
#line 302 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 304 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_760 (insn, operands);

        case 19:
          if (!((
#line 302 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 304 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_761 (insn, operands);

        case 20:
          if (!(
#line 344 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 346 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_764 (insn, operands);

        case 21:
          if (!((
#line 344 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 346 "../../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_765 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || !logical_const_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (!boolean_or_operator (x3, E_SImode))
    return NULL;
  operands[3] = x3;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!logical_const_operand (operands[2], E_SImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != COMPARE
      || GET_MODE (x8) != E_CCmode)
    return NULL;
  x9 = XEXP (x7, 0);
  operands[4] = x9;
  if (!cc_reg_operand (operands[4], E_CCmode))
    return NULL;
  x10 = XEXP (x8, 0);
  operands[5] = x10;
  if (!gpc_reg_operand (operands[5], E_SImode))
    return NULL;
  x11 = XEXP (x8, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != IF_THEN_ELSE)
    return NULL;
  x14 = XEXP (x13, 0);
  if (!equality_operator (x14, E_VOIDmode))
    return NULL;
  operands[6] = x14;
  x15 = XEXP (x14, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x16 = XEXP (x12, 0);
  if (GET_CODE (x16) != PC)
    return NULL;
  x17 = XEXP (x13, 1);
  operands[7] = x17;
  x18 = XEXP (x13, 2);
  operands[8] = x18;
  x19 = XEXP (x14, 0);
  if (!rtx_equal_p (x19, operands[4])
      || !
#line 12677 "../../../gcc/config/rs6000/rs6000.md"
(peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[4])
   && REGNO (operands[0]) != REGNO (operands[5])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_13 (insn, operands);
}
