/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern10 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V2DFmode:
      if (pattern10 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern23 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != AND)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x4;
      return 1;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern41 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern41 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern43 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern43 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern49 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern49 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern49 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern49 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern49 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern49 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern49 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern49 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern49 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern49 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern50 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern50 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern51 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern51 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern51 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern51 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern51 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern51 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern51 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern51 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern51 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern51 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern90 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x7, 0);
  if (!scratch_operand (x9, E_DImode))
    return -1;
  x10 = XEXP (x3, 0);
  switch (GET_CODE (x10))
    {
    case EQ:
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case AND:
          if (GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x10, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XEXP (x8, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 100
              || GET_MODE (x13) != E_CCmode)
            return -1;
          x14 = XEXP (x11, 0);
          operands[1] = x14;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x15 = XEXP (x11, 1);
          operands[2] = x15;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x4, 0);
          operands[3] = x16;
          operands[0] = x9;
          return 0;

        case REG:
        case SUBREG:
          operands[1] = x11;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x4, 0);
          operands[0] = x16;
          operands[3] = x9;
          x13 = XEXP (x8, 0);
          operands[4] = x13;
          if (!scratch_operand (operands[4], E_CCUNSmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NE:
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x16 = XEXP (x4, 0);
      operands[0] = x16;
      operands[3] = x9;
      x13 = XEXP (x8, 0);
      operands[4] = x13;
      if (!scratch_operand (operands[4], E_CCUNSmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern123 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern123 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern3 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern3 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern3 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern3 (x1, 
E_V2DImode) != 0)
            return -1;
          return 5;

        case E_V1TImode:
          if (pattern2 (x1, 
E_V1TImode) != 0)
            return -1;
          return 6;

        case E_TImode:
          if (pattern2 (x1, 
E_TImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case VEC_DUPLICATE:
      res = pattern125 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 8; /* [8, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!altivec_register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V1TImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V1TImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V1TImode))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_reg_operand (operands[1], E_XOmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vsx_register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      return pattern179 (x1); /* [-1, 1] */

    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != i1)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      res = pattern180 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!non_update_memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[3], i1))
    return -1;
  return pattern188 (x1); /* [-1, 1] */
}

int
pattern193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern200 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern206 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern206 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern214 (x1, 
E_V1TImode); /* [-1, 0] */

    case E_TImode:
      if (pattern214 (x1, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  return 0;
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return pattern250 (x1); /* [-1, 1] */
}

int
pattern254 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XEXP (x4, 0);
  operands[1] = x12;
  x13 = XEXP (x6, 0);
  operands[0] = x13;
  x14 = XEXP (x9, 0);
  operands[2] = x14;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[2], E_SImode)
          || GET_MODE (x10) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[2], E_DImode)
          || GET_MODE (x10) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern270 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern277 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern275 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern275 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern276 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern276 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern276 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern276 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern276 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern276 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern276 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern276 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern276 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern276 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern291 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!gpc_reg_operand (operands[2], E_HImode)
      || !gpc_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern304 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern312 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern312 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern321 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern320 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern320 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern340 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern351 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[3] = x5;
  if (!const_0_to_1_operand (operands[3], E_QImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 106
          || GET_MODE (x7) != E_CCFPmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          return pattern350 (x3, 
E_V1TImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern350 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != COMPARE
          || GET_MODE (x8) != E_CCFPmode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 3
          || XINT (x9, 1) != i1
          || GET_MODE (x9) != E_V2DFmode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 106
          || GET_MODE (x7) != E_CCFPmode)
        return -1;
      x10 = XEXP (x8, 1);
      operands[4] = x10;
      if (!zero_constant (operands[4], E_V2DFmode))
        return -1;
      x11 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      x13 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x13, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (pattern350 (x3, 
E_V1TImode) != 0)
            return -1;
          return 2;

        case E_V16QImode:
          if (pattern350 (x3, 
E_V16QImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern389 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern398 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern394 (x5, 
i1); /* [-1, 0] */
}

int
pattern406 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern404 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern404 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern405 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern405 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern405 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern405 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern405 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern405 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern405 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern405 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern405 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern405 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern420 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern420 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern421 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern421 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern421 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern421 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern421 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern421 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern421 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern421 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern421 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern421 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern453 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern462 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern471 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern480 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!scratch_operand (operands[4], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DFmode
          || !gpc_reg_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DImode
          || !gpc_reg_operand (operands[1], E_V2DImode))
        return -1;
      return 1;

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_QImode
          || !gpc_reg_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_HImode
          || !gpc_reg_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SImode
          || !gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          return pattern511 (
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern511 (
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != AND)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[4]))
        return -1;
      x12 = XEXP (x10, 1);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern512 (x10, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern512 (x10, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern532 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern298 (x1, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern298 (x1, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_KFmode:
      if (pattern299 (x1, 
E_KFmode) != 0)
        return -1;
      return 4;

    case E_TFmode:
      if (pattern299 (x1, 
E_TFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern543 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern555 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!symbol_ref_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          return 0;

        case E_DFmode:
          if (!memory_operand (operands[2], E_DFmode)
              || !gpc_reg_operand (operands[3], E_DFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!symbol_ref_operand (operands[1], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          return 2;

        case E_DFmode:
          if (!memory_operand (operands[2], E_DFmode)
              || !gpc_reg_operand (operands[3], E_DFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern577 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern582 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern589 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern597 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !const_int_operand (operands[4], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern607 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x5, 0);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  x15 = XEXP (x6, 0);
  operands[2] = x15;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x16 = XEXP (x10, 0);
  x17 = XEXP (x16, 0);
  if (!rtx_equal_p (x17, operands[1]))
    return -1;
  x18 = XEXP (x11, 0);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (scc_rev_comparison_operator (operands[1], E_VOIDmode))
    {
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_CODE (x3) != NE)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!zero_constant (operands[2], E_V2DImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern502 (x2, 
E_SFmode) != 0
              || !
#line 5742 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
            return -1;
          return 391; /* *xxselsf */

        case E_DFmode:
          if (pattern502 (x2, 
E_DFmode) != 0
              || !
#line 5742 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
            return -1;
          return 392; /* *xxseldf */

        case E_KFmode:
          if (pattern503 (x2, 
E_KFmode) != 0
              || !(
#line 5848 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 399; /* *xxselkf */

        case E_TFmode:
          if (pattern503 (x2, 
E_TFmode) != 0
              || !(
#line 5848 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 400; /* *xxseltf */

        default:
          return -1;
        }

    case LABEL_REF:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC
          || !gpc_reg_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!
#line 7954 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
        return -1;
      *pnum_clobbers = 2;
      return 573; /* *rotate_on_cmpdi */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern370 (
E_SImode) != 0)
            return -1;
          return 224; /* *boolsi3_imm */

        case E_DImode:
          if (pattern370 (
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 225; /* *booldi3_imm */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern358 (
E_TImode) != 0)
            return -1;
          return 516; /* *boolti3_internal */

        case E_PTImode:
          if (pattern358 (
E_PTImode) != 0)
            return -1;
          return 517; /* *boolpti3_internal */

        case E_V16QImode:
          if (pattern358 (
E_V16QImode) != 0
              || !
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 518; /* *boolv16qi3_internal */

        case E_V8HImode:
          if (pattern358 (
E_V8HImode) != 0
              || !
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 519; /* *boolv8hi3_internal */

        case E_V4SImode:
          if (pattern358 (
E_V4SImode) != 0
              || !
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 520; /* *boolv4si3_internal */

        case E_V4SFmode:
          if (pattern358 (
E_V4SFmode) != 0
              || !
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 521; /* *boolv4sf3_internal */

        case E_V2DImode:
          if (pattern358 (
E_V2DImode) != 0
              || !
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 522; /* *boolv2di3_internal */

        case E_V2DFmode:
          if (pattern358 (
E_V2DFmode) != 0
              || !
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 523; /* *boolv2df3_internal */

        case E_V1TImode:
          if (pattern358 (
E_V1TImode) != 0
              || !
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 524; /* *boolv1ti3_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern281 (x3))
        {
        case 0:
          if (!
#line 835 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2583; /* *fuse_and_nand */

        case 1:
          if (!(
#line 835 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2584; /* *fuse_and_nand */

        case 2:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2939; /* *fuse_vand_vnand */

        case 3:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2940; /* *fuse_vand_vnand */

        case 4:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2941; /* *fuse_vand_vnand */

        case 5:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2942; /* *fuse_vand_vnand */

        case 6:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2943; /* *fuse_vand_vnand */

        case 7:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2944; /* *fuse_vand_vnand */

        case 8:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2945; /* *fuse_vand_vnand */

        case 9:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2946; /* *fuse_vand_vnand */

        case 10:
          if (!(
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2947; /* *fuse_vand_vnand */

        case 11:
          if (!(
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2948; /* *fuse_vand_vnand */

        case 12:
          if (!
#line 853 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2585; /* *fuse_andc_nand */

        case 13:
          if (!(
#line 853 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2586; /* *fuse_andc_nand */

        case 14:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2949; /* *fuse_vandc_vnand */

        case 15:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2950; /* *fuse_vandc_vnand */

        case 16:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2951; /* *fuse_vandc_vnand */

        case 17:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2952; /* *fuse_vandc_vnand */

        case 18:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2953; /* *fuse_vandc_vnand */

        case 19:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2954; /* *fuse_vandc_vnand */

        case 20:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2955; /* *fuse_vandc_vnand */

        case 21:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2956; /* *fuse_vandc_vnand */

        case 22:
          if (!(
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2957; /* *fuse_vandc_vnand */

        case 23:
          if (!(
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2958; /* *fuse_vandc_vnand */

        case 24:
          if (!
#line 907 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2591; /* *fuse_nor_nand */

        case 25:
          if (!(
#line 907 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2592; /* *fuse_nor_nand */

        case 26:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2979; /* *fuse_vnor_vnand */

        case 27:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2980; /* *fuse_vnor_vnand */

        case 28:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2981; /* *fuse_vnor_vnand */

        case 29:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2982; /* *fuse_vnor_vnand */

        case 30:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2983; /* *fuse_vnor_vnand */

        case 31:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2984; /* *fuse_vnor_vnand */

        case 32:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2985; /* *fuse_vnor_vnand */

        case 33:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2986; /* *fuse_vnor_vnand */

        case 34:
          if (!(
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2987; /* *fuse_vnor_vnand */

        case 35:
          if (!(
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2988; /* *fuse_vnor_vnand */

        default:
          return -1;
        }

    case NOT:
      switch (pattern284 (x3))
        {
        case 0:
          if (!
#line 871 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2587; /* *fuse_eqv_nand */

        case 1:
          if (!(
#line 871 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2588; /* *fuse_eqv_nand */

        case 2:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2959; /* *fuse_veqv_vnand */

        case 3:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2960; /* *fuse_veqv_vnand */

        case 4:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2961; /* *fuse_veqv_vnand */

        case 5:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2962; /* *fuse_veqv_vnand */

        case 6:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2963; /* *fuse_veqv_vnand */

        case 7:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2964; /* *fuse_veqv_vnand */

        case 8:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2965; /* *fuse_veqv_vnand */

        case 9:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2966; /* *fuse_veqv_vnand */

        case 10:
          if (!(
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2967; /* *fuse_veqv_vnand */

        case 11:
          if (!(
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2968; /* *fuse_veqv_vnand */

        default:
          return -1;
        }

    case IOR:
      switch (pattern285 (x3))
        {
        case 0:
          if (!
#line 889 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2589; /* *fuse_nand_nand */

        case 1:
          if (!(
#line 889 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2590; /* *fuse_nand_nand */

        case 2:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2969; /* *fuse_vnand_vnand */

        case 3:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2970; /* *fuse_vnand_vnand */

        case 4:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2971; /* *fuse_vnand_vnand */

        case 5:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2972; /* *fuse_vnand_vnand */

        case 6:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2973; /* *fuse_vnand_vnand */

        case 7:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2974; /* *fuse_vnand_vnand */

        case 8:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2975; /* *fuse_vnand_vnand */

        case 9:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2976; /* *fuse_vnand_vnand */

        case 10:
          if (!(
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2977; /* *fuse_vnand_vnand */

        case 11:
          if (!(
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2978; /* *fuse_vnand_vnand */

        case 12:
          if (!
#line 943 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2595; /* *fuse_orc_nand */

        case 13:
          if (!(
#line 943 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2596; /* *fuse_orc_nand */

        case 14:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2999; /* *fuse_vorc_vnand */

        case 15:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3000; /* *fuse_vorc_vnand */

        case 16:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3001; /* *fuse_vorc_vnand */

        case 17:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3002; /* *fuse_vorc_vnand */

        case 18:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3003; /* *fuse_vorc_vnand */

        case 19:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3004; /* *fuse_vorc_vnand */

        case 20:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3005; /* *fuse_vorc_vnand */

        case 21:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3006; /* *fuse_vorc_vnand */

        case 22:
          if (!(
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3007; /* *fuse_vorc_vnand */

        case 23:
          if (!(
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3008; /* *fuse_vorc_vnand */

        case 24:
          if (!
#line 925 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2593; /* *fuse_or_nand */

        case 25:
          if (!(
#line 925 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2594; /* *fuse_or_nand */

        case 26:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2989; /* *fuse_vor_vnand */

        case 27:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2990; /* *fuse_vor_vnand */

        case 28:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2991; /* *fuse_vor_vnand */

        case 29:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2992; /* *fuse_vor_vnand */

        case 30:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2993; /* *fuse_vor_vnand */

        case 31:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2994; /* *fuse_vor_vnand */

        case 32:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2995; /* *fuse_vor_vnand */

        case 33:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2996; /* *fuse_vor_vnand */

        case 34:
          if (!(
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2997; /* *fuse_vor_vnand */

        case 35:
          if (!(
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2998; /* *fuse_vor_vnand */

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern272 (x3, 
E_SImode) != 0
                  || !
#line 961 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2597; /* *fuse_xor_nand */

            case E_DImode:
              if (pattern272 (x3, 
E_DImode) != 0
                  || !(
#line 961 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2598; /* *fuse_xor_nand */

            case E_V4SImode:
              if (pattern273 (x3, 
E_V4SImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3009; /* *fuse_vxor_vnand */

            case E_V8HImode:
              if (pattern273 (x3, 
E_V8HImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3010; /* *fuse_vxor_vnand */

            case E_V16QImode:
              if (pattern273 (x3, 
E_V16QImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3011; /* *fuse_vxor_vnand */

            case E_V4SFmode:
              if (pattern273 (x3, 
E_V4SFmode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3012; /* *fuse_vxor_vnand */

            case E_V2DFmode:
              if (pattern273 (x3, 
E_V2DFmode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3013; /* *fuse_vxor_vnand */

            case E_V2DImode:
              if (pattern273 (x3, 
E_V2DImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3014; /* *fuse_vxor_vnand */

            case E_V1TImode:
              if (pattern273 (x3, 
E_V1TImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3015; /* *fuse_vxor_vnand */

            case E_TImode:
              if (pattern273 (x3, 
E_TImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3016; /* *fuse_vxor_vnand */

            case E_KFmode:
              if (pattern273 (x3, 
E_KFmode) != 0
                  || !(
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3017; /* *fuse_vxor_vnand */

            case E_TFmode:
              if (pattern273 (x3, 
E_TFmode) != 0
                  || !(
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3018; /* *fuse_vxor_vnand */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern429 (x3))
            {
            case 0:
              if (!
#line 1231 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2627; /* *fuse_eqv_or */

            case 1:
              if (!(
#line 1231 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2628; /* *fuse_eqv_or */

            case 2:
              if (!
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3119; /* *fuse_veqv_vor */

            case 3:
              if (!
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3120; /* *fuse_veqv_vor */

            case 4:
              if (!
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3121; /* *fuse_veqv_vor */

            case 5:
              if (!
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3122; /* *fuse_veqv_vor */

            case 6:
              if (!
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3123; /* *fuse_veqv_vor */

            case 7:
              if (!
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3124; /* *fuse_veqv_vor */

            case 8:
              if (!
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3125; /* *fuse_veqv_vor */

            case 9:
              if (!
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3126; /* *fuse_veqv_vor */

            case 10:
              if (!(
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3127; /* *fuse_veqv_vor */

            case 11:
              if (!(
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3128; /* *fuse_veqv_vor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 979 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2599; /* *fuse_add_nand */

        case 1:
          if (!(
#line 979 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2600; /* *fuse_add_nand */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 997 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2601; /* *fuse_subf_nand */

        case 1:
          if (!(
#line 997 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2602; /* *fuse_subf_nand */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!u7bit_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 5497 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1693; /* xvtstdcsp */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 5497 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1694; /* xvtstdcdp */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      switch (pattern460 (
E_DImode))
        {
        case 0:
          if (!
#line 5261 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1676; /* xsiexpdp_si */

        case 1:
          if (!(
#line 5261 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1677; /* xsiexpdp_di */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern460 (
E_DFmode))
        {
        case 0:
          if (!
#line 5271 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1678; /* xsiexpdpf_si */

        case 1:
          if (!(
#line 5271 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1679; /* xsiexpdpf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6820 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 479; /* btruncsf2 */

    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DFmode)
          && gpc_reg_operand (operands[1], E_DFmode)
          && 
#line 6820 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return 480; /* btruncdf2 */
      if (!vsx_register_operand (operands[0], E_DFmode)
          || !vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2331 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1412; /* *vsx_b2truncdf2 */

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15467 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1179; /* btrunckf2 */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15467 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1180; /* btrunctf2 */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2331 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1413; /* *vsx_b2truncv4sf2 */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2331 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1414; /* *vsx_b2truncv2df2 */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (gpc_reg_operand (operands[1], E_KFmode)
          && (
#line 5356 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 331; /* signbitkf2_dm */
      if (!memory_operand (operands[1], E_KFmode)
          || !(
#line 5375 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 333; /* signbitkf2_dm_mem */

    case E_TFmode:
      if (gpc_reg_operand (operands[1], E_TFmode)
          && (
#line 5356 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 332; /* signbittf2_dm */
      if (!memory_operand (operands[1], E_TFmode)
          || !(
#line 5375 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 334; /* signbittf2_dm_mem */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6859 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_VSX))
        return -1;
      return 487; /* *xsrdpisf2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6859 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_VSX))
        return -1;
      return 488; /* *xsrdpidf2 */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2455 "../../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1428; /* vsx_xscvdpspn */

    case E_SFmode:
      if (!vsx_register_operand (operands[1], E_SFmode)
          || !
#line 2471 "../../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1430; /* vsx_xscvdpspn_scalar */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!u5bit_cint_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern132 (x3, 
E_V16QImode) != 0
          || !
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode)))
        return -1;
      return 1625; /* vsx_xxsldwi_v16qi */

    case E_V8HImode:
      if (pattern132 (x3, 
E_V8HImode) != 0
          || !
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode)))
        return -1;
      return 1626; /* vsx_xxsldwi_v8hi */

    case E_V4SImode:
      if (pattern132 (x3, 
E_V4SImode) != 0
          || !
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
        return -1;
      return 1627; /* vsx_xxsldwi_v4si */

    case E_V2DImode:
      if (pattern132 (x3, 
E_V2DImode) != 0
          || !
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1628; /* vsx_xxsldwi_v2di */

    case E_V4SFmode:
      if (pattern132 (x3, 
E_V4SFmode) != 0
          || !
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
        return -1;
      return 1629; /* vsx_xxsldwi_v4sf */

    case E_V2DFmode:
      if (pattern132 (x3, 
E_V2DFmode) != 0
          || !
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
        return -1;
      return 1630; /* vsx_xxsldwi_v2df */

    case E_V1TImode:
      if (pattern132 (x3, 
E_V1TImode) != 0
          || !
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V1TImode)))
        return -1;
      return 1631; /* vsx_xxsldwi_v1ti */

    case E_TImode:
      if (pattern132 (x3, 
E_TImode) != 0
          || !
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (TImode)))
        return -1;
      return 1632; /* vsx_xxsldwi_ti */

    case E_KFmode:
      if (pattern132 (x3, 
E_KFmode) != 0
          || !(
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (KFmode)) && 
#line 58 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 1633; /* vsx_xxsldwi_kf */

    case E_TFmode:
      if (pattern132 (x3, 
E_TFmode) != 0
          || !(
#line 4907 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (TFmode)) && 
#line 59 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 1634; /* vsx_xxsldwi_tf */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (pattern30 (x2))
    {
    case 0:
      switch (GET_MODE (x2))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2244; /* altivec_stvx_v16qi_2op_si */

            case 1:
              if (!(
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2245; /* altivec_stvx_v16qi_2op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2248; /* altivec_stvx_v2df_2op_si */

            case 1:
              if (!(
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2249; /* altivec_stvx_v2df_2op_di */

            default:
              return -1;
            }

        case E_KFmode:
          if (!register_operand (operands[0], E_KFmode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2254; /* altivec_stvx_kf_2op_si */

            case 1:
              if (!(
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2255; /* altivec_stvx_kf_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (x2))
        {
        case E_V16QImode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V16QImode))
            {
            case 0:
              if (!(
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2262; /* altivec_stvx_v16qi_1op_si */

            case 1:
              if (!(
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2263; /* altivec_stvx_v16qi_1op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2266; /* altivec_stvx_v2df_1op_si */

            case 1:
              if (!(
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2267; /* altivec_stvx_v2df_1op_di */

            default:
              return -1;
            }

        case E_KFmode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_KFmode))
            {
            case 0:
              if (!(
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2272; /* altivec_stvx_kf_1op_si */

            case 1:
              if (!(
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2273; /* altivec_stvx_kf_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      res = recog_115 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case HIGH:
      res = recog_116 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && input_operand (operands[1], E_SImode)
          && 
#line 7743 "../../../gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], SImode)
   || gpc_reg_operand (operands[1], SImode)))
        return 568; /* *movsi_internal1 */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && input_operand (operands[1], E_QImode)
          && 
#line 8116 "../../../gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], QImode)
   || gpc_reg_operand (operands[1], QImode)))
        return 576; /* *movqi_internal */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && input_operand (operands[1], E_HImode)
          && 
#line 8116 "../../../gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], HImode)
   || gpc_reg_operand (operands[1], HImode)))
        return 577; /* *movhi_internal */
      break;

    case E_CCmode:
      if (nonimmediate_operand (operands[0], E_CCmode)
          && general_operand (operands[1], E_CCmode)
          && 
#line 8165 "../../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCmode)
   || register_operand (operands[1], CCmode)))
        return 578; /* *movcc_cc */
      break;

    case E_CCUNSmode:
      if (nonimmediate_operand (operands[0], E_CCUNSmode)
          && general_operand (operands[1], E_CCUNSmode)
          && 
#line 8165 "../../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCUNSmode)
   || register_operand (operands[1], CCUNSmode)))
        return 579; /* *movcc_ccuns */
      break;

    case E_CCEQmode:
      if (nonimmediate_operand (operands[0], E_CCEQmode)
          && general_operand (operands[1], E_CCEQmode)
          && 
#line 8165 "../../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCEQmode)
   || register_operand (operands[1], CCEQmode)))
        return 580; /* *movcc_cceq */
      break;

    case E_CCFPmode:
      if (nonimmediate_operand (operands[0], E_CCFPmode)
          && general_operand (operands[1], E_CCFPmode)
          && 
#line 8165 "../../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCFPmode)
   || register_operand (operands[1], CCFPmode)))
        return 581; /* *movcc_ccfp */
      break;

    case E_V4SFmode:
      if (pnum_clobbers != NULL
          && memory_operand (operands[0], E_V4SFmode)
          && immediate_operand (operands[1], E_V4SFmode)
          && 
#line 3458 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])))
        {
          *pnum_clobbers = 1;
          return 1487; /* vsx_stxvd2x4_le_const_v4sf */
        }
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode)
          && 
#line 245 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
        return 1792; /* *altivec_movv4sf */
      break;

    default:
      break;
    }
  operands[0] = x2;
  switch (pattern32 (x3, 
E_V4SFmode))
    {
    case 0:
      if ((
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2246; /* altivec_stvx_v4sf_2op_si */
      break;

    case 1:
      if ((
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2247; /* altivec_stvx_v4sf_2op_di */
      break;

    case 2:
      if ((
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2264; /* altivec_stvx_v4sf_1op_si */
      break;

    case 3:
      if ((
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2265; /* altivec_stvx_v4sf_1op_di */
      break;

    default:
      break;
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case HIGH:
      if (GET_MODE (x2) != E_SImode
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) == UNSPEC
          && GET_MODE (x4) == E_SImode)
        {
          switch (XVECLEN (x4, 0))
            {
            case 2:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              x6 = XVECEXP (x4, 0, 1);
              operands[2] = x6;
              switch (XINT (x4, 1))
                {
                case 14:
                  if (rs6000_tls_symbol_ref (operands[1], E_SImode)
                      && gpc_reg_operand (operands[2], E_SImode)
                      && (
#line 10598 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 750; /* *tls_gd_high32 */
                  break;

                case 23:
                  if (gpc_reg_operand (operands[1], E_SImode)
                      && rs6000_tls_symbol_ref (operands[2], E_SImode)
                      && (
#line 10711 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 770; /* *tls_got_dtprel_high32 */
                  break;

                case 27:
                  if (gpc_reg_operand (operands[1], E_SImode)
                      && rs6000_tls_symbol_ref (operands[2], E_SImode)
                      && (
#line 10791 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 784; /* *tls_got_tprel_high32 */
                  break;

                default:
                  break;
                }
              break;

            case 1:
              if (XINT (x4, 1) == 15)
                {
                  x5 = XVECEXP (x4, 0, 0);
                  operands[1] = x5;
                  if (gpc_reg_operand (operands[1], E_SImode)
                      && (
#line 10644 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 758; /* *tls_ld_high32 */
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x4;
      if (!
#line 11351 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && !TARGET_64BIT && !flag_pic))
        return -1;
      return 807; /* elf_high */

    case MEM:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != MINUS
              || GET_MODE (x8) != E_SImode
              || !gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x8, 1);
          operands[3] = x11;
          if (!immediate_operand (operands[3], E_SImode)
              || !
#line 11219 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2))
            return -1;
          return 799; /* load_toc_v4_PIC_2 */

        case AND:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -16]
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          switch (pattern34 (x4))
            {
            case 0:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2201; /* altivec_lvx_v4sf_2op_si */

            case 1:
              if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2202; /* altivec_lvx_v4sf_2op_di */

            case 2:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2219; /* altivec_lvx_v4sf_1op_si */

            case 3:
              if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2220; /* altivec_lvx_v4sf_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      res = recog_31 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSPEC:
      res = recog_108 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (pattern69 ())
    {
    case 0:
      if ((
#line 11337 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 805; /* *tocrefsi */
      break;

    case 1:
      if ((
#line 11337 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 806; /* *tocrefdi */
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 3:
          switch (XINT (x2, 1))
            {
            case 88:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x5 = XVECEXP (x2, 0, 1);
              operands[2] = x5;
              x6 = XVECEXP (x2, 0, 2);
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (GET_MODE (x2) != E_SImode
                      || !gpc_reg_operand (operands[1], E_SImode)
                      || !symbol_ref_operand (operands[2], E_SImode))
                    return -1;
                  if (memory_operand (operands[0], E_SImode)
                      && (
#line 11367 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ
   && DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 809; /* *pltseq_tocsave_si */
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 11402 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 815; /* *pltseq_mtctr_si */

                case E_DImode:
                  if (GET_MODE (x2) != E_DImode
                      || !gpc_reg_operand (operands[1], E_DImode)
                      || !symbol_ref_operand (operands[2], E_DImode))
                    return -1;
                  if (memory_operand (operands[0], E_DImode)
                      && (
#line 11367 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ
   && DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 810; /* *pltseq_tocsave_di */
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 11402 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 816; /* *pltseq_mtctr_di */

                default:
                  return -1;
                }

            case 89:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x5 = XVECEXP (x2, 0, 1);
              operands[2] = x5;
              x6 = XVECEXP (x2, 0, 2);
              operands[3] = x6;
              switch (pattern337 (x2))
                {
                case 0:
                  if (!(
#line 11379 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 811; /* *pltseq_plt16_ha_si */

                case 1:
                  if (!(
#line 11379 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 812; /* *pltseq_plt16_ha_di */

                default:
                  return -1;
                }

            case 17:
              if (pattern222 (x2, 
E_CCmode, 
102) != 0)
                return -1;
              x5 = XVECEXP (x2, 0, 1);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 103
                  || GET_MODE (x5) != E_CCmode)
                return -1;
              x6 = XVECEXP (x2, 0, 2);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 104
                  || GET_MODE (x6) != E_CCmode
                  || !gpc_reg_operand (operands[0], E_SImode))
                return -1;
              return 1002; /* prologue_movesi_from_cr */

            case 445:
              if (pnum_clobbers == NULL)
                return -1;
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x5 = XVECEXP (x2, 0, 1);
              operands[2] = x5;
              if (!int_reg_operand (operands[2], E_DImode))
                return -1;
              x6 = XVECEXP (x2, 0, 2);
              operands[3] = x6;
              if (!const_int_operand (operands[3], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!int_reg_operand (operands[0], E_SImode)
                      || GET_MODE (x2) != E_SImode
                      || !d_form_memory (operands[1], E_SImode)
                      || !
#line 152 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3346; /* *pcrel_opt_ldsi_gpr */

                case E_DImode:
                  if (!int_reg_operand (operands[0], E_DImode)
                      || GET_MODE (x2) != E_DImode
                      || !d_form_memory (operands[1], E_DImode)
                      || !
#line 152 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3347; /* *pcrel_opt_lddi_gpr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          return recog_109 (x1, insn, pnum_clobbers);

        case 2:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (XINT (x2, 1))
            {
            case 49:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern381 (x2, 
E_SImode) != 0
                      || !(
#line 14443 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1051; /* bpermd_si */

                case E_DImode:
                  if (pattern381 (x2, 
E_DImode) != 0
                      || !(
#line 14443 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1052; /* bpermd_di */

                default:
                  return -1;
                }

            case 65:
              if (GET_MODE (x2) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 14821 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                return -1;
              return 1072; /* addg6s */

            case 68:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern141 (x2, 
E_SImode) != 0
                      || !
#line 14852 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                    return -1;
                  return 1075; /* dive_si */

                case E_DImode:
                  if (pattern141 (x2, 
E_DImode) != 0
                      || !(
#line 14852 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 1077; /* dive_di */

                default:
                  return -1;
                }

            case 69:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern141 (x2, 
E_SImode) != 0
                      || !
#line 14852 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                    return -1;
                  return 1076; /* diveu_si */

                case E_DImode:
                  if (pattern141 (x2, 
E_DImode) != 0
                      || !(
#line 14852 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 1078; /* diveu_di */

                default:
                  return -1;
                }

            case 70:
              if (GET_MODE (x2) != E_DImode
                  || !const_0_to_1_operand (operands[2], E_QImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && register_operand (operands[1], E_TDmode))
                {
                  if ((
#line 14881 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                    return 1081; /* unpacktd_dm */
                  if ((
#line 14904 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                    return 1084; /* unpacktd_nodm */
                }
              if (!register_operand (operands[0], E_DImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1TImode:
                  if (!register_operand (operands[1], E_V1TImode)
                      || !
#line 14991 "../../../gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return -1;
                  return 1089; /* unpackv1ti */

                case E_KFmode:
                  if (!register_operand (operands[1], E_KFmode)
                      || !
#line 14991 "../../../gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)))
                    return -1;
                  return 1090; /* unpackkf */

                default:
                  return -1;
                }

            case 144:
              if (GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || !gpc_reg_operand (operands[1], E_V2DImode)
                  || !gpc_reg_operand (operands[2], E_V2DImode)
                  || !
#line 3646 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1502; /* vsx_vslo_v2di */

            case 145:
              if (pnum_clobbers == NULL
                  || !gpc_reg_operand (operands[2], E_DImode))
                return -1;
              switch (pattern216 (x2))
                {
                case 0:
                  if (gpc_reg_operand (operands[1], E_V2DImode)
                      && 
#line 3658 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                    {
                      *pnum_clobbers = 2;
                      return 1504; /* vsx_extract_v2di_var */
                    }
                  if (!memory_operand (operands[1], E_V2DImode)
                      || !
#line 3675 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1506; /* *vsx_extract_v2di_var_load */

                case 1:
                  if (gpc_reg_operand (operands[1], E_V4SImode)
                      && 
#line 4185 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                    {
                      *pnum_clobbers = 2;
                      return 1533; /* vsx_extract_v4si_var */
                    }
                  if (!memory_operand (operands[1], E_V4SImode)
                      || !
#line 4204 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1536; /* *vsx_extract_v4si_var_load */

                default:
                  return -1;
                }

            case 170:
              if (pattern341 (x2, 
E_V16QImode) != 0
                  || !
#line 5974 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1724; /* vextublx */

            case 173:
              if (pattern341 (x2, 
E_V16QImode) != 0
                  || !
#line 5985 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1725; /* vextubrx */

            case 171:
              if (pattern341 (x2, 
E_V8HImode) != 0
                  || !
#line 5996 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1726; /* vextuhlx */

            case 174:
              if (pattern341 (x2, 
E_V8HImode) != 0
                  || !
#line 6007 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1727; /* vextuhrx */

            case 172:
              if (pattern341 (x2, 
E_V4SImode) != 0
                  || !
#line 6018 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1728; /* vextuwlx */

            case 175:
              if (pattern341 (x2, 
E_V4SImode) != 0
                  || !
#line 6029 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1729; /* vextuwrx */

            case 191:
              if (GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || !const_0_to_1_operand (operands[2], E_QImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16QImode:
                  if (!altivec_register_operand (operands[1], E_V16QImode)
                      || !
#line 6472 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1744; /* vec_cntmb_v16qi */

                case E_V8HImode:
                  if (!altivec_register_operand (operands[1], E_V8HImode)
                      || !
#line 6472 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1745; /* vec_cntmb_v8hi */

                case E_V4SImode:
                  if (!altivec_register_operand (operands[1], E_V4SImode)
                      || !
#line 6472 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1746; /* vec_cntmb_v4si */

                case E_V2DImode:
                  if (!altivec_register_operand (operands[1], E_V2DImode)
                      || !
#line 6472 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1747; /* vec_cntmb_v2di */

                default:
                  return -1;
                }

            case 351:
              if (GET_MODE (x2) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !altivec_register_operand (operands[1], E_V2DImode)
                  || !u3bit_cint_operand (operands[2], E_QImode)
                  || !
#line 4681 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2350; /* vgnb */

            case 444:
              if (GET_MODE (x2) != E_DImode
                  || !base_reg_operand (operands[0], E_DImode)
                  || !pcrel_external_address (operands[1], E_DImode)
                  || !const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 125 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3343; /* pcrel_opt_ld_addr_same_reg */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case EQ:
          switch (pattern175 (x1))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 936; /* *plus_eq_si */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 937; /* *plus_eq_di */

            default:
              return -1;
            }

        case NE:
          switch (pattern175 (x1))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 938; /* *plus_ne_si */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 939; /* *plus_ne_di */

            default:
              return -1;
            }

        case AND:
          switch (pattern45 (x1))
            {
            case 0:
              if (!
#line 1663 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2675; /* *fuse_and_add */

            case 1:
              if (!(
#line 1663 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2676; /* *fuse_and_add */

            case 2:
              if (!
#line 1699 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2679; /* *fuse_nor_add */

            case 3:
              if (!(
#line 1699 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2680; /* *fuse_nor_add */

            default:
              return -1;
            }

        case IOR:
          switch (pattern46 (x1))
            {
            case 0:
              if (!
#line 1681 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2677; /* *fuse_nand_add */

            case 1:
              if (!(
#line 1681 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2678; /* *fuse_nand_add */

            case 2:
              if (!
#line 1717 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2681; /* *fuse_or_add */

            case 3:
              if (!(
#line 1717 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2682; /* *fuse_or_add */

            default:
              return -1;
            }

        case PLUS:
          switch (pattern122 (x1))
            {
            case 0:
              if (!
#line 3031 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3339; /* *fuse_add_add */

            case 1:
              if (!(
#line 3031 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 3340; /* *fuse_add_add */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 16L:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 0);
          if (!gpc_reg_operand (x6, E_SImode))
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              operands[2] = x6;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1571 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 56; /* *mulchw */

            case ASHIFTRT:
              x9 = XEXP (x7, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              operands[1] = x6;
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1632 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 60; /* *mulhhw */

            default:
              return -1;
            }

        case 32L:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != ASHIFTRT)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          switch (pattern294 (x3))
            {
            case 0:
              if (!
#line 6556 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1770; /* smulv2di3_highpart */

            case 1:
              if (!
#line 6556 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1771; /* smulv4si3_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (!gpc_reg_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      switch (GET_CODE (x7))
        {
        case ZERO_EXTEND:
          operands[2] = x6;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_HImode)
              || !
#line 1600 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 58; /* *mulchwu */

        case LSHIFTRT:
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          operands[1] = x6;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 1664 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 62; /* *mulhhwu */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern47 (x3, 
SIGN_EXTEND) != 0
          || !
#line 1690 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 64; /* *mullhw */

    case ZERO_EXTEND:
      if (pattern47 (x3, 
ZERO_EXTEND) != 0
          || !
#line 1716 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 66; /* *mullhwu */

    case REG:
    case SUBREG:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern266 (x3, 
E_SImode) != 0)
            return -1;
          return 165; /* mulsi3 */

        case E_DImode:
          if (pattern266 (x3, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 166; /* muldi3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5097 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 316; /* *mulsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5097 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 317; /* *muldf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15040 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1097; /* mulkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15040 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1098; /* multf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1718 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1338; /* *vsx_mulv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1718 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1339; /* *vsx_mulv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6577 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1774; /* mulv2di3 */

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0
              || !
#line 803 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1909; /* mulv4si3_p8 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 193 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2440; /* muldd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 193 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2441; /* multd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 5018 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 306; /* *abssf2_fpr */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 5018 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 307; /* *absdf2_fpr */

    case E_KFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_KFmode)
          && GET_MODE (x3) == E_KFmode
          && register_operand (operands[1], E_KFmode)
          && (
#line 9327 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        {
          *pnum_clobbers = 1;
          return 629; /* ieee_128bit_vsx_abskf2 */
        }
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15132 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1109; /* abskf2_hw */

    case E_TFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_TFmode)
          && GET_MODE (x3) == E_TFmode
          && register_operand (operands[1], E_TFmode)
          && (
#line 9327 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        {
          *pnum_clobbers = 1;
          return 630; /* ieee_128bit_vsx_abstf2 */
        }
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15132 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1110; /* abstf2_hw */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 1991 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1358; /* *vsx_absv4sf2 */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 1991 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1359; /* *vsx_absv2df2 */

    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_DDmode)
          || !
#line 94 "../../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2428; /* absdd2 */

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 118 "../../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2431; /* abstd2 */

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern19 (x3, 
E_SImode) != 0)
            return -1;
          return 190; /* *divsi3 */

        case E_DImode:
          if (pattern19 (x3, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 191; /* *divdi3 */

        case E_TImode:
          if (pattern1 (x3, 
E_TImode) != 0
              || !
#line 3441 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
            return -1;
          return 198; /* divti3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5123 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 318; /* *divsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5123 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 319; /* *divdf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15050 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1099; /* divkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15050 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1100; /* divtf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1773 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1341; /* *vsx_divv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1773 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1342; /* *vsx_divv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6516 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1762; /* divv2di3 */

        case E_V4SImode:
          if (pattern2 (x3, 
E_V4SImode) != 0
              || !
#line 6516 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1763; /* divv4si3 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 201 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2442; /* divdd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 201 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2443; /* divtd3 */

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern328 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 192; /* divsi3_sra */

        case E_DImode:
          if (pattern328 (x3, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 193; /* divdi3_sra */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) == SET)
    {
      res = recog_158 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      if (XWINT (x6, 0) != -1L
          || GET_CODE (x4) != SET)
        return -1;
      switch (pattern353 (x1, 
NE))
        {
        case 0:
          if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 84; /* *addsi3_imm_carry_m1 */

        case 1:
          if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 85; /* *adddi3_imm_carry_m1 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x6) != 98
          || GET_CODE (x4) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern516 (x1, 
E_SImode) != 0)
            return -1;
          return 92; /* addsi3_carry_in_0 */

        case E_DImode:
          if (pattern516 (x1, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 93; /* adddi3_carry_in_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!cc_reg_operand (operands[1], E_CCmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !(
#line 13540 "../../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 981; /* indirect_jumpsi_nospec */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 13540 "../../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 982; /* indirect_jumpdi_nospec */

            default:
              return -1;
            }

        case USE:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !(
#line 13647 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 983; /* tablejumpsi_insn_normal */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 13647 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 984; /* tablejumpdi_insn_normal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) == SET)
        {
          res = recog_165 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x3;
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1)
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (XINT (x5, 1))
        {
        case 279:
          switch (pattern500 ())
            {
            case 0:
              if (!
#line 3182 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2231; /* altivec_stvx_v4si_internal */

            case 1:
              if (!
#line 3182 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2232; /* altivec_stvx_v8hi_internal */

            case 2:
              if (!
#line 3182 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2233; /* altivec_stvx_v16qi_internal */

            case 3:
              if (!
#line 3182 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2234; /* altivec_stvx_v4sf_internal */

            case 4:
              if (!
#line 3182 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2235; /* altivec_stvx_v2df_internal */

            case 5:
              if (!
#line 3182 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2236; /* altivec_stvx_v2di_internal */

            case 6:
              if (!
#line 3182 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2237; /* altivec_stvx_v1ti_internal */

            case 7:
              if (!(
#line 3182 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2238; /* altivec_stvx_kf_internal */

            case 8:
              if (!(
#line 3182 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2239; /* altivec_stvx_tf_internal */

            default:
              return -1;
            }

        case 280:
          switch (pattern500 ())
            {
            case 0:
              if (!
#line 3235 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2276; /* altivec_stvxl_v4si */

            case 1:
              if (!
#line 3235 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2277; /* altivec_stvxl_v8hi */

            case 2:
              if (!
#line 3235 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2278; /* altivec_stvxl_v16qi */

            case 3:
              if (!
#line 3235 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2279; /* altivec_stvxl_v4sf */

            case 4:
              if (!
#line 3235 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2280; /* altivec_stvxl_v2df */

            case 5:
              if (!
#line 3235 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2281; /* altivec_stvxl_v2di */

            case 6:
              if (!
#line 3235 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2282; /* altivec_stvxl_v1ti */

            case 7:
              if (!(
#line 3235 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2283; /* altivec_stvxl_kf */

            case 8:
              if (!(
#line 3235 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2284; /* altivec_stvxl_tf */

            default:
              return -1;
            }

        case 305:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4280 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2297; /* altivec_stvlx */

        case 306:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4289 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2298; /* altivec_stvlxl */

        case 307:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4298 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2299; /* altivec_stvrx */

        case 308:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4307 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2300; /* altivec_stvrxl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_157 (x1, insn, pnum_clobbers);

    case 1:
      return recog_156 (x1, insn, pnum_clobbers);

    case 3:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (XINT (x3, 1))
        {
        case 123:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || !gpc_reg_operand (operands[0], E_V4SFmode))
            return -1;
          switch (pattern470 (x1))
            {
            case 0:
              if (!
#line 4616 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1606; /* vsx_set_v4sf_p9 */

            case 1:
              if (!
#line 4652 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1607; /* *vsx_set_v4sf_p9_zero */

            case 2:
              if (!
#line 4712 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
                return -1;
              return 1609; /* *vsx_insert_extract_v4sf_p9_2 */

            default:
              return -1;
            }

        case 214:
          if (pattern349 (x1, 
E_V4SImode) != 0
              || !
#line 1052 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1935; /* altivec_vmsumuhs */

        case 215:
          if (pattern349 (x1, 
E_V4SImode) != 0
              || !
#line 1063 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1936; /* altivec_vmsumshs */

        case 216:
          if (pattern349 (x1, 
E_V8HImode) != 0
              || !
#line 1124 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1955; /* altivec_vmhaddshs */

        case 217:
          if (pattern349 (x1, 
E_V8HImode) != 0
              || !
#line 1135 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1956; /* altivec_vmhraddshs */

        case 342:
          switch (pattern351 (x1, 
342))
            {
            case 0:
              if (!
#line 4592 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2333; /* bcdadd_v1ti */

            case 1:
              if (!
#line 4592 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2335; /* bcdadd_v16qi */

            case 2:
              if (!
#line 4627 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2341; /* *bcdadd_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2343; /* *bcdadd_test2_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern351 (x1, 
343))
            {
            case 0:
              if (!
#line 4592 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2334; /* bcdsub_v1ti */

            case 1:
              if (!
#line 4592 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2336; /* bcdsub_v16qi */

            case 2:
              if (!
#line 4627 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2342; /* *bcdsub_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2344; /* *bcdsub_test2_v16qi */

            default:
              return -1;
            }

        case 345:
          if (GET_MODE (x3) != E_V16QImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern253 (x6, 
E_CCFPmode, 
106) != 0
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode)
              || !
#line 4763 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2355; /* bcdshift_v16qi */

        case 445:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern540 (x3, 
E_QImode) != 0
                  || !
#line 152 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3344; /* *pcrel_opt_ldqi_gpr */

            case E_HImode:
              if (pattern540 (x3, 
E_HImode) != 0
                  || !
#line 152 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3345; /* *pcrel_opt_ldhi_gpr */

            case E_SImode:
              if (pattern540 (x3, 
E_SImode) != 0
                  || !
#line 152 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3346; /* *pcrel_opt_ldsi_gpr */

            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || !d_form_memory (operands[1], E_DImode))
                return -1;
              if (int_reg_operand (operands[0], E_DImode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3347; /* *pcrel_opt_lddi_gpr */
              if (!vsx_register_operand (operands[0], E_DImode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3358; /* *pcrel_opt_lddi_vsx */

            case E_SFmode:
              if (GET_MODE (x3) != E_SFmode
                  || !d_form_memory (operands[1], E_SFmode))
                return -1;
              if (int_reg_operand (operands[0], E_SFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3348; /* *pcrel_opt_ldsf_gpr */
              if (!vsx_register_operand (operands[0], E_SFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3360; /* *pcrel_opt_ldsf_vsx */

            case E_DFmode:
              if (GET_MODE (x3) != E_DFmode
                  || !d_form_memory (operands[1], E_DFmode))
                return -1;
              if (int_reg_operand (operands[0], E_DFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3349; /* *pcrel_opt_lddf_gpr */
              if (!vsx_register_operand (operands[0], E_DFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3359; /* *pcrel_opt_lddf_vsx */

            case E_TImode:
              if (pattern541 (x3, 
E_TImode) != 0
                  || !
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3362; /* *pcrel_opt_ldti */

            case E_KFmode:
              if (pattern541 (x3, 
E_KFmode) != 0
                  || !
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3363; /* *pcrel_opt_ldkf */

            case E_V1TImode:
              if (pattern541 (x3, 
E_V1TImode) != 0
                  || !
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3364; /* *pcrel_opt_ldv1ti */

            case E_V2DImode:
              if (pattern541 (x3, 
E_V2DImode) != 0
                  || !
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3365; /* *pcrel_opt_ldv2di */

            case E_V4SImode:
              if (pattern541 (x3, 
E_V4SImode) != 0
                  || !
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3366; /* *pcrel_opt_ldv4si */

            case E_V8HImode:
              if (pattern541 (x3, 
E_V8HImode) != 0
                  || !
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3367; /* *pcrel_opt_ldv8hi */

            case E_V16QImode:
              if (pattern541 (x3, 
E_V16QImode) != 0
                  || !
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3368; /* *pcrel_opt_ldv16qi */

            case E_V2DFmode:
              if (pattern541 (x3, 
E_V2DFmode) != 0
                  || !
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3369; /* *pcrel_opt_ldv2df */

            case E_V4SFmode:
              if (pattern541 (x3, 
E_V4SFmode) != 0
                  || !
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3370; /* *pcrel_opt_ldv4sf */

            case E_TFmode:
              if (pattern541 (x3, 
E_TFmode) != 0
                  || !(
#line 256 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 99 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
                return -1;
              return 3371; /* *pcrel_opt_ldtf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      res = recog_159 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      switch (pattern296 (x1, 
98, 
CLOBBER))
        {
        case 0:
          if (pattern517 (x1, 
E_SImode) != 0)
            return -1;
          return 124; /* subfsi3_carry_in_xx */

        case 1:
          if (pattern517 (x1, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 125; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case PLUS:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          res = recog_160 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[0] = x7;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              res = recog_161 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x7;
          if (pattern297 (x1) == 0)
            {
              x5 = XEXP (x3, 1);
              switch (GET_CODE (x5))
                {
                case REG:
                case SUBREG:
                  operands[2] = x5;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern562 (x1, 
E_SImode) == 0)
                        return 90; /* *addsi3_carry_in_internal2 */
                      break;

                    case E_DImode:
                      if (pattern562 (x1, 
E_DImode) == 0
                          && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                        return 91; /* *adddi3_carry_in_internal2 */
                      break;

                    default:
                      break;
                    }
                  break;

                case CONST_INT:
                  if (XWINT (x5, 0) == -1L)
                    {
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern563 (x1, 
E_SImode) == 0)
                            return 94; /* addsi3_carry_in_m1 */
                          break;

                        case E_DImode:
                          if (pattern563 (x1, 
E_DImode) == 0
                              && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                            return 95; /* adddi3_carry_in_m1 */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x7;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          switch (pattern250 (x1))
            {
            case 0:
              if (!
#line 3031 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3339; /* *fuse_add_add */

            case 1:
              if (!(
#line 3031 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 3340; /* *fuse_add_add */

            default:
              return -1;
            }

        case NOT:
          if (pattern297 (x1) != 0)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern550 (x1, 
E_SImode) != 0)
                return -1;
              return 118; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern550 (x1, 
E_DImode) != 0
                  || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 119; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 98)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern518 (x1, 
E_SImode) != 0)
            return -1;
          return 120; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern518 (x1, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 121; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x11 = XEXP (x4, 1);
      operands[1] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern542 (x1, 
E_SImode) != 0)
            return -1;
          return 122; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern542 (x1, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 123; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (GET_MODE (x4) != E_V2DFmode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT
          || GET_MODE (x11) != E_DFmode)
        return -1;
      x14 = XEXP (x11, 1);
      if (GET_CODE (x14) != PARALLEL
          || XVECLEN (x14, 0) != 1)
        return -1;
      x15 = XVECEXP (x14, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!vfloat_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || pattern82 (x1) != 0
          || !
#line 4927 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1635; /* vsx_reduc_plus_v2df */

    case AND:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 1663 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2675; /* *fuse_and_add */

        case 1:
          if (!(
#line 1663 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2676; /* *fuse_and_add */

        case 2:
          if (!
#line 1699 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2679; /* *fuse_nor_add */

        case 3:
          if (!(
#line 1699 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2680; /* *fuse_nor_add */

        default:
          return -1;
        }

    case IOR:
      switch (pattern196 (x1))
        {
        case 0:
          if (!
#line 1681 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2677; /* *fuse_nand_add */

        case 1:
          if (!(
#line 1681 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2678; /* *fuse_nand_add */

        case 2:
          if (!
#line 1717 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2681; /* *fuse_or_add */

        case 3:
          if (!(
#line 1717 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2682; /* *fuse_or_add */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case EQ:
    case GE:
    case GT:
      operands[1] = x4;
      if (fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern300 (x1))
            {
            case 0:
              if (
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 381; /* *movsfsfcc_p9 */
              break;

            case 1:
              if (
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 383; /* *movsfdfcc_p9 */
              break;

            case 2:
              if (
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 382; /* *movdfsfcc_p9 */
              break;

            case 3:
              if (
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 384; /* *movdfdfcc_p9 */
              break;

            case 4:
              if ((
#line 5770 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 393; /* *movkfcc_p10 */
              break;

            case 5:
              if ((
#line 5770 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 394; /* *movtfcc_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern254 (x1, 
EQ))
        {
        case 0:
          if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 2;
          return 990; /* bdz_si */

        case 1:
          if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 2;
          return 992; /* bdz_di */

        default:
          return -1;
        }

    case NE:
    case UNLE:
    case UNLT:
      operands[1] = x4;
      if (invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern300 (x1))
            {
            case 0:
              if (
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 385; /* *movsfsfcc_invert_p9 */
              break;

            case 1:
              if (
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 387; /* *movsfdfcc_invert_p9 */
              break;

            case 2:
              if (
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 386; /* *movdfsfcc_invert_p9 */
              break;

            case 3:
              if (
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 388; /* *movdfdfcc_invert_p9 */
              break;

            case 4:
              if ((
#line 5802 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 395; /* *movkfcc_invert_p10 */
              break;

            case 5:
              if ((
#line 5802 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 396; /* *movtfcc_invert_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern254 (x1, 
NE))
        {
        case 0:
          if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 2;
          return 991; /* bdnz_si */

        case 1:
          if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 2;
          return 993; /* bdnz_di */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 1);
      if (!branch_comparison_operator (x5, E_VOIDmode))
        return -1;
      operands[3] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC
          || pattern415 (x1) != 0)
        return -1;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      x11 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x11, 0);
      operands[2] = x12;
      x13 = XEXP (x4, 0);
      switch (GET_CODE (x13))
        {
        case EQ:
          switch (pattern588 (x1))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 994; /* bdztf_si */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 996; /* bdztf_di */

            default:
              return -1;
            }

        case NE:
          switch (pattern588 (x1))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 995; /* bdnztf_si */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 997; /* bdnztf_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case UNSIGNED_FLOAT:
          if (pattern200 (x1, 
USE, 
E_DFmode) != 0
              || pattern411 (x1) != 0
              || !
#line 6170 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)))
            return -1;
          return 416; /* *floatunssidf2_internal */

        case FIX:
          if (pattern200 (x1, 
CLOBBER, 
E_SImode) != 0)
            return -1;
          switch (pattern412 (x1))
            {
            case 0:
              if (!(
#line 9097 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 621; /* *fix_truncifsi2_internal */

            case 1:
              if (!(
#line 9097 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return -1;
              return 622; /* *fix_trunctfsi2_internal */

            default:
              return -1;
            }

        case CALL:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode
              || pattern258 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          if (!immediate_operand (operands[3], E_SImode))
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          x13 = XVECEXP (x1, 0, 3);
          x14 = XEXP (x13, 1);
          x15 = XVECEXP (x14, 0, 0);
          operands[5] = x15;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (pattern600 (x1, 
E_SImode) != 0
                  || !(
#line 11749 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 841; /* *call_value_indirect_aixsi */

            case E_DImode:
              if (pattern600 (x1, 
E_DImode) != 0
                  || !(
#line 11749 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 842; /* *call_value_indirect_aixdi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != AND)
            return -1;
          x16 = XEXP (x5, 1);
          if (!branch_comparison_operator (x16, E_VOIDmode))
            return -1;
          operands[3] = x16;
          x17 = XEXP (x16, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern116 (x1) != 0)
            return -1;
          x18 = XEXP (x16, 0);
          operands[4] = x18;
          if (!cc_reg_operand (operands[4], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          x19 = XEXP (x8, 0);
          operands[0] = x19;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[5] = x12;
          x13 = XVECEXP (x1, 0, 3);
          x20 = XEXP (x13, 0);
          operands[6] = x20;
          if (!scratch_operand (operands[6], E_CCmode))
            return -1;
          x21 = XEXP (x2, 0);
          operands[7] = x21;
          if (!scratch_operand (operands[7], E_CCEQmode))
            return -1;
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case EQ:
              switch (pattern604 (x1))
                {
                case 0:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 994; /* bdztf_si */

                case 1:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 996; /* bdztf_di */

                default:
                  return -1;
                }

            case NE:
              switch (pattern604 (x1))
                {
                case 0:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 995; /* bdnztf_si */

                case 1:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 997; /* bdnztf_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode
          || pattern258 (x1) != 0)
        return -1;
      x22 = XEXP (x6, 0);
      operands[0] = x22;
      x4 = XEXP (x3, 1);
      operands[1] = x4;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      operands[3] = x12;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XVECEXP (x14, 0, 0);
      operands[4] = x15;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern595 (x1, 
E_SImode) != 0
              || !(
#line 11728 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 839; /* *call_indirect_aixsi */

        case E_DImode:
          if (pattern595 (x1, 
E_DImode) != 0
              || !(
#line 11728 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 840; /* *call_indirect_aixdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      switch (XINT (x5, 1))
        {
        case 87:
          if (GET_MODE (x5) != E_SImode
              || !nonimmediate_operand (operands[0], E_SImode))
            return NULL;
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          if (!input_operand (operands[1], E_SFmode)
              || !scratch_operand (operands[2], E_V4SFmode)
              || !(
#line 7832 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))) && 
#line 7847 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && int_reg_operand (operands[0], SImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))))
            return NULL;
          return gen_split_291 (insn, operands);

        case 86:
          if (GET_MODE (x5) != E_SFmode
              || !scratch_operand (operands[2], E_DImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_SFmode))
            {
              x7 = XVECEXP (x5, 0, 0);
              operands[1] = x7;
              if (input_operand (operands[1], E_SImode)
                  && (
#line 8385 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))) && 
#line 8400 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && vsx_reg_sfsubreg_ok (operands[0], SFmode)
   && int_reg_operand_not_pseudo (operands[1], SImode))))
                return gen_split_301 (insn, operands);
            }
          x7 = XVECEXP (x5, 0, 0);
          if (!lowpart_subreg_operator (x7, E_SImode))
            return NULL;
          switch (pattern495 (x7))
            {
            case 0:
              if (!(
#line 8452 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG) && 
#line 8454 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_302 (insn, operands);

            case 1:
              if (!(
#line 8452 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG) && 
#line 8454 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_303 (insn, operands);

            default:
              return NULL;
            }

        case 61:
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern468 (x5, 
E_DImode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_342 (insn, operands);

            case E_DFmode:
              if (pattern468 (x5, 
E_DFmode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_343 (insn, operands);

            case E_DDmode:
              if (pattern468 (x5, 
E_DDmode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_344 (insn, operands);

            case E_TImode:
              if (pattern468 (x5, 
E_TImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_345 (insn, operands);

            case E_V16QImode:
              if (pattern468 (x5, 
E_V16QImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_346 (insn, operands);

            case E_V8HImode:
              if (pattern468 (x5, 
E_V8HImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_347 (insn, operands);

            case E_V4SImode:
              if (pattern468 (x5, 
E_V4SImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_348 (insn, operands);

            case E_V4SFmode:
              if (pattern468 (x5, 
E_V4SFmode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_349 (insn, operands);

            case E_V2DImode:
              if (pattern468 (x5, 
E_V2DImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_350 (insn, operands);

            case E_V2DFmode:
              if (pattern468 (x5, 
E_V2DFmode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_351 (insn, operands);

            case E_V1TImode:
              if (pattern468 (x5, 
E_V1TImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_352 (insn, operands);

            case E_KFmode:
              if (pattern468 (x5, 
E_KFmode, 
E_IFmode) != 0
                  || !((
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case E_TFmode:
              if (pattern468 (x5, 
E_TFmode, 
E_IFmode) != 0
                  || !((
#line 9634 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 9636 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            case E_SFmode:
              if (pattern468 (x5, 
E_SFmode, 
E_DImode) != 0
                  || !(
#line 9688 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9690 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_365 (insn, operands);

            default:
              return NULL;
            }

        case 64:
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern469 (x5, 
E_TImode) != 0
                  || !(
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_366 (insn, operands);

            case E_V16QImode:
              if (pattern469 (x5, 
E_V16QImode) != 0
                  || !(
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_367 (insn, operands);

            case E_V8HImode:
              if (pattern469 (x5, 
E_V8HImode) != 0
                  || !(
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_368 (insn, operands);

            case E_V4SImode:
              if (pattern469 (x5, 
E_V4SImode) != 0
                  || !(
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_369 (insn, operands);

            case E_V4SFmode:
              if (pattern468 (x5, 
E_V4SFmode, 
E_V4SFmode) != 0
                  || !(
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_370 (insn, operands);

            case E_V2DImode:
              if (pattern469 (x5, 
E_V2DImode) != 0
                  || !(
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_371 (insn, operands);

            case E_V2DFmode:
              if (pattern469 (x5, 
E_V2DFmode) != 0
                  || !(
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_372 (insn, operands);

            case E_V1TImode:
              if (pattern469 (x5, 
E_V1TImode) != 0
                  || !(
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_373 (insn, operands);

            case E_KFmode:
              if (pattern469 (x5, 
E_KFmode) != 0
                  || !((
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_374 (insn, operands);

            case E_TFmode:
              if (pattern469 (x5, 
E_TFmode) != 0
                  || !((
#line 9724 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 9726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_375 (insn, operands);

            case E_SFmode:
              if (pattern468 (x5, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 9752 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9754 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_376 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      if (XINT (x5, 1) != 145)
        return NULL;
      switch (pattern348 (x1))
        {
        case 0:
          if (!(
#line 3675 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3677 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_611 (insn, operands);

        case 1:
          if (!(
#line 3675 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3677 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_612 (insn, operands);

        case 2:
          if (!(
#line 3762 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3764 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_617 (insn, operands);

        case 3:
          if (!(
#line 4204 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_636 (insn, operands);

        case 4:
          if (!(
#line 4204 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_637 (insn, operands);

        case 5:
          if (!(
#line 4204 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_638 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      if (XINT (x5, 1) != 123
          || GET_MODE (x5) != E_V4SFmode
          || !gpc_reg_operand (operands[0], E_V4SFmode))
        return NULL;
      x7 = XVECEXP (x5, 0, 0);
      operands[1] = x7;
      switch (pattern470 (x1))
        {
        case 0:
          if (!(
#line 4616 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 4618 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_673 (insn, operands);

        case 1:
          if (!(
#line 4652 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 4654 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_674 (insn, operands);

        case 2:
          if (!(
#line 4712 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))) && 
#line 4716 "../../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_675 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern416 (x2, 
E_SImode) != 0
                  || !(
#line 3840 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3844 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_78 (insn, operands);

            case E_DImode:
              if (pattern416 (x2, 
E_DImode) != 0
                  || !((
#line 3840 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3844 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_79 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern369 (x2, 
E_TImode) != 0
                  || !
#line 7388 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
                return NULL;
              return gen_split_230 (insn, operands);

            case E_PTImode:
              if (pattern369 (x2, 
E_PTImode) != 0
                  || !
#line 7388 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
                return NULL;
              return gen_split_231 (insn, operands);

            case E_V16QImode:
              if (pattern369 (x2, 
E_V16QImode) != 0
                  || !(
#line 7388 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_232 (insn, operands);

            case E_V8HImode:
              if (pattern369 (x2, 
E_V8HImode) != 0
                  || !(
#line 7388 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_233 (insn, operands);

            case E_V4SImode:
              if (pattern369 (x2, 
E_V4SImode) != 0
                  || !(
#line 7388 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_234 (insn, operands);

            case E_V4SFmode:
              if (pattern369 (x2, 
E_V4SFmode) != 0
                  || !(
#line 7388 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_235 (insn, operands);

            case E_V2DImode:
              if (pattern369 (x2, 
E_V2DImode) != 0
                  || !(
#line 7388 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_236 (insn, operands);

            case E_V2DFmode:
              if (pattern369 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7388 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_237 (insn, operands);

            case E_V1TImode:
              if (pattern369 (x2, 
E_V1TImode) != 0
                  || !(
#line 7388 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_238 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
        return NULL;
      switch (pattern261 (x2))
        {
        case 0:
          if (!((
#line 9532 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 9534 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_340 (insn, operands);

        case 1:
          if (!((
#line 9532 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 9534 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_341 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (nonimmediate_operand (operands[0], E_TImode)
      && input_operand (operands[1], E_TImode)
      && 
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], TImode)
       || int_reg_operand (operands[1], TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TImode)
           && !vsx_register_operand (operands[1], TImode)))))
    return gen_split_355 (insn, operands);
  if (int_reg_operand (operands[0], E_TImode)
      && const_scalar_int_operand (operands[1], E_TImode)
      && 
#line 10063 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (TImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))))
    return gen_split_388 (insn, operands);
  if (nonimmediate_operand (operands[0], E_TImode)
      && input_operand (operands[1], E_TImode))
    {
      if (
#line 10090 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return gen_split_390 (insn, operands);
      if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return gen_split_538 (insn, operands);
    }
  if (indexed_or_indirect_operand (operands[0], E_TImode)
      && indexed_or_indirect_operand (operands[1], E_TImode)
      && (
#line 427 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && TARGET_VSX
   && !TARGET_P9_VECTOR
   && can_create_pseudo_p ()) && 
#line 432 "../../../gcc/config/rs6000/vsx.md"
( 1)))
    return gen_split_563 (insn, operands);
  if (vsx_register_operand (operands[0], E_TImode)
      && memory_operand (operands[1], E_TImode)
      && 
#line 1045 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TImode)))
    return gen_split_586 (insn, operands);
  if (memory_operand (operands[0], E_TImode)
      && vsx_register_operand (operands[1], E_TImode))
    {
      if (
#line 1075 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return gen_split_590 (insn, operands);
      if (
#line 1131 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return gen_split_594 (insn, operands);
    }
  if (!altivec_register_operand (operands[0], E_TImode))
    return NULL;
  if (easy_vector_constant_msb (operands[1], E_TImode)
      && 
#line 286 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && reload_completed))
    return gen_split_699 (insn, operands);
  if (easy_vector_constant_add_self (operands[1], E_TImode)
      && 
#line 324 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && reload_completed))
    return gen_split_709 (insn, operands);
  if (!easy_vector_constant_vsldoi (operands[1], E_TImode)
      || !
#line 353 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()))
    return NULL;
  return gen_split_719 (insn, operands);
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x4) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7582 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], TImode)))
            return gen_split_270 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7611 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_279 (insn, operands);

        case E_PTImode:
          if (GET_MODE (x3) != E_PTImode
              || GET_MODE (x4) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7582 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], PTImode)))
            return gen_split_271 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7611 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_280 (insn, operands);

        case E_V16QImode:
          if (pattern317 (x3, 
E_V16QImode) != 0
              || !(
#line 7582 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_V8HImode:
          if (pattern317 (x3, 
E_V8HImode) != 0
              || !(
#line 7582 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_273 (insn, operands);

        case E_V4SImode:
          if (pattern317 (x3, 
E_V4SImode) != 0
              || !(
#line 7582 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_274 (insn, operands);

        case E_V4SFmode:
          if (pattern317 (x3, 
E_V4SFmode) != 0
              || !(
#line 7582 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_275 (insn, operands);

        case E_V2DImode:
          if (pattern317 (x3, 
E_V2DImode) != 0
              || !(
#line 7582 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_276 (insn, operands);

        case E_V2DFmode:
          if (pattern317 (x3, 
E_V2DFmode) != 0
              || !(
#line 7582 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_277 (insn, operands);

        case E_V1TImode:
          if (pattern317 (x3, 
E_V1TImode) != 0
              || !(
#line 7582 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_278 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!vlogical_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !vlogical_operand (operands[1], E_TImode)
              || !
#line 7639 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
            return NULL;
          return gen_split_281 (insn, operands);

        case E_PTImode:
          if (!vlogical_operand (operands[0], E_PTImode)
              || GET_MODE (x3) != E_PTImode
              || !vlogical_operand (operands[1], E_PTImode)
              || !
#line 7639 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
            return NULL;
          return gen_split_282 (insn, operands);

        case E_V16QImode:
          if (!vlogical_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !vlogical_operand (operands[1], E_V16QImode)
              || !(
#line 7639 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_283 (insn, operands);

        case E_V8HImode:
          if (!vlogical_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !vlogical_operand (operands[1], E_V8HImode)
              || !(
#line 7639 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_284 (insn, operands);

        case E_V4SImode:
          if (!vlogical_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !vlogical_operand (operands[1], E_V4SImode)
              || !(
#line 7639 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_285 (insn, operands);

        case E_V4SFmode:
          if (!vlogical_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !vlogical_operand (operands[1], E_V4SFmode)
              || !(
#line 7639 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_286 (insn, operands);

        case E_V2DImode:
          if (!vlogical_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !vlogical_operand (operands[1], E_V2DImode)
              || !(
#line 7639 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_287 (insn, operands);

        case E_V2DFmode:
          if (!vlogical_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vlogical_operand (operands[1], E_V2DFmode)
              || !(
#line 7639 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_288 (insn, operands);

        case E_V1TImode:
          if (!vlogical_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !vlogical_operand (operands[1], E_V1TImode)
              || !(
#line 7639 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_289 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case DIV:
      switch (pattern119 (x1, 
MOD))
        {
        case 0:
          if (!
#line 3539 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_1 (insn, operands);

        case 1:
          if (!(
#line 3539 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_2 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern119 (x1, 
UMOD))
        {
        case 0:
          if (!
#line 3561 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_3 (insn, operands);

        case 1:
          if (!(
#line 3561 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_4 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CCmode)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x2, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!int_reg_operand (operands[1], E_SImode)
              || !int_reg_operand (operands[0], E_SImode)
              || !(
#line 8059 "../../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        case E_DImode:
          if (!int_reg_operand (operands[1], E_DImode)
              || !int_reg_operand (operands[0], E_DImode)
              || !(
#line 8059 "../../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_6 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case HIGH:
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_SImode)
              && pattern361 (x2, 
E_SImode) == 0)
            {
              if ((
#line 8074 "../../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 8074 "../../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && ((
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_8 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (peep2_current_count >= 3)
            {
              res = peephole2_1 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          if (!fusion_gpr_addis (operands[1], E_SImode))
            return NULL;
          switch (pattern362 (x2, 
E_SImode))
            {
            case 0:
              if (!(
#line 14717 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_14 (insn, operands);

            case 1:
              if (!(
#line 14717 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_15 (insn, operands);

            case 2:
              if (!(
#line 14717 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_16 (insn, operands);

            case 3:
              if (!(
#line 14717 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 484 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_17 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_DImode)
              && pattern361 (x2, 
E_DImode) == 0
              && (
#line 8074 "../../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (fusion_gpr_addis (operands[1], E_DImode))
            {
              switch (pattern362 (x2, 
E_DImode))
                {
                case 0:
                  if ((
#line 14717 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_18 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if ((
#line 14717 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_19 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 14717 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_20 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 3:
                  if ((
#line 14717 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 484 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_21 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DImode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DImode)
              && simple_offsettable_mem_operand (operands[2], E_DImode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_26 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_27 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DImode)
              || !altivec_register_operand (operands[2], E_DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_32 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_33 (insn, operands);

        case E_DFmode:
          operands[0] = x5;
          if (pattern264 (x3, 
E_DFmode) == 0
              && 
#line 10545 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_11 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DFmode)
              && simple_offsettable_mem_operand (operands[2], E_DFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_22 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_23 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DFmode)
              || !altivec_register_operand (operands[2], E_DFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_28 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_29 (insn, operands);

        case E_SFmode:
          operands[0] = x5;
          if (pattern264 (x3, 
E_SFmode) == 0
              && 
#line 10554 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_12 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_SFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_SFmode)
              && simple_offsettable_mem_operand (operands[2], E_SFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_24 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_25 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_SFmode)
              || !altivec_register_operand (operands[2], E_SFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_30 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_31 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != ROTATE)
        return NULL;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!int_reg_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || GET_MODE (x8) != E_V1TImode)
            return NULL;
          if (memory_operand (operands[1], E_V1TImode)
              && int_reg_operand (operands[2], E_V1TImode)
              && 
#line 1095 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_34 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!int_reg_operand (operands[1], E_V1TImode)
              || !memory_operand (operands[2], E_V1TImode)
              || !
#line 1107 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_36 (insn, operands);

        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x8) != E_TImode)
            return NULL;
          if (int_reg_operand (operands[0], E_TImode))
            {
              if (memory_operand (operands[1], E_TImode)
                  && int_reg_operand (operands[2], E_TImode)
                  && 
#line 1095 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_35 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (int_reg_operand (operands[1], E_TImode)
                  && memory_operand (operands[2], E_TImode)
                  && 
#line 1107 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_37 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!vsx_register_operand (operands[0], E_TImode)
              || !vsx_register_operand (operands[1], E_TImode)
              || !vsx_register_operand (operands[2], E_TImode)
              || !
#line 1121 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_38 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!int_reg_operand (operands[2], E_DImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[3] = x6;
      if (!vsx_register_operand (operands[3], E_SImode))
        return NULL;
      x7 = XEXP (x2, 0);
      operands[4] = x7;
      if (!int_reg_operand (operands[4], E_SImode))
        return NULL;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_SImode)
        return NULL;
      x11 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x11) != SET)
        return NULL;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != ASHIFT
          || GET_MODE (x12) != E_DImode)
        return NULL;
      x13 = XEXP (x12, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return NULL;
      x14 = XEXP (x11, 0);
      operands[7] = x14;
      if (!int_reg_operand (operands[7], E_DImode))
        return NULL;
      x15 = XEXP (x12, 0);
      operands[8] = x15;
      if (!int_reg_operand (operands[8], E_DImode))
        return NULL;
      x16 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x16) != SET)
        return NULL;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != UNSPEC
          || XVECLEN (x17, 0) != 1
          || XINT (x17, 1) != 62
          || GET_MODE (x17) != E_SFmode)
        return NULL;
      x18 = XEXP (x16, 0);
      operands[9] = x18;
      if (!vsx_register_operand (operands[9], E_SFmode))
        return NULL;
      x19 = XVECEXP (x17, 0, 0);
      if (!rtx_equal_p (x19, operands[7]))
        return NULL;
      switch (GET_CODE (x8))
        {
        case AND:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_39 (insn, operands);

        case IOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_40 (insn, operands);

        case XOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_41 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
