/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vfloat_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vfloat_operand (operands[1], i1)
      || !vfloat_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[11]))
    {
    case E_SImode:
      if (!scratch_operand (operands[11], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[11], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 26
      || GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!mma_assemble_input_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!mma_assemble_input_operand (operands[2], E_V16QImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!mma_assemble_input_operand (operands[3], E_V16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!mma_assemble_input_operand (operands[4], E_V16QImode))
    return -1;
  return 0;
}

int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      return pattern44 (x3); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern42 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case NOT:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case NOT:
          return pattern52 (x3); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern58 (x3);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern63 (x3);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern70 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 282
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 109
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern84 (x8, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern84 (x8, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern84 (x8, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!offsettable_mem_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_CCmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern110 (x4, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern110 (x4, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern120 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern120 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 96)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !immediate_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !immediate_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern141 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      if (GET_MODE (x5) != E_V2DFmode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 1L
          || !vfloat_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!vfloat_operand (operands[1], E_V2DFmode))
        return -1;
      x13 = XEXP (x9, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x4, 1);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 102
          || GET_MODE (x5) != E_V4SFmode)
        return -1;
      x15 = XVECEXP (x5, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 3L
          || !vfloat_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x4) != E_V4SFmode)
        return -1;
      x14 = XEXP (x4, 1);
      operands[1] = x14;
      if (!vfloat_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern204 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  return pattern203 (x1, 
i1); /* [-1, 3] */
}

int
pattern211 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!altivec_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern220 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern220 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 356
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x7) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x7) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern253 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 441
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!cc_reg_operand (operands[1], E_CCmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[0] = x7;
  return 0;
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern260 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern260 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern267 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern272 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern272 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern273 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern273 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern273 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern273 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern273 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern273 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern273 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern273 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern273 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern273 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern288 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern288 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern296 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern306 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!memory_operand (operands[0], E_V4SFmode)
          || !immediate_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!memory_operand (operands[0], E_V4SImode)
          || !immediate_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern326 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scc_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !symbol_ref_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !symbol_ref_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern347 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern354 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern359 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !non_add_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern365 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern371 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern41 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern41 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern59 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern59 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern59 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern59 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern59 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern59 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern59 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern59 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern59 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern59 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern402 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern400 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern400 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern401 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern401 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern401 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern401 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern401 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern401 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern401 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern401 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern401 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern401 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern415 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  return 0;
}

int
pattern420 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern428 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern435 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || !register_operand (operands[1], E_V2DImode)
      || !register_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], E_V2DImode))
    return -1;
  return 0;
}

int
pattern439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern33 (x2); /* [-1, 1] */
}

int
pattern446 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern454 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern458 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern473 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern483 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1)
    return -1;
  return 0;
}

int
pattern489 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern502 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[3], i1)
      || !vsx_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern506 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern515 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern523 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern523 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern524 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern524 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern524 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern524 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern524 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern524 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern524 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern524 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern524 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern524 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern546 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern554 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern553 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern553 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern567 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!symbol_ref_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !short_cint_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern581 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern588 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[2], E_SImode)
          || GET_MODE (x9) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[2], E_DImode)
          || GET_MODE (x9) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  x12 = XEXP (x9, 1);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x4, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x5, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern487 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5586 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 357; /* *isel_reversed_cc_si */

        case 1:
          if (!
#line 5586 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 359; /* *isel_reversed_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern487 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5586 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 358; /* *isel_reversed_cc_di */

        case 1:
          if (!(
#line 5586 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 360; /* *isel_reversed_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  operands[4] = x6;
  x7 = XEXP (x3, 2);
  operands[5] = x7;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern505 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 381; /* *movsfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 383; /* *movsfdfcc_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern505 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 382; /* *movdfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 384; /* *movdfdfcc_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern506 (x3, 
E_KFmode) != 0
              || !(
#line 5770 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 393; /* *movkfcc_p10 */

        case E_TFmode:
          if (pattern506 (x3, 
E_TFmode) != 0
              || !(
#line 5770 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 394; /* *movtfcc_p10 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      if (!all_ones_constant (operands[4], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !zero_constant (operands[5], E_V2DImode))
        return -1;
      if (vsx_register_operand (operands[0], E_V2DImode))
        {
          switch (pattern504 ())
            {
            case 0:
              if (
#line 5732 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 389; /* *fpmasksf */
              break;

            case 1:
              if (
#line 5732 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 390; /* *fpmaskdf */
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[2], E_KFmode)
              || !altivec_register_operand (operands[3], E_KFmode)
              || !(
#line 5837 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 397; /* *fpmaskkf */

        case E_TFmode:
          if (!altivec_register_operand (operands[2], E_TFmode)
              || !altivec_register_operand (operands[3], E_TFmode)
              || !(
#line 5837 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 398; /* *fpmasktf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x4;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x10 = XEXP (x5, 0);
      operands[5] = x10;
      x11 = XEXP (x5, 1);
      operands[6] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern560 (x2, 
E_SImode) != 0
              || !
#line 4281 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
            return -1;
          return 256; /* *rotlsi3_insert */

        case E_DImode:
          if (pattern560 (x2, 
E_DImode) != 0
              || !(
#line 4281 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 257; /* *rotldi3_insert */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 1);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              switch (GET_CODE (x10))
                {
                case ASHIFT:
                case ROTATE:
                case LSHIFTRT:
                  operands[4] = x10;
                  operands[5] = x4;
                  operands[6] = x9;
                  x12 = XEXP (x10, 0);
                  operands[1] = x12;
                  x13 = XEXP (x10, 1);
                  operands[2] = x13;
                  if (!const_int_operand (operands[2], E_SImode))
                    return -1;
                  x11 = XEXP (x5, 1);
                  operands[3] = x11;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern574 (x2, 
E_SImode) != 0
                          || !
#line 4299 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
                        return -1;
                      return 258; /* *rotlsi3_insert_2 */

                    case E_DImode:
                      if (pattern574 (x2, 
E_DImode) != 0
                          || !(
#line 4299 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 259; /* *rotldi3_insert_2 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (!gpc_reg_operand (operands[0], E_SImode)
                          || GET_MODE (x2) != E_SImode
                          || GET_MODE (x3) != E_SImode)
                        return -1;
                      operands[1] = x4;
                      if (!gpc_reg_operand (operands[1], E_SImode))
                        return -1;
                      operands[2] = x9;
                      if (!const_int_operand (operands[2], E_SImode)
                          || GET_MODE (x5) != E_SImode)
                        return -1;
                      operands[3] = x10;
                      if (!gpc_reg_operand (operands[3], E_SImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[4] = x11;
                      if (!const_int_operand (operands[4], E_SImode)
                          || !
#line 4375 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)
   && UINTVAL (operands[2]) != 0 && UINTVAL (operands[4]) != 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 267; /* *rotlsi3_insert_5 */

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x2) != E_DImode
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (x4, E_DImode)
                          || !const_int_operand (x9, E_DImode))
                        return -1;
                      operands[2] = x9;
                      operands[1] = x4;
                      if (GET_MODE (x5) == E_DImode)
                        {
                          operands[3] = x10;
                          if (gpc_reg_operand (operands[3], E_DImode))
                            {
                              x11 = XEXP (x5, 1);
                              operands[4] = x11;
                              if (const_int_operand (operands[4], E_DImode)
                                  && 
#line 4389 "../../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                                return 268; /* *rotldi3_insert_6 */
                            }
                        }
                      operands[4] = x9;
                      operands[3] = x4;
                      if (GET_MODE (x5) != E_DImode)
                        return -1;
                      operands[1] = x10;
                      if (!gpc_reg_operand (operands[1], E_DImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[2] = x11;
                      if (!const_int_operand (operands[2], E_DImode)
                          || !
#line 4404 "../../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 269; /* *rotldi3_insert_7 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern219 (x2))
                {
                case 0:
                  if (!
#line 4313 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
                    return -1;
                  return 260; /* rotlsi3_insert_3 */

                case 1:
                  if (!(
#line 4313 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 261; /* rotldi3_insert_3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (GET_MODE (x5) != E_SImode
                  || !gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              operands[3] = x4;
              if (!gpc_reg_operand (operands[3], E_SImode))
                return -1;
              operands[4] = x9;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x5, 0);
              operands[1] = x10;
              if (!gpc_reg_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 4365 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) + exact_log2 (-UINTVAL (operands[4])) == 32))
                return -1;
              return 266; /* *rotlsi3_insert_4 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              if (GET_CODE (x10) != NOT)
                return -1;
              x6 = XEXP (x1, 0);
              operands[0] = x6;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern488 (x2, 
E_V4SImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V4SImode) == 0
                      && 
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1888; /* altivec_vselv4si3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V4SImode) != 0
                      || !
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return -1;
                  return 1898; /* altivec_vselv4si4 */

                case E_V8HImode:
                  if (pattern488 (x2, 
E_V8HImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V8HImode) == 0
                      && 
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1889; /* altivec_vselv8hi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V8HImode) != 0
                      || !
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return -1;
                  return 1899; /* altivec_vselv8hi4 */

                case E_V16QImode:
                  if (pattern488 (x2, 
E_V16QImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V16QImode) == 0
                      && 
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1890; /* altivec_vselv16qi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V16QImode) != 0
                      || !
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return -1;
                  return 1900; /* altivec_vselv16qi4 */

                case E_V4SFmode:
                  if (pattern488 (x2, 
E_V4SFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V4SFmode) == 0
                      && 
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1891; /* altivec_vselv4sf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V4SFmode) != 0
                      || !
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return -1;
                  return 1901; /* altivec_vselv4sf4 */

                case E_V2DFmode:
                  if (pattern488 (x2, 
E_V2DFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V2DFmode) == 0
                      && 
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1892; /* altivec_vselv2df3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V2DFmode) != 0
                      || !
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return -1;
                  return 1902; /* altivec_vselv2df4 */

                case E_V2DImode:
                  if (pattern488 (x2, 
E_V2DImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V2DImode) == 0
                      && 
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1893; /* altivec_vselv2di3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V2DImode) != 0
                      || !
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return -1;
                  return 1903; /* altivec_vselv2di4 */

                case E_V1TImode:
                  if (pattern488 (x2, 
E_V1TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V1TImode) == 0
                      && 
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1894; /* altivec_vselv1ti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V1TImode) != 0
                      || !
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return -1;
                  return 1904; /* altivec_vselv1ti4 */

                case E_TImode:
                  if (pattern488 (x2, 
E_TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_TImode) == 0
                      && 
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1895; /* altivec_vselti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_TImode) != 0
                      || !
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return -1;
                  return 1905; /* altivec_vselti4 */

                case E_KFmode:
                  if (pattern488 (x2, 
E_KFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_KFmode) == 0
                      && (
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1896; /* altivec_vselkf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_KFmode) != 0
                      || !(
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 1906; /* altivec_vselkf4 */

                case E_TFmode:
                  if (pattern488 (x2, 
E_TFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_TFmode) == 0
                      && (
#line 735 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1897; /* altivec_vseltf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_TFmode) != 0
                      || !(
#line 751 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 1907; /* altivec_vseltf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              switch (pattern371 (x2))
                {
                case 0:
                  if (!
#line 1195 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2623; /* *fuse_and_or */

                case 1:
                  if (!(
#line 1195 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2624; /* *fuse_and_or */

                case 2:
                  if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3099; /* *fuse_vand_vor */

                case 3:
                  if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3100; /* *fuse_vand_vor */

                case 4:
                  if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3101; /* *fuse_vand_vor */

                case 5:
                  if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3102; /* *fuse_vand_vor */

                case 6:
                  if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3103; /* *fuse_vand_vor */

                case 7:
                  if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3104; /* *fuse_vand_vor */

                case 8:
                  if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3105; /* *fuse_vand_vor */

                case 9:
                  if (!
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3106; /* *fuse_vand_vor */

                case 10:
                  if (!(
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3107; /* *fuse_vand_vor */

                case 11:
                  if (!(
#line 2599 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3108; /* *fuse_vand_vor */

                default:
                  return -1;
                }

            case NOT:
              if (pnum_clobbers == NULL)
                return -1;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              operands[0] = x4;
              operands[1] = x9;
              switch (pattern62 (x2))
                {
                case 0:
                  if (!
#line 1375 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2643; /* *fuse_and_orc */

                case 1:
                  if (!(
#line 1375 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2644; /* *fuse_and_orc */

                case 2:
                  if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3179; /* *fuse_vand_vorc */

                case 3:
                  if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3180; /* *fuse_vand_vorc */

                case 4:
                  if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3181; /* *fuse_vand_vorc */

                case 5:
                  if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3182; /* *fuse_vand_vorc */

                case 6:
                  if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3183; /* *fuse_vand_vorc */

                case 7:
                  if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3184; /* *fuse_vand_vorc */

                case 8:
                  if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3185; /* *fuse_vand_vorc */

                case 9:
                  if (!
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3186; /* *fuse_vand_vorc */

                case 10:
                  if (!(
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3187; /* *fuse_vand_vorc */

                case 11:
                  if (!(
#line 2743 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3188; /* *fuse_vand_vorc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_19 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5239 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1670; /* xsiexpqpf_kf */

        case E_V1TImode:
          if (!altivec_register_operand (operands[1], E_V1TImode)
              || !altivec_register_operand (operands[2], E_V2DImode)
              || !(
#line 5251 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1672; /* xsiexpqp_kf_v2di */

        case E_TImode:
          if (!altivec_register_operand (operands[1], E_TImode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5251 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1673; /* xsiexpqp_kf_di */

        default:
          return -1;
        }

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5239 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1671; /* xsiexpqpf_tf */

        case E_V1TImode:
          if (!altivec_register_operand (operands[1], E_V1TImode)
              || !altivec_register_operand (operands[2], E_V2DImode)
              || !(
#line 5251 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1674; /* xsiexpqp_tf_v2di */

        case E_TImode:
          if (!altivec_register_operand (operands[1], E_TImode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5251 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1675; /* xsiexpqp_tf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !
#line 9556 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 643; /* p8_fmrgow_di */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9556 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 644; /* p8_fmrgow_df */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !
#line 9556 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 645; /* p8_fmrgow_dd */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 2045 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2024; /* altivec_vrldnm */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 2045 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2025; /* altivec_vrlwnm */

    case E_V1TImode:
      if (pattern132 (x3, 
E_V1TImode) != 0
          || !
#line 2069 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2026; /* altivec_vrlqnm_inst */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], E_SFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_SFmode)
      || !
#line 3232 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
    return -1;
  return 1463; /* vsx_concat_v2sf */
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!u6bit_cint_operand (operands[1], E_QImode)
          || !altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 6455 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1738; /* vec_mtvsrbmi */

    case REG:
    case SUBREG:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!altivec_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !
#line 6463 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1739; /* vec_mtvsr_v16qi */

        case E_V8HImode:
          if (!altivec_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !
#line 6463 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1740; /* vec_mtvsr_v8hi */

        case E_V4SImode:
          if (!altivec_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !
#line 6463 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1741; /* vec_mtvsr_v4si */

        case E_V2DImode:
          if (!altivec_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !
#line 6463 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1742; /* vec_mtvsr_v2di */

        case E_V1TImode:
          if (!altivec_register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !
#line 6463 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1743; /* vec_mtvsr_v1ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1))
    {
    case 0:
      if (!
#line 6840 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 483; /* floorsf2 */

    case 1:
      if (!
#line 6840 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 484; /* floordf2 */

    case 2:
      if (!(
#line 15447 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1175; /* floorkf2 */

    case 3:
      if (!(
#line 15447 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1176; /* floortf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2339 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1415; /* vsx_floorv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2589 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2107; /* *altivec_vrfim */

    case 5:
      if (!
#line 2339 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1416; /* vsx_floorv2df2 */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2065 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1370; /* *vsx_tsqrtdf2_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2065 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1371; /* *vsx_tsqrtv4sf2_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2065 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1372; /* *vsx_tsqrtv2df2_internal */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_VECTOR:
      switch (pattern318 (x3))
        {
        case 0:
          if (!
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()))
            return -1;
          return 1799; /* sldoi_to_movv4si */

        case 1:
          if (!
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()))
            return -1;
          return 1800; /* sldoi_to_movv8hi */

        case 2:
          if (!
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()))
            return -1;
          return 1801; /* sldoi_to_movv16qi */

        case 3:
          if (!
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1802; /* sldoi_to_movv4sf */

        case 4:
          if (!
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1803; /* sldoi_to_movv2df */

        case 5:
          if (!
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()))
            return -1;
          return 1804; /* sldoi_to_movv2di */

        case 6:
          if (!
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()))
            return -1;
          return 1805; /* sldoi_to_movv1ti */

        case 7:
          if (!
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()))
            return -1;
          return 1806; /* sldoi_to_movti */

        case 8:
          if (!(
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 1807; /* sldoi_to_movkf */

        case 9:
          if (!(
#line 391 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 1808; /* sldoi_to_movtf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!immediate_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern141 (x3, 
E_V4SImode) != 0
              || !
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2116; /* altivec_vsldoi_v4si */

        case E_V8HImode:
          if (pattern141 (x3, 
E_V8HImode) != 0
              || !
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2117; /* altivec_vsldoi_v8hi */

        case E_V16QImode:
          if (pattern141 (x3, 
E_V16QImode) != 0
              || !
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2118; /* altivec_vsldoi_v16qi */

        case E_V4SFmode:
          if (pattern141 (x3, 
E_V4SFmode) != 0
              || !
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2119; /* altivec_vsldoi_v4sf */

        case E_V2DFmode:
          if (pattern141 (x3, 
E_V2DFmode) != 0
              || !
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2120; /* altivec_vsldoi_v2df */

        case E_V2DImode:
          if (pattern141 (x3, 
E_V2DImode) != 0
              || !
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2121; /* altivec_vsldoi_v2di */

        case E_V1TImode:
          if (pattern141 (x3, 
E_V1TImode) != 0
              || !
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2122; /* altivec_vsldoi_v1ti */

        case E_TImode:
          if (pattern141 (x3, 
E_TImode) != 0
              || !
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2123; /* altivec_vsldoi_ti */

        case E_KFmode:
          if (pattern141 (x3, 
E_KFmode) != 0
              || !(
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2124; /* altivec_vsldoi_kf */

        case E_TFmode:
          if (pattern141 (x3, 
E_TFmode) != 0
              || !(
#line 2685 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2125; /* altivec_vsldoi_tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 976; /* jump */
        }
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      res = recog_114 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && input_operand (operands[1], E_SFmode))
        {
          if (
#line 8257 "../../../gcc/config/rs6000/rs6000.md"
((register_operand (operands[0], SFmode)
   || register_operand (operands[1], SFmode))
   && TARGET_HARD_FLOAT
   && (TARGET_ALLOW_SF_SUBREG
       || valid_sf_si_move (operands[0], operands[1], SFmode))))
            return 582; /* movsf_hardfloat */
          if (
#line 8335 "../../../gcc/config/rs6000/rs6000.md"
((gpc_reg_operand (operands[0], SFmode)
   || gpc_reg_operand (operands[1], SFmode))
   && TARGET_SOFT_FLOAT))
            return 584; /* *movsf_softfloat */
        }
      break;

    case E_SDmode:
      if (nonimmediate_operand (operands[0], E_SDmode)
          && input_operand (operands[1], E_SDmode))
        {
          if (
#line 8302 "../../../gcc/config/rs6000/rs6000.md"
((register_operand (operands[0], SDmode)
   || register_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT))
            return 583; /* movsd_hardfloat */
          if (
#line 8335 "../../../gcc/config/rs6000/rs6000.md"
((gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_SOFT_FLOAT))
            return 585; /* *movsd_softfloat */
        }
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && input_operand (operands[1], E_DFmode))
        {
          if (
#line 8575 "../../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 589; /* *movdf_hardfloat32 */
          if (
#line 8620 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 591; /* *movdf_softfloat32 */
          if (
#line 8649 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 593; /* *movdf_hardfloat64 */
          if (
#line 8701 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 595; /* *movdf_softfloat64 */
        }
      break;

    case E_DDmode:
      if (nonimmediate_operand (operands[0], E_DDmode)
          && input_operand (operands[1], E_DDmode))
        {
          if (
#line 8575 "../../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 590; /* *movdd_hardfloat32 */
          if (
#line 8620 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 592; /* *movdd_softfloat32 */
          if (
#line 8649 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 594; /* *movdd_hardfloat64 */
          if (
#line 8701 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 596; /* *movdd_softfloat64 */
        }
      break;

    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if ((
#line 8807 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TFmode)
   && (TFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))))
            return 601; /* *movtf_64bit_dm */
          if ((
#line 8843 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TFmode)
       || int_reg_operand_not_pseudo (operands[0], TFmode)
       || int_reg_operand_not_pseudo (operands[1], TFmode))
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))))
            return 605; /* *movtf_32bit */
          if ((
#line 8861 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 543 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
            return 608; /* *movtf_softfloat */
        }
      if (vsx_register_operand (operands[0], E_TFmode)
          && memory_operand (operands[1], E_TFmode)
          && (
#line 1040 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TFmode)) && 
#line 36 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 1276; /* *vsx_le_perm_load_tf */
      if (memory_operand (operands[0], E_TFmode)
          && vsx_register_operand (operands[1], E_TFmode)
          && (
#line 1063 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 1280; /* *vsx_le_perm_store_tf */
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if ((
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && 
#line 70 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return 1299; /* vsx_movtf_64bit */
          if ((
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && 
#line 70 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return 1309; /* *vsx_movtf_32bit */
          if ((
#line 245 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && 
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return 1797; /* *altivec_movtf */
        }
      break;

    case E_IFmode:
      if (nonimmediate_operand (operands[0], E_IFmode)
          && input_operand (operands[1], E_IFmode))
        {
          if ((
#line 8807 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (IFmode)
   && (IFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))))
            return 602; /* *movif_64bit_dm */
          if ((
#line 8843 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (IFmode)
       || int_reg_operand_not_pseudo (operands[0], IFmode)
       || int_reg_operand_not_pseudo (operands[1], IFmode))
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))))
            return 606; /* *movif_32bit */
          if ((
#line 8861 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 544 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
            return 609; /* *movif_softfloat */
        }
      break;

    case E_TDmode:
      if (nonimmediate_operand (operands[0], E_TDmode)
          && input_operand (operands[1], E_TDmode))
        {
          if ((
#line 8807 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TDmode)
   && (TDmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
            return 603; /* *movtd_64bit_dm */
          if (
#line 8826 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && !WORDS_BIG_ENDIAN
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))))
            return 604; /* *movtd_64bit_nodm */
          if ((
#line 8843 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TDmode)
       || int_reg_operand_not_pseudo (operands[0], TDmode)
       || int_reg_operand_not_pseudo (operands[1], TDmode))
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
            return 607; /* *movtd_32bit */
          if ((
#line 8861 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 545 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
            return 610; /* *movtd_softfloat */
        }
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && input_operand (operands[1], E_DImode))
        {
          if (
#line 9795 "../../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DImode)
       || gpc_reg_operand (operands[1], DImode))))
            return 696; /* *movdi_internal32 */
          if (
#line 9892 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DImode)
       || gpc_reg_operand (operands[1], DImode))))
            return 697; /* *movdi_internal64 */
        }
      if (gpc_reg_operand (operands[0], E_DImode))
        {
          if (pcrel_local_address (operands[1], E_DImode)
              && 
#line 11071 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PCREL))
            return 792; /* *pcrel_local_addr */
          if (pcrel_external_address (operands[1], E_DImode)
              && 
#line 11083 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PCREL))
            return 793; /* *pcrel_extern_addr */
        }
      break;

    case E_TImode:
      if (input_operand (operands[1], E_TImode))
        {
          if (reg_or_mem_operand (operands[0], E_TImode)
              && 
#line 10037 "../../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64
   && (TImode != TImode || VECTOR_MEM_NONE_P (TImode))
   && (gpc_reg_operand (operands[0], TImode)
       || gpc_reg_operand (operands[1], TImode))))
            return 698; /* *movti_string */
          if (nonimmediate_operand (operands[0], E_TImode)
              && 
#line 10050 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_POWERPC64 && VECTOR_MEM_NONE_P (TImode)
   && (gpc_reg_operand (operands[0], TImode)
       || gpc_reg_operand (operands[1], TImode)))))
            return 700; /* *movti_ppc64 */
        }
      if (indexed_or_indirect_operand (operands[0], E_TImode)
          && indexed_or_indirect_operand (operands[1], E_TImode)
          && 
#line 427 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && TARGET_VSX
   && !TARGET_P9_VECTOR
   && can_create_pseudo_p ()))
        return 1258; /* *vsx_le_mem_to_mem_mov_ti */
      if (vsx_register_operand (operands[0], E_TImode)
          && memory_operand (operands[1], E_TImode)
          && 
#line 1040 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TImode)))
        return 1277; /* *vsx_le_perm_load_ti */
      if (memory_operand (operands[0], E_TImode)
          && vsx_register_operand (operands[1], E_TImode)
          && 
#line 1063 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return 1281; /* *vsx_le_perm_store_ti */
      if (nonimmediate_operand (operands[0], E_TImode)
          && input_operand (operands[1], E_TImode))
        {
          if (
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))))
            return 1300; /* vsx_movti_64bit */
          if (
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))))
            return 1310; /* *vsx_movti_32bit */
          if (
#line 267 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))))
            return 1798; /* *altivec_movti */
        }
      break;

    case E_PTImode:
      if (input_operand (operands[1], E_PTImode))
        {
          if (reg_or_mem_operand (operands[0], E_PTImode)
              && 
#line 10037 "../../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64
   && (PTImode != TImode || VECTOR_MEM_NONE_P (TImode))
   && (gpc_reg_operand (operands[0], PTImode)
       || gpc_reg_operand (operands[1], PTImode))))
            return 699; /* *movpti_string */
          if (nonimmediate_operand (operands[0], E_PTImode)
              && 
#line 10050 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_POWERPC64 && VECTOR_MEM_NONE_P (PTImode)
   && (gpc_reg_operand (operands[0], PTImode)
       || gpc_reg_operand (operands[1], PTImode)))))
            return 701; /* *movpti_ppc64 */
        }
      break;

    default:
      break;
    }
  operands[0] = x2;
  switch (pattern32 (x3, 
E_TFmode))
    {
    case 0:
      if ((
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)))))
        return 2256; /* altivec_stvx_tf_2op_si */
      break;

    case 1:
      if ((
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)))))
        return 2257; /* altivec_stvx_tf_2op_di */
      break;

    case 2:
      if ((
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)))))
        return 2274; /* altivec_stvx_tf_1op_si */
      break;

    case 3:
      if ((
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)))))
        return 2275; /* altivec_stvx_tf_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  switch (pattern35 (x1, 
E_TFmode))
    {
    case 0:
      if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
        return -1;
      return 2211; /* altivec_lvx_tf_2op_si */

    case 1:
      if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
        return -1;
      return 2212; /* altivec_lvx_tf_2op_di */

    case 2:
      if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
        return -1;
      return 2229; /* altivec_lvx_tf_1op_si */

    case 3:
      if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 212 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
        return -1;
      return 2230; /* altivec_lvx_tf_1op_di */

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5879 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 402; /* floatsisf2_lfiwax */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 7037 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS))
                    return 502; /* floatdisf2_fcfids */
                  if (pnum_clobbers != NULL)
                    {
                      if (memory_operand (operands[1], E_DImode)
                          && 
#line 7048 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS))
                        {
                          *pnum_clobbers = 1;
                          return 503; /* *floatdisf2_mem */
                        }
                      if (gpc_reg_operand (operands[1], E_DImode)
                          && 
#line 7068 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS))
                        {
                          *pnum_clobbers = 1;
                          return 504; /* floatdisf2_internal1 */
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern333 (
E_SFmode))
            {
            case 0:
              if (!
#line 6217 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 417; /* *floatqisf2_internal */

            case 1:
              if (!
#line 6217 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 418; /* *floathisf2_internal */

            default:
              return -1;
            }

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5879 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 403; /* floatsidf2_lfiwax */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 6924 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT))
                    return 490; /* floatdidf2 */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 6975 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    {
                      *pnum_clobbers = 1;
                      return 499; /* *floatdidf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern333 (
E_DFmode))
            {
            case 0:
              if (!
#line 6217 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 419; /* *floatqidf2_internal */

            case 1:
              if (!
#line 6217 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 420; /* *floathidf2_internal */

            default:
              return -1;
            }

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_KFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6933 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 491; /* floattikf2 */
          if (!altivec_register_operand (operands[0], E_KFmode))
            return -1;
          switch (pattern334 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15319 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1159; /* float_kfdi2_hw */

            case 1:
              if (!(
#line 15328 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1161; /* float_kfsi2_hw */

            case 2:
              if (!(
#line 15347 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1163; /* floatqikf2 */

            case 3:
              if (!(
#line 15347 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1164; /* floathikf2 */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_TFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6933 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 492; /* floattitf2 */
          if (!altivec_register_operand (operands[0], E_TFmode))
            return -1;
          switch (pattern334 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15319 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1160; /* float_tfdi2_hw */

            case 1:
              if (!(
#line 15328 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1162; /* float_tfsi2_hw */

            case 2:
              if (!(
#line 15347 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1165; /* floatqitf2 */

            case 3:
              if (!(
#line 15347 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1166; /* floathitf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SFmode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && 
#line 2278 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1396; /* vsx_floatv4siv4sf2 */
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || !vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 2489 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1432; /* vsx_xvcvsxwsp */

        case E_V2DFmode:
          if (GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DFmode)
              && gpc_reg_operand (operands[1], E_V2DImode)
              && 
#line 2278 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1397; /* vsx_floatv2div2df2 */
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 2496 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1434; /* vsx_xvcvsxddp */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 217 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP && TARGET_POPCNTD))
            return -1;
          return 2446; /* floatdidd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !
#line 224 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2447; /* floatditd2 */

            case E_TImode:
              if (!gpc_reg_operand (operands[1], E_TImode)
                  || !
#line 232 "../../../gcc/config/rs6000/dfp.md"
(TARGET_POWER10))
                return -1;
              return 2448; /* floattitd2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern66 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5920 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS))
            return -1;
          *pnum_clobbers = 1;
          return 404; /* floatsisf2_lfiwax_mem */

        case 1:
          if (!
#line 5920 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID))
            return -1;
          *pnum_clobbers = 1;
          return 405; /* floatsidf2_lfiwax_mem */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern335 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5944 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 406; /* floatsisf2_lfiwax_qi_mem_zext */

            case 1:
              if (!
#line 5944 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 407; /* floatsisf2_lfiwax_hi_mem_zext */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern335 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 5944 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* floatsidf2_lfiwax_qi_mem_zext */

            case 1:
              if (!
#line 5944 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* floatsidf2_lfiwax_hi_mem_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FIX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (!
#line 6692 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND
   && flag_unsafe_math_optimizations && !flag_trapping_math && TARGET_FRIZ))
                return -1;
              return 468; /* *friz */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || !
#line 6711 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 2;
              return 470; /* *round32df2_fprs */

            default:
              return -1;
            }

        case E_SFmode:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || GET_MODE (x4) != E_SImode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 6711 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 469; /* *round32sf2_fprs */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || GET_MODE (x4) != E_V2DImode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 3117 "../../../gcc/config/rs6000/vsx.md"
(TARGET_HARD_FLOAT
   && VECTOR_UNIT_VSX_P (V2DFmode) && flag_unsafe_math_optimizations
   && !flag_trapping_math && TARGET_FRIZ))
            return -1;
          return 1454; /* *vsx_float_fix_v2df2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern68 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 2631 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1444; /* vsx_xvcvsxwdp_be */

        case 1:
          if (!
#line 2640 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1446; /* vsx_xvcvsxwdp_le */

        case 2:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4437 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 1;
              return 1569; /* *vsx_extract_si_float_df */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1588; /* *vsx_ext_SI_fl_df */

        case 3:
          if (!
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1580; /* *vsx_ext_QI_fl_df */

        case 4:
          if (!
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1584; /* *vsx_ext_HI_fl_df */

        case 5:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 2;
              return 1571; /* *vsx_extract_si_float_sf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1587; /* *vsx_ext_SI_fl_sf */

        case 6:
          if (!
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1579; /* *vsx_ext_QI_fl_sf */

        case 7:
          if (!
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1583; /* *vsx_ext_HI_fl_sf */

        case 8:
          if (!(
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          *pnum_clobbers = 2;
          return 1573; /* *vsx_extract_si_float_if */

        case 9:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            {
              *pnum_clobbers = 2;
              return 1575; /* *vsx_extract_si_float_kf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1589; /* *vsx_ext_SI_fl_kf */

        case 10:
          if (!(
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1581; /* *vsx_ext_QI_fl_kf */

        case 11:
          if (!(
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1585; /* *vsx_ext_HI_fl_kf */

        case 12:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            {
              *pnum_clobbers = 2;
              return 1577; /* *vsx_extract_si_float_tf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1590; /* *vsx_ext_SI_fl_tf */

        case 13:
          if (!(
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1582; /* *vsx_ext_QI_fl_tf */

        case 14:
          if (!(
#line 4543 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1586; /* *vsx_ext_HI_fl_tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 96; /* *one_cmplsi2 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 97; /* *one_cmpldi2 */

        case E_TImode:
          if (!vlogical_operand (operands[0], E_TImode)
              || GET_MODE (x2) != E_TImode
              || !vlogical_operand (operands[1], E_TImode))
            return -1;
          return 558; /* one_cmplti2 */

        case E_PTImode:
          if (!vlogical_operand (operands[0], E_PTImode)
              || GET_MODE (x2) != E_PTImode
              || !vlogical_operand (operands[1], E_PTImode))
            return -1;
          return 559; /* one_cmplpti2 */

        case E_V16QImode:
          if (!vlogical_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !vlogical_operand (operands[1], E_V16QImode)
              || !
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 560; /* one_cmplv16qi2 */

        case E_V8HImode:
          if (!vlogical_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !vlogical_operand (operands[1], E_V8HImode)
              || !
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 561; /* one_cmplv8hi2 */

        case E_V4SImode:
          if (!vlogical_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !vlogical_operand (operands[1], E_V4SImode)
              || !
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 562; /* one_cmplv4si2 */

        case E_V4SFmode:
          if (!vlogical_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !vlogical_operand (operands[1], E_V4SFmode)
              || !
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 563; /* one_cmplv4sf2 */

        case E_V2DImode:
          if (!vlogical_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !vlogical_operand (operands[1], E_V2DImode)
              || !
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 564; /* one_cmplv2di2 */

        case E_V2DFmode:
          if (!vlogical_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !vlogical_operand (operands[1], E_V2DFmode)
              || !
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 565; /* one_cmplv2df2 */

        case E_V1TImode:
          if (!vlogical_operand (operands[0], E_V1TImode)
              || GET_MODE (x2) != E_V1TImode
              || !vlogical_operand (operands[1], E_V1TImode)
              || !
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 566; /* one_cmplv1ti2 */

        default:
          return -1;
        }

    case XOR:
      return recog_4 (x1, insn, pnum_clobbers);

    case EQ:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern270 (x2, 
E_V16QImode) != 0
              || !
#line 5863 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1705; /* vcmpneb */

        case E_V8HImode:
          if (pattern270 (x2, 
E_V8HImode) != 0
              || !
#line 5913 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1708; /* vcmpneh */

        case E_V4SImode:
          if (pattern270 (x2, 
E_V4SImode) != 0
              || !
#line 5933 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1710; /* vcmpnew */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern5 (x1, pnum_clobbers))
    {
    case 0:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_register_operand (operands[1], E_SFmode)
          && vsx_register_operand (operands[2], E_SFmode)
          && 
#line 5488 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 338; /* *smaxsf3_vsx */
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !gpc_reg_operand (operands[2], E_SFmode)
          || !
#line 5515 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 346; /* *smaxsf3_fpr */

    case 1:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_register_operand (operands[1], E_DFmode)
          && vsx_register_operand (operands[2], E_DFmode)
          && 
#line 5488 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 340; /* *smaxdf3_vsx */
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !gpc_reg_operand (operands[2], E_DFmode)
          || !
#line 5515 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 348; /* *smaxdf3_fpr */

    case 2:
      if (!(
#line 5502 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 342; /* smaxkf3 */

    case 3:
      if (!(
#line 5502 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 344; /* smaxtf3 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2008 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1362; /* vsx_smaxv4sf3 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode)
          || !
#line 1089 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1945; /* *altivec_smaxv4sf3 */

    case 5:
      if (!
#line 2008 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1363; /* vsx_smaxv2df3 */

    case 6:
      if (!
#line 1081 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1941; /* smaxv4si3 */

    case 7:
      if (!
#line 1081 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
        return -1;
      return 1942; /* smaxv8hi3 */

    case 8:
      if (!
#line 1081 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
        return -1;
      return 1943; /* smaxv16qi3 */

    case 9:
      if (!
#line 1081 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
        return -1;
      return 1944; /* smaxv2di3 */

    case 10:
      if (!
#line 4927 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1637; /* vsx_reduc_smax_v2df */

    case 11:
      if (!
#line 4949 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1640; /* vsx_reduc_smax_v4sf */

    default:
      return -1;
    }
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != AND)
            return -1;
          switch (pattern183 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode))
                {
                  if (pnum_clobbers != NULL
                      && 
#line 3681 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
                    {
                      *pnum_clobbers = 1;
                      return 203; /* *andsi3_imm_dot2 */
                    }
                  if (
#line 3730 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                    return 207; /* *andsi3_imm_mask_dot2 */
                }
              if (!const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 3814 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                return 215; /* *andsi3_mask_dot2 */
              if (!
#line 3882 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
                return -1;
              return 221; /* *andsi3_2insn_dot2 */

            case 1:
              if (logical_const_operand (operands[2], E_DImode))
                {
                  if (pnum_clobbers != NULL
                      && (
#line 3681 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 1;
                      return 204; /* *anddi3_imm_dot2 */
                    }
                  if ((
#line 3730 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return 208; /* *anddi3_imm_mask_dot2 */
                }
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              if ((
#line 3814 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 216; /* *anddi3_mask_dot2 */
              if (!(
#line 3882 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 222; /* *anddi3_2insn_dot2 */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern179 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode)
                  && 
#line 3705 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                return 205; /* *andsi3_imm_mask_dot */
              if (!const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 3785 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                return 213; /* *andsi3_mask_dot */
              if (!
#line 3859 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
                return -1;
              return 219; /* *andsi3_2insn_dot */

            case 1:
              if (logical_const_operand (operands[2], E_DImode)
                  && (
#line 3705 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 206; /* *anddi3_imm_mask_dot */
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              if ((
#line 3785 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 214; /* *anddi3_mask_dot */
              if (!(
#line 3859 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 220; /* *anddi3_2insn_dot */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      if (GET_CODE (x5) == LSHIFTRT)
        {
          res = recog_153 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x6 = XEXP (x2, 0);
      operands[5] = x6;
      operands[4] = x5;
      switch (pattern513 (x1))
        {
        case 0:
          if (!
#line 4198 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          return 248; /* *rotlsi3_mask_dot */

        case 1:
          if (!(
#line 4198 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 249; /* *rotldi3_mask_dot */

        case 2:
          if (!
#line 4230 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          return 250; /* *rotlsi3_mask_dot2 */

        case 3:
          if (!(
#line 4230 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 251; /* *rotldi3_mask_dot2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 0);
      operands[3] = x8;
      if (!scratch_operand (operands[3], E_CCmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern498 (x4, 
E_SImode) != 0
              || !
#line 3642 "../../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], SImode)))
            return -1;
          return 199; /* andsi3_imm */

        case E_DImode:
          if (pattern498 (x4, 
E_DImode) != 0
              || !(
#line 3642 "../../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 200; /* anddi3_imm */

        default:
          return -1;
        }

    case AND:
      switch (pattern247 (x1))
        {
        case 0:
          if (!
#line 367 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2531; /* *fuse_and_and */

        case 1:
          if (!(
#line 367 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2532; /* *fuse_and_and */

        case 2:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2699; /* *fuse_vand_vand */

        case 3:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2700; /* *fuse_vand_vand */

        case 4:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2701; /* *fuse_vand_vand */

        case 5:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2702; /* *fuse_vand_vand */

        case 6:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2703; /* *fuse_vand_vand */

        case 7:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2704; /* *fuse_vand_vand */

        case 8:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2705; /* *fuse_vand_vand */

        case 9:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2706; /* *fuse_vand_vand */

        case 10:
          if (!(
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2707; /* *fuse_vand_vand */

        case 11:
          if (!(
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2708; /* *fuse_vand_vand */

        case 12:
          if (!
#line 547 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2551; /* *fuse_and_andc */

        case 13:
          if (!(
#line 547 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2552; /* *fuse_and_andc */

        case 14:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2779; /* *fuse_vand_vandc */

        case 15:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2780; /* *fuse_vand_vandc */

        case 16:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2781; /* *fuse_vand_vandc */

        case 17:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2782; /* *fuse_vand_vandc */

        case 18:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2783; /* *fuse_vand_vandc */

        case 19:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2784; /* *fuse_vand_vandc */

        case 20:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2785; /* *fuse_vand_vandc */

        case 21:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2786; /* *fuse_vand_vandc */

        case 22:
          if (!(
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2787; /* *fuse_vand_vandc */

        case 23:
          if (!(
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2788; /* *fuse_vand_vandc */

        case 24:
          if (!
#line 385 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2533; /* *fuse_andc_and */

        case 25:
          if (!(
#line 385 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2534; /* *fuse_andc_and */

        case 26:
          if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2709; /* *fuse_vandc_vand */

        case 27:
          if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2710; /* *fuse_vandc_vand */

        case 28:
          if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2711; /* *fuse_vandc_vand */

        case 29:
          if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2712; /* *fuse_vandc_vand */

        case 30:
          if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2713; /* *fuse_vandc_vand */

        case 31:
          if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2714; /* *fuse_vandc_vand */

        case 32:
          if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2715; /* *fuse_vandc_vand */

        case 33:
          if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2716; /* *fuse_vandc_vand */

        case 34:
          if (!(
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2717; /* *fuse_vandc_vand */

        case 35:
          if (!(
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2718; /* *fuse_vandc_vand */

        case 36:
          if (!
#line 565 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2553; /* *fuse_andc_andc */

        case 37:
          if (!(
#line 565 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2554; /* *fuse_andc_andc */

        case 38:
          if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2789; /* *fuse_vandc_vandc */

        case 39:
          if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2790; /* *fuse_vandc_vandc */

        case 40:
          if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2791; /* *fuse_vandc_vandc */

        case 41:
          if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2792; /* *fuse_vandc_vandc */

        case 42:
          if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2793; /* *fuse_vandc_vandc */

        case 43:
          if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2794; /* *fuse_vandc_vandc */

        case 44:
          if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2795; /* *fuse_vandc_vandc */

        case 45:
          if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2796; /* *fuse_vandc_vandc */

        case 46:
          if (!(
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2797; /* *fuse_vandc_vandc */

        case 47:
          if (!(
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2798; /* *fuse_vandc_vandc */

        case 48:
          if (!
#line 439 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2539; /* *fuse_nor_and */

        case 49:
          if (!(
#line 439 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2540; /* *fuse_nor_and */

        case 50:
          if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2739; /* *fuse_vnor_vand */

        case 51:
          if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2740; /* *fuse_vnor_vand */

        case 52:
          if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2741; /* *fuse_vnor_vand */

        case 53:
          if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2742; /* *fuse_vnor_vand */

        case 54:
          if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2743; /* *fuse_vnor_vand */

        case 55:
          if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2744; /* *fuse_vnor_vand */

        case 56:
          if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2745; /* *fuse_vnor_vand */

        case 57:
          if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2746; /* *fuse_vnor_vand */

        case 58:
          if (!(
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2747; /* *fuse_vnor_vand */

        case 59:
          if (!(
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2748; /* *fuse_vnor_vand */

        case 60:
          if (!
#line 619 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2559; /* *fuse_nor_andc */

        case 61:
          if (!(
#line 619 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2560; /* *fuse_nor_andc */

        case 62:
          if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2819; /* *fuse_vnor_vandc */

        case 63:
          if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2820; /* *fuse_vnor_vandc */

        case 64:
          if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2821; /* *fuse_vnor_vandc */

        case 65:
          if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2822; /* *fuse_vnor_vandc */

        case 66:
          if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2823; /* *fuse_vnor_vandc */

        case 67:
          if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2824; /* *fuse_vnor_vandc */

        case 68:
          if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2825; /* *fuse_vnor_vandc */

        case 69:
          if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2826; /* *fuse_vnor_vandc */

        case 70:
          if (!(
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2827; /* *fuse_vnor_vandc */

        case 71:
          if (!(
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2828; /* *fuse_vnor_vandc */

        default:
          return -1;
        }

    case NOT:
      return recog_162 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 421 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2537; /* *fuse_nand_and */

        case 1:
          if (!(
#line 421 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2538; /* *fuse_nand_and */

        case 2:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2729; /* *fuse_vnand_vand */

        case 3:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2730; /* *fuse_vnand_vand */

        case 4:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2731; /* *fuse_vnand_vand */

        case 5:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2732; /* *fuse_vnand_vand */

        case 6:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2733; /* *fuse_vnand_vand */

        case 7:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2734; /* *fuse_vnand_vand */

        case 8:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2735; /* *fuse_vnand_vand */

        case 9:
          if (!
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2736; /* *fuse_vnand_vand */

        case 10:
          if (!(
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2737; /* *fuse_vnand_vand */

        case 11:
          if (!(
#line 1933 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2738; /* *fuse_vnand_vand */

        case 12:
          if (!
#line 601 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2557; /* *fuse_nand_andc */

        case 13:
          if (!(
#line 601 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2558; /* *fuse_nand_andc */

        case 14:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2809; /* *fuse_vnand_vandc */

        case 15:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2810; /* *fuse_vnand_vandc */

        case 16:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2811; /* *fuse_vnand_vandc */

        case 17:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2812; /* *fuse_vnand_vandc */

        case 18:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2813; /* *fuse_vnand_vandc */

        case 19:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2814; /* *fuse_vnand_vandc */

        case 20:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2815; /* *fuse_vnand_vandc */

        case 21:
          if (!
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2816; /* *fuse_vnand_vandc */

        case 22:
          if (!(
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2817; /* *fuse_vnand_vandc */

        case 23:
          if (!(
#line 2077 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2818; /* *fuse_vnand_vandc */

        case 24:
          if (!
#line 475 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2543; /* *fuse_orc_and */

        case 25:
          if (!(
#line 475 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2544; /* *fuse_orc_and */

        case 26:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2759; /* *fuse_vorc_vand */

        case 27:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2760; /* *fuse_vorc_vand */

        case 28:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2761; /* *fuse_vorc_vand */

        case 29:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2762; /* *fuse_vorc_vand */

        case 30:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2763; /* *fuse_vorc_vand */

        case 31:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2764; /* *fuse_vorc_vand */

        case 32:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2765; /* *fuse_vorc_vand */

        case 33:
          if (!
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2766; /* *fuse_vorc_vand */

        case 34:
          if (!(
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2767; /* *fuse_vorc_vand */

        case 35:
          if (!(
#line 1987 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2768; /* *fuse_vorc_vand */

        case 36:
          if (!
#line 655 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2563; /* *fuse_orc_andc */

        case 37:
          if (!(
#line 655 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2564; /* *fuse_orc_andc */

        case 38:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2839; /* *fuse_vorc_vandc */

        case 39:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2840; /* *fuse_vorc_vandc */

        case 40:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2841; /* *fuse_vorc_vandc */

        case 41:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2842; /* *fuse_vorc_vandc */

        case 42:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2843; /* *fuse_vorc_vandc */

        case 43:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2844; /* *fuse_vorc_vandc */

        case 44:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2845; /* *fuse_vorc_vandc */

        case 45:
          if (!
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2846; /* *fuse_vorc_vandc */

        case 46:
          if (!(
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2847; /* *fuse_vorc_vandc */

        case 47:
          if (!(
#line 2131 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2848; /* *fuse_vorc_vandc */

        case 48:
          if (!
#line 457 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2541; /* *fuse_or_and */

        case 49:
          if (!(
#line 457 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2542; /* *fuse_or_and */

        case 50:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2749; /* *fuse_vor_vand */

        case 51:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2750; /* *fuse_vor_vand */

        case 52:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2751; /* *fuse_vor_vand */

        case 53:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2752; /* *fuse_vor_vand */

        case 54:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2753; /* *fuse_vor_vand */

        case 55:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2754; /* *fuse_vor_vand */

        case 56:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2755; /* *fuse_vor_vand */

        case 57:
          if (!
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2756; /* *fuse_vor_vand */

        case 58:
          if (!(
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2757; /* *fuse_vor_vand */

        case 59:
          if (!(
#line 1969 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2758; /* *fuse_vor_vand */

        case 60:
          if (!
#line 637 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2561; /* *fuse_or_andc */

        case 61:
          if (!(
#line 637 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2562; /* *fuse_or_andc */

        case 62:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2829; /* *fuse_vor_vandc */

        case 63:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2830; /* *fuse_vor_vandc */

        case 64:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2831; /* *fuse_vor_vandc */

        case 65:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2832; /* *fuse_vor_vandc */

        case 66:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2833; /* *fuse_vor_vandc */

        case 67:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2834; /* *fuse_vor_vandc */

        case 68:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2835; /* *fuse_vor_vandc */

        case 69:
          if (!
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2836; /* *fuse_vor_vandc */

        case 70:
          if (!(
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2837; /* *fuse_vor_vandc */

        case 71:
          if (!(
#line 2113 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2838; /* *fuse_vor_vandc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern249 (x1))
        {
        case 0:
          if (!
#line 493 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2545; /* *fuse_xor_and */

        case 1:
          if (!(
#line 493 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2546; /* *fuse_xor_and */

        case 2:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2769; /* *fuse_vxor_vand */

        case 3:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2770; /* *fuse_vxor_vand */

        case 4:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2771; /* *fuse_vxor_vand */

        case 5:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2772; /* *fuse_vxor_vand */

        case 6:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2773; /* *fuse_vxor_vand */

        case 7:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2774; /* *fuse_vxor_vand */

        case 8:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2775; /* *fuse_vxor_vand */

        case 9:
          if (!
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2776; /* *fuse_vxor_vand */

        case 10:
          if (!(
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2777; /* *fuse_vxor_vand */

        case 11:
          if (!(
#line 2005 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2778; /* *fuse_vxor_vand */

        case 12:
          if (!
#line 673 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2565; /* *fuse_xor_andc */

        case 13:
          if (!(
#line 673 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2566; /* *fuse_xor_andc */

        case 14:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2849; /* *fuse_vxor_vandc */

        case 15:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2850; /* *fuse_vxor_vandc */

        case 16:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2851; /* *fuse_vxor_vandc */

        case 17:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2852; /* *fuse_vxor_vandc */

        case 18:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2853; /* *fuse_vxor_vandc */

        case 19:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2854; /* *fuse_vxor_vandc */

        case 20:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2855; /* *fuse_vxor_vandc */

        case 21:
          if (!
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2856; /* *fuse_vxor_vandc */

        case 22:
          if (!(
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2857; /* *fuse_vxor_vandc */

        case 23:
          if (!(
#line 2149 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2858; /* *fuse_vxor_vandc */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern251 (x1))
        {
        case 0:
          if (!
#line 511 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2547; /* *fuse_add_and */

        case 1:
          if (!(
#line 511 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2548; /* *fuse_add_and */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern251 (x1))
        {
        case 0:
          if (!
#line 529 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2549; /* *fuse_subf_and */

        case 1:
          if (!(
#line 529 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2550; /* *fuse_subf_and */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_193 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_186 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_188 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          if (pattern16 (x1) == 0
              && 
#line 6081 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFID && TARGET_HARD_FLOAT))
            return 415; /* *floatsidf2_internal */
          break;

        case 5:
          res = recog_189 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_190 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 10:
          switch (pattern18 (x1))
            {
            case 0:
              if ((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return 882; /* *cmpif_internal2 */
              break;

            case 1:
              if ((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 883; /* *cmpif_internal2 */
              break;

            case 2:
              if ((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return 884; /* *cmptf_internal2 */
              break;

            case 3:
              if ((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 885; /* *cmptf_internal2 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 1)
        {
          res = recog_191 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 4
          && any_parallel_operand (operands[0], E_VOIDmode))
        {
          res = recog_192 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) < 5
          || !any_parallel_operand (operands[0], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x2) != USE)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x5))
        {
        case RETURN:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 96)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != USE)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x4, 0);
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          switch (REGNO (x3))
            {
            case 11:
              switch (pattern565 (x1))
                {
                case 0:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1028; /* *return_and_restore_gpregs_si_r11 */

                case 1:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1034; /* *return_and_restore_fpregs_si_r11 */

                case 2:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1029; /* *return_and_restore_gpregs_di_r11 */

                case 3:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1035; /* *return_and_restore_fpregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern565 (x1))
                {
                case 0:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1030; /* *return_and_restore_gpregs_si_r12 */

                case 1:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1036; /* *return_and_restore_fpregs_si_r12 */

                case 2:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1031; /* *return_and_restore_gpregs_di_r12 */

                case 3:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1037; /* *return_and_restore_fpregs_di_r12 */

                default:
                  return -1;
                }

            case 1:
              switch (pattern565 (x1))
                {
                case 0:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1032; /* *return_and_restore_gpregs_si_r1 */

                case 1:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1038; /* *return_and_restore_fpregs_si_r1 */

                case 2:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1033; /* *return_and_restore_gpregs_di_r1 */

                case 3:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1039; /* *return_and_restore_fpregs_di_r1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CLOBBER:
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 96)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x3) != 0)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          switch (REGNO (x9))
            {
            case 11:
              switch (pattern568 (x1))
                {
                case 0:
                  if (!(
#line 461 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1811; /* *save_vregs_si_r11 */

                case 1:
                  if (!(
#line 461 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1812; /* *save_vregs_di_r11 */

                case 2:
                  if (!(
#line 487 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1815; /* *restore_vregs_si_r11 */

                case 3:
                  if (!(
#line 487 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1816; /* *restore_vregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern568 (x1))
                {
                case 0:
                  if (!(
#line 474 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1813; /* *save_vregs_si_r12 */

                case 1:
                  if (!(
#line 474 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1814; /* *save_vregs_di_r12 */

                case 2:
                  if (!(
#line 500 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1817; /* *restore_vregs_si_r12 */

                case 3:
                  if (!(
#line 500 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1818; /* *restore_vregs_di_r12 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 15:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 459; /* rs6000_mtfsb0 */

            case 16:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6518 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 460; /* rs6000_mtfsb1 */

            case 0:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 867; /* blockage */

            case 18:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 989; /* speculation_barrier */

            case 4:
              if (pnum_clobbers == NULL)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1044; /* eh_set_lr_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1045; /* eh_set_lr_di */

                default:
                  return -1;
                }

            case 5:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                  if (XWINT (x5, 0) != 0L)
                    return -1;
                  return 1216; /* isync */

                case REG:
                case SUBREG:
                  if (pnum_clobbers == NULL)
                    return -1;
                  operands[0] = x5;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1217; /* loadsync_qi */

                    case E_HImode:
                      if (!register_operand (operands[0], E_HImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1218; /* loadsync_hi */

                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1219; /* loadsync_si */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 111 "../../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1220; /* loadsync_di */

                    case E_TImode:
                      if (!register_operand (operands[0], E_TImode)
                          || !
#line 112 "../../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1221; /* loadsync_ti */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 24:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2951 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2161; /* altivec_dssall */

            case 25:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!immediate_operand (operands[0], E_QImode)
                  || !
#line 2958 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2162; /* altivec_dss */

            default:
              return -1;
            }

        case 2:
          switch (XINT (x1, 1))
            {
            case 17:
              x5 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 0
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 96
                  || GET_MODE (x6) != E_SImode)
                return -1;
              return 1050; /* split_stack_return */

            case 13:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14688 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1066; /* rs6000_mtfsf */

            case 14:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14695 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1067; /* rs6000_mtfsf_hi */

            case 96:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!int_reg_operand (operands[0], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!simple_offsettable_mem_operand (operands[1], E_DImode)
                  || !
#line 15858 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_rop_protect))
                return -1;
              return 1213; /* hashchk */

            case 39:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!u10bit_cint_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!gpc_reg_operand (operands[0], E_SImode)
                      || !
#line 280 "../../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                    return -1;
                  return 2507; /* htm_mtspr_si */

                case E_DImode:
                  if (!gpc_reg_operand (operands[0], E_DImode)
                      || !(
#line 280 "../../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2508; /* htm_mtspr_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!
#line 13515 "../../../gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 977; /* return */

    case SIMPLE_RETURN:
      return 978; /* simple_return */

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          x5 = XVECEXP (x1, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (XINT (x1, 1))
            {
            case 57:
              return 987; /* nop */

            case 58:
              return 988; /* group_ending_nop */

            default:
              return -1;
            }

        case 3:
          x5 = XVECEXP (x1, 0, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          operands[2] = x8;
          if (!immediate_operand (operands[2], E_QImode))
            return -1;
          switch (XINT (x1, 1))
            {
            case 272:
              if (!
#line 2966 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2163; /* altivec_dst */

            case 273:
              if (!
#line 2974 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2164; /* altivec_dstt */

            case 274:
              if (!
#line 2982 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2165; /* altivec_dstst */

            case 275:
              if (!
#line 2990 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2166; /* altivec_dststt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x13 = XEXP (x1, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x1, 0);
      switch (GET_CODE (x14))
        {
        case CONST_INT:
          if (XWINT (x14, 0) != 1L)
            return -1;
          return 998; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[0] = x14;
          if (!ordered_comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          x16 = XEXP (x14, 1);
          operands[2] = x16;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !reg_or_short_operand (operands[2], E_SImode))
                return -1;
              return 999; /* *rs6000.md:13918 */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !reg_or_short_operand (operands[2], E_DImode)
                  || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 1000; /* *rs6000.md:13918 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EH_RETURN:
      return 1046; /* eh_return_internal */

    case PREFETCH:
      x14 = XEXP (x1, 0);
      operands[0] = x14;
      if (!indexed_or_indirect_address (operands[0], E_VOIDmode))
        return -1;
      x13 = XEXP (x1, 1);
      operands[1] = x13;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x1, 2);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 1047; /* prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IOR:
      res = split_10 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern263 (x2))
            {
            case 0:
              return gen_split_86 (insn, operands);

            case 1:
              if (
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return gen_split_88 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case AND:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == ASHIFT)
            {
              switch (pattern219 (x2))
                {
                case 0:
                  if ((
#line 4333 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 4336 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_106 (insn, operands);
                  break;

                case 1:
                  if (((
#line 4333 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4336 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_108 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case ASHIFT:
          switch (pattern207 (x2))
            {
            case 0:
              if (
#line 4348 "../../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                return gen_split_111 (insn, operands);
              break;

            case 1:
              if ((
#line 4348 "../../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return gen_split_114 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pattern358 (
E_TImode) != 0
          || !
#line 7424 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
        return NULL;
      return gen_split_239 (insn, operands);

    case E_PTImode:
      if (pattern358 (
E_PTImode) != 0
          || !
#line 7424 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
        return NULL;
      return gen_split_240 (insn, operands);

    case E_V16QImode:
      if (pattern358 (
E_V16QImode) != 0
          || !(
#line 7424 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_241 (insn, operands);

    case E_V8HImode:
      if (pattern358 (
E_V8HImode) != 0
          || !(
#line 7424 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_242 (insn, operands);

    case E_V4SImode:
      if (pattern358 (
E_V4SImode) != 0
          || !(
#line 7424 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_243 (insn, operands);

    case E_V4SFmode:
      if (pattern358 (
E_V4SFmode) != 0
          || !(
#line 7424 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_244 (insn, operands);

    case E_V2DImode:
      if (pattern358 (
E_V2DImode) != 0
          || !(
#line 7424 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_245 (insn, operands);

    case E_V2DFmode:
      if (pattern358 (
E_V2DFmode) != 0
          || !(
#line 7424 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_246 (insn, operands);

    case E_V1TImode:
      if (pattern358 (
E_V1TImode) != 0
          || !(
#line 7424 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_247 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = split_9 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case IOR:
    case XOR:
      res = split_11 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT)
    return NULL;
  operands[3] = x3;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!boolean_operator (operands[3], E_TImode)
              || GET_MODE (x4) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && 
#line 7461 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], TImode)))
            return gen_split_248 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !
#line 7490 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_257 (insn, operands);

        case E_PTImode:
          if (!boolean_operator (operands[3], E_PTImode)
              || GET_MODE (x4) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && 
#line 7461 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], PTImode)))
            return gen_split_249 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !
#line 7490 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_258 (insn, operands);

        case E_V16QImode:
          if (pattern373 (x4, 
E_V16QImode) != 0
              || !(
#line 7461 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_250 (insn, operands);

        case E_V8HImode:
          if (pattern373 (x4, 
E_V8HImode) != 0
              || !(
#line 7461 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_251 (insn, operands);

        case E_V4SImode:
          if (pattern373 (x4, 
E_V4SImode) != 0
              || !(
#line 7461 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_252 (insn, operands);

        case E_V4SFmode:
          if (pattern373 (x4, 
E_V4SFmode) != 0
              || !(
#line 7461 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_253 (insn, operands);

        case E_V2DImode:
          if (pattern373 (x4, 
E_V2DImode) != 0
              || !(
#line 7461 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_254 (insn, operands);

        case E_V2DFmode:
          if (pattern373 (x4, 
E_V2DFmode) != 0
              || !(
#line 7461 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_255 (insn, operands);

        case E_V1TImode:
          if (pattern373 (x4, 
E_V1TImode) != 0
              || !(
#line 7461 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_256 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!boolean_operator (operands[3], E_TImode)
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7521 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], TImode)))
            return gen_split_259 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7551 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_268 (insn, operands);

        case E_PTImode:
          if (!boolean_operator (operands[3], E_PTImode)
              || GET_MODE (x4) != E_PTImode
              || GET_MODE (x5) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7521 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], PTImode)))
            return gen_split_260 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7551 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_269 (insn, operands);

        case E_V16QImode:
          if (pattern376 (x3, 
E_V16QImode) != 0
              || !(
#line 7521 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_261 (insn, operands);

        case E_V8HImode:
          if (pattern376 (x3, 
E_V8HImode) != 0
              || !(
#line 7521 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_262 (insn, operands);

        case E_V4SImode:
          if (pattern376 (x3, 
E_V4SImode) != 0
              || !(
#line 7521 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_263 (insn, operands);

        case E_V4SFmode:
          if (pattern376 (x3, 
E_V4SFmode) != 0
              || !(
#line 7521 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_264 (insn, operands);

        case E_V2DImode:
          if (pattern376 (x3, 
E_V2DImode) != 0
              || !(
#line 7521 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_265 (insn, operands);

        case E_V2DFmode:
          if (pattern376 (x3, 
E_V2DFmode) != 0
              || !(
#line 7521 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_266 (insn, operands);

        case E_V1TImode:
          if (pattern376 (x3, 
E_V1TImode) != 0
              || !(
#line 7521 "../../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_267 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2)
    return NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return peephole2_2 (x1, insn, pmatch_len_);

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 3
          || pattern265 (x1, 
E_V1TImode, 
E_CCFPmode, 
106) != 0)
        return NULL;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1TImode))
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1TImode))
        return NULL;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_1_operand (operands[3], E_QImode))
        return NULL;
      x7 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 2)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_CODE (x8) != SET)
        return NULL;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != COMPARE
          || GET_MODE (x9) != E_CCFPmode)
        return NULL;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != UNSPEC
          || XVECLEN (x10, 0) != 3
          || GET_MODE (x10) != E_V2DFmode)
        return NULL;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 106
          || GET_MODE (x11) != E_CCFPmode)
        return NULL;
      x12 = XVECEXP (x7, 0, 1);
      if (GET_CODE (x12) != CLOBBER)
        return NULL;
      x13 = XEXP (x9, 1);
      operands[4] = x13;
      if (!zero_constant (operands[4], E_V2DFmode))
        return NULL;
      x14 = XEXP (x12, 0);
      operands[5] = x14;
      if (!register_operand (operands[5], E_V1TImode))
        return NULL;
      x15 = XVECEXP (x10, 0, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return NULL;
      x16 = XVECEXP (x10, 0, 1);
      if (!rtx_equal_p (x16, operands[2]))
        return NULL;
      x17 = XVECEXP (x10, 0, 2);
      if (!rtx_equal_p (x17, operands[3]))
        return NULL;
      switch (XINT (x3, 1))
        {
        case 342:
          if (XINT (x10, 1) != 342
              || !
#line 4819 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_42 (insn, operands);

        case 343:
          if (XINT (x10, 1) != 343
              || !
#line 4819 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_43 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
