/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!vfloat_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!vfloat_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x1, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != FLOAT
      || GET_MODE (x3) != E_DFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  if (!gpc_reg_operand (operands[0], E_DFmode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[1] = x10;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x4, 0);
  operands[2] = x11;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[3] = x12;
  if (!gpc_reg_operand (operands[3], E_DFmode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[4] = x13;
  if (!offsettable_mem_operand (operands[4], E_DFmode))
    return -1;
  x14 = XEXP (x7, 0);
  operands[5] = x14;
  if (!gpc_reg_operand (operands[5], E_DFmode))
    return -1;
  x15 = XEXP (x8, 0);
  operands[6] = x15;
  if (!gpc_reg_operand (operands[6], E_SImode))
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case PLUS:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      return pattern33 (x1); /* [-1, 1] */

    case REG:
    case SUBREG:
      operands[1] = x2;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern42 (x3); /* [-1, 1] */

    case NOT:
      res = pattern44 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode)
          || !const_int_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode)
          || !const_int_operand (operands[2], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2DFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT
      || GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_DFmode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x4, 1);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_DFmode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!vfloat_operand (operands[0], E_V2DFmode)
      || pattern82 (x1) != 0)
    return -1;
  return 0;
}

int
pattern98 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || pattern104 (
E_SImode) != 0)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (pattern104 (
E_DImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern104 (
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  return 0;
}

int
pattern128 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return pattern127 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      res = pattern127 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode)
          || !altivec_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode)
          || !altivec_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode)
          || !altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!altivec_register_operand (operands[1], E_V2DImode)
          || !altivec_register_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern174 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern174 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern182 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  if (!cc_reg_operand (operands[3], E_CCmode))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern191 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern191 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern203 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern202 (x1, 
i1); /* [-1, 3] */
}

int
pattern208 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 445)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern232 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  return pattern236 (x1); /* [-1, 23] */
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern232 (x4, 
i1); /* [-1, 0] */
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      return pattern237 (x6); /* [-1, 23] */

    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          res = pattern242 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        case NOT:
          res = pattern246 (x6);
          if (res >= 0)
            return res + 48; /* [48, 71] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 3)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 96)
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !non_logical_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern266 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern274 (x1); /* [-1, 11] */

    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          res = pattern277 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        case NOT:
          res = pattern280 (x1);
          if (res >= 0)
            return res + 24; /* [24, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern312 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern322 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern333 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern349 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], E_V8HImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8HImode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[3] = x9;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern366 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1)
      || !vsx_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern372 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern387 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern394 (x4, 
i1); /* [-1, 0] */
}

int
pattern404 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern417 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !rs6000_tls_symbol_ref (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern419 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern426 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode)
          || !zero_fp_constant (operands[4], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !zero_fp_constant (operands[4], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern436 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode
      || !register_operand (operands[0], E_V2DImode)
      || !register_operand (operands[1], E_V2DImode)
      || !register_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern440 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != MULT
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || GET_MODE (x4) != E_SImode)
    return -1;
  x11 = XEXP (x5, 0);
  if (!gpc_reg_operand (x11, E_SImode))
    return -1;
  x12 = XEXP (x4, 1);
  if (GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x7, 0);
  operands[0] = x13;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x8, 1);
  if (GET_MODE (x14) != E_SImode)
    return -1;
  return 0;
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_zero_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[4], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[4], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern467 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern466 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_DImode:
      if (pattern466 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern479 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode)
          || !scratch_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !scratch_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !scratch_operand (operands[2], i1))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !scratch_operand (operands[2], i1))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern491 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern498 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern504 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!vsx_register_operand (operands[2], E_SFmode)
          || !vsx_register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!vsx_register_operand (operands[2], E_DFmode)
          || !vsx_register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern512 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern520 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern528 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern535 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_reg_operand (operands[1], E_XOmode)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !vsx_register_operand (operands[3], E_V16QImode)
      || !const_0_to_15_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern540 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !d_form_memory (operands[1], i1)
      || !int_reg_operand (operands[2], E_DImode)
      || !scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern545 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || pattern374 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern552 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          return pattern551 (x7, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_QImode:
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern572 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern571 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern571 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern584 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], E_V2DFmode)
      || !vsx_register_operand (operands[2], E_V2DFmode)
      || !vsx_register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  return 0;
}

int
pattern591 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[0], i1)
      || !memory_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern601 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x6, 0);
  if (!gpc_reg_operand (x13, E_SImode))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern326 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5618 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 369; /* *setnbc_cc_si */

        case 1:
          if (!
#line 5618 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 371; /* *setnbc_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern326 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5618 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 370; /* *setnbc_cc_di */

        case 1:
          if (!(
#line 5618 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 372; /* *setnbc_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      res = recog_10 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_CODE (x3))
    {
    case GE:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern426 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5652 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 377; /* *fselsfsf4 */

            case 1:
              if (!
#line 5652 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 379; /* *fselsfdf4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern426 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5652 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 378; /* *fseldfsf4 */

            case 1:
              if (!
#line 5652 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 380; /* *fseldfdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case UNLE:
    case UNLT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      x8 = XEXP (x2, 2);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern505 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 385; /* *movsfsfcc_invert_p9 */

            case 1:
              if (!
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 387; /* *movsfdfcc_invert_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern505 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 386; /* *movdfsfcc_invert_p9 */

            case 1:
              if (!
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 388; /* *movdfdfcc_invert_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern506 (x2, 
E_KFmode) != 0
              || !(
#line 5802 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 395; /* *movkfcc_invert_p10 */

        case E_TFmode:
          if (pattern506 (x2, 
E_TFmode) != 0
              || !(
#line 5802 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 396; /* *movtfcc_invert_p10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case AND:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern489 (x2, 
E_V4SImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V4SImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1868; /* altivec_vselv4si */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V4SImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                return -1;
              return 1878; /* altivec_vselv4si2 */

            case E_V8HImode:
              if (pattern489 (x2, 
E_V8HImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V8HImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1869; /* altivec_vselv8hi */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V8HImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                return -1;
              return 1879; /* altivec_vselv8hi2 */

            case E_V16QImode:
              if (pattern489 (x2, 
E_V16QImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V16QImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1870; /* altivec_vselv16qi */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V16QImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                return -1;
              return 1880; /* altivec_vselv16qi2 */

            case E_V4SFmode:
              if (pattern489 (x2, 
E_V4SFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V4SFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1871; /* altivec_vselv4sf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                return -1;
              return 1881; /* altivec_vselv4sf2 */

            case E_V2DFmode:
              if (pattern489 (x2, 
E_V2DFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V2DFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1872; /* altivec_vselv2df */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V2DFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                return -1;
              return 1882; /* altivec_vselv2df2 */

            case E_V2DImode:
              if (pattern489 (x2, 
E_V2DImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V2DImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1873; /* altivec_vselv2di */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V2DImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                return -1;
              return 1883; /* altivec_vselv2di2 */

            case E_V1TImode:
              if (pattern489 (x2, 
E_V1TImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V1TImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1874; /* altivec_vselv1ti */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V1TImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                return -1;
              return 1884; /* altivec_vselv1ti2 */

            case E_TImode:
              if (pattern489 (x2, 
E_TImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_TImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1875; /* altivec_vselti */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_TImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                return -1;
              return 1885; /* altivec_vselti2 */

            case E_KFmode:
              if (pattern489 (x2, 
E_KFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_KFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && (
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1876; /* altivec_vselkf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_KFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !(
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 1886; /* altivec_vselkf2 */

            case E_TFmode:
              if (pattern489 (x2, 
E_TFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_TFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && (
#line 703 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1877; /* altivec_vseltf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_TFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !(
#line 719 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 1887; /* altivec_vseltf2 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern53 (x2, 
E_SImode) != 0
                  || !
#line 1213 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2625; /* *fuse_andc_or */

            case E_DImode:
              if (pattern53 (x2, 
E_DImode) != 0
                  || !(
#line 1213 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2626; /* *fuse_andc_or */

            case E_V4SImode:
              if (pattern54 (x2, 
E_V4SImode) != 0
                  || !
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3109; /* *fuse_vandc_vor */

            case E_V8HImode:
              if (pattern54 (x2, 
E_V8HImode) != 0
                  || !
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3110; /* *fuse_vandc_vor */

            case E_V16QImode:
              if (pattern54 (x2, 
E_V16QImode) != 0
                  || !
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3111; /* *fuse_vandc_vor */

            case E_V4SFmode:
              if (pattern54 (x2, 
E_V4SFmode) != 0
                  || !
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3112; /* *fuse_vandc_vor */

            case E_V2DFmode:
              if (pattern54 (x2, 
E_V2DFmode) != 0
                  || !
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3113; /* *fuse_vandc_vor */

            case E_V2DImode:
              if (pattern54 (x2, 
E_V2DImode) != 0
                  || !
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3114; /* *fuse_vandc_vor */

            case E_V1TImode:
              if (pattern54 (x2, 
E_V1TImode) != 0
                  || !
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3115; /* *fuse_vandc_vor */

            case E_TImode:
              if (pattern54 (x2, 
E_TImode) != 0
                  || !
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3116; /* *fuse_vandc_vor */

            case E_KFmode:
              if (pattern54 (x2, 
E_KFmode) != 0
                  || !(
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3117; /* *fuse_vandc_vor */

            case E_TFmode:
              if (pattern54 (x2, 
E_TFmode) != 0
                  || !(
#line 2617 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3118; /* *fuse_vandc_vor */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (pattern57 (x2))
            {
            case 0:
              if (!
#line 1393 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2645; /* *fuse_andc_orc */

            case 1:
              if (!(
#line 1393 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2646; /* *fuse_andc_orc */

            case 2:
              if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3189; /* *fuse_vandc_vorc */

            case 3:
              if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3190; /* *fuse_vandc_vorc */

            case 4:
              if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3191; /* *fuse_vandc_vorc */

            case 5:
              if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3192; /* *fuse_vandc_vorc */

            case 6:
              if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3193; /* *fuse_vandc_vorc */

            case 7:
              if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3194; /* *fuse_vandc_vorc */

            case 8:
              if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3195; /* *fuse_vandc_vorc */

            case 9:
              if (!
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3196; /* *fuse_vandc_vorc */

            case 10:
              if (!(
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3197; /* *fuse_vandc_vorc */

            case 11:
              if (!(
#line 2761 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3198; /* *fuse_vandc_vorc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x3, 0);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (pattern52 (x2))
        {
        case 0:
          if (!
#line 1267 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2631; /* *fuse_nor_or */

        case 1:
          if (!(
#line 1267 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2632; /* *fuse_nor_or */

        case 2:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3139; /* *fuse_vnor_vor */

        case 3:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3140; /* *fuse_vnor_vor */

        case 4:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3141; /* *fuse_vnor_vor */

        case 5:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3142; /* *fuse_vnor_vor */

        case 6:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3143; /* *fuse_vnor_vor */

        case 7:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3144; /* *fuse_vnor_vor */

        case 8:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3145; /* *fuse_vnor_vor */

        case 9:
          if (!
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3146; /* *fuse_vnor_vor */

        case 10:
          if (!(
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3147; /* *fuse_vnor_vor */

        case 11:
          if (!(
#line 2671 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3148; /* *fuse_vnor_vor */

        case 12:
          if (!
#line 1447 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2651; /* *fuse_nor_orc */

        case 13:
          if (!(
#line 1447 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2652; /* *fuse_nor_orc */

        case 14:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3219; /* *fuse_vnor_vorc */

        case 15:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3220; /* *fuse_vnor_vorc */

        case 16:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3221; /* *fuse_vnor_vorc */

        case 17:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3222; /* *fuse_vnor_vorc */

        case 18:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3223; /* *fuse_vnor_vorc */

        case 19:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3224; /* *fuse_vnor_vorc */

        case 20:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3225; /* *fuse_vnor_vorc */

        case 21:
          if (!
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3226; /* *fuse_vnor_vorc */

        case 22:
          if (!(
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3227; /* *fuse_vnor_vorc */

        case 23:
          if (!(
#line 2815 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3228; /* *fuse_vnor_vorc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 653; /* p8_xxpermdi_ti */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 654; /* p8_xxpermdi_v16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 655; /* p8_xxpermdi_v8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 656; /* p8_xxpermdi_v4si */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 657; /* p8_xxpermdi_v4sf */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 658; /* p8_xxpermdi_v2di */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 659; /* p8_xxpermdi_v2df */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 660; /* p8_xxpermdi_v1ti */

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !(
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 661; /* p8_xxpermdi_kf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !(
#line 9624 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 662; /* p8_xxpermdi_tf */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !rs6000_tls_symbol_ref (operands[1], E_SImode)
              || !(
#line 10566 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 746; /* *tls_gd_pcrel32 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !rs6000_tls_symbol_ref (operands[1], E_DImode)
              || !(
#line 10566 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 747; /* *tls_gd_pcrel64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern417 (x3, 
E_SImode) != 0
              || !(
#line 10575 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 748; /* *tls_gd32 */

        case E_DImode:
          if (pattern417 (x3, 
E_DImode) != 0
              || !(
#line 10575 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 749; /* *tls_gd64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!u5bit_cint_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 4870 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
        return -1;
      return 1619; /* vsx_xxspltw_v4sf_direct */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 4870 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
        return -1;
      return 1620; /* vsx_xxspltw_v4si_direct */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!mma_disassemble_output_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (pattern434 ())
    {
    case 0:
      if (!
#line 415 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && vsx_register_operand (operands[1], OOmode)))
        return -1;
      return 2359; /* *vsx_disassemble_pair */

    case 1:
      if (!
#line 489 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[1], XOmode)))
        return -1;
      return 2361; /* *mma_disassemble_acc */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode)
      || !
#line 15834 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC && TARGET_64BIT))
    return -1;
  return 1211; /* *cmpeqb_internal */
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!vsx_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6488 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1753; /* vec_expand_v16qi */

    case E_V8HImode:
      if (!vsx_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !vsx_register_operand (operands[1], E_V8HImode)
          || !
#line 6488 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1754; /* vec_expand_v8hi */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 6488 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1755; /* vec_expand_v4si */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 6488 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1756; /* vec_expand_v2di */

    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V1TImode)
          || !
#line 6488 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1757; /* vec_expand_v1ti */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (nonimmediate_operand (operands[0], E_SFmode))
    {
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (input_operand (operands[1], E_SImode)
          && 
#line 8385 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))))
        {
          *pnum_clobbers = 1;
          return 586; /* movsf_from_si */
        }
    }
  if (!gpc_reg_operand (operands[0], E_SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  if (!lowpart_subreg_operator (x4, E_SImode))
    return -1;
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!input_operand (operands[1], E_DImode)
          || !
#line 8452 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      *pnum_clobbers = 1;
      return 587; /* movsf_from_si2_ashiftrt */

    case LSHIFTRT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!input_operand (operands[1], E_DImode)
          || !
#line 8452 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      *pnum_clobbers = 1;
      return 588; /* movsf_from_si2_lshiftrt */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15532 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1191; /* sqrtkf2_odd */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15532 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1192; /* sqrttf2_odd */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6776 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
        return -1;
      return 473; /* lrintsfdi2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6776 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
        return -1;
      return 474; /* lrintdfdi2 */

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !
#line 4423 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1565; /* vreplace_un_si */

    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !
#line 4423 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1566; /* vreplace_un_sf */

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !
#line 4423 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1567; /* vreplace_un_di */

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !
#line 4423 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1568; /* vreplace_un_df */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 32:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (pattern292 (x2))
        {
        case 0:
          if (!
#line 2523 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB))
            return -1;
          return 137; /* popcntbsi2 */

        case 1:
          if (!(
#line 2523 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 138; /* popcntbdi2 */

        default:
          return -1;
        }

    case 50:
      return recog_61 (x1, insn, pnum_clobbers);

    case 33:
      return recog_77 (x1, insn, pnum_clobbers);

    case 46:
      return recog_76 (x1, insn, pnum_clobbers);

    case 85:
      return recog_74 (x1, insn, pnum_clobbers);

    case 54:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5861 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX))
        return -1;
      return 401; /* lfiwax */

    case 55:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5963 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX))
        return -1;
      return 410; /* lfiwzx */

    case 5:
      switch (pattern155 (x1, 
FIX))
        {
        case 0:
          if (!
#line 6669 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 464; /* fctiwz_sf */

        case 1:
          if (!
#line 6669 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 465; /* fctiwz_df */

        default:
          return -1;
        }

    case 56:
      switch (pattern155 (x1, 
UNSIGNED_FIX))
        {
        case 0:
          if (!
#line 6680 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 466; /* fctiwuz_sf */

        case 1:
          if (!
#line 6680 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 467; /* fctiwuz_df */

        default:
          return -1;
        }

    case 53:
      return recog_94 (x1, insn, pnum_clobbers);

    case 52:
      return recog_93 (x1, insn, pnum_clobbers);

    case 9:
      return recog_62 (x1, insn, pnum_clobbers);

    case 8:
      return recog_72 (x1, insn, pnum_clobbers);

    case 6:
      return recog_71 (x1, insn, pnum_clobbers);

    case 7:
      return recog_68 (x1, insn, pnum_clobbers);

    case 10:
      return recog_84 (x1, insn, pnum_clobbers);

    case 31:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !
#line 6880 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PPC_GFXOPT))
        return -1;
      return 489; /* stfiwx */

    case 87:
      return recog_75 (x1, insn, pnum_clobbers);

    case 86:
      return recog_69 (x1, insn, pnum_clobbers);

    case 97:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 8733 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 597; /* xxspltidp_sf_internal */

        case 1:
          if (!
#line 8733 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 598; /* xxspltidp_df_internal */

        default:
          return -1;
        }

    case 98:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 8742 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 599; /* xxspltiw_sf_internal */

        case 1:
          if (!
#line 8742 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 600; /* xxspltiw_df_internal */

        default:
          return -1;
        }

    case 60:
      return recog_88 (x1, insn, pnum_clobbers);

    case 62:
      return recog_73 (x1, insn, pnum_clobbers);

    case 64:
      return recog_63 (x1, insn, pnum_clobbers);

    case 15:
      return recog_87 (x1, insn, pnum_clobbers);

    case 2:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 96
          || GET_MODE (x3) != E_SImode
          || !
#line 11135 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4 && flag_pic == 1 && TARGET_32BIT))
        return -1;
      return 796; /* load_toc_v4_pic_si */

    case 73:
      return recog_83 (x1, insn, pnum_clobbers);

    case 83:
      return recog_82 (x1, insn, pnum_clobbers);

    case 84:
      return recog_92 (x1, insn, pnum_clobbers);

    case 36:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1214; /* *hwsync */

    case 37:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1215; /* *lwsync */

    case 72:
      return recog_86 (x1, insn, pnum_clobbers);

    case 122:
      return recog_81 (x1, insn, pnum_clobbers);

    case 19:
      if (GET_MODE (x2) != E_CCmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!cc_reg_operand (operands[0], E_CCmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2214 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1391; /* *xvtlsbb_internal */

    case 124:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 2308 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1404; /* vsx_xsrdpi */

        case 1:
          if (!
#line 2308 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1405; /* vsx_xvrspi */

        case 2:
          if (!
#line 2308 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1406; /* vsx_xvrdpi */

        default:
          return -1;
        }

    case 125:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 2316 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1407; /* vsx_xsrdpic */

        case 1:
          if (!
#line 2316 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1408; /* vsx_xvrspic */

        case 2:
          if (!
#line 2316 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1409; /* vsx_xvrdpic */

        default:
          return -1;
        }

    case 107:
      return recog_66 (x1, insn, pnum_clobbers);

    case 108:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2427 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1425; /* vsx_xvcvhpsp */

    case 143:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2436 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1426; /* vsx_xvcvsphp */

    case 110:
      return recog_91 (x1, insn, pnum_clobbers);

    case 109:
      return recog_80 (x1, insn, pnum_clobbers);

    case 105:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2596 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1440; /* vsx_xvcvdpsxws */

    case 106:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2604 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1441; /* vsx_xvcvdpuxws */

    case 113:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2612 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1442; /* vsx_xvcvsxdsp */

    case 114:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2620 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1443; /* vsx_xvcvuxdsp */

    case 111:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2661 "../../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1448; /* vsx_xvcvsxwdp_df */

    case 112:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2669 "../../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1449; /* vsx_xvcvuxwdp_df */

    case 139:
      return recog_67 (x1, insn, pnum_clobbers);

    case 190:
      if (GET_MODE (x2) != E_TImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_TImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_TImode)
          || !
#line 5187 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1658; /* extendditi2_vector */

    case 146:
      return recog_90 (x1, insn, pnum_clobbers);

    case 147:
      return recog_89 (x1, insn, pnum_clobbers);

    case 155:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 5463 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1687; /* xvxexpsp */

        case 1:
          if (!
#line 5463 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1688; /* xvxexpdp */

        default:
          return -1;
        }

    case 156:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 5473 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1689; /* xvxsigsp */

        case 1:
          if (!
#line 5473 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1690; /* xvxsigdp */

        default:
          return -1;
        }

    case 141:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1736; /* vsx_xvcvspbf16 */

    case 140:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1737; /* vsx_xvcvbf16spn */

    case 189:
      return recog_64 (x1, insn, pnum_clobbers);

    case 192:
      return recog_65 (x1, insn, pnum_clobbers);

    case 204:
      return recog_78 (x1, insn, pnum_clobbers);

    case 205:
      if (GET_MODE (x2) != E_V2DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6628 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1777; /* xxspltidp_v2df_inst */

    case 356:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 907 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1920; /* vstrir_direct_v8hi */

        case 1:
          if (!
#line 907 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1921; /* vstrir_direct_v16qi */

        default:
          return -1;
        }

    case 357:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 959 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1924; /* vstril_direct_v8hi */

        case 1:
          if (!
#line 959 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1925; /* vstril_direct_v16qi */

        default:
          return -1;
        }

    case 360:
      return recog_85 (x1, insn, pnum_clobbers);

    case 256:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2581 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2106; /* altivec_vrfin */

    case 261:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2635 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2112; /* altivec_vlogefp */

    case 262:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2643 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2113; /* altivec_vexptefp */

    case 264:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2693 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2126; /* altivec_vupkhsw */

        case 1:
          if (!
#line 2693 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2127; /* altivec_vupkhsh */

        case 2:
          if (!
#line 2693 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2128; /* altivec_vupkhsb */

        default:
          return -1;
        }

    case 266:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2706 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2129; /* altivec_vupkhsw_direct */

        case 1:
          if (!
#line 2706 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2130; /* altivec_vupkhsh_direct */

        case 2:
          if (!
#line 2706 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2131; /* altivec_vupkhsb_direct */

        default:
          return -1;
        }

    case 265:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2714 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2132; /* altivec_vupklsw */

        case 1:
          if (!
#line 2714 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2133; /* altivec_vupklsh */

        case 2:
          if (!
#line 2714 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2134; /* altivec_vupklsb */

        default:
          return -1;
        }

    case 267:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2727 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2135; /* *altivec_vupklsw_direct */

        case 1:
          if (!
#line 2727 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2136; /* *altivec_vupklsh_direct */

        case 2:
          if (!
#line 2727 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2137; /* *altivec_vupklsb_direct */

        default:
          return -1;
        }

    case 268:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2735 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2138; /* altivec_vupkhpx */

    case 269:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2748 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2139; /* altivec_vupklpx */

    case 162:
      switch (pattern162 (x1))
        {
        case 0:
          if (!
#line 3020 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2167; /* altivec_lvsl_reg_si */

        case 1:
          if (!(
#line 3020 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2168; /* altivec_lvsl_reg_di */

        default:
          return -1;
        }

    case 276:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3028 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2169; /* altivec_lvsl_direct */

    case 163:
      switch (pattern162 (x1))
        {
        case 0:
          if (!
#line 3058 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2170; /* altivec_lvsr_reg_si */

        case 1:
          if (!(
#line 3058 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2171; /* altivec_lvsr_reg_di */

        default:
          return -1;
        }

    case 277:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3066 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2172; /* altivec_lvsr_direct */

    case 281:
      return recog_70 (x1, insn, pnum_clobbers);

    case 301:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4247 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2293; /* altivec_lvlx */

    case 302:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4255 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2294; /* altivec_lvlxl */

    case 303:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4263 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2295; /* altivec_lvrx */

    case 304:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4271 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2296; /* altivec_lvrxl */

    case 329:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode)
          || !
#line 4419 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2321; /* p8v_vgbbd */

    case 421:
      if (GET_MODE (x2) != E_XOmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 510 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2362; /* mma_xxmfacc */

    case 422:
      if (GET_MODE (x2) != E_XOmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 510 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2363; /* mma_xxmtacc */

    case 424:
      if (GET_MODE (x2) != E_DDmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_DDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_SDmode)
          || !
#line 41 "../../../gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], DDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2423; /* movsd_store */

    case 423:
      if (GET_MODE (x2) != E_SDmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_SDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DDmode)
          || !
#line 51 "../../../gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], DDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2424; /* movsd_load */

    case 437:
      return recog_79 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case MULT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[3] = x3;
          if (!gpc_reg_operand (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x6))
            {
            case ASHIFTRT:
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x9 = XEXP (x6, 0);
              if (!gpc_reg_operand (x9, E_SImode))
                return -1;
              switch (GET_CODE (x7))
                {
                case SIGN_EXTEND:
                  operands[2] = x9;
                  x10 = XEXP (x7, 0);
                  operands[1] = x10;
                  if (!gpc_reg_operand (operands[1], E_HImode)
                      || !
#line 1478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 50; /* *nmacchw */

                case ASHIFTRT:
                  x11 = XEXP (x7, 1);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x9;
                  x10 = XEXP (x7, 0);
                  operands[2] = x10;
                  if (!gpc_reg_operand (operands[2], E_SImode)
                      || !
#line 1513 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 52; /* *nmachhw */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x7) != SIGN_EXTEND)
                return -1;
              x9 = XEXP (x6, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x10 = XEXP (x7, 0);
              operands[2] = x10;
              if (!gpc_reg_operand (operands[2], E_HImode)
                  || !
#line 1542 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 54; /* *nmaclhw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern209 (x2, 
E_SImode) != 0)
                return -1;
              return 102; /* *subfsi3 */

            case E_DImode:
              if (pattern209 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 103; /* *subfdi3 */

            case E_SFmode:
              if (pattern210 (x2, 
E_SFmode) != 0
                  || !
#line 5079 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 314; /* *subsf3_fpr */

            case E_DFmode:
              if (pattern210 (x2, 
E_DFmode) != 0
                  || !
#line 5079 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 315; /* *subdf3_fpr */

            case E_KFmode:
              if (pattern211 (x2, 
E_KFmode) != 0
                  || !(
#line 15030 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1095; /* subkf3 */

            case E_TFmode:
              if (pattern211 (x2, 
E_TFmode) != 0
                  || !(
#line 15030 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1096; /* subtf3 */

            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              operands[1] = x3;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode))
                {
                  operands[2] = x4;
                  if (vsx_register_operand (operands[2], E_V4SFmode)
                      && 
#line 1710 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                    return 1336; /* *vsx_subv4sf3 */
                }
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode))
                return -1;
              operands[2] = x4;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !
#line 563 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 1835; /* *altivec_subv4sf3 */

            case E_V2DFmode:
              if (!vsx_register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode)
                return -1;
              operands[1] = x3;
              if (!vsx_register_operand (operands[1], E_V2DFmode))
                return -1;
              operands[2] = x4;
              if (!vsx_register_operand (operands[2], E_V2DFmode)
                  || !
#line 1710 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1337; /* *vsx_subv2df3 */

            case E_V4SImode:
              if (pattern212 (x2, 
E_V4SImode) != 0
                  || !
#line 555 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 1831; /* subv4si3 */

            case E_V8HImode:
              if (pattern212 (x2, 
E_V8HImode) != 0
                  || !
#line 555 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 1832; /* subv8hi3 */

            case E_V16QImode:
              if (pattern212 (x2, 
E_V16QImode) != 0
                  || !
#line 555 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 1833; /* subv16qi3 */

            case E_V2DImode:
              if (pattern212 (x2, 
E_V2DImode) != 0
                  || !
#line 555 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 1834; /* subv2di3 */

            case E_V1TImode:
              if (pattern212 (x2, 
E_V1TImode) != 0
                  || !
#line 4450 "../../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
                return -1;
              return 2324; /* subv1ti3 */

            case E_DDmode:
              if (pattern210 (x2, 
E_DDmode) != 0
                  || !
#line 185 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2438; /* subdd3 */

            case E_TDmode:
              if (pattern210 (x2, 
E_TDmode) != 0
                  || !
#line 185 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2439; /* subtd3 */

            default:
              return -1;
            }

        case EQ:
          switch (pattern40 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 940; /* *minus_eq_si */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 941; /* *minus_eq_di */

            default:
              return -1;
            }

        case NE:
          switch (pattern40 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 942; /* *minus_ne_si */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 943; /* *minus_ne_di */

            default:
              return -1;
            }

        case AND:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              switch (pattern321 (x2))
                {
                case 0:
                  if (!
#line 1807 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2691; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2692; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern323 (x2))
                {
                case 0:
                  if (!
#line 1843 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2695; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2696; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case NOT:
              switch (pattern323 (x2))
                {
                case 0:
                  if (!
#line 1825 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2693; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2694; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern321 (x2))
                {
                case 0:
                  if (!
#line 1861 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2697; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2698; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern324 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 108; /* subfsi3_imm */

        case E_DImode:
          if (pattern324 (x2, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 109; /* subfdi3_imm */

        default:
          return -1;
        }

    case UMAX:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != UMIN)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x12 = XEXP (x3, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern419 (x2, 
E_V4SImode) != 0
              || !
#line 4384 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2305; /* uabdv4si3 */

        case E_V8HImode:
          if (pattern419 (x2, 
E_V8HImode) != 0
              || !
#line 4384 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2306; /* uabdv8hi3 */

        case E_V16QImode:
          if (pattern419 (x2, 
E_V16QImode) != 0
              || !
#line 4384 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2307; /* uabdv16qi3 */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1735 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2683; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2684; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2687; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2688; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern46 (x1))
        {
        case 0:
          if (!
#line 1753 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2685; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2686; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2689; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2690; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  res = recog_26 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_CODE (x2))
    {
    case NE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers != NULL)
            {
              switch (pattern331 (x2))
                {
                case 0:
                  if (reg_or_short_operand (operands[2], E_SImode)
                      && 
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                    {
                      *pnum_clobbers = 3;
                      return 889; /* nesisi2_isel */
                    }
                  if (scc_eq_operand (operands[2], E_SImode)
                      && (
#line 12993 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 3;
                      return 930; /* *nesi3 */
                    }
                  break;

                case 1:
                  if ((
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 909; /* nesidi2_isel */
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        case E_DImode:
          if (pnum_clobbers != NULL)
            {
              switch (pattern332 (x2))
                {
                case 0:
                  if (reg_or_short_operand (operands[2], E_SImode)
                      && (
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 899; /* nedisi2_isel */
                    }
                  if (scc_eq_operand (operands[2], E_SImode)
                      && (
#line 13248 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 945; /* *nesi3_extdi */
                    }
                  break;

                case 1:
                  if (reg_or_short_operand (operands[2], E_DImode)
                      && (
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 919; /* nedidi2_isel */
                    }
                  if (scc_eq_operand (operands[2], E_DImode)
                      && (
#line 12993 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 3;
                      return 931; /* *nedi3 */
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SFmode:
          if (pattern10 (x2, 
E_V4SFmode) == 0
              && 
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return 1238; /* vector_nev4sf */
          break;

        case E_V2DFmode:
          if (pattern10 (x2, 
E_V2DFmode) == 0
              && 
#line 606 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return 1245; /* vector_nev2df */
          break;

        default:
          break;
        }
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 947; /* *nesi_cc */

        case 1:
          if (!(
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 951; /* *nedi_cc */

        default:
          return -1;
        }

    case LE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 955; /* *lesi_cc */

        case 1:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 961; /* *ledi_cc */

        default:
          return -1;
        }

    case LEU:
      switch (pattern128 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 895; /* leusisi2_isel */

        case 1:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 915; /* leusidi2_isel */

        case 2:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 905; /* leudisi2_isel */

        case 3:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 925; /* leudidi2_isel */

        default:
          return -1;
        }

    case GE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 956; /* *gesi_cc */

        case 1:
          if (!(
#line 13300 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 962; /* *gedi_cc */

        default:
          return -1;
        }

    case GEU:
      switch (pattern128 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 897; /* geusisi2_isel */

        case 1:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 917; /* geusidi2_isel */

        case 2:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 907; /* geudisi2_isel */

        case 3:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 927; /* geudidi2_isel */

        default:
          return -1;
        }

    case ORDERED:
      switch (pattern12 (x2))
        {
        case 0:
          if (!
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 946; /* *orderedsi_cc */

        case 1:
          if (!(
#line 13282 "../../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 950; /* *ordereddi_cc */

        case 2:
          if (!
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1253; /* vector_orderedv4sf */

        case 3:
          if (!
#line 653 "../../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1257; /* vector_orderedv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case XOR:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 1);
      operands[1] = x10;
      x11 = XEXP (x6, 1);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern527 (x6, 
E_SImode) != 0
                  || !
#line 403 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2535; /* *fuse_eqv_and */

            case E_DImode:
              if (pattern527 (x6, 
E_DImode) != 0
                  || !(
#line 403 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2536; /* *fuse_eqv_and */

            case E_V4SImode:
              if (pattern528 (x6, 
E_V4SImode) != 0
                  || !
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2719; /* *fuse_veqv_vand */

            case E_V8HImode:
              if (pattern528 (x6, 
E_V8HImode) != 0
                  || !
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2720; /* *fuse_veqv_vand */

            case E_V16QImode:
              if (pattern528 (x6, 
E_V16QImode) != 0
                  || !
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2721; /* *fuse_veqv_vand */

            case E_V4SFmode:
              if (pattern528 (x6, 
E_V4SFmode) != 0
                  || !
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2722; /* *fuse_veqv_vand */

            case E_V2DFmode:
              if (pattern528 (x6, 
E_V2DFmode) != 0
                  || !
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2723; /* *fuse_veqv_vand */

            case E_V2DImode:
              if (pattern528 (x6, 
E_V2DImode) != 0
                  || !
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2724; /* *fuse_veqv_vand */

            case E_V1TImode:
              if (pattern528 (x6, 
E_V1TImode) != 0
                  || !
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2725; /* *fuse_veqv_vand */

            case E_TImode:
              if (pattern528 (x6, 
E_TImode) != 0
                  || !
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2726; /* *fuse_veqv_vand */

            case E_KFmode:
              if (pattern528 (x6, 
E_KFmode) != 0
                  || !(
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2727; /* *fuse_veqv_vand */

            case E_TFmode:
              if (pattern528 (x6, 
E_TFmode) != 0
                  || !(
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2728; /* *fuse_veqv_vand */

            default:
              return -1;
            }

        case NOT:
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern393 (x6, 
E_SImode) != 0
                  || !
#line 583 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2555; /* *fuse_eqv_andc */

            case E_DImode:
              if (pattern393 (x6, 
E_DImode) != 0
                  || !(
#line 583 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2556; /* *fuse_eqv_andc */

            case E_V4SImode:
              if (pattern395 (x6, 
E_V4SImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2799; /* *fuse_veqv_vandc */

            case E_V8HImode:
              if (pattern395 (x6, 
E_V8HImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2800; /* *fuse_veqv_vandc */

            case E_V16QImode:
              if (pattern395 (x6, 
E_V16QImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2801; /* *fuse_veqv_vandc */

            case E_V4SFmode:
              if (pattern395 (x6, 
E_V4SFmode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2802; /* *fuse_veqv_vandc */

            case E_V2DFmode:
              if (pattern395 (x6, 
E_V2DFmode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2803; /* *fuse_veqv_vandc */

            case E_V2DImode:
              if (pattern395 (x6, 
E_V2DImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2804; /* *fuse_veqv_vandc */

            case E_V1TImode:
              if (pattern395 (x6, 
E_V1TImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2805; /* *fuse_veqv_vandc */

            case E_TImode:
              if (pattern395 (x6, 
E_TImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2806; /* *fuse_veqv_vandc */

            case E_KFmode:
              if (pattern395 (x6, 
E_KFmode) != 0
                  || !(
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2807; /* *fuse_veqv_vandc */

            case E_TFmode:
              if (pattern395 (x6, 
E_TFmode) != 0
                  || !(
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2808; /* *fuse_veqv_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern403 (x6))
        {
        case 0:
          if (!
#line 1015 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2603; /* *fuse_and_nor */

        case 1:
          if (!(
#line 1015 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2604; /* *fuse_and_nor */

        case 2:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3019; /* *fuse_vand_vnor */

        case 3:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3020; /* *fuse_vand_vnor */

        case 4:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3021; /* *fuse_vand_vnor */

        case 5:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3022; /* *fuse_vand_vnor */

        case 6:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3023; /* *fuse_vand_vnor */

        case 7:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3024; /* *fuse_vand_vnor */

        case 8:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3025; /* *fuse_vand_vnor */

        case 9:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3026; /* *fuse_vand_vnor */

        case 10:
          if (!(
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3027; /* *fuse_vand_vnor */

        case 11:
          if (!(
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3028; /* *fuse_vand_vnor */

        case 12:
          if (!
#line 1033 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2605; /* *fuse_andc_nor */

        case 13:
          if (!(
#line 1033 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2606; /* *fuse_andc_nor */

        case 14:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3029; /* *fuse_vandc_vnor */

        case 15:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3030; /* *fuse_vandc_vnor */

        case 16:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3031; /* *fuse_vandc_vnor */

        case 17:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3032; /* *fuse_vandc_vnor */

        case 18:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3033; /* *fuse_vandc_vnor */

        case 19:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3034; /* *fuse_vandc_vnor */

        case 20:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3035; /* *fuse_vandc_vnor */

        case 21:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3036; /* *fuse_vandc_vnor */

        case 22:
          if (!(
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3037; /* *fuse_vandc_vnor */

        case 23:
          if (!(
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3038; /* *fuse_vandc_vnor */

        case 24:
          if (!
#line 1087 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2611; /* *fuse_nor_nor */

        case 25:
          if (!(
#line 1087 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2612; /* *fuse_nor_nor */

        case 26:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3059; /* *fuse_vnor_vnor */

        case 27:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3060; /* *fuse_vnor_vnor */

        case 28:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3061; /* *fuse_vnor_vnor */

        case 29:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3062; /* *fuse_vnor_vnor */

        case 30:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3063; /* *fuse_vnor_vnor */

        case 31:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3064; /* *fuse_vnor_vnor */

        case 32:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3065; /* *fuse_vnor_vnor */

        case 33:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3066; /* *fuse_vnor_vnor */

        case 34:
          if (!(
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3067; /* *fuse_vnor_vnor */

        case 35:
          if (!(
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3068; /* *fuse_vnor_vnor */

        default:
          return -1;
        }

    case NOT:
      switch (pattern406 (x6))
        {
        case 0:
          if (!
#line 1051 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2607; /* *fuse_eqv_nor */

        case 1:
          if (!(
#line 1051 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2608; /* *fuse_eqv_nor */

        case 2:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3039; /* *fuse_veqv_vnor */

        case 3:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3040; /* *fuse_veqv_vnor */

        case 4:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3041; /* *fuse_veqv_vnor */

        case 5:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3042; /* *fuse_veqv_vnor */

        case 6:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3043; /* *fuse_veqv_vnor */

        case 7:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3044; /* *fuse_veqv_vnor */

        case 8:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3045; /* *fuse_veqv_vnor */

        case 9:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3046; /* *fuse_veqv_vnor */

        case 10:
          if (!(
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3047; /* *fuse_veqv_vnor */

        case 11:
          if (!(
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3048; /* *fuse_veqv_vnor */

        default:
          return -1;
        }

    case IOR:
      switch (pattern407 (x6))
        {
        case 0:
          if (!
#line 1069 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2609; /* *fuse_nand_nor */

        case 1:
          if (!(
#line 1069 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2610; /* *fuse_nand_nor */

        case 2:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3049; /* *fuse_vnand_vnor */

        case 3:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3050; /* *fuse_vnand_vnor */

        case 4:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3051; /* *fuse_vnand_vnor */

        case 5:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3052; /* *fuse_vnand_vnor */

        case 6:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3053; /* *fuse_vnand_vnor */

        case 7:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3054; /* *fuse_vnand_vnor */

        case 8:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3055; /* *fuse_vnand_vnor */

        case 9:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3056; /* *fuse_vnand_vnor */

        case 10:
          if (!(
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3057; /* *fuse_vnand_vnor */

        case 11:
          if (!(
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3058; /* *fuse_vnand_vnor */

        case 12:
          if (!
#line 1123 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2615; /* *fuse_orc_nor */

        case 13:
          if (!(
#line 1123 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2616; /* *fuse_orc_nor */

        case 14:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3079; /* *fuse_vorc_vnor */

        case 15:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3080; /* *fuse_vorc_vnor */

        case 16:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3081; /* *fuse_vorc_vnor */

        case 17:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3082; /* *fuse_vorc_vnor */

        case 18:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3083; /* *fuse_vorc_vnor */

        case 19:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3084; /* *fuse_vorc_vnor */

        case 20:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3085; /* *fuse_vorc_vnor */

        case 21:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3086; /* *fuse_vorc_vnor */

        case 22:
          if (!(
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3087; /* *fuse_vorc_vnor */

        case 23:
          if (!(
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3088; /* *fuse_vorc_vnor */

        case 24:
          if (!
#line 1105 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2613; /* *fuse_or_nor */

        case 25:
          if (!(
#line 1105 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2614; /* *fuse_or_nor */

        case 26:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3069; /* *fuse_vor_vnor */

        case 27:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3070; /* *fuse_vor_vnor */

        case 28:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3071; /* *fuse_vor_vnor */

        case 29:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3072; /* *fuse_vor_vnor */

        case 30:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3073; /* *fuse_vor_vnor */

        case 31:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3074; /* *fuse_vor_vnor */

        case 32:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3075; /* *fuse_vor_vnor */

        case 33:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3076; /* *fuse_vor_vnor */

        case 34:
          if (!(
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3077; /* *fuse_vor_vnor */

        case 35:
          if (!(
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3078; /* *fuse_vor_vnor */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 1159 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2619; /* *fuse_add_nor */

        case 1:
          if (!(
#line 1159 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2620; /* *fuse_add_nor */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 1177 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2621; /* *fuse_subf_nor */

        case 1:
          if (!(
#line 1177 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2622; /* *fuse_subf_nor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (XINT (x4, 1) != 87
              || GET_MODE (x4) != E_SImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[1] = x7;
          if (!input_operand (operands[1], E_SFmode))
            return -1;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!scratch_operand (operands[2], E_V4SFmode)
              || !
#line 7892 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))))
            return -1;
          return 570; /* *movdi_from_sf_zero_ext */

        case 3:
          if (XINT (x4, 1) != 445)
            return -1;
          switch (pattern409 (x1))
            {
            case 0:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  if (!d_form_memory (operands[1], E_SImode)
                      || !(
#line 170 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3351; /* *pcrel_opt_ldsi_udi_gpr */

                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !(
#line 185 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3355; /* *pcrel_opt_ldhi_udi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !(
#line 200 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3357; /* *pcrel_opt_ldqi_udi_gpr */

                default:
                  return -1;
                }

            case 1:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !
#line 185 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  return 3353; /* *pcrel_opt_ldhi_usi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !
#line 200 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  return 3356; /* *pcrel_opt_ldqi_usi_gpr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      if (pattern198 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          switch (pattern552 (x1, 
E_SImode))
            {
            case 0:
              if (!(
#line 10372 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 716; /* *movhi_update2 */

            case 1:
              if (!(
#line 10372 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 718; /* *movhi_update2 */

            case 2:
              if (!(
#line 10439 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 728; /* *movqi_update2 */

            case 3:
              if (!(
#line 10439 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 730; /* *movqi_update2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern552 (x1, 
E_DImode))
            {
            case 0:
              if (!(
#line 10372 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 717; /* *movhi_update2 */

            case 1:
              if (!(
#line 10372 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 719; /* *movhi_update2 */

            case 2:
              if (!(
#line 10439 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 729; /* *movqi_update2 */

            case 3:
              if (!(
#line 10439 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 731; /* *movqi_update2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      if (vsx_register_operand (operands[1], E_V4SImode)
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x4) == E_SImode)
        {
          x11 = XVECEXP (x9, 0, 0);
          operands[2] = x11;
          if (const_int_operand (operands[2], E_QImode))
            {
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              if (scratch_operand (operands[3], E_V4SImode)
                  && 
#line 3957 "../../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
                return 1515; /* *mfvsrwz */
            }
        }
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      switch (pattern499 (x1))
        {
        case 0:
          if (!
#line 4025 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1519; /* *vsx_extract_v16qi_di_p9 */

        case 1:
          if (!
#line 4025 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1520; /* *vsx_extract_v8hi_di_p9 */

        case 2:
          if (!
#line 4025 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1521; /* *vsx_extract_v4si_di_p9 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 432; /* fixuns_truncsfqi2 */
              break;

            case 1:
              if (
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 436; /* fixuns_truncdfqi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      switch (pattern479 (
E_QImode))
        {
        case 0:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 444; /* *fixuns_truncsfqi2_mem */

        case 1:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 450; /* *fixuns_truncdfqi2_mem */

        case 2:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1148; /* *fixuns_trunckfqi2_mem */

        case 3:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1154; /* *fixuns_trunctfqi2_mem */

        default:
          return -1;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 434; /* fixuns_truncsfhi2 */
              break;

            case 1:
              if (
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 438; /* fixuns_truncdfhi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      switch (pattern479 (
E_HImode))
        {
        case 0:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 446; /* *fixuns_truncsfhi2_mem */

        case 1:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 452; /* *fixuns_truncdfhi2_mem */

        case 2:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1150; /* *fixuns_trunckfhi2_mem */

        case 3:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1156; /* *fixuns_trunctfhi2_mem */

        default:
          return -1;
        }

    case 2:
      if (memory_operand (operands[0], E_SImode))
        {
          switch (pattern478 ())
            {
            case 0:
              if (
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                return 448; /* *fixuns_truncsfsi2_mem */
              break;

            case 1:
              if (
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                return 454; /* *fixuns_truncdfsi2_mem */
              break;

            case 2:
              if ((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 1152; /* *fixuns_trunckfsi2_mem */
              break;

            case 3:
              if ((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 1158; /* *fixuns_trunctfsi2_mem */
              break;

            default:
              break;
            }
        }
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      switch (pattern477 (
E_DImode))
        {
        case 0:
          if (!
#line 6467 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 455; /* fixuns_truncsfsi2_stfiwx */

        case 1:
          if (!
#line 6467 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 456; /* fixuns_truncdfsi2_stfiwx */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x9))
    {
    case CLOBBER:
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 96)
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          switch (pattern555 (x1))
            {
            case 0:
              if (memory_operand (operands[2], E_SImode)
                  && gpc_reg_operand (operands[3], E_SImode)
                  && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return 1005; /* *save_gpregs_si_r11 */
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !memory_operand (operands[3], E_SImode)
                  || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1022; /* *restore_gpregs_si_r11 */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1011; /* *save_fpregs_si_r11 */

            case 2:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode)
                  && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return 1006; /* *save_gpregs_di_r11 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode)
                  || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1023; /* *restore_gpregs_di_r11 */

            case 3:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1012; /* *save_fpregs_di_r11 */

            default:
              return -1;
            }

        case 12:
          switch (pattern555 (x1))
            {
            case 0:
              if (memory_operand (operands[2], E_SImode)
                  && gpc_reg_operand (operands[3], E_SImode)
                  && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return 1007; /* *save_gpregs_si_r12 */
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !memory_operand (operands[3], E_SImode)
                  || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1024; /* *restore_gpregs_si_r12 */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1013; /* *save_fpregs_si_r12 */

            case 2:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode)
                  && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return 1008; /* *save_gpregs_di_r12 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode)
                  || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1025; /* *restore_gpregs_di_r12 */

            case 3:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1014; /* *save_fpregs_di_r12 */

            default:
              return -1;
            }

        case 1:
          switch (pattern555 (x1))
            {
            case 0:
              if (memory_operand (operands[2], E_SImode)
                  && gpc_reg_operand (operands[3], E_SImode)
                  && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return 1009; /* *save_gpregs_si_r1 */
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !memory_operand (operands[3], E_SImode)
                  || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1026; /* *restore_gpregs_si_r1 */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1015; /* *save_fpregs_si_r1 */

            case 2:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode)
                  && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return 1010; /* *save_gpregs_di_r1 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode)
                  || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1027; /* *restore_gpregs_di_r1 */

            case 3:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1016; /* *save_fpregs_di_r1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!gpc_reg_operand (operands[2], E_DFmode)
          || !memory_operand (operands[3], E_DFmode))
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          switch (pattern556 (x4))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1040; /* *return_and_restore_fpregs_aix_si_r11 */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1041; /* *return_and_restore_fpregs_aix_di_r11 */

            default:
              return -1;
            }

        case 1:
          switch (pattern556 (x4))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1042; /* *return_and_restore_fpregs_aix_si_r1 */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1043; /* *return_and_restore_fpregs_aix_di_r1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return NULL;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[2] = x8;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern533 (x3, 
E_V2DFmode, 
E_DFmode))
            {
            case 0:
              if (!((
#line 3613 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 3615 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_605 (insn, operands);

            case 1:
              if (!((
#line 3613 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_606 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          switch (pattern533 (x3, 
E_V2DImode, 
E_DImode))
            {
            case 0:
              if (!((
#line 3613 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 3615 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_607 (insn, operands);

            case 1:
              if (!((
#line 3613 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_608 (insn, operands);

            default:
              return NULL;
            }

        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return NULL;
          if (vsx_register_operand (operands[0], E_SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && scratch_operand (operands[3], E_V4SFmode)
              && (
#line 3692 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 3694 "../../../gcc/config/rs6000/vsx.md"
( 1)))
            return gen_split_613 (insn, operands);
          if (!register_operand (operands[0], E_SFmode))
            return NULL;
          switch (pattern557 ())
            {
            case 0:
              if (!((
#line 3725 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 3727 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_614 (insn, operands);

            case 1:
              if (!((
#line 3725 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3727 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_615 (insn, operands);

            default:
              return NULL;
            }

        case E_QImode:
          if (GET_MODE (x3) != E_QImode)
            return NULL;
          if (int_reg_operand (operands[0], E_QImode)
              && altivec_register_operand (operands[1], E_V16QImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_618 (insn, operands);
          if (!const_0_to_15_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_QImode)
              && gpc_reg_operand (operands[1], E_V16QImode)
              && scratch_operand (operands[3], E_V16QImode)
              && (
#line 4117 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_628 (insn, operands);
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_630 (insn, operands);

        case E_HImode:
          if (GET_MODE (x3) != E_HImode)
            return NULL;
          if (int_reg_operand (operands[0], E_HImode)
              && altivec_register_operand (operands[1], E_V8HImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_619 (insn, operands);
          if (!const_0_to_7_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_HImode)
              && gpc_reg_operand (operands[1], E_V8HImode)
              && scratch_operand (operands[3], E_V8HImode)
              && (
#line 4117 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_629 (insn, operands);
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_631 (insn, operands);

        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          if (int_reg_operand (operands[0], E_SImode)
              && altivec_register_operand (operands[1], E_V4SImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_620 (insn, operands);
          if (!const_0_to_3_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_SImode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && scratch_operand (operands[3], E_V4SImode)
              && (
#line 4081 "../../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 4083 "../../../gcc/config/rs6000/vsx.md"
( INTVAL (operands[2]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
            return gen_split_627 (insn, operands);
          if (!register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_632 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (pattern414 (x1) != 0
          || !(
#line 4997 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_683 (insn, operands);

    case SMIN:
      if (pattern414 (x1) != 0
          || !(
#line 4997 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_684 (insn, operands);

    case SMAX:
      if (pattern414 (x1) != 0
          || !(
#line 4997 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_685 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case COMPARE:
          return split_2 (x1, insn);

        case BSWAP:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              switch (GET_CODE (operands[0]))
                {
                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (!gpc_reg_operand (operands[0], E_HImode)
                          || GET_MODE (x3) != E_HImode
                          || !gpc_reg_operand (operands[1], E_HImode)
                          || !scratch_operand (operands[2], E_SImode)
                          || !
#line 2677 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], HImode)))
                        return NULL;
                      return gen_split_50 (insn, operands);

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (operands[1], E_DImode)
                          || !
#line 3086 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                        return NULL;
                      return gen_split_57 (insn, operands);

                    default:
                      return NULL;
                    }

                case MEM:
                  if (!indexed_or_indirect_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !gpc_reg_operand (operands[1], E_DImode)
                      || !gpc_reg_operand (operands[2], E_SImode)
                      || !
#line 3038 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                    return NULL;
                  return gen_split_56 (insn, operands);

                default:
                  return NULL;
                }

            case MEM:
              if (!indexed_or_indirect_operand (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 2986 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                return NULL;
              return gen_split_55 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              switch (pattern355 (x1))
                {
                case 0:
                  if (!(
#line 4472 "../../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)) && 
#line 4475 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_119 (insn, operands);

                case 1:
                  if (!((
#line 4472 "../../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4475 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_120 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFT:
              if (pattern252 (x3) != 0)
                return NULL;
              switch (pattern526 (x1))
                {
                case 0:
                  if (!(
#line 4528 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8) && 
#line 4530 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_124 (insn, operands);

                case 1:
                  if (!(
#line 4528 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16) && 
#line 4530 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_125 (insn, operands);

                case 2:
                  if (!(
#line 4528 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32) && 
#line 4530 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_126 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case IF_THEN_ELSE:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x8 = XEXP (x3, 1);
          operands[4] = x8;
          x9 = XEXP (x3, 2);
          operands[5] = x9;
          x7 = XEXP (x4, 0);
          operands[6] = x7;
          if (!scratch_operand (operands[6], E_V2DImode))
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case EQ:
            case GE:
            case GT:
              if (!fpmask_comparison_operator (operands[1], E_CCFPmode))
                return NULL;
              switch (pattern532 (x3))
                {
                case 0:
                  if (!(
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_161 (insn, operands);

                case 1:
                  if (!(
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_163 (insn, operands);

                case 2:
                  if (!(
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_162 (insn, operands);

                case 3:
                  if (!(
#line 5665 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_164 (insn, operands);

                case 4:
                  if (!((
#line 5770 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 5772 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_169 (insn, operands);

                case 5:
                  if (!((
#line 5770 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 5772 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_170 (insn, operands);

                default:
                  return NULL;
                }

            case NE:
            case UNLE:
            case UNLT:
              if (!invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
                return NULL;
              switch (pattern532 (x3))
                {
                case 0:
                  if (!(
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                case 1:
                  if (!(
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_167 (insn, operands);

                case 2:
                  if (!(
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_166 (insn, operands);

                case 3:
                  if (!(
#line 5697 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_168 (insn, operands);

                case 4:
                  if (!((
#line 5802 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 5804 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_171 (insn, operands);

                case 5:
                  if (!((
#line 5802 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 5804 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_172 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case FLOAT:
          return split_5 (x1, insn);

        case UNSIGNED_FLOAT:
          switch (pattern79 (x1))
            {
            case 0:
              if (!(
#line 5976 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS) && 
#line 5978 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_181 (insn, operands);

            case 1:
              if (!(
#line 7129 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS) && 
#line 7131 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_229 (insn, operands);

            case 2:
              if (!(
#line 5976 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID) && 
#line 5978 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_182 (insn, operands);

            case 3:
              if (!(
#line 7004 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))) && 
#line 7006 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_226 (insn, operands);

            case 4:
              if (!((
#line 15394 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15396 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_525 (insn, operands);

            case 5:
              if (!((
#line 15414 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15416 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_527 (insn, operands);

            case 6:
              if (!((
#line 15414 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15416 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_528 (insn, operands);

            case 7:
              if (!((
#line 15394 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15396 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_526 (insn, operands);

            case 8:
              if (!((
#line 15414 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15416 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_529 (insn, operands);

            case 9:
              if (!((
#line 15414 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15416 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_530 (insn, operands);

            case 10:
              if (!(
#line 6016 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS) && 
#line 6018 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_183 (insn, operands);

            case 11:
              if (!(
#line 6016 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID) && 
#line 6018 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_184 (insn, operands);

            case 12:
              if (const_0_to_3_operand (operands[2], E_QImode)
                  && scratch_operand (operands[3], E_V4SImode)
                  && (
#line 4437 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4439 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                return gen_split_640 (insn, operands);
              if (!const_int_operand (operands[2], E_QImode)
                  || !scratch_operand (operands[3], E_SImode)
                  || !(
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_670 (insn, operands);

            case 13:
              if (!(
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_662 (insn, operands);

            case 14:
              if (!(
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_666 (insn, operands);

            case 15:
              if (!(
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_661 (insn, operands);

            case 16:
              if (!(
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_665 (insn, operands);

            case 17:
              if (!(
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_669 (insn, operands);

            case 18:
              if (!((
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_663 (insn, operands);

            case 19:
              if (!((
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_667 (insn, operands);

            case 20:
              if (!((
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_671 (insn, operands);

            case 21:
              if (!((
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_664 (insn, operands);

            case 22:
              if (!((
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_668 (insn, operands);

            case 23:
              if (!((
#line 4568 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_672 (insn, operands);

            default:
              return NULL;
            }

        case FIX:
          switch (pattern80 (x1))
            {
            case 0:
              if (nonimmediate_operand (operands[0], E_SImode))
                {
                  switch (pattern477 (
E_DImode))
                    {
                    case 0:
                      if ((
#line 6326 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6329 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_195 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6326 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6329 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_196 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_SImode))
                return NULL;
              switch (pattern478 ())
                {
                case 0:
                  if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_211 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_217 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_511 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_517 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              if (gpc_reg_operand (operands[0], E_QImode))
                {
                  switch (pattern477 (
E_SImode))
                    {
                    case 0:
                      if ((
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                        return gen_split_199 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                        return gen_split_203 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_QImode))
                return NULL;
              switch (pattern479 (
E_QImode))
                {
                case 0:
                  if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_207 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_213 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_507 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_513 (insn, operands);

                default:
                  return NULL;
                }

            case 2:
              if (gpc_reg_operand (operands[0], E_HImode))
                {
                  switch (pattern477 (
E_SImode))
                    {
                    case 0:
                      if ((
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                        return gen_split_201 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                        return gen_split_205 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_HImode))
                return NULL;
              switch (pattern479 (
E_HImode))
                {
                case 0:
                  if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_209 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_215 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_509 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_515 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case UNSIGNED_FIX:
          return split_6 (x1, insn);

        case UNSPEC:
          return split_3 (x1, insn);

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_DImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return NULL;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case UNSPEC:
              if (XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 87
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x10 = XVECEXP (x6, 0, 0);
              operands[1] = x10;
              if (!input_operand (operands[1], E_SFmode))
                return NULL;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!scratch_operand (operands[2], E_V4SFmode)
                  || !(
#line 7892 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))) && 
#line 7903 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && register_operand (operands[0], DImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))))
                return NULL;
              return gen_split_292 (insn, operands);

            case VEC_SELECT:
              x11 = XEXP (x6, 1);
              if (GET_CODE (x11) != PARALLEL
                  || XVECLEN (x11, 0) != 1)
                return NULL;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              switch (pattern499 (x1))
                {
                case 0:
                  if (!(
#line 4025 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_621 (insn, operands);

                case 1:
                  if (!(
#line 4025 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_622 (insn, operands);

                case 2:
                  if (!(
#line 4025 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_623 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case FLOAT_EXTEND:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DFmode))
            return NULL;
          switch (pattern357 (x1))
            {
            case 0:
              if (!((
#line 8912 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8915 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_322 (insn, operands);

            case 1:
              if (!((
#line 8912 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8915 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_323 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!scratch_operand (operands[2], E_V16QImode))
            return NULL;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              switch (pattern301 (x3))
                {
                case 0:
                  if (!((
#line 9299 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9301 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 1:
                  if (!((
#line 9299 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9301 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_331 (insn, operands);

                default:
                  return NULL;
                }

            case ABS:
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_KFmode:
                  if (pattern475 (x3, 
E_KFmode) != 0
                      || !((
#line 9357 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9359 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_334 (insn, operands);

                case E_TFmode:
                  if (pattern475 (x3, 
E_TFmode) != 0
                      || !((
#line 9357 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9359 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_335 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case ABS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          switch (pattern302 (x1))
            {
            case 0:
              if (!((
#line 9327 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9329 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_332 (insn, operands);

            case 1:
              if (!((
#line 9327 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9329 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_333 (insn, operands);

            default:
              return NULL;
            }

        case FLOAT_TRUNCATE:
          if (GET_MODE (x3) != E_SFmode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!vsx_register_operand (operands[0], E_SFmode))
            return NULL;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (pattern451 ())
            {
            case 0:
              if (!((
#line 15257 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15259 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_505 (insn, operands);

            case 1:
              if (!((
#line 15257 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15259 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_506 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x7 = XEXP (x4, 0);
          switch (pattern315 (x7))
            {
            case 0:
              if (!(
#line 3458 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])) && 
#line 3464 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_603 (insn, operands);

            case 1:
              if (!(
#line 3458 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SImode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SImode)
   && const_vec_duplicate_p (operands[1])) && 
#line 3464 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_604 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          return split_4 (x1, insn);

        case PLUS:
          if (pattern83 (x1) != 0
              || !(
#line 4927 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_677 (insn, operands);

        case SMIN:
          if (pattern83 (x1) != 0
              || !(
#line 4927 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_678 (insn, operands);

        case SMAX:
          if (pattern83 (x1) != 0
              || !(
#line 4927 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_679 (insn, operands);

        case SIGN_EXTEND:
          if (GET_MODE (x3) != E_TImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER
              || pattern259 (x1, 
E_TImode, 
E_DImode, 
98) != 0)
            return NULL;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!input_operand (operands[1], E_DImode)
              || !(
#line 5133 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && TARGET_POWER10) && 
#line 5135 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_689 (insn, operands);

        case ASHIFT:
          switch (pattern88 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_732 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_735 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern88 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_733 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_736 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern88 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_734 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_737 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return NULL;
      x13 = XVECEXP (x2, 0, 0);
      operands[0] = x13;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      switch (pattern356 ())
        {
        case 0:
          if (!(
#line 14320 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return NULL;
          return gen_split_490 (insn, operands);

        case 1:
          if (!(
#line 14320 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_491 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
