/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          return 0;

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          return 1;

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0)
            return -1;
          return 2;

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0)
            return -1;
          return 3;

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          return 4;

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0)
            return -1;
          return 5;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0)
            return -1;
          return 6;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) != 0)
            return -1;
          return 7;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) != 0)
            return -1;
          return 8;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern4 (x3) != 0)
        return -1;
      return 10;

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 102
          || GET_MODE (x4) != E_V4SFmode)
        return -1;
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !vfloat_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!vfloat_operand (operands[1], E_V4SFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != IF_THEN_ELSE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x6, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XEXP (x6, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XEXP (x1, 0);
  operands[0] = x11;
  if (!gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x12 = XEXP (x3, 0);
  operands[1] = x12;
  if (!cc_reg_operand (operands[1], i1))
    return -1;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  return pattern63 (x3); /* [-1, 23] */
}

int
pattern69 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || !small_toc_ref (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !small_toc_ref (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[2], E_DImode))
    return -1;
  return pattern70 (); /* [-1, 2] */
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_V4SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_V16QImode)
              || !const_int_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_V8HImode)
              || !const_int_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SFmode:
      res = pattern74 (x3, 
E_SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_KFmode:
      res = pattern74 (x3, 
E_KFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_TFmode:
      res = pattern74 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern104 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XVECEXP (x4, 0, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[3] = x10;
  x11 = XEXP (x6, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern106 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern106 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern106 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      return pattern134 (x3, 
E_KFmode); /* [-1, 0] */

    case E_TFmode:
      if (pattern134 (x3, 
E_TFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern141 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern141 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern141 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern141 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 5;

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0)
        return -1;
      return 6;

    case E_TImode:
      if (pattern141 (x3, 
E_TImode) != 0)
        return -1;
      return 7;

    case E_KFmode:
      if (pattern141 (x3, 
E_KFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern141 (x3, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x9))
    {
    case CLOBBER:
      return pattern179 (x1); /* [-1, 1] */

    case SET:
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != i1)
        return -1;
      res = pattern183 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      return pattern192 (x5); /* [-1, 1] */

    case NOT:
      res = pattern194 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern202 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode)
              || !gpc_reg_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !gpc_reg_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != i1)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      x9 = XEXP (x7, 1);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (pattern201 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern201 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern234 (x3, 
i1); /* [-1, 0] */
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern238 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern238 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern239 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern239 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern239 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern239 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern239 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern239 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern239 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern239 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern239 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern239 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern240 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern240 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern241 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern241 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern241 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern241 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern241 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern241 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern241 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern241 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern241 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern241 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern280 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern277 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern274 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 98)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 98)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern304 (x4, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern304 (x4, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern320 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scc_rev_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern345 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern357 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_IFmode:
      if (!gpc_reg_operand (operands[0], E_IFmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_IFmode)
        return -1;
      return 0;

    case E_TFmode:
      if (!gpc_reg_operand (operands[0], E_TFmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_TFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern367 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern383 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern391 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              return pattern385 (
E_SImode); /* [-1, 0] */

            case E_DImode:
              if (pattern385 (
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case SET:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[3]))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern386 (
E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern386 (
E_DImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x10 = XEXP (x5, 0);
          operands[2] = x10;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern387 (x5, 
E_SImode) != 0)
                    return -1;
                  return 4;

                case E_DImode:
                  if (pattern387 (x5, 
E_DImode) != 0)
                    return -1;
                  return 5;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern388 (x5, 
E_SImode) != 0)
                    return -1;
                  return 6;

                case E_DImode:
                  if (pattern388 (x5, 
E_DImode) != 0)
                    return -1;
                  return 7;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x6, 0);
          operands[2] = x11;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern389 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 8;

                case E_DImode:
                  if (pattern389 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 9;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern390 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 10;

                case E_DImode:
                  if (pattern390 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern449 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (XWINT (x13, 0) != 1L
      || pattern413 (x1) != 0)
    return -1;
  return 0;
}

int
pattern465 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1)
      || !const_0_to_3_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern474 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern473 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern473 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern484 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case USE:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 3)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 2)
        return -1;
      return 0;

    case SET:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 3)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 2)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 96)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern499 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern514 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      return 0;

    case E_V2DFmode:
      return 1;

    case E_V4SImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V16QImode:
      return 4;

    case E_V2DImode:
      return 5;

    case E_V1TImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern529 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !scratch_operand (operands[3], E_SImode)
          || !scratch_operand (operands[4], E_SImode)
          || !scratch_operand (operands[5], E_CCmode))
        return -1;
      return pattern109 (); /* [-1, 1] */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !reg_or_short_operand (operands[2], E_DImode)
              || !scratch_operand (operands[3], E_DImode)
              || !scratch_operand (operands[4], E_DImode)
              || !scratch_operand (operands[5], E_CCmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern547 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[2] = x7;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern559 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern565 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!symbol_ref_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !memory_operand (operands[3], E_SImode))
            return -1;
          return 0;

        case E_DFmode:
          if (!gpc_reg_operand (operands[2], E_DFmode)
              || !memory_operand (operands[3], E_DFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!symbol_ref_operand (operands[1], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !memory_operand (operands[3], E_DImode))
            return -1;
          return 2;

        case E_DFmode:
          if (!gpc_reg_operand (operands[2], E_DFmode)
              || !memory_operand (operands[3], E_DFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern594 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern599 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x11 = XEXP (x4, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  x13 = XEXP (x5, 0);
  operands[2] = x13;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x14 = XEXP (x8, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern327 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5627 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 373; /* *setnbcr_cc_si */

        case 1:
          if (!
#line 5627 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 375; /* *setnbcr_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern327 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5627 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 374; /* *setnbcr_cc_di */

        case 1:
          if (!(
#line 5627 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 376; /* *setnbcr_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!cc_reg_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x2, 1);
  switch (GET_CODE (x8))
    {
    case RETURN:
      if (!
#line 13383 "../../../gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 968; /* *creturn */

    case SIMPLE_RETURN:
      return 969; /* *creturn */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      switch (pattern63 (x3))
        {
        case 0:
          if (!
#line 367 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2531; /* *fuse_and_and */

        case 1:
          if (!(
#line 367 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2532; /* *fuse_and_and */

        case 2:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2699; /* *fuse_vand_vand */

        case 3:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2700; /* *fuse_vand_vand */

        case 4:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2701; /* *fuse_vand_vand */

        case 5:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2702; /* *fuse_vand_vand */

        case 6:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2703; /* *fuse_vand_vand */

        case 7:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2704; /* *fuse_vand_vand */

        case 8:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2705; /* *fuse_vand_vand */

        case 9:
          if (!
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2706; /* *fuse_vand_vand */

        case 10:
          if (!(
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2707; /* *fuse_vand_vand */

        case 11:
          if (!(
#line 1879 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2708; /* *fuse_vand_vand */

        case 12:
          if (!
#line 547 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2551; /* *fuse_and_andc */

        case 13:
          if (!(
#line 547 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2552; /* *fuse_and_andc */

        case 14:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2779; /* *fuse_vand_vandc */

        case 15:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2780; /* *fuse_vand_vandc */

        case 16:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2781; /* *fuse_vand_vandc */

        case 17:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2782; /* *fuse_vand_vandc */

        case 18:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2783; /* *fuse_vand_vandc */

        case 19:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2784; /* *fuse_vand_vandc */

        case 20:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2785; /* *fuse_vand_vandc */

        case 21:
          if (!
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2786; /* *fuse_vand_vandc */

        case 22:
          if (!(
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2787; /* *fuse_vand_vandc */

        case 23:
          if (!(
#line 2023 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2788; /* *fuse_vand_vandc */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern58 (x3))
            {
            case 0:
              if (!
#line 385 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2533; /* *fuse_andc_and */

            case 1:
              if (!(
#line 385 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2534; /* *fuse_andc_and */

            case 2:
              if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2709; /* *fuse_vandc_vand */

            case 3:
              if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2710; /* *fuse_vandc_vand */

            case 4:
              if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2711; /* *fuse_vandc_vand */

            case 5:
              if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2712; /* *fuse_vandc_vand */

            case 6:
              if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2713; /* *fuse_vandc_vand */

            case 7:
              if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2714; /* *fuse_vandc_vand */

            case 8:
              if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2715; /* *fuse_vandc_vand */

            case 9:
              if (!
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2716; /* *fuse_vandc_vand */

            case 10:
              if (!(
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2717; /* *fuse_vandc_vand */

            case 11:
              if (!(
#line 1897 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2718; /* *fuse_vandc_vand */

            case 12:
              if (!
#line 565 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2553; /* *fuse_andc_andc */

            case 13:
              if (!(
#line 565 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2554; /* *fuse_andc_andc */

            case 14:
              if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2789; /* *fuse_vandc_vandc */

            case 15:
              if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2790; /* *fuse_vandc_vandc */

            case 16:
              if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2791; /* *fuse_vandc_vandc */

            case 17:
              if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2792; /* *fuse_vandc_vandc */

            case 18:
              if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2793; /* *fuse_vandc_vandc */

            case 19:
              if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2794; /* *fuse_vandc_vandc */

            case 20:
              if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2795; /* *fuse_vandc_vandc */

            case 21:
              if (!
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2796; /* *fuse_vandc_vandc */

            case 22:
              if (!(
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2797; /* *fuse_vandc_vandc */

            case 23:
              if (!(
#line 2041 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2798; /* *fuse_vandc_vandc */

            default:
              return -1;
            }

        case NOT:
          switch (pattern52 (x3))
            {
            case 0:
              if (!
#line 439 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2539; /* *fuse_nor_and */

            case 1:
              if (!(
#line 439 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2540; /* *fuse_nor_and */

            case 2:
              if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2739; /* *fuse_vnor_vand */

            case 3:
              if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2740; /* *fuse_vnor_vand */

            case 4:
              if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2741; /* *fuse_vnor_vand */

            case 5:
              if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2742; /* *fuse_vnor_vand */

            case 6:
              if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2743; /* *fuse_vnor_vand */

            case 7:
              if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2744; /* *fuse_vnor_vand */

            case 8:
              if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2745; /* *fuse_vnor_vand */

            case 9:
              if (!
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2746; /* *fuse_vnor_vand */

            case 10:
              if (!(
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2747; /* *fuse_vnor_vand */

            case 11:
              if (!(
#line 1951 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2748; /* *fuse_vnor_vand */

            case 12:
              if (!
#line 619 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2559; /* *fuse_nor_andc */

            case 13:
              if (!(
#line 619 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2560; /* *fuse_nor_andc */

            case 14:
              if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2819; /* *fuse_vnor_vandc */

            case 15:
              if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2820; /* *fuse_vnor_vandc */

            case 16:
              if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2821; /* *fuse_vnor_vandc */

            case 17:
              if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2822; /* *fuse_vnor_vandc */

            case 18:
              if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2823; /* *fuse_vnor_vandc */

            case 19:
              if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2824; /* *fuse_vnor_vandc */

            case 20:
              if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2825; /* *fuse_vnor_vandc */

            case 21:
              if (!
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2826; /* *fuse_vnor_vandc */

            case 22:
              if (!(
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2827; /* *fuse_vnor_vandc */

            case 23:
              if (!(
#line 2095 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2828; /* *fuse_vnor_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 896; /* gesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 916; /* gesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 906; /* gedisi2_isel */

        case 1:
          if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 926; /* gedidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2175 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1385; /* *vsx_gev4sf */
      if (!altivec_register_operand (operands[0], E_V4SFmode)
          || !altivec_register_operand (operands[1], E_V4SFmode)
          || !altivec_register_operand (operands[2], E_V4SFmode)
          || !
#line 690 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1867; /* *altivec_gev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern2 (x2, 
E_V2DFmode) != 0
          || !
#line 2175 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1386; /* *vsx_gev2df */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 13)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern490 (x3, 
E_SImode) != 0
              || !(
#line 169 "../../../gcc/config/rs6000/darwin.md"
(DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 1; /* macho_correct_pic_si */

        case E_DImode:
          if (pattern490 (x3, 
E_DImode) != 0
              || !(
#line 169 "../../../gcc/config/rs6000/darwin.md"
(DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 2; /* macho_correct_pic_di */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern380 (x3, 
E_SImode) == 0)
            return 68; /* *addsi3 */
          break;

        case E_DImode:
          if (pattern380 (x3, 
E_DImode) == 0
              && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return 69; /* *adddi3 */
          break;

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) == 0
              && 
#line 5061 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return 312; /* *addsf3_fpr */
          break;

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) == 0
              && 
#line 5061 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return 313; /* *adddf3_fpr */
          break;

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) == 0
              && (
#line 15020 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 1093; /* addkf3 */
          break;

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) == 0
              && (
#line 15020 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 1094; /* addtf3 */
          break;

        case E_V4SFmode:
          if (GET_MODE (x3) == E_V4SFmode)
            {
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && 
#line 1702 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1334; /* *vsx_addv4sf3 */
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && 
#line 519 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return 1823; /* *altivec_addv4sf3 */
            }
          break;

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) == 0
              && 
#line 1702 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1335; /* *vsx_addv2df3 */
          break;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) == 0
              && 
#line 511 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return 1819; /* addv4si3 */
          break;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) == 0
              && 
#line 511 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return 1820; /* addv8hi3 */
          break;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) == 0
              && 
#line 511 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return 1821; /* addv16qi3 */
          break;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) == 0
              && 
#line 511 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return 1822; /* addv2di3 */
          break;

        case E_V1TImode:
          if (pattern3 (x3, 
E_V1TImode) == 0
              && 
#line 4433 "../../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
            return 2322; /* addv1ti3 */
          break;

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) == 0
              && 
#line 177 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return 2436; /* adddd3 */
          break;

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) == 0
              && 
#line 177 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return 2437; /* addtd3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern458 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 92; /* addsi3_carry_in_0 */

        case E_DImode:
          if (pattern458 (x3, 
E_DImode) != 0
              || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 93; /* adddi3_carry_in_0 */

        default:
          return -1;
        }

    case HIGH:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != CONST)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != MINUS
          || GET_MODE (x8) != E_SImode
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!symbol_ref_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      if (!symbol_ref_operand (operands[3], E_SImode)
          || !
#line 11231 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_SECURE_PLT && DEFAULT_ABI == ABI_V4 && flag_pic))
        return -1;
      return 800; /* load_toc_v4_PIC_3b */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode)
          || !
#line 3360 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1473; /* xxgenpcvm_v16qi_internal */

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode)
          || !
#line 3360 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1474; /* xxgenpcvm_v8hi_internal */

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !altivec_register_operand (operands[1], E_V4SImode)
          || !
#line 3360 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1475; /* xxgenpcvm_v4si_internal */

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !altivec_register_operand (operands[1], E_V2DImode)
          || !
#line 3360 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1476; /* xxgenpcvm_v2di_internal */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      if (XWINT (x4, 0) != 0L)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !rs6000_tls_symbol_ref (operands[1], E_SImode)
              || !(
#line 10756 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 780; /* *tls_got_tprel_pcrel_32 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !rs6000_tls_symbol_ref (operands[1], E_DImode)
              || !(
#line 10756 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 781; /* *tls_got_tprel_pcrel_64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern221 (x3))
        {
        case 0:
          if (!(
#line 10768 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 782; /* tls_got_tprel_32 */

        case 1:
          if (!(
#line 10768 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 783; /* tls_got_tprel_64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0
          || !
#line 80 "../../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2481; /* crypto_vpmsumb */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0
          || !
#line 80 "../../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2482; /* crypto_vpmsumh */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 80 "../../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2483; /* crypto_vpmsumw */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 80 "../../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2484; /* crypto_vpmsumd */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_0_to_12_operand (operands[2], E_QImode)
      || !
#line 6041 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
    return -1;
  return 1730; /* extract4b */
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!got_no_const_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode)
      || !
#line 7696 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4 && flag_pic == 1))
    return -1;
  return 567; /* *movsi_got_internal */
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!vsx_register_operand (operands[1], E_DFmode)
              || !
#line 2362 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1419; /* vsx_xscvdpsp */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2400 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1422; /* vsx_xvcvdpsp */

        case E_SFmode:
          if (!vsx_register_operand (operands[1], E_SFmode)
              || !
#line 2446 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1427; /* vsx_xscvdpsp_scalar */

        default:
          return -1;
        }

    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2409 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1423; /* vsx_xscvspdp */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2418 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1424; /* vsx_xscvspdp_scalar2 */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 3242 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2286; /* altivec_stvehx */

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 3242 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2287; /* altivec_stvebx */

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 3249 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2288; /* *altivec_stvesfx */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6587 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1775; /* xxspltiw_v4si */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6607 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1776; /* xxspltiw_v4sf_inst */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9564 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 646; /* p8_mtvsrwz */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 9572 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 647; /* p8_mtvsrwz_v16qisi2 */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2074; /* altivec_vperm_v4si_direct */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0
          || !
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2075; /* altivec_vperm_v8hi_direct */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2076; /* altivec_vperm_v16qi_direct */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 2507 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2084; /* altivec_vperm_v8hiv16qi */

        default:
          return -1;
        }

    case E_V4SFmode:
      if (pattern141 (x3, 
E_V4SFmode) != 0
          || !
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2077; /* altivec_vperm_v4sf_direct */

    case E_V2DFmode:
      if (pattern141 (x3, 
E_V2DFmode) != 0
          || !
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2078; /* altivec_vperm_v2df_direct */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2079; /* altivec_vperm_v2di_direct */

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0
          || !
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2080; /* altivec_vperm_v1ti_direct */

    case E_TImode:
      if (pattern141 (x3, 
E_TImode) != 0
          || !
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2081; /* altivec_vperm_ti_direct */

    case E_KFmode:
      if (pattern141 (x3, 
E_KFmode) != 0
          || !(
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 2082; /* altivec_vperm_kf_direct */

    case E_TFmode:
      if (pattern141 (x3, 
E_TFmode) != 0
          || !(
#line 2494 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 2083; /* altivec_vperm_tf_direct */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V1TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V2DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 2)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !vsx_register_operand (operands[0], E_V1TImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!vsx_register_operand (operands[1], E_V1TImode)
      || !
#line 3348 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
    return -1;
  return 1472; /* xxswapd_v1ti */
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (GET_CODE (x2) == SUBREG)
        {
          res = recog_110 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case PC:
          operands[0] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && (
#line 13533 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 979; /* *indirect_jumpsi */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && (
#line 13533 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 980; /* *indirect_jumpdi */
              break;

            default:
              break;
            }
          break;

        case MEM:
          operands[0] = x3;
          operands[1] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (indexed_or_indirect_operand (operands[0], E_V2DFmode)
                  && vsx_register_operand (operands[1], E_V2DFmode)
                  && 
#line 663 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1265; /* *vsx_le_perm_store_v2df */
              break;

            case E_V2DImode:
              if (indexed_or_indirect_operand (operands[0], E_V2DImode)
                  && vsx_register_operand (operands[1], E_V2DImode)
                  && 
#line 663 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1266; /* *vsx_le_perm_store_v2di */
              break;

            case E_V4SFmode:
              if (indexed_or_indirect_operand (operands[0], E_V4SFmode)
                  && vsx_register_operand (operands[1], E_V4SFmode)
                  && 
#line 733 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1267; /* *vsx_le_perm_store_v4sf */
              break;

            case E_V4SImode:
              if (indexed_or_indirect_operand (operands[0], E_V4SImode)
                  && vsx_register_operand (operands[1], E_V4SImode)
                  && 
#line 733 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1268; /* *vsx_le_perm_store_v4si */
              break;

            case E_V8HImode:
              if (indexed_or_indirect_operand (operands[0], E_V8HImode)
                  && vsx_register_operand (operands[1], E_V8HImode)
                  && 
#line 808 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1269; /* *vsx_le_perm_store_v8hi */
              break;

            case E_V16QImode:
              if (indexed_or_indirect_operand (operands[0], E_V16QImode)
                  && vsx_register_operand (operands[1], E_V16QImode)
                  && 
#line 893 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1270; /* *vsx_le_perm_store_v16qi */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case MEM:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (vsx_register_operand (operands[0], E_V2DFmode)
              && indexed_or_indirect_operand (operands[1], E_V2DFmode)
              && 
#line 449 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1259; /* *vsx_le_perm_load_v2df */
          break;

        case E_V2DImode:
          if (vsx_register_operand (operands[0], E_V2DImode)
              && indexed_or_indirect_operand (operands[1], E_V2DImode)
              && 
#line 449 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1260; /* *vsx_le_perm_load_v2di */
          break;

        case E_V4SFmode:
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && indexed_or_indirect_operand (operands[1], E_V4SFmode)
              && 
#line 497 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1261; /* *vsx_le_perm_load_v4sf */
          break;

        case E_V4SImode:
          if (vsx_register_operand (operands[0], E_V4SImode)
              && indexed_or_indirect_operand (operands[1], E_V4SImode)
              && 
#line 497 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1262; /* *vsx_le_perm_load_v4si */
          break;

        case E_V8HImode:
          if (vsx_register_operand (operands[0], E_V8HImode)
              && indexed_or_indirect_operand (operands[1], E_V8HImode)
              && 
#line 547 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1263; /* *vsx_le_perm_load_v8hi */
          break;

        case E_V16QImode:
          if (vsx_register_operand (operands[0], E_V16QImode)
              && indexed_or_indirect_operand (operands[1], E_V16QImode)
              && 
#line 601 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1264; /* *vsx_le_perm_load_v16qi */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (vsx_register_operand (operands[0], E_KFmode)
          && memory_operand (operands[1], E_KFmode)
          && (
#line 1040 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], KFmode)) && 
#line 35 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 1275; /* *vsx_le_perm_load_kf */
      break;

    case E_V1TImode:
      if (vsx_register_operand (operands[0], E_V1TImode)
          && memory_operand (operands[1], E_V1TImode)
          && 
#line 1040 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], V1TImode)))
        return 1278; /* *vsx_le_perm_load_v1ti */
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (memory_operand (operands[0], E_KFmode)
          && vsx_register_operand (operands[1], E_KFmode)
          && (
#line 1063 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 1279; /* *vsx_le_perm_store_kf */
      break;

    case E_V1TImode:
      if (memory_operand (operands[0], E_V1TImode)
          && vsx_register_operand (operands[1], E_V1TImode)
          && 
#line 1063 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
        return 1282; /* *vsx_le_perm_store_v1ti */
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && input_operand (operands[1], E_V16QImode))
        {
          if (
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))))
            return 1291; /* vsx_movv16qi_64bit */
          if (
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))))
            return 1301; /* *vsx_movv16qi_32bit */
          if (
#line 245 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))))
            return 1791; /* *altivec_movv16qi */
        }
      break;

    case E_V4SFmode:
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode))
        {
          if (
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
            return 1295; /* vsx_movv4sf_64bit */
          if (
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
            return 1305; /* *vsx_movv4sf_32bit */
        }
      break;

    case E_V2DFmode:
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && input_operand (operands[1], E_V2DFmode))
        {
          if (
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))))
            return 1296; /* vsx_movv2df_64bit */
          if (
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))))
            return 1306; /* *vsx_movv2df_32bit */
          if (
#line 245 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))))
            return 1793; /* *altivec_movv2df */
        }
      break;

    case E_V1TImode:
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && input_operand (operands[1], E_V1TImode))
        {
          if (
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))))
            return 1297; /* vsx_movv1ti_64bit */
          if (
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))))
            return 1307; /* *vsx_movv1ti_32bit */
        }
      break;

    case E_KFmode:
      if (nonimmediate_operand (operands[0], E_KFmode)
          && input_operand (operands[1], E_KFmode))
        {
          if ((
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && 
#line 69 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return 1298; /* vsx_movkf_64bit */
          if ((
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && 
#line 69 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return 1308; /* *vsx_movkf_32bit */
          if ((
#line 245 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && 
#line 211 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return 1796; /* *altivec_movkf */
        }
      break;

    case E_OOmode:
      if (nonimmediate_operand (operands[0], E_OOmode)
          && input_operand (operands[1], E_OOmode)
          && 
#line 298 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], OOmode)
       || gpc_reg_operand (operands[1], OOmode))))
        return 2356; /* *movoo */
      break;

    case E_XOmode:
      if (nonimmediate_operand (operands[0], E_XOmode)
          && input_operand (operands[1], E_XOmode)
          && 
#line 345 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], XOmode)
       || gpc_reg_operand (operands[1], XOmode))))
        return 2357; /* *movxo */
      break;

    default:
      break;
    }
  operands[0] = x2;
  res = recog_111 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case SUBREG:
      res = recog_112 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_113 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (nonimmediate_operand (operands[0], E_V1TImode))
    {
      operands[1] = x2;
      if (input_operand (operands[1], E_V1TImode)
          && 
#line 245 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))))
        return 1795; /* *altivec_movv1ti */
    }
  operands[0] = x2;
  switch (pattern32 (x3, 
E_V1TImode))
    {
    case 0:
      if ((
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2252; /* altivec_stvx_v1ti_2op_si */
      break;

    case 1:
      if ((
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2253; /* altivec_stvx_v1ti_2op_di */
      break;

    case 2:
      if ((
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2270; /* altivec_stvx_v1ti_1op_si */
      break;

    case 3:
      if ((
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2271; /* altivec_stvx_v1ti_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  switch (pattern35 (x1, 
E_V1TImode))
    {
    case 0:
      if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 2207; /* altivec_lvx_v1ti_2op_si */

    case 1:
      if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2208; /* altivec_lvx_v1ti_2op_di */

    case 2:
      if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 2225; /* altivec_lvx_v1ti_1op_si */

    case 3:
      if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2226; /* altivec_lvx_v1ti_1op_di */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern8 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_SImode))
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_SImode)
                {
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SFmode:
                      if (gpc_reg_operand (operands[1], E_SFmode)
                          && 
#line 6326 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 425; /* fix_truncsfsi2_stfiwx */
                        }
                      break;

                    case E_DFmode:
                      if (gpc_reg_operand (operands[1], E_DFmode)
                          && 
#line 6326 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 426; /* fix_truncdfsi2_stfiwx */
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6425 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 439; /* *fix_truncsfsi2_p8 */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6425 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 441; /* *fix_truncdfsi2_p8 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers != NULL
              && memory_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                    {
                      *pnum_clobbers = 1;
                      return 447; /* *fix_truncsfsi2_mem */
                    }
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                    {
                      *pnum_clobbers = 1;
                      return 453; /* *fix_truncdfsi2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (altivec_register_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15287 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1131; /* fix_kfsi2_hw */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15287 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1133; /* fix_tfsi2_hw */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern336 (
E_SImode))
            {
            case 0:
              if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1151; /* *fix_trunckfsi2_mem */

            case 1:
              if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1157; /* *fix_trunctfsi2_mem */

            default:
              return -1;
            }

        case E_DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6389 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    return 429; /* *fix_truncsfdi2_fctidz */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6389 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    return 430; /* *fix_truncdfdi2_fctidz */
                  break;

                case E_DDmode:
                  if (gpc_reg_operand (operands[1], E_DDmode)
                      && 
#line 253 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                    return 2451; /* fixdddi2 */
                  break;

                case E_TDmode:
                  if (gpc_reg_operand (operands[1], E_TDmode)
                      && 
#line 253 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                    return 2452; /* fixtddi2 */
                  break;

                default:
                  break;
                }
            }
          if (!altivec_register_operand (operands[0], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 15287 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1135; /* fix_kfdi2_hw */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 15287 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1137; /* fix_tfdi2_hw */

            default:
              return -1;
            }

        case E_QImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_QImode)
                {
                  if (gpc_reg_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 431; /* fix_truncsfqi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 435; /* fix_truncdfqi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 443; /* *fix_truncsfqi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 449; /* *fix_truncdfqi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_QImode)
            return -1;
          if (altivec_register_operand (operands[0], E_QImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1139; /* fix_trunckfqi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1143; /* fix_trunctfqi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern336 (
E_QImode))
            {
            case 0:
              if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1147; /* *fix_trunckfqi2_mem */

            case 1:
              if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1153; /* *fix_trunctfqi2_mem */

            default:
              return -1;
            }

        case E_HImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_HImode)
                {
                  if (gpc_reg_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 433; /* fix_truncsfhi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 437; /* fix_truncdfhi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 445; /* *fix_truncsfhi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 451; /* *fix_truncdfhi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_HImode)
            return -1;
          if (altivec_register_operand (operands[0], E_HImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1141; /* fix_trunckfhi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1145; /* fix_trunctfhi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern336 (
E_HImode))
            {
            case 0:
              if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1149; /* *fix_trunckfhi2_mem */

            case 1:
              if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1155; /* *fix_trunctfhi2_mem */

            default:
              return -1;
            }

        case E_TImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_TImode)
            return -1;
          if (vsx_register_operand (operands[0], E_TImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (vsx_register_operand (operands[1], E_KFmode)
                      && (
#line 6951 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 495; /* fix_trunckfti2 */
                  break;

                case E_TFmode:
                  if (vsx_register_operand (operands[1], E_TFmode)
                      && (
#line 6951 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 496; /* fix_trunctfti2 */
                  break;

                default:
                  break;
                }
            }
          if (!gpc_reg_operand (operands[0], E_TImode)
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 261 "../../../gcc/config/rs6000/dfp.md"
(TARGET_POWER10))
            return -1;
          return 2453; /* fixtdti2 */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V4SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SImode)
              && gpc_reg_operand (operands[1], E_V4SFmode)
              && 
#line 2292 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1400; /* vsx_fix_truncv4sfv4si2 */
          if (!vsx_register_operand (operands[0], E_V4SImode)
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 2503 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1436; /* vsx_xvcvspsxws */

        case E_V2DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V2DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DImode)
              && gpc_reg_operand (operands[1], E_V2DFmode)
              && 
#line 2292 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1401; /* vsx_fix_truncv2dfv2di2 */
          if (!vsx_register_operand (operands[0], E_V2DImode)
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2510 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1438; /* vsx_xvcvdpsxds */

        case E_V4SFmode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && 
#line 2323 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1410; /* vsx_btruncv4sf2 */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 2468 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 2073; /* *altivec_vrfiz */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2323 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1411; /* vsx_btruncv2df2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 242 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2449; /* ftruncdd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_TDmode
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 242 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2450; /* ftrunctd2 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 2680 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
        return -1;
      return 1450; /* vsx_xvcvspsxds_be */

    case 2:
      if (!
#line 2689 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
        return -1;
      return 1452; /* vsx_xvcvspsxds_le */

    default:
      return -1;
    }
}

 int
recog_137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_117 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_DUPLICATE:
      res = recog_118 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (vsx_register_operand (operands[0], E_V8HImode)
          && xxspltib_constant_nosplit (operands[1], E_V8HImode)
          && 
#line 1156 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1284; /* xxspltib_v8hi_nosplit */
      if (altivec_register_operand (operands[0], E_V8HImode)
          && xxspltib_constant_split (operands[1], E_V8HImode)
          && 
#line 1174 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1287; /* *xxspltib_v8hi_split */
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && input_operand (operands[1], E_V8HImode))
        {
          if (
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))))
            return 1292; /* vsx_movv8hi_64bit */
          if (
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))))
            return 1302; /* *vsx_movv8hi_32bit */
          if (
#line 245 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))))
            return 1790; /* *altivec_movv8hi */
        }
      break;

    case E_V4SImode:
      if (vsx_register_operand (operands[0], E_V4SImode)
          && xxspltib_constant_nosplit (operands[1], E_V4SImode)
          && 
#line 1156 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1285; /* xxspltib_v4si_nosplit */
      if (altivec_register_operand (operands[0], E_V4SImode)
          && xxspltib_constant_split (operands[1], E_V4SImode)
          && 
#line 1174 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1288; /* *xxspltib_v4si_split */
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && input_operand (operands[1], E_V4SImode))
        {
          if (
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))))
            return 1293; /* vsx_movv4si_64bit */
          if (
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))))
            return 1303; /* *vsx_movv4si_32bit */
        }
      break;

    case E_V2DImode:
      if (vsx_register_operand (operands[0], E_V2DImode)
          && xxspltib_constant_nosplit (operands[1], E_V2DImode)
          && 
#line 1156 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1286; /* xxspltib_v2di_nosplit */
      if (altivec_register_operand (operands[0], E_V2DImode))
        {
          if (xxspltib_constant_split (operands[1], E_V2DImode)
              && 
#line 1174 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return 1289; /* *xxspltib_v2di_split */
          if (vspltisw_vupkhsw_constant_split (operands[1], E_V2DImode)
              && 
#line 1213 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P8_VECTOR && vspltisw_vupkhsw_constant_split (operands[1], V2DImode)))
            return 1290; /* *vspltisw_v2di_split */
        }
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && input_operand (operands[1], E_V2DImode))
        {
          if (
#line 1258 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))))
            return 1294; /* vsx_movv2di_64bit */
          if (
#line 1312 "../../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))))
            return 1304; /* *vsx_movv2di_32bit */
          if (
#line 245 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))))
            return 1794; /* *altivec_movv2di */
        }
      break;

    default:
      break;
    }
  operands[0] = x2;
  res = recog_119 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case VEC_DUPLICATE:
      res = recog_120 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_121 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (pnum_clobbers != NULL
      && memory_operand (operands[0], E_V4SImode))
    {
      operands[1] = x2;
      if (immediate_operand (operands[1], E_V4SImode)
          && 
#line 3458 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SImode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SImode)
   && const_vec_duplicate_p (operands[1])))
        {
          *pnum_clobbers = 1;
          return 1488; /* vsx_stxvd2x4_le_const_v4si */
        }
    }
  if (nonimmediate_operand (operands[0], E_V4SImode))
    {
      operands[1] = x2;
      if (input_operand (operands[1], E_V4SImode)
          && 
#line 245 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))))
        return 1789; /* *altivec_movv4si */
    }
  operands[0] = x2;
  switch (pattern32 (x3, 
E_V4SImode))
    {
    case 0:
      if ((
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2240; /* altivec_stvx_v4si_2op_si */
      break;

    case 1:
      if ((
#line 3218 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2241; /* altivec_stvx_v4si_2op_di */
      break;

    case 2:
      if ((
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2258; /* altivec_stvx_v4si_1op_si */
      break;

    case 3:
      if ((
#line 3226 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2259; /* altivec_stvx_v4si_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  switch (pattern35 (x1, 
E_V4SImode))
    {
    case 0:
      if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 2195; /* altivec_lvx_v4si_2op_si */

    case 1:
      if (!(
#line 3162 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2196; /* altivec_lvx_v4si_2op_di */

    case 2:
      if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 2213; /* altivec_lvx_v4si_1op_si */

    case 3:
      if (!(
#line 3170 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2214; /* altivec_lvx_v4si_1op_di */

    default:
      return -1;
    }
}

 int
recog_146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_SFmode)
          && gpc_reg_operand (operands[1], E_DFmode)
          && 
#line 5278 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return 330; /* *truncdfsf2_fpr */
      if (pnum_clobbers == NULL
          || !vsx_register_operand (operands[0], E_SFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15257 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1129; /* trunckfsf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15257 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1130; /* trunctfsf2_hw */

        default:
          return -1;
        }

    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DFmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_IFmode:
              if (gpc_reg_operand (operands[1], E_IFmode))
                {
                  if ((
#line 8978 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 615; /* truncifdf2_internal1 */
                  if ((
#line 8994 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 617; /* truncifdf2_internal2 */
                }
              break;

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode))
                {
                  if ((
#line 8978 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 616; /* trunctfdf2_internal1 */
                  if ((
#line 8994 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 618; /* trunctfdf2_internal2 */
                }
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15244 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1127; /* trunckfdf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15244 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1128; /* trunctfdf2_hw */

        default:
          return -1;
        }

    case E_SDmode:
      if (!gpc_reg_operand (operands[0], E_SDmode)
          || GET_MODE (x3) != E_SDmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DDmode:
          if (!gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 80 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2426; /* truncddsd2 */

        case E_TDmode:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 165 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2435; /* trunctdsd2 */

        default:
          return -1;
        }

    case E_DDmode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 154 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      *pnum_clobbers = 1;
      return 2434; /* trunctddd2 */

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case MULT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != MULT
          || GET_MODE (x10) != E_SImode
          || GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x6, 1);
      operands[4] = x13;
      if (!gpc_reg_operand (operands[4], E_SImode))
        return -1;
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x15 = XEXP (x10, 0);
      if (GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XEXP (x10, 1);
      if (GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[4]))
        return -1;
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern601 (x1, 
ASHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case SIGN_EXTEND:
              if (pattern606 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1274 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 37; /* *macchwc */

            case ASHIFTRT:
              if (pattern607 (x1, 
ASHIFTRT) != 0
                  || !
#line 1340 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 41; /* *machhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern601 (x1, 
LSHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case ZERO_EXTEND:
              if (pattern606 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1306 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 39; /* *macchwuc */

            case LSHIFTRT:
              if (pattern607 (x1, 
LSHIFTRT) != 0
                  || !
#line 1375 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 43; /* *machhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern602 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1406 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 45; /* *maclhwc */

        case ZERO_EXTEND:
          if (pattern602 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1435 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 47; /* *maclhwuc */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x7;
      x13 = XEXP (x6, 1);
      operands[2] = x13;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (pattern202 (x1, 
PLUS))
            {
            case 0:
              if (!
#line 1872 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 70; /* *addsi3_dot */

            case 1:
              if (!(
#line 1872 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 71; /* *adddi3_dot */

            case 2:
              if (!
#line 1896 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 72; /* *addsi3_dot2 */

            case 3:
              if (!(
#line 1896 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 73; /* *adddi3_dot2 */

            default:
              return -1;
            }

        case CONST_INT:
          if (pnum_clobbers == NULL)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PLUS)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x17 = XEXP (x9, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern582 (x9, 
E_SImode) != 0
                  || !
#line 1944 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 76; /* *addsi3_imm_dot2 */

            case E_DImode:
              if (pattern582 (x9, 
E_DImode) != 0
                  || !(
#line 1944 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 77; /* *adddi3_imm_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern178 (x1, 
ZERO_EXTEND))
        {
        case 0:
          return 9; /* *zero_extendqisi2_dot */

        case 1:
          return 15; /* *zero_extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 10; /* *zero_extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 16; /* *zero_extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 20; /* *zero_extendsidi2_dot */

        case 5:
          return 11; /* *zero_extendqisi2_dot2 */

        case 6:
          return 17; /* *zero_extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 12; /* *zero_extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 18; /* *zero_extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 21; /* *zero_extendsidi2_dot2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern178 (x1, 
SIGN_EXTEND))
        {
        case 0:
          return 24; /* *extendqisi2_dot */

        case 1:
          return 30; /* *extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 25; /* *extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 31; /* *extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 35; /* *extendsidi2_dot */

        case 5:
          return 26; /* *extendqisi2_dot2 */

        case 6:
          return 32; /* *extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 27; /* *extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 33; /* *extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 36; /* *extendsidi2_dot2 */

        default:
          return -1;
        }

    case PLUS:
      return recog_155 (x1, insn, pnum_clobbers);

    case MINUS:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case MULT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != MINUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != MULT
              || GET_MODE (x10) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x11 = XEXP (x4, 0);
          operands[4] = x11;
          if (!gpc_reg_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (GET_MODE (x12) != E_SImode)
            return -1;
          x13 = XEXP (x7, 1);
          if (GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          x16 = XEXP (x10, 1);
          if (GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x9, 0);
          if (!rtx_equal_p (x17, operands[4]))
            return -1;
          switch (GET_CODE (x12))
            {
            case ASHIFTRT:
              x18 = XEXP (x12, 1);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  || GET_CODE (x15) != ASHIFTRT)
                return -1;
              x19 = XEXP (x15, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x20 = XEXP (x12, 0);
              if (!gpc_reg_operand (x20, E_SImode))
                return -1;
              switch (GET_CODE (x13))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x16) != SIGN_EXTEND)
                    return -1;
                  operands[2] = x20;
                  x21 = XEXP (x13, 0);
                  operands[1] = x21;
                  if (!gpc_reg_operand (operands[1], E_HImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[2]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[1])
                      || !
#line 1466 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 49; /* *nmacchwc */

                case ASHIFTRT:
                  x24 = XEXP (x13, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                      || GET_CODE (x16) != ASHIFTRT)
                    return -1;
                  x25 = XEXP (x16, 1);
                  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x20;
                  x21 = XEXP (x13, 0);
                  operands[2] = x21;
                  if (!gpc_reg_operand (operands[2], E_SImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[1]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[2])
                      || !
#line 1500 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 51; /* *nmachhwc */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_CODE (x15) != SIGN_EXTEND
                  || GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x20 = XEXP (x12, 0);
              operands[1] = x20;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x21 = XEXP (x13, 0);
              operands[2] = x21;
              if (!gpc_reg_operand (operands[2], E_HImode))
                return -1;
              x22 = XEXP (x15, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x23 = XEXP (x16, 0);
              if (!rtx_equal_p (x23, operands[2])
                  || !
#line 1531 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 53; /* *nmaclhwc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x7;
          x11 = XEXP (x4, 0);
          operands[2] = x11;
          switch (pattern486 (x1))
            {
            case 0:
              if (!
#line 2215 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 104; /* *subfsi3_dot */

            case 1:
              if (!(
#line 2215 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 105; /* *subfdi3_dot */

            case 2:
              if (!
#line 2239 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 106; /* *subfsi3_dot2 */

            case 3:
              if (!(
#line 2239 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 107; /* *subfdi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern440 (x1, 
ASHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              if (pattern598 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1560 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 55; /* *mulchwc */

            case ASHIFTRT:
              if (pattern599 (x1, 
ASHIFTRT) != 0
                  || !
#line 1620 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 59; /* *mulhhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern440 (x1, 
LSHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              if (pattern598 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1589 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 57; /* *mulchwuc */

            case LSHIFTRT:
              if (pattern599 (x1, 
LSHIFTRT) != 0
                  || !
#line 1652 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 61; /* *mulhhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern441 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1680 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 63; /* *mullhwc */

        case ZERO_EXTEND:
          if (pattern441 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1706 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 65; /* *mullhwuc */

        case REG:
        case SUBREG:
          switch (pattern203 (x1, 
MULT))
            {
            case 0:
              if (!
#line 3124 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 167; /* *mulsi3_dot */

            case 1:
              if (!(
#line 3124 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 168; /* *muldi3_dot */

            case 2:
              if (!
#line 3149 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 169; /* *mulsi3_dot2 */

            case 3:
              if (!(
#line 3149 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 170; /* *muldi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern181 (x1, 
NOT))
        {
        case 0:
          if (!
#line 2132 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 98; /* *one_cmplsi2_dot */

        case 1:
          if (!(
#line 2132 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 99; /* *one_cmpldi2_dot */

        case 2:
          if (!
#line 2153 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 100; /* *one_cmplsi2_dot2 */

        case 3:
          if (!(
#line 2153 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 101; /* *one_cmpldi2_dot2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern181 (x1, 
NEG))
        {
        case 0:
          if (!
#line 2410 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 129; /* *negsi2_dot */

        case 1:
          if (!(
#line 2410 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 130; /* *negdi2_dot */

        case 2:
          if (!
#line 2431 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 131; /* *negsi2_dot2 */

        case 3:
          if (!(
#line 2431 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 132; /* *negdi2_dot2 */

        default:
          return -1;
        }

    case DIV:
      if (pattern182 (x1, pnum_clobbers, 
DIV) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      x9 = XEXP (x8, 1);
      x17 = XEXP (x9, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x10 = XEXP (x9, 1);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern575 (x9, 
E_SImode) != 0
              || !
#line 3420 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 196; /* *divsi3_sra_dot2 */

        case E_DImode:
          if (pattern575 (x9, 
E_DImode) != 0
              || !(
#line 3420 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 197; /* *divdi3_sra_dot2 */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      if (!cc_reg_operand (x6, E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      if (GET_CODE (x4) == AND)
        {
          res = recog_154 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[4] = x6;
      switch (pattern391 (x1))
        {
        case 0:
          if (!
#line 4016 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 228; /* *boolsi3_dot */

        case 1:
          if (!(
#line 4016 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 229; /* *booldi3_dot */

        case 2:
          if (!
#line 4039 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 230; /* *boolsi3_dot2 */

        case 3:
          if (!(
#line 4039 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 231; /* *booldi3_dot2 */

        case 4:
          if (!
#line 4071 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 234; /* *boolcsi3_dot */

        case 5:
          if (!(
#line 4071 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 235; /* *boolcdi3_dot */

        case 6:
          if (!
#line 4094 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 236; /* *boolcsi3_dot2 */

        case 7:
          if (!(
#line 4094 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 237; /* *boolcdi3_dot2 */

        case 8:
          if (!
#line 4126 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 240; /* *boolccsi3_dot */

        case 9:
          if (!(
#line 4126 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 241; /* *boolccdi3_dot */

        case 10:
          if (!
#line 4149 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 242; /* *boolccsi3_dot2 */

        case 11:
          if (!(
#line 4149 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 243; /* *boolccdi3_dot2 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern184 (x1, 
ROTATE))
        {
        case 0:
          if (!
#line 4590 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 278; /* *rotlsi3_dot */

        case 1:
          if (!(
#line 4590 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 279; /* *rotldi3_dot */

        case 2:
          if (!
#line 4615 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 280; /* *rotlsi3_dot2 */

        case 3:
          if (!(
#line 4615 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 281; /* *rotldi3_dot2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 4658 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 285; /* *ashlsi3_dot */

        case 1:
          if (!(
#line 4658 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 286; /* *ashldi3_dot */

        case 2:
          if (!
#line 4683 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 287; /* *ashlsi3_dot2 */

        case 3:
          if (!(
#line 4683 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 288; /* *ashldi3_dot2 */

        case 4:
          if (!
#line 4732 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 290; /* ashdi3_extswsli_dot */

        case 5:
          if (!
#line 4782 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 291; /* ashdi3_extswsli_dot2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern184 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!
#line 4847 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 295; /* *lshrsi3_dot */

        case 1:
          if (!(
#line 4847 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 296; /* *lshrdi3_dot */

        case 2:
          if (!
#line 4872 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 297; /* *lshrsi3_dot2 */

        case 3:
          if (!(
#line 4872 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 298; /* *lshrdi3_dot2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern182 (x1, pnum_clobbers, 
ASHIFTRT) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 4945 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 304; /* *ashrsi3_dot2 */

        case 1:
          if (!(
#line 4945 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 305; /* *ashrdi3_dot2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      switch (pattern442 (x1))
        {
        case 0:
          if (!
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
            return -1;
          return 574; /* *movsi_internal2 */

        case 1:
          if (!
#line 513 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 575; /* *movdi_internal2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern186 (x1, 
CLOBBER, 
E_CCFPmode) != 0
          || GET_MODE (x3) != E_CCFPmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (!zero_constant (x5, E_V2DFmode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          x27 = XVECEXP (x4, 0, 1);
          operands[2] = x27;
          x28 = XVECEXP (x4, 0, 2);
          operands[3] = x28;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 342:
              switch (pattern583 ())
                {
                case 0:
                  if (!
#line 4610 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2337; /* *bcdadd_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2339; /* *bcdadd_test_v16qi */

                default:
                  return -1;
                }

            case 343:
              switch (pattern583 ())
                {
                case 0:
                  if (!
#line 4610 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2338; /* *bcdsub_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2340; /* *bcdsub_test_v16qi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 343)
            return -1;
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          operands[2] = x5;
          switch (GET_MODE (operands[1]))
            {
            case E_V1TImode:
              if (!register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !
#line 4737 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2353; /* *bcdinvalid_v1ti */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[0], E_V16QImode)
                  || !
#line 4737 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2354; /* *bcdinvalid_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      switch (pattern190 (x1))
        {
        case 0:
          if (!
#line 28 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2509; /* *ld_cmpdi_cr0_DI_clobber_CC_none */

        case 1:
          if (!
#line 112 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2513; /* *lwz_cmpwi_cr0_SI_clobber_CC_none */

        case 2:
          if (!
#line 239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2519; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 3:
          if (!(
#line 239 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2520; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 4:
          if (!
#line 49 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2510; /* *ld_cmpldi_cr0_DI_clobber_CCUNS_none */

        case 5:
          if (!
#line 133 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2514; /* *lwz_cmpldi_cr0_SI_clobber_CCUNS_none */

        case 6:
          if (!
#line 260 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2521; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 7:
          if (!(
#line 260 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2522; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 8:
          if (!
#line 323 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2527; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 9:
          if (!(
#line 323 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2528; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 10:
          if (!
#line 70 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2511; /* *ld_cmpdi_cr0_DI_DI_CC_none */

        case 11:
          if (!
#line 154 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2515; /* *lwz_cmpwi_cr0_SI_SI_CC_none */

        case 12:
          if (!
#line 91 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2512; /* *ld_cmpldi_cr0_DI_DI_CCUNS_none */

        case 13:
          if (!
#line 175 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2516; /* *lwz_cmpldi_cr0_SI_SI_CCUNS_none */

        case 14:
          if (!(
#line 196 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2517; /* *lwa_cmpdi_cr0_SI_EXTSI_CC_sign */

        case 15:
          if (!
#line 281 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2523; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 16:
          if (!(
#line 281 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2524; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 17:
          if (!(
#line 218 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2518; /* *lwz_cmpldi_cr0_SI_EXTSI_CCUNS_zero */

        case 18:
          if (!
#line 302 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2525; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 19:
          if (!(
#line 302 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2526; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 20:
          if (!
#line 344 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2529; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        case 21:
          if (!(
#line 344 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2530; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern80 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          switch (pattern477 (
E_DImode))
            {
            case 0:
              if (
#line 6326 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 425; /* fix_truncsfsi2_stfiwx */
              break;

            case 1:
              if (
#line 6326 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 426; /* fix_truncdfsi2_stfiwx */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      switch (pattern478 ())
        {
        case 0:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 447; /* *fix_truncsfsi2_mem */

        case 1:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 453; /* *fix_truncdfsi2_mem */

        case 2:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1151; /* *fix_trunckfsi2_mem */

        case 3:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1157; /* *fix_trunctfsi2_mem */

        default:
          return -1;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 431; /* fix_truncsfqi2 */
              break;

            case 1:
              if (
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 435; /* fix_truncdfqi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      switch (pattern479 (
E_QImode))
        {
        case 0:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 443; /* *fix_truncsfqi2_mem */

        case 1:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 449; /* *fix_truncdfqi2_mem */

        case 2:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1147; /* *fix_trunckfqi2_mem */

        case 3:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1153; /* *fix_trunctfqi2_mem */

        default:
          return -1;
        }

    case 2:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 433; /* fix_truncsfhi2 */
              break;

            case 1:
              if (
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 437; /* fix_truncdfhi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      switch (pattern479 (
E_HImode))
        {
        case 0:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 445; /* *fix_truncsfhi2_mem */

        case 1:
          if (!
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 451; /* *fix_truncdfhi2_mem */

        case 2:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1149; /* *fix_trunckfhi2_mem */

        case 3:
          if (!(
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1155; /* *fix_trunctfhi2_mem */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[3] = x6;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 17:
          if (GET_MODE (x3) != E_SImode
              || !mfcr_operation (operands[0], E_VOIDmode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !cc_reg_operand (operands[2], E_CCmode)
              || !
#line 13945 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MFCRF))
            return -1;
          return 1001; /* *movesi_from_cr_one */

        case 18:
          if (GET_MODE (x3) != E_CCmode
              || !mtcrf_operation (operands[0], E_VOIDmode)
              || !cc_reg_operand (operands[1], E_CCmode)
              || !gpc_reg_operand (operands[2], E_SImode))
            return -1;
          return 1019; /* *movsi_to_cr */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x3;
      if (gpc_reg_operand (operands[2], E_SImode))
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (memory_operand (operands[1], E_SImode))
            {
              if (crsave_operation (operands[0], E_VOIDmode))
                return 1003; /* *crsave */
              if (stmw_operation (operands[0], E_VOIDmode)
                  && 
#line 13984 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULTIPLE))
                return 1004; /* *stmw */
            }
        }
      if (!memory_operand (operands[2], E_SImode)
          || !lmw_operation (operands[0], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !
#line 14152 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_MULTIPLE))
        return -1;
      return 1021; /* *lmw */

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 1
          || !tie_operand (operands[0], E_VOIDmode))
        return -1;
      return 1017; /* stack_tie */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 21
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 108
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 108
          || GET_MODE (x4) != E_SImode
          || !vrsave_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 421 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1810; /* *set_vrsave_internal */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          switch (pattern179 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode)
                  && (
#line 3705 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3710 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_70 (insn, operands);
              if (!const_int_operand (operands[2], E_SImode))
                return NULL;
              if ((
#line 3785 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3794 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_74 (insn, operands);
              if (!(
#line 3859 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3864 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_80 (insn, operands);

            case 1:
              if (logical_const_operand (operands[2], E_DImode)
                  && ((
#line 3705 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3710 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_71 (insn, operands);
              if (!const_int_operand (operands[2], E_DImode))
                return NULL;
              if (((
#line 3785 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3794 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_75 (insn, operands);
              if (!((
#line 3859 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3864 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_81 (insn, operands);

            default:
              return NULL;
            }

        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != AND)
            return NULL;
          switch (pattern183 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode)
                  && (
#line 3730 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3735 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_72 (insn, operands);
              if (!const_int_operand (operands[2], E_SImode))
                return NULL;
              if ((
#line 3814 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3823 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_76 (insn, operands);
              if (!(
#line 3882 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3887 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_82 (insn, operands);

            case 1:
              if (logical_const_operand (operands[2], E_DImode)
                  && ((
#line 3730 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3735 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_73 (insn, operands);
              if (!const_int_operand (operands[2], E_DImode))
                return NULL;
              if (((
#line 3814 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3823 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_77 (insn, operands);
              if (!((
#line 3882 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3887 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x5;
      x6 = XEXP (x2, 0);
      operands[5] = x6;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      switch (pattern513 (x1))
        {
        case 0:
          if (!(
#line 4198 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)) && 
#line 4206 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_101 (insn, operands);

        case 1:
          if (!((
#line 4198 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4206 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_102 (insn, operands);

        case 2:
          if (!(
#line 4230 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)) && 
#line 4238 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_103 (insn, operands);

        case 3:
          if (!((
#line 4230 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4238 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_104 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if ((
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                return gen_split_200 (insn, operands);
              break;

            case 1:
              if ((
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                return gen_split_204 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return NULL;
      switch (pattern479 (
E_QImode))
        {
        case 0:
          if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 1:
          if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_214 (insn, operands);

        case 2:
          if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_508 (insn, operands);

        case 3:
          if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_514 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if ((
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                return gen_split_202 (insn, operands);
              break;

            case 1:
              if ((
#line 6405 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                return gen_split_206 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return NULL;
      switch (pattern479 (
E_HImode))
        {
        case 0:
          if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_210 (insn, operands);

        case 1:
          if (!(
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 2:
          if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_510 (insn, operands);

        case 3:
          if (!((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_516 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (memory_operand (operands[0], E_SImode))
        {
          switch (pattern478 ())
            {
            case 0:
              if ((
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_212 (insn, operands);
              break;

            case 1:
              if ((
#line 6438 "../../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_218 (insn, operands);
              break;

            case 2:
              if (((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_512 (insn, operands);
              break;

            case 3:
              if (((
#line 15308 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_518 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonimmediate_operand (operands[0], E_SImode))
        return NULL;
      switch (pattern477 (
E_DImode))
        {
        case 0:
          if (!(
#line 6467 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6471 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_219 (insn, operands);

        case 1:
          if (!(
#line 6467 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6471 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_220 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern263 (x2))
        {
        case 0:
          return gen_split_85 (insn, operands);

        case 1:
          if (!
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return NULL;
          return gen_split_87 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (!const_int_operand (x5, E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern206 (x2, 
E_SImode) != 0
                  || !
#line 4348 "../../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                return NULL;
              return gen_split_110 (insn, operands);

            case E_DImode:
              if (pattern206 (x2, 
E_DImode) != 0
                  || !(
#line 4348 "../../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_113 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          operands[3] = x5;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern545 (x2, 
E_SImode) != 0
                  || !
#line 4422 "../../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (SImode)))
                return NULL;
              return gen_split_115 (insn, operands);

            case E_DImode:
              if (pattern545 (x2, 
E_DImode) != 0
                  || !(
#line 4422 "../../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_116 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          operands[2] = x5;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern432 (x2, 
E_DImode) != 0)
                return NULL;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  if (!memory_operand (operands[3], E_QImode)
                      || !
#line 4504 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 8))
                    return NULL;
                  return gen_split_121 (insn, operands);

                case E_HImode:
                  if (!memory_operand (operands[3], E_HImode)
                      || !
#line 4504 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 16))
                    return NULL;
                  return gen_split_122 (insn, operands);

                case E_SImode:
                  if (!memory_operand (operands[3], E_SImode)
                      || !
#line 4504 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 32))
                    return NULL;
                  return gen_split_123 (insn, operands);

                default:
                  return NULL;
                }

            case E_SImode:
              if (pattern432 (x2, 
E_SImode) != 0)
                return NULL;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  if (!memory_operand (operands[3], E_QImode)
                      || !
#line 4549 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 8))
                    return NULL;
                  return gen_split_127 (insn, operands);

                case E_HImode:
                  if (!memory_operand (operands[3], E_HImode)
                      || !
#line 4549 "../../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 16))
                    return NULL;
                  return gen_split_128 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != ASHIFT)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return NULL;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern546 (x2, 
E_SImode) != 0
              || !
#line 4446 "../../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (SImode)))
            return NULL;
          return gen_split_117 (insn, operands);

        case E_DImode:
          if (pattern546 (x2, 
E_DImode) != 0
              || !(
#line 4446 "../../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          return gen_split_118 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_prefixed_constant (operands[1], E_SFmode)
          && 
#line 8750 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
        return gen_split_310 (insn, operands);
      break;

    case E_DFmode:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_prefixed_constant (operands[1], E_DFmode)
          && 
#line 8750 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
        return gen_split_311 (insn, operands);
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if (((
#line 8807 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TFmode)
   && (TFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))) && 
#line 8812 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_312 (insn, operands);
          if (((
#line 8843 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TFmode)
       || int_reg_operand_not_pseudo (operands[0], TFmode)
       || int_reg_operand_not_pseudo (operands[1], TFmode))
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))) && 
#line 8850 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_316 (insn, operands);
          if (((
#line 8861 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 543 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 8865 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_319 (insn, operands);
          if ((
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], TFmode)
       || int_reg_operand (operands[1], TFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TFmode)
           && !vsx_register_operand (operands[1], TFmode)))) && 
#line 561 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_364 (insn, operands);
          if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_540 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_TFmode)
          && memory_operand (operands[1], E_TFmode)
          && (
#line 1045 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TFmode)) && 
#line 36 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_585 (insn, operands);
      if (memory_operand (operands[0], E_TFmode)
          && vsx_register_operand (operands[1], E_TFmode))
        {
          if ((
#line 1075 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_589 (insn, operands);
          if ((
#line 1131 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_593 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_TFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_TFmode)
          && (
#line 286 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && reload_completed) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_701 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_TFmode)
          && (
#line 324 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && reload_completed) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_711 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_TFmode)
          || !(
#line 353 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return NULL;
      return gen_split_721 (insn, operands);

    case E_IFmode:
      if (!nonimmediate_operand (operands[0], E_IFmode)
          || !input_operand (operands[1], E_IFmode))
        return NULL;
      if (((
#line 8807 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (IFmode)
   && (IFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 8812 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_313 (insn, operands);
      if (((
#line 8843 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (IFmode)
       || int_reg_operand_not_pseudo (operands[0], IFmode)
       || int_reg_operand_not_pseudo (operands[1], IFmode))
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 8850 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_317 (insn, operands);
      if (!((
#line 8861 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 544 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8865 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_320 (insn, operands);

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !input_operand (operands[1], E_TDmode))
        return NULL;
      if (((
#line 8807 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TDmode)
   && (TDmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8812 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_314 (insn, operands);
      if ((
#line 8826 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && !WORDS_BIG_ENDIAN
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 8830 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_315 (insn, operands);
      if (((
#line 8843 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TDmode)
       || int_reg_operand_not_pseudo (operands[0], TDmode)
       || int_reg_operand_not_pseudo (operands[1], TDmode))
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8850 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_318 (insn, operands);
      if (!((
#line 8861 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 545 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8865 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_321 (insn, operands);

    case E_TImode:
      return split_12 (x1, insn);

    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && input_operand (operands[1], E_V16QImode))
        {
          if (
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V16QImode)
       || int_reg_operand (operands[1], V16QImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V16QImode)
           && !vsx_register_operand (operands[1], V16QImode)))))
            return gen_split_356 (insn, operands);
          if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_531 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V16QImode)
          && indexed_or_indirect_operand (operands[1], E_V16QImode)
          && (
#line 601 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 603 "../../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_569 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V16QImode)
          && vsx_register_operand (operands[1], E_V16QImode))
        {
          if (
#line 901 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_580 (insn, operands);
          if (
#line 959 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_581 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V16QImode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V16QImode)
          && 
#line 286 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && reload_completed))
        return gen_split_694 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V16QImode)
          && 
#line 324 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && reload_completed))
        return gen_split_704 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V16QImode)
          || !
#line 353 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_714 (insn, operands);

    case E_V8HImode:
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && input_operand (operands[1], E_V8HImode))
        {
          if (
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V8HImode)
       || int_reg_operand (operands[1], V8HImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V8HImode)
           && !vsx_register_operand (operands[1], V8HImode)))))
            return gen_split_357 (insn, operands);
          if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_532 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V8HImode)
          && indexed_or_indirect_operand (operands[1], E_V8HImode)
          && (
#line 547 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 549 "../../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_568 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V8HImode)
          || !vsx_register_operand (operands[1], E_V8HImode))
        return NULL;
      if (
#line 816 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_578 (insn, operands);
      if (!
#line 866 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_579 (insn, operands);

    case E_V4SImode:
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && input_operand (operands[1], E_V4SImode))
        {
          if (
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V4SImode)
       || int_reg_operand (operands[1], V4SImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SImode)
           && !vsx_register_operand (operands[1], V4SImode)))))
            return gen_split_358 (insn, operands);
          if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_533 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V4SImode)
          && indexed_or_indirect_operand (operands[1], E_V4SImode)
          && (
#line 497 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 499 "../../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_567 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V4SImode)
          || !vsx_register_operand (operands[1], E_V4SImode))
        return NULL;
      if (
#line 741 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_575 (insn, operands);
      if (!
#line 787 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_577 (insn, operands);

    case E_V4SFmode:
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode))
        {
          if (
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V4SFmode)
       || int_reg_operand (operands[1], V4SFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SFmode)
           && !vsx_register_operand (operands[1], V4SFmode)))))
            return gen_split_359 (insn, operands);
          if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_535 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && indexed_or_indirect_operand (operands[1], E_V4SFmode)
          && (
#line 497 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 499 "../../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_566 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode))
        {
          if (
#line 741 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_574 (insn, operands);
          if (
#line 787 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_576 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V4SFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V4SFmode)
          && 
#line 286 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && reload_completed))
        return gen_split_695 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V4SFmode)
          && 
#line 324 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && reload_completed))
        return gen_split_705 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V4SFmode)
          || !
#line 353 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_715 (insn, operands);

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && input_operand (operands[1], E_V2DImode))
        {
          if (
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V2DImode)
       || int_reg_operand (operands[1], V2DImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DImode)
           && !vsx_register_operand (operands[1], V2DImode)))))
            return gen_split_360 (insn, operands);
          if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_534 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V2DImode)
          && indexed_or_indirect_operand (operands[1], E_V2DImode)
          && (
#line 449 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 451 "../../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_565 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V2DImode)
          || !vsx_register_operand (operands[1], E_V2DImode))
        return NULL;
      if (
#line 671 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_571 (insn, operands);
      if (!
#line 715 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_573 (insn, operands);

    case E_V2DFmode:
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && input_operand (operands[1], E_V2DFmode))
        {
          if (
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V2DFmode)
       || int_reg_operand (operands[1], V2DFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DFmode)
           && !vsx_register_operand (operands[1], V2DFmode)))))
            return gen_split_361 (insn, operands);
          if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_536 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V2DFmode)
          && indexed_or_indirect_operand (operands[1], E_V2DFmode)
          && (
#line 449 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 451 "../../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_564 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V2DFmode)
          && vsx_register_operand (operands[1], E_V2DFmode))
        {
          if (
#line 671 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_570 (insn, operands);
          if (
#line 715 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_572 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V2DFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V2DFmode)
          && 
#line 286 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && reload_completed))
        return gen_split_696 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V2DFmode)
          && 
#line 324 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && reload_completed))
        return gen_split_706 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V2DFmode)
          || !
#line 353 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_716 (insn, operands);

    case E_V1TImode:
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && input_operand (operands[1], E_V1TImode))
        {
          if (
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V1TImode)
       || int_reg_operand (operands[1], V1TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V1TImode)
           && !vsx_register_operand (operands[1], V1TImode)))))
            return gen_split_362 (insn, operands);
          if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_537 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V1TImode)
          && memory_operand (operands[1], E_V1TImode)
          && 
#line 1045 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], V1TImode)))
        return gen_split_587 (insn, operands);
      if (memory_operand (operands[0], E_V1TImode)
          && vsx_register_operand (operands[1], E_V1TImode))
        {
          if (
#line 1075 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
            return gen_split_591 (insn, operands);
          if (
#line 1131 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
            return gen_split_595 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V1TImode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V1TImode)
          && 
#line 286 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && reload_completed))
        return gen_split_698 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V1TImode)
          && 
#line 324 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && reload_completed))
        return gen_split_708 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V1TImode)
          || !
#line 353 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_718 (insn, operands);

    case E_KFmode:
      if (nonimmediate_operand (operands[0], E_KFmode)
          && input_operand (operands[1], E_KFmode))
        {
          if ((
#line 9660 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], KFmode)
       || int_reg_operand (operands[1], KFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], KFmode)
           && !vsx_register_operand (operands[1], KFmode)))) && 
#line 560 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_363 (insn, operands);
          if (
#line 171 "../../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_539 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_KFmode)
          && memory_operand (operands[1], E_KFmode)
          && (
#line 1045 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], KFmode)) && 
#line 35 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_584 (insn, operands);
      if (memory_operand (operands[0], E_KFmode)
          && vsx_register_operand (operands[1], E_KFmode))
        {
          if ((
#line 1075 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_588 (insn, operands);
          if ((
#line 1131 "../../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_592 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_KFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_KFmode)
          && (
#line 286 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && reload_completed) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_700 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_KFmode)
          && (
#line 324 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && reload_completed) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_710 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_KFmode)
          || !(
#line 353 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return NULL;
      return gen_split_720 (insn, operands);

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && input_operand (operands[1], E_DImode)
          && 
#line 9856 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return gen_split_378 (insn, operands);
      if (int_reg_operand (operands[0], E_DImode)
          && const_int_operand (operands[1], E_DImode))
        {
          if (
#line 9957 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && num_insns_constant (operands[1], DImode) > 1
   && !IN_RANGE (INTVAL (operands[1]), -0x80000000, 0xffffffff)
   && rs6000_is_valid_and_mask (operands[1], DImode)))
            return gen_split_381 (insn, operands);
          if (
#line 9975 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[1], DImode) > 1))
            return gen_split_382 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_DImode)
          || !s5bit_cint_operand (operands[1], E_DImode)
          || !
#line 9987 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && reload_completed))
        return NULL;
      return gen_split_383 (insn, operands);

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !input_operand (operands[1], E_DFmode)
          || !
#line 9856 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_379 (insn, operands);

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !input_operand (operands[1], E_DDmode)
          || !
#line 9856 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_380 (insn, operands);

    case E_PTImode:
      if (!nonimmediate_operand (operands[0], E_PTImode)
          || !input_operand (operands[1], E_PTImode)
          || !
#line 10090 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return NULL;
      return gen_split_391 (insn, operands);

    case E_OOmode:
      if (!nonimmediate_operand (operands[0], E_OOmode)
          || !input_operand (operands[1], E_OOmode)
          || !(
#line 298 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], OOmode)
       || gpc_reg_operand (operands[1], OOmode))) && 
#line 305 "../../../gcc/config/rs6000/mma.md"
( reload_completed
   && (!MEM_P (operands[0]) && !MEM_P (operands[1])))))
        return NULL;
      return gen_split_738 (insn, operands);

    case E_XOmode:
      if (!nonimmediate_operand (operands[0], E_XOmode)
          || !input_operand (operands[1], E_XOmode)
          || !(
#line 345 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], XOmode)
       || gpc_reg_operand (operands[1], XOmode))) && 
#line 352 "../../../gcc/config/rs6000/mma.md"
( reload_completed)))
        return NULL;
      return gen_split_739 (insn, operands);

    default:
      return NULL;
    }
}
