/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 2L)
        return -1;
      return 0;

    case 1L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern3 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1, machine_mode i1, int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2]
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      return pattern6 (x3, 
E_V4SImode); /* [-1, 1] */

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          res = pattern67 (x1, 
E_DFmode);
          if (res >= 0)
            return res + 2; /* [2, 4] */
          return -1;

        case E_SFmode:
          res = pattern67 (x1, 
E_SFmode);
          if (res >= 0)
            return res + 5; /* [5, 7] */
          return -1;

        case E_IFmode:
          if (!gpc_reg_operand (operands[0], E_IFmode)
              || GET_MODE (x1) != E_IFmode
              || GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_QImode))
            return -1;
          return 8;

        case E_KFmode:
          res = pattern67 (x1, 
E_KFmode);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        case E_TFmode:
          res = pattern67 (x1, 
E_TFmode);
          if (res >= 0)
            return res + 12; /* [12, 14] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern86 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern91 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_V4SImode))
    return -1;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[0], E_IFmode)
          || GET_MODE (x3) != E_IFmode)
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      return 2;

    case E_TFmode:
      if (!gpc_reg_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern41 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern141 (x3, 
E_V4SFmode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 2;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_V16QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!vsx_register_operand (operands[0], E_V16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          return pattern179 (x1); /* [-1, 1] */

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT)
            return -1;
          res = pattern183 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!reg_or_mem_operand (operands[1], E_SImode)
          || !u6bit_cint_operand (operands[2], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          return 4;

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT
              || GET_MODE (x10) != E_DImode)
            return -1;
          x13 = XEXP (x10, 0);
          if (GET_CODE (x13) != SIGN_EXTEND
              || GET_MODE (x13) != E_DImode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x10, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern222 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern239 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          return pattern246 (x6); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern242 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern237 (x6);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern259 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern272 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern272 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern294 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern293 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern293 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern303 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern301 (x5); /* [-1, 1] */
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern309 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern309 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vlogical_operand (operands[1], i1)
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern324 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern330 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern339 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!vsx_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!vsx_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern354 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern354 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern361 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern370 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_or_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern378 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern385 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern402 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern399 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern396 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern416 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern425 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern423 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern423 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern424 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern424 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern424 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern424 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern424 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern424 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern424 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern424 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern424 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern424 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern445 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern445 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern446 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern446 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern446 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern446 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern446 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern446 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern446 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern446 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern446 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern446 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], E_V4SFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (!const_0_to_3_operand (x4, E_QImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (!scratch_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 0;

    case CONST_DOUBLE:
      operands[2] = x7;
      if (!zero_fp_constant (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 1;

    case VEC_SELECT:
      if (GET_MODE (x7) != E_SFmode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x4;
      operands[5] = x6;
      return 2;

    default:
      return -1;
    }
}

int
pattern492 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern501 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 3)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2)
    return -1;
  return 0;
}

int
pattern507 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern516 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern520 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern520 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern521 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern521 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern521 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern521 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern521 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern521 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern521 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern521 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern521 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern521 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern553 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern561 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern568 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[4] = x3;
      if (!altivec_register_operand (operands[4], E_V4SImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XVECEXP (x1, 0, 0);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_SImode:
          return pattern566 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern566 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case MEM:
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      x12 = XEXP (x10, 1);
      operands[4] = x12;
      x8 = XVECEXP (x1, 0, 0);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_SImode:
          if (pattern567 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern567 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern602 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x9, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x5, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x6, 0);
  operands[2] = x14;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x11, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LT:
      if (pattern48 (x1, 
E_CCmode, 
GT) == 0
          && 
#line 15710 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1208; /* setb_signed */
      break;

    case LTU:
      if (pattern48 (x1, 
E_CCUNSmode, 
GTU) == 0
          && 
#line 15723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1209; /* setb_unsigned */
      break;

    default:
      break;
    }
  operands[1] = x3;
  if (!scc_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern456 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5570 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 353; /* isel_cc_si */

        case 1:
          if (!
#line 5570 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 355; /* isel_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern456 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5570 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 354; /* isel_cc_di */

        case 1:
          if (!(
#line 5570 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 356; /* isel_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          switch (pattern429 (x3))
            {
            case 0:
              if (!
#line 403 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2535; /* *fuse_eqv_and */

            case 1:
              if (!(
#line 403 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2536; /* *fuse_eqv_and */

            case 2:
              if (!
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2719; /* *fuse_veqv_vand */

            case 3:
              if (!
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2720; /* *fuse_veqv_vand */

            case 4:
              if (!
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2721; /* *fuse_veqv_vand */

            case 5:
              if (!
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2722; /* *fuse_veqv_vand */

            case 6:
              if (!
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2723; /* *fuse_veqv_vand */

            case 7:
              if (!
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2724; /* *fuse_veqv_vand */

            case 8:
              if (!
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2725; /* *fuse_veqv_vand */

            case 9:
              if (!
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2726; /* *fuse_veqv_vand */

            case 10:
              if (!(
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2727; /* *fuse_veqv_vand */

            case 11:
              if (!(
#line 1915 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2728; /* *fuse_veqv_vand */

            default:
              return -1;
            }

        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern272 (x3, 
E_SImode) != 0
                  || !
#line 583 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2555; /* *fuse_eqv_andc */

            case E_DImode:
              if (pattern272 (x3, 
E_DImode) != 0
                  || !(
#line 583 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2556; /* *fuse_eqv_andc */

            case E_V4SImode:
              if (pattern273 (x3, 
E_V4SImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2799; /* *fuse_veqv_vandc */

            case E_V8HImode:
              if (pattern273 (x3, 
E_V8HImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2800; /* *fuse_veqv_vandc */

            case E_V16QImode:
              if (pattern273 (x3, 
E_V16QImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2801; /* *fuse_veqv_vandc */

            case E_V4SFmode:
              if (pattern273 (x3, 
E_V4SFmode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2802; /* *fuse_veqv_vandc */

            case E_V2DFmode:
              if (pattern273 (x3, 
E_V2DFmode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2803; /* *fuse_veqv_vandc */

            case E_V2DImode:
              if (pattern273 (x3, 
E_V2DImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2804; /* *fuse_veqv_vandc */

            case E_V1TImode:
              if (pattern273 (x3, 
E_V1TImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2805; /* *fuse_veqv_vandc */

            case E_TImode:
              if (pattern273 (x3, 
E_TImode) != 0
                  || !
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2806; /* *fuse_veqv_vandc */

            case E_KFmode:
              if (pattern273 (x3, 
E_KFmode) != 0
                  || !(
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2807; /* *fuse_veqv_vandc */

            case E_TFmode:
              if (pattern273 (x3, 
E_TFmode) != 0
                  || !(
#line 2059 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2808; /* *fuse_veqv_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern281 (x3))
        {
        case 0:
          if (!
#line 1015 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2603; /* *fuse_and_nor */

        case 1:
          if (!(
#line 1015 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2604; /* *fuse_and_nor */

        case 2:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3019; /* *fuse_vand_vnor */

        case 3:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3020; /* *fuse_vand_vnor */

        case 4:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3021; /* *fuse_vand_vnor */

        case 5:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3022; /* *fuse_vand_vnor */

        case 6:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3023; /* *fuse_vand_vnor */

        case 7:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3024; /* *fuse_vand_vnor */

        case 8:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3025; /* *fuse_vand_vnor */

        case 9:
          if (!
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3026; /* *fuse_vand_vnor */

        case 10:
          if (!(
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3027; /* *fuse_vand_vnor */

        case 11:
          if (!(
#line 2455 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3028; /* *fuse_vand_vnor */

        case 12:
          if (!
#line 1033 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2605; /* *fuse_andc_nor */

        case 13:
          if (!(
#line 1033 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2606; /* *fuse_andc_nor */

        case 14:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3029; /* *fuse_vandc_vnor */

        case 15:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3030; /* *fuse_vandc_vnor */

        case 16:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3031; /* *fuse_vandc_vnor */

        case 17:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3032; /* *fuse_vandc_vnor */

        case 18:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3033; /* *fuse_vandc_vnor */

        case 19:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3034; /* *fuse_vandc_vnor */

        case 20:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3035; /* *fuse_vandc_vnor */

        case 21:
          if (!
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3036; /* *fuse_vandc_vnor */

        case 22:
          if (!(
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3037; /* *fuse_vandc_vnor */

        case 23:
          if (!(
#line 2473 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3038; /* *fuse_vandc_vnor */

        case 24:
          if (!
#line 1087 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2611; /* *fuse_nor_nor */

        case 25:
          if (!(
#line 1087 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2612; /* *fuse_nor_nor */

        case 26:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3059; /* *fuse_vnor_vnor */

        case 27:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3060; /* *fuse_vnor_vnor */

        case 28:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3061; /* *fuse_vnor_vnor */

        case 29:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3062; /* *fuse_vnor_vnor */

        case 30:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3063; /* *fuse_vnor_vnor */

        case 31:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3064; /* *fuse_vnor_vnor */

        case 32:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3065; /* *fuse_vnor_vnor */

        case 33:
          if (!
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3066; /* *fuse_vnor_vnor */

        case 34:
          if (!(
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3067; /* *fuse_vnor_vnor */

        case 35:
          if (!(
#line 2527 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3068; /* *fuse_vnor_vnor */

        default:
          return -1;
        }

    case NOT:
      switch (pattern284 (x3))
        {
        case 0:
          if (!
#line 1051 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2607; /* *fuse_eqv_nor */

        case 1:
          if (!(
#line 1051 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2608; /* *fuse_eqv_nor */

        case 2:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3039; /* *fuse_veqv_vnor */

        case 3:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3040; /* *fuse_veqv_vnor */

        case 4:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3041; /* *fuse_veqv_vnor */

        case 5:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3042; /* *fuse_veqv_vnor */

        case 6:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3043; /* *fuse_veqv_vnor */

        case 7:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3044; /* *fuse_veqv_vnor */

        case 8:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3045; /* *fuse_veqv_vnor */

        case 9:
          if (!
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3046; /* *fuse_veqv_vnor */

        case 10:
          if (!(
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3047; /* *fuse_veqv_vnor */

        case 11:
          if (!(
#line 2491 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3048; /* *fuse_veqv_vnor */

        default:
          return -1;
        }

    case IOR:
      switch (pattern285 (x3))
        {
        case 0:
          if (!
#line 1069 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2609; /* *fuse_nand_nor */

        case 1:
          if (!(
#line 1069 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2610; /* *fuse_nand_nor */

        case 2:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3049; /* *fuse_vnand_vnor */

        case 3:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3050; /* *fuse_vnand_vnor */

        case 4:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3051; /* *fuse_vnand_vnor */

        case 5:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3052; /* *fuse_vnand_vnor */

        case 6:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3053; /* *fuse_vnand_vnor */

        case 7:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3054; /* *fuse_vnand_vnor */

        case 8:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3055; /* *fuse_vnand_vnor */

        case 9:
          if (!
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3056; /* *fuse_vnand_vnor */

        case 10:
          if (!(
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3057; /* *fuse_vnand_vnor */

        case 11:
          if (!(
#line 2509 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3058; /* *fuse_vnand_vnor */

        case 12:
          if (!
#line 1123 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2615; /* *fuse_orc_nor */

        case 13:
          if (!(
#line 1123 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2616; /* *fuse_orc_nor */

        case 14:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3079; /* *fuse_vorc_vnor */

        case 15:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3080; /* *fuse_vorc_vnor */

        case 16:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3081; /* *fuse_vorc_vnor */

        case 17:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3082; /* *fuse_vorc_vnor */

        case 18:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3083; /* *fuse_vorc_vnor */

        case 19:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3084; /* *fuse_vorc_vnor */

        case 20:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3085; /* *fuse_vorc_vnor */

        case 21:
          if (!
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3086; /* *fuse_vorc_vnor */

        case 22:
          if (!(
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3087; /* *fuse_vorc_vnor */

        case 23:
          if (!(
#line 2563 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3088; /* *fuse_vorc_vnor */

        case 24:
          if (!
#line 1105 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2613; /* *fuse_or_nor */

        case 25:
          if (!(
#line 1105 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2614; /* *fuse_or_nor */

        case 26:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3069; /* *fuse_vor_vnor */

        case 27:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3070; /* *fuse_vor_vnor */

        case 28:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3071; /* *fuse_vor_vnor */

        case 29:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3072; /* *fuse_vor_vnor */

        case 30:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3073; /* *fuse_vor_vnor */

        case 31:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3074; /* *fuse_vor_vnor */

        case 32:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3075; /* *fuse_vor_vnor */

        case 33:
          if (!
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3076; /* *fuse_vor_vnor */

        case 34:
          if (!(
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3077; /* *fuse_vor_vnor */

        case 35:
          if (!(
#line 2545 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3078; /* *fuse_vor_vnor */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 1159 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2619; /* *fuse_add_nor */

        case 1:
          if (!(
#line 1159 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2620; /* *fuse_add_nor */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 1177 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2621; /* *fuse_subf_nor */

        case 1:
          if (!(
#line 1177 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2622; /* *fuse_subf_nor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V2DFmode)
          && 
#line 3658 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1503; /* vsx_extract_v2df_var */
        }
      if (!memory_operand (operands[1], E_V2DFmode)
          || !
#line 3675 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1505; /* *vsx_extract_v2df_var_load */

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V4SFmode)
          && 
#line 3745 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1510; /* vsx_extract_v4sf_var */
        }
      if (!memory_operand (operands[1], E_V4SFmode)
          || !
#line 3762 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1511; /* *vsx_extract_v4sf_var_load */

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V16QImode)
          && 
#line 4185 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1531; /* vsx_extract_v16qi_var */
        }
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 4204 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1534; /* *vsx_extract_v16qi_var_load */

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V8HImode)
          && 
#line 4185 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1532; /* vsx_extract_v8hi_var */
        }
      if (!memory_operand (operands[1], E_V8HImode)
          || !
#line 4204 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1535; /* *vsx_extract_v8hi_var_load */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !vsx_register_operand (operands[2], E_DFmode)
          || !
#line 1969 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1351; /* *vsx_tdivdf3_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !vsx_register_operand (operands[2], E_V4SFmode)
          || !
#line 1969 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1352; /* *vsx_tdivv4sf3_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !vsx_register_operand (operands[2], E_V2DFmode)
          || !
#line 1969 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1353; /* *vsx_tdivv2df3_internal */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 4510 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2330; /* altivec_vbpermq */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 4520 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2331; /* altivec_vbpermq2 */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (pattern132 (x3, 
E_V4SFmode) != 0
          || !
#line 5484 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1691; /* xviexpsp */

    case E_V2DFmode:
      if (pattern132 (x3, 
E_V2DFmode) != 0
          || !
#line 5484 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1692; /* xviexpdp */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2547 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB))
        return -1;
      return 141; /* paritysi2_cmpb */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode)
          || !(
#line 2547 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 142; /* paritydi2_cmpb */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 4410 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2316; /* rs6000_vprtybv8hi2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 4410 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2317; /* rs6000_vprtybv4si2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 4410 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2318; /* rs6000_vprtybv2di2 */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 4410 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2319; /* rs6000_vprtybv1ti2 */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode)
          || !
#line 4410 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2320; /* rs6000_vprtybti2 */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1))
    {
    case 0:
      if (!
#line 6830 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 481; /* ceilsf2 */

    case 1:
      if (!
#line 6830 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 482; /* ceildf2 */

    case 2:
      if (!(
#line 15457 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1177; /* ceilkf2 */

    case 3:
      if (!(
#line 15457 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1178; /* ceiltf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2347 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1417; /* vsx_ceilv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2573 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2105; /* altivec_vrfip */

    case 5:
      if (!
#line 2347 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1418; /* vsx_ceilv2df2 */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !fusion_addis_mem_combo_load (operands[1], E_QImode)
          || !
#line 14733 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 1068; /* *fusion_gpr_load_qi */

    case E_HImode:
      if (!base_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !fusion_addis_mem_combo_load (operands[1], E_HImode)
          || !
#line 14733 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 1069; /* *fusion_gpr_load_hi */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15593 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1201; /* trunckfdf2_odd */

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15593 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1202; /* trunctfdf2_odd */

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_1_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 111 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2491; /* crypto_vshasigmaw */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 111 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2492; /* crypto_vshasigmad */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 11:
      switch (pattern129 (x1))
        {
        case 0:
          if (!(
#line 177 "../../../gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 3; /* load_macho_picbase_si */

        case 1:
          if (!(
#line 177 "../../../gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 4; /* load_macho_picbase_di */

        default:
          return -1;
        }

    case 12:
      switch (pattern129 (x1))
        {
        case 0:
          if (!(
#line 193 "../../../gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 5; /* reload_macho_picbase_si */

        case 1:
          if (!(
#line 193 "../../../gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 6; /* reload_macho_picbase_di */

        default:
          return -1;
        }

    case 90:
      if (pattern130 (x1) != 0
          || !
#line 2556 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_64BIT))
        return -1;
      return 143; /* cfuged */

    case 91:
      if (pattern130 (x1) != 0
          || !
#line 2565 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 144; /* cntlzdm */

    case 92:
      if (pattern130 (x1) != 0
          || !
#line 2574 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 145; /* cnttzdm */

    case 93:
      if (pattern131 (x1) != 0
          || !
#line 2583 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 146; /* pdepd */

    case 94:
      if (pattern131 (x1) != 0
          || !
#line 2592 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 147; /* pextd */

    case 51:
      return recog_60 (x1, insn, pnum_clobbers);

    case 99:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 5535 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 349; /* fmaxsf3 */

        case 1:
          if (!
#line 5535 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 351; /* fmaxdf3 */

        default:
          return -1;
        }

    case 100:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 5535 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 350; /* fminsf3 */

        case 1:
          if (!
#line 5535 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 352; /* fmindf3 */

        default:
          return -1;
        }

    case 4:
      return recog_59 (x1, insn, pnum_clobbers);

    case 59:
      return recog_42 (x1, insn, pnum_clobbers);

    case 63:
      return recog_32 (x1, insn, pnum_clobbers);

    case 14:
      return recog_37 (x1, insn, pnum_clobbers);

    case 20:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10660 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 762; /* tls_dtprel_32 */

        case 1:
          if (!(
#line 10660 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 763; /* tls_dtprel_64 */

        default:
          return -1;
        }

    case 21:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10672 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 764; /* tls_dtprel_ha_32 */

        case 1:
          if (!(
#line 10672 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 765; /* tls_dtprel_ha_64 */

        default:
          return -1;
        }

    case 22:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10680 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 766; /* tls_dtprel_lo_32 */

        case 1:
          if (!(
#line 10680 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 767; /* tls_dtprel_lo_64 */

        default:
          return -1;
        }

    case 23:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10688 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 768; /* tls_got_dtprel_32 */

        case 1:
          if (!(
#line 10688 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 769; /* tls_got_dtprel_64 */

        default:
          return -1;
        }

    case 24:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10728 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 774; /* tls_tprel_32 */

        case 1:
          if (!(
#line 10728 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 775; /* tls_tprel_64 */

        default:
          return -1;
        }

    case 25:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10740 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 776; /* tls_tprel_ha_32 */

        case 1:
          if (!(
#line 10740 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 777; /* tls_tprel_ha_64 */

        default:
          return -1;
        }

    case 26:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10748 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 778; /* tls_tprel_lo_32 */

        case 1:
          if (!(
#line 10748 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 779; /* tls_tprel_lo_64 */

        default:
          return -1;
        }

    case 27:
      return recog_38 (x1, insn, pnum_clobbers);

    case 29:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10808 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 788; /* tls_tls_pcrel_32 */

        case 1:
          if (!(
#line 10808 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 789; /* tls_tls_pcrel_64 */

        default:
          return -1;
        }

    case 28:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10816 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 790; /* tls_tls_32 */

        case 1:
          if (!(
#line 10816 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && HAVE_AS_TLS) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 791; /* tls_tls_64 */

        default:
          return -1;
        }

    case 18:
      return recog_58 (x1, insn, pnum_clobbers);

    case 70:
      return recog_50 (x1, insn, pnum_clobbers);

    case 71:
      return recog_41 (x1, insn, pnum_clobbers);

    case 78:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15489 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1183; /* addkf3_odd */

        case 1:
          if (!(
#line 15489 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1184; /* addtf3_odd */

        default:
          return -1;
        }

    case 79:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15500 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1185; /* subkf3_odd */

        case 1:
          if (!(
#line 15500 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1186; /* subtf3_odd */

        default:
          return -1;
        }

    case 80:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1187; /* mulkf3_odd */

        case 1:
          if (!(
#line 15511 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1188; /* multf3_odd */

        default:
          return -1;
        }

    case 81:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15522 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1189; /* divkf3_odd */

        case 1:
          if (!(
#line 15522 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1190; /* divtf3_odd */

        default:
          return -1;
        }

    case 75:
      if (pattern136 (x1) != 0
          || !
#line 15691 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return -1;
      return 1207; /* *cmprb_internal */

    case 76:
      if (pattern136 (x1) != 0
          || !
#line 15778 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return -1;
      return 1210; /* *cmprb2_internal */

    case 77:
      return recog_57 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern137 (x1, 
E_V2DImode) != 0
          || !
#line 1728 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1340; /* vsx_mul_v2di */

    case 130:
      if (pattern137 (x1, 
E_V2DImode) != 0
          || !
#line 1783 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1343; /* vsx_div_v2di */

    case 131:
      if (pattern137 (x1, 
E_V2DImode) != 0
          || !
#line 1830 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1344; /* vsx_udiv_v2di */

    case 132:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1887 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1345; /* vsx_div_v1ti */

    case 133:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1896 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1346; /* vsx_udiv_v1ti */

    case 134:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1905 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1347; /* vsx_dives_v1ti */

    case 135:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1914 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1348; /* vsx_diveu_v1ti */

    case 136:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1923 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1349; /* vsx_mods_v1ti */

    case 137:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1932 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1350; /* vsx_modu_v1ti */

    case 121:
      return recog_40 (x1, insn, pnum_clobbers);

    case 104:
      return recog_56 (x1, insn, pnum_clobbers);

    case 188:
      return recog_35 (x1, insn, pnum_clobbers);

    case 144:
      return recog_55 (x1, insn, pnum_clobbers);

    case 145:
      return recog_33 (x1, insn, pnum_clobbers);

    case 128:
      return recog_45 (x1, insn, pnum_clobbers);

    case 129:
      return recog_44 (x1, insn, pnum_clobbers);

    case 149:
      return recog_34 (x1, insn, pnum_clobbers);

    case 148:
      return recog_48 (x1, insn, pnum_clobbers);

    case 157:
      return recog_54 (x1, insn, pnum_clobbers);

    case 158:
      return recog_43 (x1, insn, pnum_clobbers);

    case 177:
      if (pattern138 (x1, 
E_V16QImode) != 0
          || !
#line 5887 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1706; /* vcmpnezb */

    case 179:
      if (pattern138 (x1, 
E_V8HImode) != 0
          || !
#line 5923 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1709; /* vcmpnezh */

    case 181:
      if (pattern138 (x1, 
E_V4SImode) != 0
          || !
#line 5943 "../../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1711; /* vcmpnezw */

    case 182:
      return recog_53 (x1, insn, pnum_clobbers);

    case 200:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 6497 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1758; /* dives_v2di */

        case 1:
          if (!
#line 6497 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1759; /* dives_v4si */

        default:
          return -1;
        }

    case 201:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 6507 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1760; /* diveu_v2di */

        case 1:
          if (!
#line 6507 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1761; /* diveu_v4si */

        default:
          return -1;
        }

    case 218:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 528 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1824; /* altivec_vaddcuw */

    case 248:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 572 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1836; /* altivec_vsubcuw */

    case 219:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 600 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1843; /* uavgv4si3_ceil */

        case 1:
          if (!
#line 600 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1844; /* uavgv8hi3_ceil */

        case 2:
          if (!
#line 600 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1845; /* uavgv16qi3_ceil */

        default:
          return -1;
        }

    case 220:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 609 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1846; /* avgv4si3_ceil */

        case 1:
          if (!
#line 609 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1847; /* avgv8hi3_ceil */

        case 2:
          if (!
#line 609 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1848; /* avgv16qi3_ceil */

        default:
          return -1;
        }

    case 209:
      if (pattern143 (x1, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 618 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1849; /* altivec_vcmpbfp */

    case 331:
      switch (pattern144 (x1))
        {
        case 0:
          if (!
#line 1535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1980; /* p8_vmrgew_v4sf_direct */

        case 1:
          if (!
#line 1535 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1981; /* p8_vmrgew_v4si_direct */

        default:
          return -1;
        }

    case 332:
      switch (pattern144 (x1))
        {
        case 0:
          if (!
#line 1544 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1982; /* p8_vmrgow_v4sf_direct */

        case 1:
          if (!
#line 1544 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1983; /* p8_vmrgow_v4si_direct */

        default:
          return -1;
        }

    case 221:
      if (pattern145 (x1) != 0
          || !
#line 1761 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1984; /* altivec_vmuleub */

    case 229:
      if (pattern145 (x1) != 0
          || !
#line 1770 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1985; /* altivec_vmuloub */

    case 222:
      if (pattern145 (x1) != 0
          || !
#line 1779 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1986; /* altivec_vmulesb */

    case 230:
      if (pattern145 (x1) != 0
          || !
#line 1788 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1987; /* altivec_vmulosb */

    case 223:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1797 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1988; /* altivec_vmuleuh */

    case 231:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1806 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1989; /* altivec_vmulouh */

    case 224:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1815 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1990; /* altivec_vmulesh */

    case 232:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1824 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1991; /* altivec_vmulosh */

    case 225:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1833 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1992; /* altivec_vmuleuw */

    case 227:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1842 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1993; /* altivec_vmuleud */

    case 233:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1851 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1994; /* altivec_vmulouw */

    case 235:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1860 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1995; /* altivec_vmuloud */

    case 226:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1869 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1996; /* altivec_vmulesw */

    case 228:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1878 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1997; /* altivec_vmulesd */

    case 234:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1887 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1998; /* altivec_vmulosw */

    case 236:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1896 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1999; /* altivec_vmulosd */

    case 237:
      if (pattern143 (x1, 
E_V4SImode, 
E_V8HImode) != 0
          || !
#line 1906 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2000; /* altivec_vpkpx */

    case 238:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1920 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2001; /* altivec_vpksdss */

        case 1:
          if (!
#line 1920 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2002; /* altivec_vpkswss */

        case 2:
          if (!
#line 1920 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2003; /* altivec_vpkshss */

        default:
          return -1;
        }

    case 239:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1934 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2004; /* altivec_vpksdus */

        case 1:
          if (!
#line 1934 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2005; /* altivec_vpkswus */

        case 2:
          if (!
#line 1934 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2006; /* altivec_vpkshus */

        default:
          return -1;
        }

    case 240:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1948 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2007; /* altivec_vpkudus */

        case 1:
          if (!
#line 1948 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2008; /* altivec_vpkuwus */

        case 2:
          if (!
#line 1948 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2009; /* altivec_vpkuhus */

        default:
          return -1;
        }

    case 241:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1962 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2010; /* altivec_vpkudum */

        case 1:
          if (!
#line 1962 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2011; /* altivec_vpkuwum */

        case 2:
          if (!
#line 1962 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2012; /* altivec_vpkuhum */

        default:
          return -1;
        }

    case 242:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1976 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2013; /* altivec_vpkudum_direct */

        case 1:
          if (!
#line 1976 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2014; /* altivec_vpkuwum_direct */

        case 2:
          if (!
#line 1976 "../../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2015; /* altivec_vpkuhum_direct */

        default:
          return -1;
        }

    case 347:
      return recog_49 (x1, insn, pnum_clobbers);

    case 244:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2079 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2027; /* altivec_vsl */

    case 245:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2088 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2028; /* altivec_vslo */

    case 309:
      if (pattern148 (x1, 
E_V16QImode) != 0
          || !
#line 2097 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2029; /* vslv */

    case 310:
      if (pattern148 (x1, 
E_V16QImode) != 0
          || !
#line 2106 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2030; /* vsrv */

    case 246:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2166 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2048; /* altivec_vsr */

    case 247:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2175 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2049; /* altivec_vsro */

    case 330:
      return recog_36 (x1, insn, pnum_clobbers);

    case 257:
      if (pattern149 (x1) != 0
          || !
#line 2598 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2108; /* altivec_vcfux */

    case 258:
      if (pattern149 (x1) != 0
          || !
#line 2607 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2109; /* altivec_vcfsx */

    case 334:
      if (pattern140 (x1, 
E_V1TImode) != 0
          || !
#line 4442 "../../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2323; /* altivec_vaddcuq */

    case 337:
      if (pattern140 (x1, 
E_V1TImode) != 0
          || !
#line 4459 "../../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2325; /* altivec_vsubcuq */

    case 340:
      return recog_47 (x1, insn, pnum_clobbers);

    case 341:
      if (pattern148 (x1, 
E_V2DImode) != 0
          || !
#line 4529 "../../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2332; /* altivec_vbpermd */

    case 348:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4636 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2345; /* vcfuged */

    case 349:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4645 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2346; /* vclzdm */

    case 350:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4654 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2347; /* vctzdm */

    case 352:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4663 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2348; /* vpdepd */

    case 353:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4672 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2349; /* vpextd */

    case 354:
      if (pattern150 (x1) != 0
          || !
#line 4690 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2351; /* vclrlb */

    case 355:
      if (pattern150 (x1) != 0
          || !
#line 4704 "../../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2352; /* vclrrb */

    case 361:
      return recog_52 (x1, insn, pnum_clobbers);

    case 362:
      return recog_51 (x1, insn, pnum_clobbers);

    case 416:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2365; /* mma_xvi4ger8 */

    case 418:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2366; /* mma_xvi8ger4 */

    case 412:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2367; /* mma_xvi16ger2 */

    case 414:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2368; /* mma_xvi16ger2s */

    case 397:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2369; /* mma_xvf16ger2 */

    case 392:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2370; /* mma_xvbf16ger2 */

    case 402:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2371; /* mma_xvf32ger */

    case 407:
      if (pattern151 (x1, 
E_OOmode) != 0
          || !
#line 549 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2389; /* mma_xvf64ger */

    case 425:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_0_to_3_operand (operands[1], E_QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern382 (x2))
        {
        case 0:
          if (!
#line 284 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2454; /* dfp_ddedpd_dd */

        case 1:
          if (!
#line 284 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2455; /* dfp_ddedpd_td */

        default:
          return -1;
        }

    case 426:
      return recog_39 (x1, insn, pnum_clobbers);

    case 427:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern382 (x2))
        {
        case 0:
          if (!
#line 335 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2461; /* dfp_diex_dd */

        case 1:
          if (!
#line 335 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2462; /* dfp_diex_td */

        default:
          return -1;
        }

    case 429:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 385 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2465; /* dfp_dscli_dd */

        case 1:
          if (!
#line 385 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2466; /* dfp_dscli_td */

        default:
          return -1;
        }

    case 431:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 395 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2467; /* dfp_dscri_dd */

        case 1:
          if (!
#line 395 "../../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2468; /* dfp_dscri_td */

        default:
          return -1;
        }

    case 433:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2473; /* crypto_vcipher_v16qi */

        case 1:
          if (!
#line 71 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2477; /* crypto_vcipher_v2di */

        default:
          return -1;
        }

    case 434:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2474; /* crypto_vncipher_v16qi */

        case 1:
          if (!
#line 71 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2478; /* crypto_vncipher_v2di */

        default:
          return -1;
        }

    case 435:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2475; /* crypto_vcipherlast_v16qi */

        case 1:
          if (!
#line 71 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2479; /* crypto_vcipherlast_v2di */

        default:
          return -1;
        }

    case 436:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2476; /* crypto_vncipherlast_v16qi */

        case 1:
          if (!
#line 71 "../../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2480; /* crypto_vncipherlast_v2di */

        default:
          return -1;
        }

    case 440:
      return recog_46 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 11:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 6526 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 461; /* rs6000_mffscrn */

            case CONST_INT:
              if (!const_0_to_3_operand (operands[1], E_SImode)
                  || !
#line 6534 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 462; /* rs6000_mffscrni */

            default:
              return -1;
            }

        case 6:
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (pattern216 (x2))
            {
            case 0:
              if (pnum_clobbers != NULL
                  && 
#line 14589 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
                {
                  *pnum_clobbers = 2;
                  return 1061; /* rs6000_get_timebase_ppc32 */
                }
              if (!
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 1063; /* rs6000_mftb_di */

            case 1:
              return 1062; /* rs6000_mftb_si */

            default:
              return -1;
            }

        case 10:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || !
#line 14645 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1064; /* rs6000_mffsl_hw */

        case 9:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || !
#line 14681 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1065; /* rs6000_mffs */

        case 7:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 15638 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 1205; /* darnsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !(
#line 15638 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 1206; /* darndi */

            default:
              return -1;
            }

        case 95:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!simple_offsettable_mem_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!int_reg_operand (operands[1], E_DImode)
              || !
#line 15845 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_rop_protect))
            return -1;
          return 1212; /* hashst */

        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!int_reg_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !memory_operand (operands[1], E_QImode)
                  || !
#line 273 "../../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1224; /* load_lockedqi */

            case E_HImode:
              if (!int_reg_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !memory_operand (operands[1], E_HImode)
                  || !
#line 274 "../../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1225; /* load_lockedhi */

            case E_SImode:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!memory_operand (operands[1], E_SImode))
                    return -1;
                  return 1226; /* load_lockedsi */

                case E_QImode:
                  if (!memory_operand (operands[1], E_QImode)
                      || !
#line 290 "../../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                    return -1;
                  return 1228; /* load_lockedqi_si */

                case E_HImode:
                  if (!memory_operand (operands[1], E_HImode)
                      || !
#line 290 "../../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                    return -1;
                  return 1229; /* load_lockedhi_si */

                default:
                  return -1;
                }

            case E_DImode:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !memory_operand (operands[1], E_DImode)
                  || !
#line 276 "../../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1227; /* load_lockeddi */

            case E_PTImode:
              if (!quad_int_reg_operand (operands[0], E_PTImode)
                  || GET_MODE (x2) != E_PTImode
                  || !indexed_or_indirect_operand (operands[1], E_TImode)
                  || !
#line 334 "../../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI
   && !reg_mentioned_p (operands[0], operands[1])
   && quad_int_reg_operand (operands[0], PTImode)))
                return -1;
              return 1230; /* load_lockedpti */

            default:
              return -1;
            }

        case 22:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 109
              || GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_V4SImode)
              || !
#line 2938 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2159; /* altivec_mtvscr */

        case 23:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 109
              || GET_MODE (x4) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_V8HImode)
              || !
#line 2945 "../../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2160; /* altivec_mfvscr */

        case 27:
          if (GET_MODE (x2) != E_XOmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!fpr_reg_operand (operands[0], E_XOmode)
              || !
#line 521 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2364; /* mma_xxsetaccz */

        case 38:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!u10bit_cint_operand (operands[1], E_VOIDmode))
            return -1;
          switch (pattern9 (x2))
            {
            case 0:
              if (!
#line 272 "../../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2505; /* htm_mfspr_si */

            case 1:
              if (!(
#line 272 "../../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2506; /* htm_mfspr_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x2, 1))
        {
        case 19:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern377 (x2, 
E_SImode) != 0
                  || !(
#line 11390 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 813; /* *pltseq_plt16_lo_si */

            case E_DImode:
              if (pattern377 (x2, 
E_DImode) != 0
                  || !(
#line 11390 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 814; /* *pltseq_plt16_lo_di */

            default:
              return -1;
            }

        case 20:
          switch (pattern337 (x2))
            {
            case 0:
              if (!(
#line 11413 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_PLTSEQ && TARGET_ELF
   && rs6000_pcrel_p ()) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 817; /* *pltseq_plt_pcrelsi */

            case 1:
              if (!(
#line 11413 "../../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_PLTSEQ && TARGET_ELF
   && rs6000_pcrel_p ()) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 818; /* *pltseq_plt_pcreldi */

            default:
              return -1;
            }

        case 3:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern378 (x2, 
E_SImode) != 0
                  || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 870; /* probe_stack_rangesi */

            case E_DImode:
              if (pattern378 (x2, 
E_DImode) != 0
                  || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 871; /* probe_stack_rangedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (pattern29 (x1) != 0
          || !
#line 455 "../../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)))
        return -1;
      return 2360; /* *mma_assemble_acc */

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 22; /* extendqisi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode))
                return -1;
              return 28; /* *extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode)
                  || !
#line 490 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 23; /* extendqidi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode)
                  || !
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 29; /* *extendhidi2 */

            case E_SImode:
              if (!lwa_operand (operands[1], E_SImode)
                  || !
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 34; /* extendsidi2 */

            default:
              return -1;
            }

        case E_TImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !input_operand (operands[1], E_DImode)
              || !
#line 5133 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && TARGET_POWER10))
            return -1;
          *pnum_clobbers = 1;
          return 1657; /* extendditi2 */

        default:
          return -1;
        }

    case PLUS:
      if (pattern38 (x3) != 0
          || !
#line 2388 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 126; /* *subfsi3_carry_in_xx_64 */

    case ASHIFTRT:
      if (pnum_clobbers == NULL
          || pattern36 (x3) != 0
          || !
#line 4906 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 1;
      return 301; /* *ashrsi3_64 */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 3)
        return -1;
      switch (pattern208 (x4))
        {
        case 0:
          if (!int_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!d_form_memory (operands[1], E_SImode)
                  || !(
#line 170 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 3350; /* *pcrel_opt_ldsi_di_gpr */

            case E_HImode:
              if (!d_form_memory (operands[1], E_HImode)
                  || !(
#line 185 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 3354; /* *pcrel_opt_ldhi_di_gpr */

            default:
              return -1;
            }

        case 1:
          if (!int_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode
              || !d_form_memory (operands[1], E_HImode)
              || !
#line 185 "../../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          *pnum_clobbers = 1;
          return 3352; /* *pcrel_opt_ldhi_si_gpr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || pattern37 (x3, 
E_SImode, 
32, 
E_DImode) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 3239 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 179; /* smulsi3_highpart_64 */

        case ZERO_EXTEND:
          if (GET_CODE (x7) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 3239 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 180; /* umulsi3_highpart_64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_TImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !
#line 1382 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1315; /* vsx_stxvrbx */

        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !
#line 1382 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1316; /* vsx_stxvrhx */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 1382 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1317; /* vsx_stxvrwx */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !
#line 1382 "../../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1318; /* vsx_stxvrdx */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern403 (x6))
        {
        case 0:
          if (!
#line 835 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2583; /* *fuse_and_nand */

        case 1:
          if (!(
#line 835 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2584; /* *fuse_and_nand */

        case 2:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2939; /* *fuse_vand_vnand */

        case 3:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2940; /* *fuse_vand_vnand */

        case 4:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2941; /* *fuse_vand_vnand */

        case 5:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2942; /* *fuse_vand_vnand */

        case 6:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2943; /* *fuse_vand_vnand */

        case 7:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2944; /* *fuse_vand_vnand */

        case 8:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2945; /* *fuse_vand_vnand */

        case 9:
          if (!
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2946; /* *fuse_vand_vnand */

        case 10:
          if (!(
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2947; /* *fuse_vand_vnand */

        case 11:
          if (!(
#line 2311 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2948; /* *fuse_vand_vnand */

        case 12:
          if (!
#line 853 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2585; /* *fuse_andc_nand */

        case 13:
          if (!(
#line 853 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2586; /* *fuse_andc_nand */

        case 14:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2949; /* *fuse_vandc_vnand */

        case 15:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2950; /* *fuse_vandc_vnand */

        case 16:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2951; /* *fuse_vandc_vnand */

        case 17:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2952; /* *fuse_vandc_vnand */

        case 18:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2953; /* *fuse_vandc_vnand */

        case 19:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2954; /* *fuse_vandc_vnand */

        case 20:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2955; /* *fuse_vandc_vnand */

        case 21:
          if (!
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2956; /* *fuse_vandc_vnand */

        case 22:
          if (!(
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2957; /* *fuse_vandc_vnand */

        case 23:
          if (!(
#line 2329 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2958; /* *fuse_vandc_vnand */

        case 24:
          if (!
#line 907 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2591; /* *fuse_nor_nand */

        case 25:
          if (!(
#line 907 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2592; /* *fuse_nor_nand */

        case 26:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2979; /* *fuse_vnor_vnand */

        case 27:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2980; /* *fuse_vnor_vnand */

        case 28:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2981; /* *fuse_vnor_vnand */

        case 29:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2982; /* *fuse_vnor_vnand */

        case 30:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2983; /* *fuse_vnor_vnand */

        case 31:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2984; /* *fuse_vnor_vnand */

        case 32:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2985; /* *fuse_vnor_vnand */

        case 33:
          if (!
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2986; /* *fuse_vnor_vnand */

        case 34:
          if (!(
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2987; /* *fuse_vnor_vnand */

        case 35:
          if (!(
#line 2383 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2988; /* *fuse_vnor_vnand */

        default:
          return -1;
        }

    case NOT:
      switch (pattern406 (x6))
        {
        case 0:
          if (!
#line 871 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2587; /* *fuse_eqv_nand */

        case 1:
          if (!(
#line 871 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2588; /* *fuse_eqv_nand */

        case 2:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2959; /* *fuse_veqv_vnand */

        case 3:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2960; /* *fuse_veqv_vnand */

        case 4:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2961; /* *fuse_veqv_vnand */

        case 5:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2962; /* *fuse_veqv_vnand */

        case 6:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2963; /* *fuse_veqv_vnand */

        case 7:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2964; /* *fuse_veqv_vnand */

        case 8:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2965; /* *fuse_veqv_vnand */

        case 9:
          if (!
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2966; /* *fuse_veqv_vnand */

        case 10:
          if (!(
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2967; /* *fuse_veqv_vnand */

        case 11:
          if (!(
#line 2347 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2968; /* *fuse_veqv_vnand */

        default:
          return -1;
        }

    case IOR:
      switch (pattern407 (x6))
        {
        case 0:
          if (!
#line 889 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2589; /* *fuse_nand_nand */

        case 1:
          if (!(
#line 889 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2590; /* *fuse_nand_nand */

        case 2:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2969; /* *fuse_vnand_vnand */

        case 3:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2970; /* *fuse_vnand_vnand */

        case 4:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2971; /* *fuse_vnand_vnand */

        case 5:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2972; /* *fuse_vnand_vnand */

        case 6:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2973; /* *fuse_vnand_vnand */

        case 7:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2974; /* *fuse_vnand_vnand */

        case 8:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2975; /* *fuse_vnand_vnand */

        case 9:
          if (!
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2976; /* *fuse_vnand_vnand */

        case 10:
          if (!(
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2977; /* *fuse_vnand_vnand */

        case 11:
          if (!(
#line 2365 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2978; /* *fuse_vnand_vnand */

        case 12:
          if (!
#line 943 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2595; /* *fuse_orc_nand */

        case 13:
          if (!(
#line 943 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2596; /* *fuse_orc_nand */

        case 14:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2999; /* *fuse_vorc_vnand */

        case 15:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3000; /* *fuse_vorc_vnand */

        case 16:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3001; /* *fuse_vorc_vnand */

        case 17:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3002; /* *fuse_vorc_vnand */

        case 18:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3003; /* *fuse_vorc_vnand */

        case 19:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3004; /* *fuse_vorc_vnand */

        case 20:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3005; /* *fuse_vorc_vnand */

        case 21:
          if (!
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3006; /* *fuse_vorc_vnand */

        case 22:
          if (!(
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3007; /* *fuse_vorc_vnand */

        case 23:
          if (!(
#line 2419 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3008; /* *fuse_vorc_vnand */

        case 24:
          if (!
#line 925 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2593; /* *fuse_or_nand */

        case 25:
          if (!(
#line 925 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2594; /* *fuse_or_nand */

        case 26:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2989; /* *fuse_vor_vnand */

        case 27:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2990; /* *fuse_vor_vnand */

        case 28:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2991; /* *fuse_vor_vnand */

        case 29:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2992; /* *fuse_vor_vnand */

        case 30:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2993; /* *fuse_vor_vnand */

        case 31:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2994; /* *fuse_vor_vnand */

        case 32:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2995; /* *fuse_vor_vnand */

        case 33:
          if (!
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2996; /* *fuse_vor_vnand */

        case 34:
          if (!(
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2997; /* *fuse_vor_vnand */

        case 35:
          if (!(
#line 2401 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2998; /* *fuse_vor_vnand */

        default:
          return -1;
        }

    case XOR:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 1);
      operands[1] = x10;
      x11 = XEXP (x6, 1);
      switch (GET_CODE (x11))
        {
        case NOT:
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern393 (x6, 
E_SImode) != 0
                  || !
#line 961 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2597; /* *fuse_xor_nand */

            case E_DImode:
              if (pattern393 (x6, 
E_DImode) != 0
                  || !(
#line 961 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2598; /* *fuse_xor_nand */

            case E_V4SImode:
              if (pattern395 (x6, 
E_V4SImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3009; /* *fuse_vxor_vnand */

            case E_V8HImode:
              if (pattern395 (x6, 
E_V8HImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3010; /* *fuse_vxor_vnand */

            case E_V16QImode:
              if (pattern395 (x6, 
E_V16QImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3011; /* *fuse_vxor_vnand */

            case E_V4SFmode:
              if (pattern395 (x6, 
E_V4SFmode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3012; /* *fuse_vxor_vnand */

            case E_V2DFmode:
              if (pattern395 (x6, 
E_V2DFmode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3013; /* *fuse_vxor_vnand */

            case E_V2DImode:
              if (pattern395 (x6, 
E_V2DImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3014; /* *fuse_vxor_vnand */

            case E_V1TImode:
              if (pattern395 (x6, 
E_V1TImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3015; /* *fuse_vxor_vnand */

            case E_TImode:
              if (pattern395 (x6, 
E_TImode) != 0
                  || !
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3016; /* *fuse_vxor_vnand */

            case E_KFmode:
              if (pattern395 (x6, 
E_KFmode) != 0
                  || !(
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3017; /* *fuse_vxor_vnand */

            case E_TFmode:
              if (pattern395 (x6, 
E_TFmode) != 0
                  || !(
#line 2437 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3018; /* *fuse_vxor_vnand */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern527 (x6, 
E_SImode) != 0
                  || !
#line 1231 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2627; /* *fuse_eqv_or */

            case E_DImode:
              if (pattern527 (x6, 
E_DImode) != 0
                  || !(
#line 1231 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2628; /* *fuse_eqv_or */

            case E_V4SImode:
              if (pattern528 (x6, 
E_V4SImode) != 0
                  || !
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3119; /* *fuse_veqv_vor */

            case E_V8HImode:
              if (pattern528 (x6, 
E_V8HImode) != 0
                  || !
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3120; /* *fuse_veqv_vor */

            case E_V16QImode:
              if (pattern528 (x6, 
E_V16QImode) != 0
                  || !
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3121; /* *fuse_veqv_vor */

            case E_V4SFmode:
              if (pattern528 (x6, 
E_V4SFmode) != 0
                  || !
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3122; /* *fuse_veqv_vor */

            case E_V2DFmode:
              if (pattern528 (x6, 
E_V2DFmode) != 0
                  || !
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3123; /* *fuse_veqv_vor */

            case E_V2DImode:
              if (pattern528 (x6, 
E_V2DImode) != 0
                  || !
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3124; /* *fuse_veqv_vor */

            case E_V1TImode:
              if (pattern528 (x6, 
E_V1TImode) != 0
                  || !
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3125; /* *fuse_veqv_vor */

            case E_TImode:
              if (pattern528 (x6, 
E_TImode) != 0
                  || !
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3126; /* *fuse_veqv_vor */

            case E_KFmode:
              if (pattern528 (x6, 
E_KFmode) != 0
                  || !(
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3127; /* *fuse_veqv_vor */

            case E_TFmode:
              if (pattern528 (x6, 
E_TFmode) != 0
                  || !(
#line 2635 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3128; /* *fuse_veqv_vor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 979 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2599; /* *fuse_add_nand */

        case 1:
          if (!(
#line 979 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2600; /* *fuse_add_nand */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 997 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2601; /* *fuse_subf_nand */

        case 1:
          if (!(
#line 997 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2602; /* *fuse_subf_nand */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern519 (x1, 
E_SImode) != 0)
                    return -1;
                  return 108; /* subfsi3_imm */

                case E_DImode:
                  if (pattern519 (x1, 
E_DImode) != 0
                      || !
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 109; /* subfdi3_imm */

                default:
                  return -1;
                }

            case SET:
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != LEU)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98)
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x9, 1);
              if (!rtx_equal_p (x11, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern564 (x1, 
E_SImode) != 0
                      || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 112; /* subfsi3_carry */

                case E_DImode:
                  if (pattern564 (x1, 
E_DImode) != 0
                      || !
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 113; /* subfdi3_carry */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              switch (pattern472 (x3))
                {
                case 0:
                  if (!
#line 1807 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2691; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2692; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern474 (x3))
                {
                case 0:
                  if (!
#line 1843 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2695; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2696; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case NOT:
              switch (pattern474 (x3))
                {
                case 0:
                  if (!
#line 1825 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2693; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2694; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern472 (x3))
                {
                case 0:
                  if (!
#line 1861 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2697; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2698; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 1735 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2683; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2684; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2687; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2688; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern196 (x1))
        {
        case 0:
          if (!
#line 1753 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2685; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2686; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2689; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2690; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  if (pnum_clobbers != NULL)
    {
      switch (pattern199 (x1))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (current_file_function_operand (operands[1], E_SImode)
                  && (
#line 11512 "../../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                {
                  *pnum_clobbers = 1;
                  return 821; /* *call_value_localsi */
                }
              if (symbol_ref_operand (operands[1], E_SImode)
                  && unspec_tls (operands[2], E_SImode))
                {
                  if ((
#line 11637 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 831; /* *call_value_nonlocal_sysvsi */
                    }
                  if ((
#line 11705 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 837; /* *call_value_nonlocal_aixsi */
                    }
                }
              break;

            case E_DImode:
              if (current_file_function_operand (operands[1], E_DImode)
                  && (
#line 11512 "../../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 822; /* *call_value_localdi */
                }
              if (symbol_ref_operand (operands[1], E_DImode)
                  && unspec_tls (operands[2], E_DImode))
                {
                  if ((
#line 11637 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 832; /* *call_value_nonlocal_sysvdi */
                    }
                  if ((
#line 11705 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 838; /* *call_value_nonlocal_aixdi */
                    }
                }
              break;

            default:
              break;
            }
          break;

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (indirect_call_operand (operands[1], E_SImode)
                  && unspec_tls (operands[2], E_SImode))
                {
                  if ((
#line 11609 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 829; /* *call_value_indirect_nonlocal_sysvsi */
                    }
                  if ((
#line 11823 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 849; /* *call_value_indirect_pcrelsi */
                    }
                }
              break;

            case E_DImode:
              if (indirect_call_operand (operands[1], E_DImode)
                  && unspec_tls (operands[2], E_DImode))
                {
                  if ((
#line 11609 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 830; /* *call_value_indirect_nonlocal_sysvdi */
                    }
                  if ((
#line 11823 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 850; /* *call_value_indirect_pcreldi */
                    }
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SIMPLE_RETURN)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!call_operand (operands[1], E_SImode)
          || !(
#line 12080 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 865; /* *sibcall_value_aixsi */

    case E_DImode:
      if (!call_operand (operands[1], E_DImode)
          || !(
#line 12080 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 866; /* *sibcall_value_aixdi */

    default:
      return -1;
    }
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case FLOAT:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern305 (x1))
            {
            case 0:
              if (!
#line 6217 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 417; /* *floatqisf2_internal */

            case 1:
              if (!
#line 6217 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 418; /* *floathisf2_internal */

            case 2:
              if (!
#line 6217 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 419; /* *floatqidf2_internal */

            case 3:
              if (!
#line 6217 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 420; /* *floathidf2_internal */

            default:
              return -1;
            }

        case CALL:
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != MEM)
            return -1;
          switch (pattern199 (x1))
            {
            case 0:
              if (pattern483 (x1, 
96, 
USE) != 0)
                return -1;
              x5 = XVECEXP (x1, 0, 2);
              x8 = XEXP (x5, 0);
              operands[4] = x8;
              if (!register_operand (operands[4], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode))
                    return -1;
                  x6 = XVECEXP (x1, 0, 3);
                  x9 = XEXP (x6, 0);
                  if (GET_MODE (x9) != E_SImode
                      || !(
#line 11662 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 833; /* *call_value_nonlocal_sysv_securesi */

                case E_DImode:
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  x6 = XVECEXP (x1, 0, 3);
                  x9 = XEXP (x6, 0);
                  if (GET_MODE (x9) != E_DImode
                      || !(
#line 11662 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 834; /* *call_value_nonlocal_sysv_securedi */

                default:
                  return -1;
                }

            case 1:
              switch (pattern484 (x1, pnum_clobbers))
                {
                case 0:
                  x5 = XVECEXP (x1, 0, 2);
                  x8 = XEXP (x5, 0);
                  operands[4] = x8;
                  x6 = XVECEXP (x1, 0, 3);
                  x10 = XEXP (x6, 1);
                  x11 = XVECEXP (x10, 0, 0);
                  operands[5] = x11;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SImode:
                      if (pattern596 (x6, 
E_SImode) != 0
                          || !(
#line 11749 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 841; /* *call_value_indirect_aixsi */

                    case E_DImode:
                      if (pattern596 (x6, 
E_DImode) != 0
                          || !(
#line 11749 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 842; /* *call_value_indirect_aixdi */

                    default:
                      return -1;
                    }

                case 1:
                  x5 = XVECEXP (x1, 0, 2);
                  x12 = XEXP (x5, 1);
                  x13 = XVECEXP (x12, 0, 0);
                  operands[4] = x13;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SImode:
                      if (pattern597 (x1, 
E_SImode) != 0
                          || !(
#line 11806 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        return -1;
                      return 847; /* *call_value_indirect_elfv2si */

                    case E_DImode:
                      if (pattern597 (x1, 
E_DImode) != 0
                          || !(
#line 11806 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return -1;
                      return 848; /* *call_value_indirect_elfv2di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 888; /* eqsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 908; /* eqsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 898; /* eqdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 918; /* eqdidi2_isel */

            default:
              return -1;
            }

        case NE:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          x16 = XEXP (x4, 0);
          operands[3] = x16;
          x8 = XEXP (x5, 0);
          operands[4] = x8;
          x9 = XEXP (x6, 0);
          operands[5] = x9;
          switch (pattern529 (x3))
            {
            case 0:
              if (
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return 889; /* nesisi2_isel */
              break;

            case 1:
              if ((
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 909; /* nesidi2_isel */
              break;

            case 2:
              if (reg_or_short_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && scratch_operand (operands[5], E_CCmode)
                  && (
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 899; /* nedisi2_isel */
              if (scc_eq_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_SImode)
                  && scratch_operand (operands[4], E_SImode)
                  && scratch_operand (operands[5], E_DImode)
                  && (
#line 13248 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 945; /* *nesi3_extdi */
              break;

            case 3:
              if ((
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 919; /* nedidi2_isel */
              break;

            default:
              break;
            }
          if (GET_CODE (x9) != REG)
            return -1;
          switch (pattern531 (x1))
            {
            case 0:
              if (!(
#line 12993 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 930; /* *nesi3 */

            case 1:
              if (!(
#line 12993 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 931; /* *nedi3 */

            default:
              return -1;
            }

        case LT:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 890; /* ltsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 910; /* ltsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 900; /* ltdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 920; /* ltdidi2_isel */

            default:
              return -1;
            }

        case LTU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 891; /* ltusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 911; /* ltusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 901; /* ltudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 921; /* ltudidi2_isel */

            default:
              return -1;
            }

        case GT:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 892; /* gtsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 912; /* gtsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 902; /* gtdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 922; /* gtdidi2_isel */

            default:
              return -1;
            }

        case GTU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 893; /* gtusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 913; /* gtusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 903; /* gtudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 923; /* gtudidi2_isel */

            default:
              return -1;
            }

        case LE:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 894; /* lesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 914; /* lesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 904; /* ledisi2_isel */

            case 3:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 924; /* ledidi2_isel */

            default:
              return -1;
            }

        case LEU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 895; /* leusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 915; /* leusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 905; /* leudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 925; /* leudidi2_isel */

            default:
              return -1;
            }

        case GE:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 896; /* gesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 916; /* gesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 906; /* gedisi2_isel */

            case 3:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 926; /* gedidi2_isel */

            default:
              return -1;
            }

        case GEU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 897; /* geusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 917; /* geusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 907; /* geudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 927; /* geudidi2_isel */

            default:
              return -1;
            }

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern308 (x1))
            {
            case 0:
              if (!(
#line 13026 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 932; /* *neg_eq_si */

            case 1:
              if (!(
#line 13026 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 933; /* *neg_eq_di */

            case 2:
              if (!(
#line 13058 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 934; /* *neg_ne_si */

            case 3:
              if (!(
#line 13058 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 935; /* *neg_ne_di */

            default:
              return -1;
            }

        case PLUS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern311 (x1))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 936; /* *plus_eq_si */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 937; /* *plus_eq_di */

            case 2:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 938; /* *plus_ne_si */

            case 3:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 939; /* *plus_ne_di */

            default:
              return -1;
            }

        case MINUS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern314 (x1))
            {
            case 0:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 940; /* *minus_eq_si */

            case 1:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 941; /* *minus_eq_di */

            case 2:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 942; /* *minus_ne_si */

            case 3:
              if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 943; /* *minus_ne_di */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          if (pattern116 (x1) != 0)
            return -1;
          x15 = XEXP (x3, 1);
          x17 = XEXP (x15, 0);
          operands[0] = x17;
          x4 = XVECEXP (x1, 0, 1);
          x16 = XEXP (x4, 0);
          operands[2] = x16;
          x5 = XVECEXP (x1, 0, 2);
          x8 = XEXP (x5, 0);
          operands[3] = x8;
          if (!scratch_operand (operands[3], E_CCmode))
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case EQ:
              switch (pattern578 (x1))
                {
                case 0:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 990; /* bdz_si */

                case 1:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 992; /* bdz_di */

                default:
                  return -1;
                }

            case NE:
              switch (pattern578 (x1))
                {
                case 0:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 991; /* bdnz_si */

                case 1:
                  if (!
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 993; /* bdnz_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          x15 = XEXP (x3, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x18 = XVECEXP (x15, 0, 0);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern482 (x1))
            {
            case 0:
              if (!
#line 5024 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1644; /* *vsx_reduc_plus_v4sf_scalar */

            case 1:
              if (!
#line 5024 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1645; /* *vsx_reduc_smin_v4sf_scalar */

            case 2:
              if (!
#line 5024 "../../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1646; /* *vsx_reduc_smax_v4sf_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x14 = XEXP (x2, 0);
      if (GET_CODE (x14) != MEM)
        return -1;
      switch (pattern117 (x1))
        {
        case 0:
          if (pattern483 (x1, 
96, 
USE) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x8 = XEXP (x5, 0);
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!symbol_ref_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              x9 = XEXP (x6, 0);
              if (GET_MODE (x9) != E_SImode
                  || !(
#line 11588 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 827; /* *call_nonlocal_sysv_securesi */

            case E_DImode:
              if (!symbol_ref_operand (operands[0], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              x9 = XEXP (x6, 0);
              if (GET_MODE (x9) != E_DImode
                  || !(
#line 11588 "../../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 828; /* *call_nonlocal_sysv_securedi */

            default:
              return -1;
            }

        case 1:
          switch (pattern484 (x1, pnum_clobbers))
            {
            case 0:
              x5 = XVECEXP (x1, 0, 2);
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              x6 = XVECEXP (x1, 0, 3);
              x10 = XEXP (x6, 1);
              x11 = XVECEXP (x10, 0, 0);
              operands[4] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern591 (x6, 
E_SImode) != 0
                      || !(
#line 11728 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 839; /* *call_indirect_aixsi */

                case E_DImode:
                  if (pattern591 (x6, 
E_DImode) != 0
                      || !(
#line 11728 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 840; /* *call_indirect_aixdi */

                default:
                  return -1;
                }

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              x12 = XEXP (x5, 1);
              x13 = XVECEXP (x12, 0, 0);
              operands[3] = x13;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern592 (x1, 
E_SImode) != 0
                      || !(
#line 11770 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 843; /* *call_indirect_elfv2si */

                case E_DImode:
                  if (pattern592 (x1, 
E_DImode) != 0
                      || !(
#line 11770 "../../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 844; /* *call_indirect_elfv2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_7 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case COMPARE:
              switch (pattern96 (x1))
                {
                case 0:
                  if (!(
#line 1919 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1923 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_29 (insn, operands);

                case 1:
                  if (!((
#line 1919 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1923 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_30 (insn, operands);

                case 2:
                  if (!(
#line 1944 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1948 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_31 (insn, operands);

                case 3:
                  if (!((
#line 1944 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1948 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_32 (insn, operands);

                case 4:
                  if (!((
#line 2275 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 2279 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_43 (insn, operands);

                case 5:
                  if (!((
#line 2275 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 2279 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_44 (insn, operands);

                case 6:
                  if (!(
#line 3394 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3398 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_62 (insn, operands);

                case 7:
                  if (!((
#line 3394 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3398 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_63 (insn, operands);

                case 8:
                  if (!(
#line 3420 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3424 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_64 (insn, operands);

                case 9:
                  if (!((
#line 3420 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3424 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_65 (insn, operands);

                case 10:
                  if (!(
#line 3654 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3659 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_66 (insn, operands);

                case 11:
                  if (!((
#line 3654 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3659 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_67 (insn, operands);

                case 12:
                  if (!(
#line 3681 "../../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3686 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_68 (insn, operands);

                case 13:
                  if (!((
#line 3681 "../../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3686 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_69 (insn, operands);

                case 14:
                  if (!(
#line 4918 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4922 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_144 (insn, operands);

                case 15:
                  if (!((
#line 4918 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4922 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_145 (insn, operands);

                case 16:
                  if (!(
#line 4945 "../../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4949 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_146 (insn, operands);

                case 17:
                  if (!((
#line 4945 "../../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4949 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_147 (insn, operands);

                default:
                  return NULL;
                }

            case BSWAP:
              if (GET_MODE (x3) != E_DImode)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!gpc_reg_operand (operands[2], E_DImode))
                return NULL;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!gpc_reg_operand (operands[3], E_DImode))
                return NULL;
              switch (GET_CODE (operands[1]))
                {
                case MEM:
                  if (!indexed_or_indirect_operand (operands[1], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode)
                      || !
#line 2828 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX && reload_completed))
                    return NULL;
                  return gen_split_52 (insn, operands);

                case REG:
                case SUBREG:
                  if (!gpc_reg_operand (operands[1], E_DImode))
                    return NULL;
                  switch (GET_CODE (operands[0]))
                    {
                    case MEM:
                      if (!indexed_or_indirect_operand (operands[0], E_DImode)
                          || !
#line 2891 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX && reload_completed))
                        return NULL;
                      return gen_split_53 (insn, operands);

                    case REG:
                    case SUBREG:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || !
#line 2953 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_P9_VECTOR && reload_completed))
                        return NULL;
                      return gen_split_54 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              switch (pattern97 (x1))
                {
                case 0:
                  if (!(
#line 3906 "../../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64) && 
#line 3909 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_84 (insn, operands);

                case 1:
                  if (!(
#line 7954 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))) && 
#line 7958 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_293 (insn, operands);

                case 2:
                  if (!(
#line 7954 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))) && 
#line 7958 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_294 (insn, operands);

                default:
                  return NULL;
                }

            case UNSIGNED_FLOAT:
              switch (pattern101 (x1))
                {
                case 0:
                  if (!(
#line 6269 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_191 (insn, operands);

                case 1:
                  if (!(
#line 6269 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_192 (insn, operands);

                case 2:
                  if (!(
#line 6269 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_193 (insn, operands);

                case 3:
                  if (!(
#line 6269 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_194 (insn, operands);

                case 4:
                  if (!(
#line 6744 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()) && 
#line 6748 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_223 (insn, operands);

                case 5:
                  if (!(
#line 6744 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()) && 
#line 6748 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_224 (insn, operands);

                case 6:
                  if (!(
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4483 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_642 (insn, operands);

                case 7:
                  if (!((
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 4483 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_644 (insn, operands);

                case 8:
                  if (!((
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4483 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_646 (insn, operands);

                case 9:
                  if (!((
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))) && 
#line 4483 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_648 (insn, operands);

                default:
                  return NULL;
                }

            case FIX:
              switch (pattern102 (x1))
                {
                case 0:
                  if (!(
#line 6362 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE) && 
#line 6365 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_197 (insn, operands);

                case 1:
                  if (!(
#line 6362 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE) && 
#line 6365 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                default:
                  return NULL;
                }

            case FLOAT:
              switch (pattern103 (x1))
                {
                case 0:
                  if (!(
#line 6711 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()) && 
#line 6715 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_221 (insn, operands);

                case 1:
                  if (!(
#line 6711 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()) && 
#line 6715 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_222 (insn, operands);

                case 2:
                  if (!(
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4483 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_641 (insn, operands);

                case 3:
                  if (!((
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 4483 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_643 (insn, operands);

                case 4:
                  if (!((
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4483 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_645 (insn, operands);

                case 5:
                  if (!((
#line 4481 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))) && 
#line 4483 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_647 (insn, operands);

                default:
                  return NULL;
                }

            case EQ:
              switch (pattern105 (x1))
                {
                case 0:
                  if (!(
#line 12928 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 12930 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_446 (insn, operands);

                case 1:
                  if (!((
#line 12928 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12930 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_447 (insn, operands);

                case 2:
                  if (!((
#line 13220 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13222 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_462 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC:
              if (XVECLEN (x3, 0) != 2
                  || XINT (x3, 1) != 145)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x10 = XVECEXP (x3, 0, 0);
              operands[1] = x10;
              x11 = XVECEXP (x3, 0, 1);
              operands[2] = x11;
              switch (pattern480 (x1))
                {
                case 0:
                  if (!(
#line 3658 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3660 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_609 (insn, operands);

                case 1:
                  if (!(
#line 3658 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3660 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_610 (insn, operands);

                case 2:
                  if (!(
#line 3745 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3747 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_616 (insn, operands);

                case 3:
                  if (!(
#line 4185 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4187 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_633 (insn, operands);

                case 4:
                  if (!(
#line 4185 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4187 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_634 (insn, operands);

                case 5:
                  if (!(
#line 4185 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4187 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_635 (insn, operands);

                default:
                  return NULL;
                }

            case VEC_SELECT:
              switch (pattern107 (x1))
                {
                case 0:
                  if (!(
#line 4049 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB) && 
#line 4051 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_624 (insn, operands);

                case 1:
                  if (!(
#line 4049 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB) && 
#line 4051 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_625 (insn, operands);

                case 2:
                  if (!(
#line 4049 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB) && 
#line 4051 "../../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_626 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (pattern108 (x1) != 0
                  || !(
#line 4949 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 4951 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_680 (insn, operands);

            case SMIN:
              if (pattern108 (x1) != 0
                  || !(
#line 4949 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 4951 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_681 (insn, operands);

            case SMAX:
              if (pattern108 (x1) != 0
                  || !(
#line 4949 "../../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 4951 "../../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_682 (insn, operands);

            default:
              return NULL;
            }

        case 6:
          if (pattern16 (x1) != 0
              || !(
#line 6081 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFID && TARGET_HARD_FLOAT) && 
#line 6083 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_185 (insn, operands);

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != CLOBBER)
            return NULL;
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != CLOBBER)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case UNSIGNED_FLOAT:
              if (GET_MODE (x3) != E_DFmode)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != USE)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != USE
                  || pattern411 (x1) != 0
                  || !(
#line 6170 "../../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)) && 
#line 6173 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_186 (insn, operands);

            case FIX:
              if (GET_MODE (x3) != E_SImode)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              switch (pattern412 (x1))
                {
                case 0:
                  if (!((
#line 9097 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 9099 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_328 (insn, operands);

                case 1:
                  if (!((
#line 9097 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 9099 "../../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_329 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != AND)
                return NULL;
              x14 = XEXP (x7, 0);
              if (!comparison_operator (x14, E_VOIDmode))
                return NULL;
              operands[1] = x14;
              x15 = XEXP (x14, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x16 = XEXP (x7, 1);
              if (!branch_comparison_operator (x16, E_VOIDmode))
                return NULL;
              operands[3] = x16;
              x17 = XEXP (x16, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x6 = XEXP (x2, 0);
              if (GET_CODE (x6) != PC)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return NULL;
              x18 = XEXP (x4, 1);
              if (GET_CODE (x18) != PLUS)
                return NULL;
              x19 = XEXP (x18, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x20 = XEXP (x14, 0);
              operands[0] = x20;
              x21 = XEXP (x16, 0);
              operands[2] = x21;
              if (!cc_reg_operand (operands[2], E_VOIDmode))
                return NULL;
              x22 = XEXP (x3, 1);
              operands[4] = x22;
              x23 = XEXP (x3, 2);
              operands[5] = x23;
              x8 = XEXP (x4, 0);
              operands[6] = x8;
              x9 = XEXP (x5, 0);
              operands[7] = x9;
              x24 = XEXP (x12, 0);
              operands[8] = x24;
              if (!scratch_operand (operands[8], E_CCmode))
                return NULL;
              x25 = XEXP (x13, 0);
              operands[9] = x25;
              if (!scratch_operand (operands[9], E_CCEQmode))
                return NULL;
              x26 = XEXP (x18, 0);
              if (!rtx_equal_p (x26, operands[0]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern605 (x18, 
E_SImode) != 0
                      || !(
#line 13862 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return NULL;
                  return gen_split_488 (insn, operands);

                case E_DImode:
                  if (pattern605 (x18, 
E_DImode) != 0
                      || !(
#line 13862 "../../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_489 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 4:
          return split_8 (x1, insn);

        case 10:
          switch (pattern18 (x1))
            {
            case 0:
              if (!((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 12726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_402 (insn, operands);

            case 1:
              if (!((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))) && 
#line 12726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_403 (insn, operands);

            case 2:
              if (!((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 12726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_404 (insn, operands);

            case 3:
              if (!((
#line 12723 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))) && 
#line 12726 "../../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_405 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      return split_18 (x1, insn);

    case EH_RETURN:
      if (!
#line 14331 "../../../gcc/config/rs6000/rs6000.md"
(epilogue_completed))
        return NULL;
      return gen_split_492 (insn, operands);

    default:
      return NULL;
    }
}
